-- name=int_investigation_button
--******************************************************************************************
function public.Init (pos_z)

  ObjAttach( "int_investigation_button", interface.originhub );
  ObjSet( "int_investigation_button", { pos_z = pos_z } );
  ObjSet( "obj_int_investigation_button", { alp = 0 } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.SHOW_ANIM_TIME = 0.5;
  private.SHOW_TIME = 0.3;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;
  private.show = 0;
  private.show_obj = "";
  public.POSITION = 936;

  private.pos_show = 0;
  private.pos_hide = 228;
  private.panel_show = false;
  ng_global.SHOW_INVESTIGATION = false;

  ObjSet("obj_int_investigation_button_open_close", {
    event_mdown = function () public.AnimPanel(false); end,
    event_menter = function () SetCursor(CURSOR_HAND) end,
    event_mleave = function () SetCursor(CURSOR_DEFAULT) end
  });

  ObjSet("spr_int_investigation_button_open_close_up", {
    event_mdown = function () public.AnimPanel(false); end,
    event_menter = function () SetCursor(CURSOR_HAND) end,
    event_mleave = function () SetCursor(CURSOR_DEFAULT) end
  });
  
  ObjSet("obj_int_investigation_use_investigation", {
    event_mdown = function () public.AnimPanel(false); end,
    event_menter = function () SetCursor(CURSOR_HAND) end,
    event_mleave = function () SetCursor(CURSOR_DEFAULT) end
  });
  
  ObjSet("obj_int_investigation_use_arrow_back", {
    event_mdown = function () public.AnimPanel(false); end,
    event_menter = function () SetCursor(CURSOR_HAND) end,
    event_mleave = function () SetCursor(CURSOR_DEFAULT) end
  });
  
  ObjSet("obj_int_investigation_button_button", {
    event_mdown = function () private.ClkDcnButton(); end,
    event_menter = function () private.MouseEnterAnim(); end,
    event_mleave = function () private.MouseLeaveAnim(); end
  });
  
  for i = 1, 3 do
    ObjSet("obj_int_investigation_button_dcn_"..i.."_clk", {
      event_mdown = function () private.ClkDcn() end,
      event_menter = function () SetCursor(CURSOR_HAND); end,
      event_mleave = function () SetCursor(CURSOR_DEFAULT); end
    });
  end;
  
  ObjSet("obj_int_investigation_button_bbt_1", {
    event_mdown = function () common_impl.ShowBbt("evidence_1") end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("obj_int_investigation_button_bbt_2", {
    event_mdown = function () common_impl.ShowBbt("evidence_2") end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("obj_int_investigation_button_bbt_3", {
    event_mdown = function () common_impl.ShowBbt("evidence_3") end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("obj_int_investigation_button_panel_dcn", { pos_x = private.pos_hide });

  private.res_arrow = 
  {

      ----investigation_1
      {
        dcn_1_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_1_on = "assets/interface/int_investigation_button/layers/clue_1",
        dcn_2_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_2_on = "assets/interface/int_investigation_button/layers/clue_2",
        dcn_3_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_3_on = "assets/interface/int_investigation_button/layers/clue_3",
        investigation_on = "assets/interface/int_investigation_button/layers/1",
        character = "assets/interface/int_investigation_button/layers/samuel"

      },

      ----investigation_2

      {

        dcn_1_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_1_on = "assets/interface/int_investigation_button/layers/clue_4",
        dcn_2_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_2_on = "assets/interface/int_investigation_button/layers/clue_5",
        dcn_3_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_3_on = "assets/interface/int_investigation_button/layers/clue_6",
        investigation_on = "assets/interface/int_investigation_button/layers/2",
        character = "assets/interface/int_investigation_button/layers/samuel"

      },

      ----investigation_3

      {

        dcn_1_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_1_on = "assets/interface/int_investigation_button/layers/clue_7",
        dcn_2_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_2_on = "assets/interface/int_investigation_button/layers/clue_8",
        dcn_3_off = "assets/interface/int_investigation_button/layers/clue_1_1",
        dcn_3_on = "assets/interface/int_investigation_button/layers/clue_9",
        investigation_on = "assets/interface/int_investigation_button/layers/3",
        character = "assets/interface/int_investigation_button/layers/ulf"

      },
      
  };

  common_impl.hint[ "vid_evidence_1" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_dcn_3_in",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;

--******************************************************************************************
function private.EventAnimEnd( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_investigation_button", { input = true } );
    if ng_global.progress[ "std" ].common.chapter == "level1" and ( not cmn.IsEventDone( "get_evidence_1_2") ) then

      public.AnimPanel(true);
      private.DcnON();

    end;

  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_investigation_button", { active = false, visible = false, input = false } );

  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id )

  local obj = "obj_int_investigation_button";
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_TIME;

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.HideAnim( event_id )

  local obj = "obj_int_investigation_button";
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_TIME;

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.Investigation_count()

  local count = 0;
  local inv = ng_global.investigation;
  for i = 1, #int_diary.DCN_ARRAY[ inv ] do
  
    local task = "get_"..int_diary.DCN_ARRAY[inv][i];
    if cmn.IsEventDone( task ) then
      count = count + 1;
    end;
  
  end;
  
  return count;
  
end;
--******************************************************************************************
function private.SetInvestigation()

  if int_diary.CheckInvestigation() then

    ObjSet("spr_int_investigation_investigation", { visible  = true }); --1 
    ObjSet("obj_int_investigation_button_dcn", { visible  = false, input = false }); 
    ObjSet("obj_int_investigation_button_button", { visible  = true, alp = 1, input = true });

  else

    ObjSet("spr_int_investigation_investigation", { visible  = true });  --0
    ObjSet("obj_int_investigation_button_dcn", { visible  = true, input = true }); 
    ObjSet("obj_int_investigation_button_button", { visible  = false, alp = 0, input = false });

  end;
  
end;
--******************************************************************************************
function public.SetDcn()

  local inv = ng_global.investigation;
  for i = 1, #int_diary.DCN_ARRAY[ inv ] do
  
    local task = "get_"..int_diary.DCN_ARRAY[ inv ][i];
    if task and cmn.IsEventDone( task ) then
  
        ObjSet( "spr_int_investigation_button_dcn_light_"..i,{ alp = 0 });
        ObjSet( "obj_int_investigation_button_bbt_"..i, { input = false });
        ObjSet( "obj_int_investigation_button_dcn_"..i.."_clk", { input = true });
        ObjSet( "spr_int_investigation_button_dcn_back_"..i, { visible  = false });
        ObjSet( "spr_int_investigation_button_dcn_front_"..i, { visible  = true });
        ObjSet( "obj_int_investigation_button_bbt", {  input = false });
    
    end;
  
  end;

  local count = private.Investigation_count();
  for j = 1, count do
    ObjSet( "spr_int_investigation_button_back_lamp_"..j.."_light", { visible  = true, alp = 1 });  
  end;

  private.SetInvestigation();

end;
--******************************************************************************************
function private.UpdateInvestigation()

  private.ResetInvestigation( ng_global.investigation );
  public.SetDcn()
  
  ObjSet("obj_int_investigation_use_investigation", { input = true }); 

  if ng_global.SHOW_INVESTIGATION then
    ObjSet("obj_int_investigation_button", { pos_x = 0 });
  else
    ObjSet("obj_int_investigation_button", { pos_x = 188 })
  end;

end;
--******************************************************************************************
function private.ResetInvestigation(investigation)

  for i = 1, 3 do

    local dcn_on = "dcn_"..i.."_on"; 
    local res_yes = private.res_arrow[ investigation ][dcn_on];

    ObjSet( "obj_int_investigation_button_dcn_"..i.."_clk", { input = false });
    ObjSet( "spr_int_investigation_button_dcn_back_"..i, { visible  = true });
    ObjSet( "spr_int_investigation_button_dcn_front_"..i, { visible  = false, res = res_yes });
    ObjSet( "spr_int_investigation_button_back_lamp_"..i.."_light", { visible  = false });
    ObjSet( "spr_int_investigation_button_dcn_light_"..i,{ alp = 1 });

  end;

  ObjSet( "spr_int_investigation_button_character", { res = private.res_arrow[ investigation ][ "character" ] });
  ObjSet( "txt_int_investigation_button_character", { text = "txt_character_question_"..investigation });
  ObjSet("txt_int_investigation_button_title_dcn",{ text = "txt_title_"..investigation });
  ObjSet("spr_int_investigation_investigation", { visible  = true, res = private.res_arrow[ investigation ]["investigation_on"] }); 
  ObjSet("spr_int_investigation_no_investigation", { visible  = false });
  ObjSet("obj_int_investigation_button_dcn", { visible  = true, input = true }); 
  ObjSet("obj_int_investigation_button_button", { visible  = false, input = false });

end;
--******************************************************************************************
function private.ClkDcn()

  ng_global.diary_current_page = ng_global.investigation
  public.HidePanel();
  int_diary.Show();
  
end;
function private.ClkDcnButton()

  int_diary.click_evidence_button( "diary" );
  
end;

--******************************************************************************************
function public.AnimPanel(lock)

  common_impl.Lock(1);

  local x1;
  local x2;
  
  if private.panel_show then 
    x1 = private.pos_show; 
    x2 = private.pos_hide;
    private.panel_show = false;
  else
    x2 = private.pos_show; 
    x1 = private.pos_hide; 
    private.panel_show = true; 
    ObjSet( "obj_int_investigation_use_arrow_back", { input = false });
    ObjSet( "spr_int_investigation_button_open_close_up", { visible  = false, input = false });
    ObjSet( "obj_int_investigation_button_open_close", { visible  = true });
  end;

  ObjSet( "spr_int_investigation_button_open_close_focus", { visible  = true });

  local trg_after = function ()
  
    private.AnimPanelEnd(lock); 
  
  end;
  
  ObjAnimate( "obj_int_investigation_button_panel_dcn", "pos_x",0,0, trg_after, 
  { 
    0.0, 0, x1,
    0.5, 3, x2 
  } );
  
end;
--******************************************************************************************
function private.AnimPanelEnd(lock)

  if ( lock == false ) then
      common_impl.Lock(0);
  end;

  local value  =  0;
  if  private.panel_show  then
    value = 1;
  end;
  ObjSet("obj_int_investigation_button_back_crop",{ input = value });
  ObjSet("obj_int_investigation_use_arrow_back", { input = 1 - value });
  ObjSet("spr_int_investigation_button_open_close_focus",{ visible = 0 });
  ObjSet("spr_int_investigation_button_open_close_up",{ visible = 1 - value, input = 1 - value });
  ObjSet("obj_int_investigation_button_open_close",{ visible = value });

end;
--******************************************************************************************
function public.HidePanel()

  if private.panel_show then
  
    common_impl.Lock(1);

    local x1 = private.pos_show  ; 
    local x2 = private.pos_hide;
    private.panel_show = false; 
  
    local trg_after = function()
  
      private.AnimPanelEnd(false);
    
    end;

    ObjAnimate( "obj_int_investigation_button_panel_dcn", "pos_x",0,0, trg_after,
    { 
      0.0, 0, x1,
      0.5, 3, x2 
    } );

  end;
  
end;
--******************************************************************************************
function private.AddDcnFx( name )

  local id;
  for i = 1,#int_diary.DCN_ARRAY[ng_global.investigation] do

    if name == int_diary.DCN_ARRAY[ng_global.investigation][i] then

      id = i;

    end;

  end;
  
  PartSysRestart( "fx_int_investigation_button" );

  ObjAttach( "obj_int_investigation_button_light", "obj_int_investigation_button_dcn_"..id );
  ObjSet( "obj_int_investigation_button_light", { alp = 1, visible = true, active = true } );

  ObjAnimate( "spr_int_investigation_button_dcn_light", "alp",0,0,"", 
  {
    0.0, 0, 0,
    0.2, 0, 1,
    0.5, 0, 0.5,
    0.7, 0, 1,
    1.0, 0, 0 
  });
  
  ObjAnimate( "spr_int_investigation_button_dcn_light_"..id, "alp",0,0,"",
  {
    0.0, 0, 1, 
    0.3, 0, 0
  });

  local trg_after = function () 

    ObjSet( "obj_int_investigation_button_light",{ alp = 0, visible = false, active = false }); 

  end;

  common_impl.DelayedCall( 1, trg_after );

end;
--******************************************************************************************
function public.AddDcnAnim( name )

  common_impl.PlayAudio( "env", "common/audio/aud_evidence_glow", 0, "", 0 );  
  local id_lamp = private.Investigation_count();
  local lamp_on = "spr_int_investigation_button_back_lamp_"..id_lamp.."_light";
  ObjSet( lamp_on,{ visible = true, alp = 0 });
  ObjAnimate( lamp_on, "alp",0,0, "",{ 0,0,0, 0.5,0,1 });

  private.AddDcnFx(name)
  
  common_impl.DelayedCall( 1, function () private.AddButtonAnim(); end );
  
end;
--******************************************************************************************
function private.AddButtonAnim()

  if int_diary.CheckInvestigation() then
  
    ObjSet("obj_int_investigation_button_dcn", {  input = false }); 
    ObjSet("obj_int_investigation_button_button", { visible  = true });

    local trg_after = function ()

      public.SetDcn();

    end;
  
    ObjAnimate( "obj_int_investigation_button_button", "alp",0,0, trg_after,
    {
      0.0, 0, 0,
      0.3, 0, 1
    });
  
    ObjAnimate( "obj_int_investigation_button_dcn", "alp",0,0, "",
    {
      0.0, 0, 1,
      0.3, 0, 0
    });

  else
  
     public.SetDcn();
  
  end;
  
end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );
  local obj = "spr_int_investigation_button_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;
  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 2, alp,  tme, 2, 1 } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_int_investigation_button_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;
  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 1, alp,  tme, 1, 0 } );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local dx_paper = (1366 - GetAppWidth()) / 342;
  local x1_paper = public.POSITION - 170*dx_paper;
  ObjSet( "obj_int_investigation_button", { pos_x = x1_paper } );

end;
--******************************************************************************************
function private.DcnON()

  ObjSet( "obj_int_investigation_button_dcn", { visible = true, alp = 1 } );
  ObjSet( "txt_int_investigation_button_title_dcn", { visible = true, alp = 1 } );
  ObjSet( "txt_int_investigation_button_character", { alp = 0 } );
  ObjSet( "obj_int_investigation_character", { active = false, alp = 0 } ); 
  ObjSet( "obj_int_investigation_button_lamp", { visible = true, alp = 1 } );
  ObjSet( "obj_int_investigation_button_bbt_1", { input = true });
  ObjSet( "obj_int_investigation_button_bbt_2", { input = true });
  ObjSet( "obj_int_investigation_button_bbt_3", { input = true });
  ObjSet( "obj_int_investigation_button_bbt_4", { input = true });
  ObjSet( "obj_int_investigation_button_bbt_5", { input = true });

end;
--******************************************************************************************
function private.DcnOFF()

  ObjSet( "obj_int_investigation_character", { active = true, visible = true, alp = 1 } );
  ObjSet( "txt_int_investigation_button_character", { visible = true, alp = 1 } );
  ObjSet( "obj_int_investigation_button_dcn", { alp = 0 } );
  ObjSet( "txt_int_investigation_button_title_dcn", { alp = 0 } );
  ObjSet( "obj_int_investigation_button_lamp", { alp = 0 } );

end;
--******************************************************************************************
function public.Show()

  ObjSet( "obj_int_investigation_button", { active = true, visible = true, input = true } );
  private.ShowAnim( 'show' );

end;
--******************************************************************************************
function public.Hide()


end;
--******************************************************************************************