-- name=ho_barn
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "barn" );
  game.relations[ "ho_barn" ].exitroom = "rm_house";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_barn" ] = { type = "win", room = "rm_house", zz = "ho_barn", zz_gate = "gho_house_barn" };
 
  local win_barn_func = function ()

    if ( cmn.IsEventDone( "win_barn" ) ) then
      interface.InventoryItemAdd( "inv_amulet", "spr_barn_win" );
      ObjSet( "inv_amulet", {drag = 0} );
      ObjDelete( "gho_house_barn" );
    end;
       

  end;
  cmn.AddSubscriber( "win_barn", win_barn_func );
  
  local opn_chest = function () 
    ObjSet( "spr_barn_ccc", {visible = 1,input=1} );
    ObjSet( "spr_barn_fff", {visible = 1,input=1} );
    ObjSet( "spr_barn_hhh", {visible = 1,input=1} );
    ObjSet( "spr_barn_aaa", {visible = 1,input=1} );    
    ObjSet( "spr_barn_ddd", {visible = 1,input=1} );
    ObjSet( "anm_barn_open_chest", {animfunc="open_chest_end",frame=0} );
    ObjDelete("gfx_barn_opn_chest_zone")
  end;
  cmn.AddSubscriber( "barn_opn_chest", opn_chest, "ho_barn" ); 

  local unmark_eee = function () 
    ObjSet( "spr_barn_eee", {visible = 1,input=1} );
    ObjDelete("gfx_barn_unmark_eee_zone")
    ObjDelete("spr_barn_sh_nailpuller")
    ObjDelete("spr_barn_unmark_eee_part_1")
    ObjSet( "anm_barn_open_cover", {animfunc="open_cover_end",frame=0} );    
  end;
  cmn.AddSubscriber( "barn_unmark_eee", unmark_eee, "ho_barn" ); 

  local unmark_iii = function () 
    ObjSet( "spr_barn_iii", {visible = 1,input=1} );
    ObjDelete("gfx_barn_unmark_iii_zone")
    ObjDelete("spr_barn_unmark_iii_part_1")
    ObjDelete("spr_barn_sh_runner")
    ObjSet( "anm_barn_open_bag", {animfunc="open_bag1_end",frame=0} );    
  end;
  cmn.AddSubscriber( "barn_unmark_iii", unmark_iii, "ho_barn" ); 
  
  local start_barn_func = function ()
  if not cmn.IsEventDone("win_barn") then
    if cmn.IsUnmarkedTask("barn","ccc") then -- сундук
      opn_chest()
    end   
    if cmn.IsUnmarkedTask("barn","eee") then -- ящик
      unmark_eee()
    end 
    if cmn.IsUnmarkedTask("barn","iii") then -- сумка
      unmark_iii()
    end     
  end
  end;
  cmn.AddSubscriber( "win_barn", start_barn_func, "ho_barn" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_house_env" )

  if ( not cmn.IsEventDone( "opn_barn" ) ) then

    cmn.InitHo( "barn" );
    cmn.SetMarkedTask( "barn", "ccc" );--сундук
    cmn.SetMarkedTask( "barn", "fff" );
    cmn.SetMarkedTask( "barn", "ddd" );
    cmn.SetMarkedTask( "barn", "hhh" );
    cmn.SetMarkedTask( "barn", "aaa" );
    cmn.SetMarkedTask( "barn", "eee" );--ящик   
    cmn.SetMarkedTask( "barn", "iii" );--сумка     
    cmn.SetEventDone( "opn_barn" );
    
  end;
  level.tutorial_ho.first()
  level.tutorial_hint.first()
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 1, { { "spr_barn_aaa" },{"gfx_barn_opn_chest_zone"} });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_barn_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 1, { { "spr_barn_ccc" },{"gfx_barn_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_barn_ddd" },{"gfx_barn_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_barn_eee" },{"gfx_barn_unmark_eee_zone","spr_barn_unmark_eee_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_barn_fff" },{"gfx_barn_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_barn_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 1, { { "spr_barn_hhh" },{"gfx_barn_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 1, { { "spr_barn_iii" },{"gfx_barn_unmark_iii_zone","spr_barn_unmark_iii_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_barn_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_barn_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          4, 0, { { "spr_barn_lll_mul_1" },{ "spr_barn_lll_mul_2" },{ "spr_barn_lll_mul_3" },{ "spr_barn_lll_mul_4" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["std"]["win_barn"].found do

    local name = tostring( ng_global.progress["std"]["win_barn"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()
  ObjDelete("grm_barn_house") 
  --  common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_barn_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_barn_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
----------------------------------------------------------------------------

function public.opn_chest() 

  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "barn", "ccc" );
    cmn.UnmarkTask( "barn", "fff" );
    cmn.UnmarkTask( "barn", "hhh" );
    cmn.UnmarkTask( "barn", "aaa" );      
    cmn.UnmarkTask( "barn", "ddd" );      
    cmn.CallEventHandler( "barn_opn_chest" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_barn_opn_chest_zone")
  SoundSfx( "aud_ho_barn_suitcase" );
  ld.AnimPlay("anm_barn_open_chest","open_chest",func_end)
end;

----------------------------------------------------------------------------

function public.unmark_eee() 
  if ApplyObj("spr_barn_unmark_eee_part_1","gfx_barn_unmark_eee_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "barn", "eee" );
    cmn.CallEventHandler( "barn_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("spr_barn_unmark_eee_part_1")
  ObjDelete("gfx_barn_unmark_eee_zone")  
  SoundSfx( "aud_ho_barn_box" )
  ld.AnimPlay("anm_barn_open_cover","open_cover",func_end)
  else 
    ObjSet("spr_barn_unmark_eee_part_1",{pos_z = 4})
    ObjSet( "spr_barn_sh_nailpuller", {alp = 1} );    
  end  
end;
----------------------------------------------------------------------------

function public.unmark_iii() 
  if ApplyObj("spr_barn_unmark_iii_part_1","gfx_barn_unmark_iii_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "barn", "iii" );
    cmn.CallEventHandler( "barn_unmark_iii" );
  end
  ld.Lock(1) 
  ObjDelete("spr_barn_unmark_iii_part_1")
  ObjDelete("gfx_barn_unmark_iii_zone")
  SoundSfx( "aud_ho_barn_bag" )
  ld.AnimPlay("anm_barn_open_bag","open_bag",func_end)
  else 
  ObjSet("spr_barn_unmark_iii_part_1",{pos_z = 1})
    ObjSet( "spr_barn_sh_runner", {alp = 1} );    
  end
end;