-- name=ho_chatterho
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chatterho" );
  game.relations[ "ho_chatterho" ].exitroom = "rm_beyondtower";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chatterho" ] = { type = "win", room = "rm_beyondtower", zz = "ho_chatterho", zz_gate = "gho_beyondtower_chatterho" };
 
  local win_chatterho_func = function ()

    if ( cmn.IsEventDone( "win_chatterho" ) ) then
      interface.InventoryItemAdd( "inv_valve", "spr_chatterho_win" );
      ObjDelete( "gho_beyondtower_chatterho" );
    end;

  end;
  cmn.AddSubscriber( "win_chatterho", win_chatterho_func );

  local unmark_hhh = function () 
    ObjSet( "spr_chatterho_hhh", {alp = 1,input=1} );
    ObjDelete("spr_chatterho_hhh_part_1")
    ObjDelete("spr_chatterho_hhh_part_2")
    ObjDelete( "spr_chatterho_hhh_part_2_sh");
  end;
  cmn.AddSubscriber( "chatterho_unmark_hhh", unmark_hhh, "ho_chatterho" );

  local unmark_ccc = function () 
    ObjSet( "spr_chatterho_ccc", {alp = 1,input=1} );
    ObjDelete("spr_chatterho_ccc_part_1")
    ObjDelete("spr_chatterho_ccc_part_2")
    ObjDelete( "spr_chatterho_ccc_part_2_sh");
  end;
  cmn.AddSubscriber( "chatterho_unmark_ccc", unmark_ccc, "ho_chatterho" );
  
  local start_chatterho_func = function ()
  if not cmn.IsEventDone("win_chatterho") then
    if cmn.IsUnmarkedTask("chatterho","hhh") then 
      unmark_hhh()
    end 
    if cmn.IsUnmarkedTask("chatterho","ccc") then 
      unmark_ccc()
    end     
  end
  end;
  cmn.AddSubscriber( "win_chatterho", start_chatterho_func, "ho_chatterho" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( 0 )

  if ( not cmn.IsEventDone( "opn_chatterho" ) ) then

    cmn.InitHo( "chatterho" );
    cmn.SetMarkedTask( "chatterho", "hhh" );
    cmn.SetMarkedTask( "chatterho", "ccc" );    
    cmn.SetEventDone( "opn_chatterho" );
    ObjSet("txt_chatterho_panel",{param0=12})
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_chatterho_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_chatterho_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 1, { { "spr_chatterho_ccc" },{"spr_chatterho_ccc_part_1","spr_chatterho_ccc_part_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_chatterho_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_chatterho_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_chatterho_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_chatterho_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 1, { { "spr_chatterho_hhh" },{"spr_chatterho_hhh_part_1","spr_chatterho_hhh_part_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_chatterho_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_chatterho_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_chatterho_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_chatterho_lll" } } );
  
  SoundHoTheme( true );
  ObjAttach("spr_chatterho_panel","int_taskpanel_impl")
  ObjSet("spr_chatterho_panel",{pos_x=0,pos_y=0})
  interface.TaskPanelShow( ho_items );

  for j = 1, #ng_global.progress["std"]["win_chatterho"].found do

    local name = tostring( ng_global.progress["std"]["win_chatterho"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  if ng_global.progress["std"]["win_chatterho"].found then
    ObjSet("txt_chatterho_panel",{param0=12-#ng_global.progress["std"]["win_chatterho"].found})
  end
   

  
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()
  ObjDetach("spr_chatterho_panel")
end
--*********************************************************************************************************************
function public.HoComplete()

  -- common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  local sum = 12 - #ng_global.progress["std"]["win_chatterho"].found
   
  ObjSet("txt_chatterho_panel",{param0=sum})
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )

  ObjSet( "spr_chatterho_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_chatterho_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.unmark_hhh()
  if ApplyObj("spr_chatterho_hhh_part_1","spr_chatterho_hhh_part_2") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "chatterho", "hhh" );
      cmn.CallEventHandler( "chatterho_unmark_hhh" );      
    end
    ld.Lock(1)
    ObjDelete("spr_chatterho_hhh_part_2")
    ObjAnimate( "spr_chatterho_hhh", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_chatterho_maraca" );
  else
    SoundSfx( "aud_wrongapply"..math.random(1,3) );
    ObjSet("spr_chatterho_hhh_part_2",{pos_z = 5})
    ObjSet( "spr_chatterho_hhh_part_2_sh", {alp = 1} );
  end
end
----------------------------------------------------------------------------
function public.unmark_ccc()
  if ApplyObj("spr_chatterho_ccc_part_1","spr_chatterho_ccc_part_2") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "chatterho", "ccc" );
      cmn.CallEventHandler( "chatterho_unmark_ccc" );      
    end
    ld.Lock(1)
    ObjDelete("spr_chatterho_ccc_part_1")
    ObjAnimate( "spr_chatterho_ccc", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_chatterho_handle" )
  else
    SoundSfx( "aud_wrongapply"..math.random(1,3) );
    ObjSet("spr_chatterho_ccc_part_1",{pos_z = 5})
    ObjSet( "spr_chatterho_ccc_part_1_sh", {alp = 1} );
  end
end