-- name=ho_puddle
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "puddle" );
  game.relations[ "ho_puddle" ].exitroom = "rm_corridor";
 
--------------------------------------------------------------------------------------------------
 common_impl.hint[ "win_puddle" ] = {
    type = "win",
    room = "rm_corridor",
    zz = "ho_puddle",
    zz_gate = "gho_corridor_puddle"
  };
 
  local win_puddle_func = function ()

    if ( cmn.IsEventDone( "win_puddle" ) ) then
      interface.InventoryItemAdd( "inv_stoneflower", "spr_puddle_win" );
      ObjDelete( "gho_corridor_puddle" );
    end;

  end;
  cmn.AddSubscriber( "win_puddle", win_puddle_func );
  
  local start_puddle_func = function ()
  if not cmn.IsEventDone("win_puddle") then
      common_impl.ProcessHoStart( "puddle" );

      local ho_found = ng_global.progress[ "std" ][ "win_puddle" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;

  end
  end;
  cmn.AddSubscriber( "win_puddle", start_puddle_func, "ho_puddle" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_corridor_env" );

  if ( not cmn.IsEventDone( "opn_puddle" ) ) then

    cmn.InitHo( "puddle" );

    cmn.SetEventDone( "opn_puddle" );

  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_puddle_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_puddle_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_puddle_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_puddle_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_puddle_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_puddle_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_puddle_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_puddle_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_puddle_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_puddle_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_puddle_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_puddle_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false )
  interface.ItemPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show()
  ObjDelete("grm_puddle_corridor") 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )


end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_puddle_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_puddle_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
   SoundSfx("aud_get_inv");

end;