-- name=ho_suitcase
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "suitcase" );
  game.relations[ "ho_suitcase" ].exitroom = "rm_rungs";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_suitcase" ] = { type = "win", room = "rm_rungs", zz = "ho_suitcase", zz_gate = "gho_rungs_suitcase" };
 
  local win_suitcase_func = function ()

    if ( cmn.IsEventDone( "win_suitcase" ) ) then
      interface.InventoryItemAdd( "inv_amuletlizard", "spr_suitcase_win",function() level_inv.ProcessGetAmuletlizardAll( "win_suitcase" ) end );
      ObjDelete( "gho_rungs_suitcase" );
    end;

  end;
  cmn.AddSubscriber( "win_suitcase", win_suitcase_func );
  
  local start_suitcase_func = function ()
  if not cmn.IsEventDone("win_suitcase") then
  
  end
  end;
  cmn.AddSubscriber( "win_suitcase", start_suitcase_func, "ho_suitcase" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_rungs_env" )

  if ( not cmn.IsEventDone( "opn_suitcase" ) ) then

    cmn.InitHo( "suitcase" );

    cmn.SetEventDone( "opn_suitcase" );
  end;

    local arr = {
                "aaa",
                "bbb",
                "ccc",
                "ddd",
                "eee",
                "fff",
              }
    for i = 1,#arr do 
      local item_name = "spr_suitcase_panel_"..arr[i].."_siluet"        
      local item_params = ObjGet( item_name );  
      --ld.LogTrace( item_name );      
      ObjSet( item_name, {
        event_menter = function () interface.PopupShow("tsk_suitcase_"..arr[i] ) end,
        event_mleave = function () interface.PopupHide() end,
        inputrect_init = 1,
        inputrect_x    = - ( 0.5 * item_params.draw_width  ),
        inputrect_y    = - ( 0.5 * item_params.draw_height ),
        inputrect_w    = item_params.draw_width,
        inputrect_h    = item_params.draw_height               
      } );
    end   
  
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          2, 0, { { "spr_suitcase_aaa_mul_1" },{ "spr_suitcase_aaa_mul_2" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          2, 0, { { "spr_suitcase_bbb_mul_1" },{ "spr_suitcase_bbb_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          2, 0, { { "spr_suitcase_ccc_mul_1" },{ "spr_suitcase_ccc_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          2, 0, { { "spr_suitcase_ddd_mul_1" },{ "spr_suitcase_ddd_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          2, 0, { { "spr_suitcase_eee_mul_1" },{ "spr_suitcase_eee_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          2, 0, { { "spr_suitcase_fff_mul_1" },{ "spr_suitcase_fff_mul_2" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

  ObjAttach("spr_suitcase_panel","int_taskpanel_impl")
  ObjSet("spr_suitcase_panel",{pos_x=0,pos_y=0})
  
  for j = 1, #ng_global.progress["std"]["win_suitcase"].found do

    local name = tostring( ng_global.progress["std"]["win_suitcase"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  private.LoadState()
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;

function public.Close()
  ObjDetach("spr_suitcase_panel")
end
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  --ld.LogTrace( item_name );
  private.LoadState()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_suitcase_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_suitcase_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------

function private.LoadState()
  public.state = {}
  for j = 1, #ng_global.progress["std"]["win_suitcase"].found do

    local task = tostring( ng_global.progress["std"]["win_suitcase"].found[j]["task"] );
    if public.state[task] then
      public.state[task] = public.state[task] + 1
    else 
      public.state[task] = 1
    end
  end;
  for k,v in pairs(public.state) do
    if public.state[k] then
      ObjSet("txt_suitcase_panel_"..k.."_text",{text="x"..(2-tonumber(v))})
    end
  end 
end
----------------------------------------------------------------------------