-- name=mg_carpetmg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_carpetmg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_carpetmg" ] = {type = "win", use_place = "mg_carpetmg", room = "rm_bedroom", zz = "mg_carpetmg", zz_gate = "gmg_bedroom_carpetmg" };

  local win_carpetmg_logic = function()
    if ld.CheckRequirements( {"win_carpetmg"} ) then
        ObjSet( "spr_carpetmg_amuletowl", {active=1, input = 1, visible = 1} );
    end
  end;
  local win_carpetmg = function()
    if ld.CheckRequirements( {"win_carpetmg"} ) then
      ObjDelete("obj_carpetmg_lvl1_root");
      ObjDelete("obj_carpetmg_lvl_2_parts_root");
      ObjSet( "anm_carpetmg_anm_carpetmg", {animfunc="idle", frame=999} );
      ObjDelete("spr_carpetmg_needle")
      ObjDelete("spr_carpetmg_sh_needle1");
    end
  end;
  cmn.AddSubscriber("win_carpetmg", win_carpetmg, private.room_objname )
  cmn.AddSubscriber("win_carpetmg", win_carpetmg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_amuletowl" ] = { type = "get", get_obj = "spr_carpetmg_amuletowl", room = "rm_bedroom", zz = "mg_carpetmg", zz_gate = "gmg_bedroom_carpetmg" };

private.get_amuletowl_logic = function()
  
end;
private.get_amuletowl_inv = function()
  interface.InventoryItemAdd("inv_amuletowl","spr_carpetmg_amuletowl");
end;
private.get_amuletowl_beg = function()
  ObjDelete("gfx_carpetmg_amuletowl")
end;
private.get_amuletowl_end = function()
  ObjDelete("spr_carpetmg_sh_amuletowl");
end;

cmn.AddSubscriber( "get_amuletowl", private.get_amuletowl_inv );
cmn.AddSubscriber( "get_amuletowl", private.get_amuletowl_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletowl", private.get_amuletowl_end, private.room_objname );
cmn.AddSubscriber( "get_amuletowl", private.get_amuletowl_logic );
--------------------------------------------------------------------
function public.get_amuletowl()
  cmn.SetEventDone( "get_amuletowl" );
  cmn.CallEventHandler( "get_amuletowl" );
  cmn.GotoRoom( "rm_bedroom" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
private.carpetmg_lvl1_parts_pos={
  {379,169},
  --{327,430},
  {703,314},
  {293,294},
  --{644,162},
  --{390,474},
  {503,309},
  --{452,141},
  {597,494},
  {548,145},
  --{311,223},
  --{693,242},
  {288,379},
  --{687,406},
  {491,495}
};


private.carpetmg_parts_pos_array={ 
{472,157},
{423,178},
{390,222},
{366,247},
{345,278},
{337,327},
{338,386},
{335,442},
{355,480},
{441,515},
{576,515},
{657,481},
{678,443},
{675,386},
{675,328},
{668,278},
{648,248},
{622,222},
{589,178},
{540,157}
}

private.carpetmg_points_pos_array={
{438,159},
{410,195},
{388,248},
{341,248},
{344,304},
{337,350},
{336,420},
{338,464},
{371,498},
{511,531},
{641,498},
{675,466},
{676,421},
{677,352},
{669,306},
{676,252},
{624,249},
{603,196},
{574,160},
{506,149}
} 


private.carpetmg_parts_init_flag = false;

function private.carpetmg_parts_init()
   if private.carpetmg_parts_init_flag==false then
      -- for lvl 1
      ObjCreate("obj_carpetmg_lvl1_root_for_anim","obj")
      ObjSet( "obj_carpetmg_lvl1_root_for_anim", {input = 1, visible = 1} );
      ObjAttach("obj_carpetmg_lvl1_root_for_anim","obj_carpetmg_lvl1_root")
      
      for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
        
        ObjCreate("spr_carpetmg_point_"..i,"spr")
        ObjSet( "spr_carpetmg_point_"..i, {res="assets/levels/level/mg_carpetmg/tr_c1", input=1, visible=1, pos_x=private.carpetmg_lvl1_parts_pos[i][1], pos_y=private.carpetmg_lvl1_parts_pos[i][2], pos_z=10, drag=0, 
       -- event_startdrag="mg_carpetmg.carpetmg_point_start_drag("..i..")", event_drag = "mg_carpetmg.carpetmg_point_drag("..i..")", event_dragdrop="mg_carpetmg.carpet_point_drop("..i..")"
     event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)", event_mdown="mg_carpetmg.carpetmg_point_drag_start("..i..")", inputrect_init=1, inputrect_x=-40, inputrect_y=-40, inputrect_w=80, inputrect_h=80} );
        ObjAttach("spr_carpetmg_point_"..i,"obj_carpetmg_lvl1_root_for_anim");
        ObjCreate("spr_carpetmg_point_"..i.."_light","spr");
        ObjSet( "spr_carpetmg_point_"..i.."_light", {res="assets/levels/level/mg_carpetmg/lig_tr_c1", input=0, alp=0, visible=1} );
        ObjAttach("spr_carpetmg_point_"..i.."_light","spr_carpetmg_point_"..i);
        
        ObjCreate("obj_carpetmg_drag_point_"..i,"obj")
        ObjSet( "obj_carpetmg_drag_point_"..i, { event_startdrag="mg_carpetmg.carpetmg_point_start_drag("..i..")", event_drag = "mg_carpetmg.carpetmg_point_drag("..i..")", event_dragdrop="mg_carpetmg.carpet_point_drop("..i..")"} );
        ObjAttach("obj_carpetmg_drag_point_"..i,"spr_carpetmg_point_"..i);
        
        ObjCreate("spr_carpetmg_line_"..i,"spr")
        ObjSet( "spr_carpetmg_line_"..i, {res="assets/levels/level/mg_carpetmg/tr_thread", input=0} );
        ObjAttach( "spr_carpetmg_line_"..i,"obj_carpetmg_lvl1_root_for_anim");
        
        ObjCreate("spr_carpetmg_line_light_"..i,"spr")
        ObjSet( "spr_carpetmg_line_light_"..i, {res="assets/levels/level/mg_carpetmg/lig_tr_thread", input=0, alp=0} );
        ObjAttach( "spr_carpetmg_line_light_"..i, "spr_carpetmg_line_"..i);
      end;  
     
      -- for lvl 2
      for i=1,#private.carpetmg_parts_pos_array,1 do 
          ObjCreate("spr_carpetmg_a"..i,"spr");
          ObjSet( "spr_carpetmg_a"..i, {alp=0, input=0, visible=0, active=1, pos_x=private.carpetmg_parts_pos_array[i][1], pos_y=private.carpetmg_parts_pos_array[i][2], res="assets/levels/level/mg_carpetmg/a"..i} );
          ObjAttach("spr_carpetmg_a"..i,"obj_carpetmg_lvl_2_parts_root");
      end;
      for i=1,#private.carpetmg_points_pos_array,1 do
          ObjCreate("obj_carpetmg_a"..i,"obj");
          ObjSet( "obj_carpetmg_a"..i, {inputrect_init=1, inputrect_w=50, inputrect_h=50, inputrect_x=-25, inputrect_y=-25, input=1, pos_x=private.carpetmg_points_pos_array[i][1],pos_y=private.carpetmg_points_pos_array[i][2],
                                        event_menter="mg_carpetmg.carpetmg_point_menter("..i..");", event_mleave="mg_carpetmg.carpetmg_point_mleave("..i..");", event_mdown=""} );
          ObjAttach("obj_carpetmg_a"..i,"obj_carpetmg_lvl_2_parts_root");
          ObjCreate("spr_carpetmg_lig"..i,"spr");
          ObjSet( "spr_carpetmg_lig"..i, {res="assets/levels/level/mg_carpetmg/lig", input=0, visible=1, alp=0} );
          ObjAttach("spr_carpetmg_lig"..i,"obj_carpetmg_a"..i);
      end;  
      private.carpetmg_parts_init_flag=true;  
   end;  
end;  

function private.carpetmg_show_points()
  --Trace( "show points" );
  local my_str="";
  for i=1,#private.carpetmg_lvl1_parts_pos,1 do
     my_str = my_str.. "{"..ObjGet("spr_carpetmg_point_"..i).pos_x..","..ObjGet("spr_carpetmg_point_"..i).pos_y.."}," ;
  end;  
  ld.LogTrace( my_str );
end;  
  
function private.carpetmg_stand_on_pos()
  -- ld.LogTrace( "stand on pos! gm.state = "..gm.state );
   ng_global.progress["std"]["win_carpetmg"].state = gm.state;
  
   if gm.state[3]==1 then 
     for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
       ObjSet( "spr_carpetmg_point_"..i, {pos_x=gm.state[1][i][1], pos_y=gm.state[1][i][2]} );
     end;  
     private.carpetmg_lines_stand();
   --  private.carpetmg_show_points();
     private.carpetmg_lvl1_win_ver();
   else 
     ObjSet( "spr_carpetmg_needle", {input=1, drag=1} );
     ObjSet("obj_carpetmg_lvl1_root",{active=0, input=0, visible=0});
     ObjSet( "obj_carpetmg_lvl_2_parts_root", {active=1, input = 1, visible = 1} );
     for i=1,#private.carpetmg_parts_pos_array,1 do 
       if gm.state[2]-1>=i or i==20 then ObjSet( "spr_carpetmg_a"..i, {visible = 1, alp=1} ); else ObjSet( "spr_carpetmg_a"..i, {visible = 0, alp=0} );  end;
     end;  
     private.carpetmg_win_ver();
   end;  
end;  

 
private.carpetmg_lines_array={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0} 
function private.carpetmg_lines_light()
    ---------------------------- line light
  for i=1,#private.carpetmg_lvl1_parts_pos,1 do
    local cur_count=0; 
    for j=1,#private.carpetmg_lvl1_parts_pos,1 do 
         if i~=j then
           if private.carpet_search_lines_per(i,j) then cur_count=cur_count+1;  end; 
         end;
    end;
    if cur_count>0 then   
      if  private.carpetmg_lines_array[i]~=1 then
        ObjSet( "spr_carpetmg_line_light_"..i, {alp=1} ); private.carpetmg_lines_array[i]=1; --ObjSet( "spr_carpetmg_line_light_"..j, {alp=1} );   
      end;
    else 
      if  private.carpetmg_lines_array[i]~=0 then 
        ObjSet( "spr_carpetmg_line_light_"..i, {alp=0} );  private.carpetmg_lines_array[i]=0;
      end;  
    end;  
  end; 
end;  
 
 
 
function private.carpetmg_lines_stand()
  local cur_x, cur_y = 0,0;
  local cur_ang=0;
  local next_point=0;
  local cur_lenght = 0;
  local cur_scale=0;
  local line_lenght=292;
  for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
    if i~=#private.carpetmg_lvl1_parts_pos then next_point=i+1; else next_point=1; end;
    local f_obj = ObjGet("spr_carpetmg_point_"..i);
    local n_obj = ObjGet("spr_carpetmg_point_"..next_point);
    
    cur_x= 0.5*(f_obj.pos_x + n_obj.pos_x);
    cur_y= 0.5*(f_obj.pos_y + n_obj.pos_y);
    cur_ang = math.atan((n_obj.pos_y-f_obj.pos_y)/(n_obj.pos_x-f_obj.pos_x))+0.5*math.pi;
    
    cur_lenght = math.pow((math.pow(f_obj.pos_x - n_obj.pos_x,2)+math.pow(f_obj.pos_y - n_obj.pos_y,2)),0.5);
    cur_scale=cur_lenght/line_lenght;
    
    ObjSet( "spr_carpetmg_line_"..i, {pos_x=cur_x, pos_y=cur_y, ang = -cur_ang, scale_y=cur_scale} );
  end;  
  
  ---------------------------- line light
 -- private.carpetmg_lines_light();

end;  

----------------------------- position drag funcs --
function public.carpetmg_point_drag_start(num)
  ObjStartDrag("obj_carpetmg_drag_point_"..num);
  ObjSet( "spr_carpetmg_point_"..num.."_light", {alp=1} );
end;  

function public.carpetmg_point_start_drag(num)
  ld.SetCursor(CURSOR_HAND);
  ObjSet( "spr_carpetmg_point_"..num, {pos_z=30});
  private.carpet_point_drag_flag=1;
  SoundSfx( "aud_mg_carpetmg_get" );
end;

private.carpet_point_drag_flag=0;
private.carpetmg_point_last_pos={0,0};
function public.carpetmg_point_drag(num)
   
   local cursor = GetZoomCursorPos(); 
   local ver_coord = {100,554};
   local hor_coord = {276,751};
   
 --  if ApplyObj("obj_carpetmg_drag_point_"..num,"spr_carpetmg_tr_c") then 
   if cursor[1]>hor_coord[1] and cursor[1]<hor_coord[2] and cursor[2]>ver_coord[1] and cursor[2]<ver_coord[2] then
       ObjSet( "spr_carpetmg_point_"..num, {pos_x=cursor[1], pos_y=cursor[2]} );
       gm.state[1][num] = ld.TableCopy(cursor)
       private.carpetmg_lines_stand();
       private.carpetmg_point_last_pos = ld.TableCopy(cursor);
   else
       if private.carpet_point_drag_flag==1 then 
          private.carpet_point_drag_flag=0;
          -- ObjSet( "spr_carpetmg_point_"..num, {pos_x=private.carpetmg_point_last_pos[1], pos_y=private.carpetmg_point_last_pos[2]} );
          if cursor[1]<=hor_coord[1] then ObjSet( "spr_carpetmg_point_"..num, {pos_x=hor_coord[1]+1} ); end;
          if cursor[1]>=hor_coord[2] then ObjSet( "spr_carpetmg_point_"..num, {pos_x=hor_coord[2]-1} ); end;  
          if cursor[2]<=ver_coord[1] then ObjSet( "spr_carpetmg_point_"..num, {pos_y=ver_coord[1]+1} ); end;
          if cursor[2]>=ver_coord[2] then ObjSet( "spr_carpetmg_point_"..num, {pos_y=ver_coord[2]-1} ); end;  
          
          ObjStopDrag("obj_carpetmg_drag_point_"..num)
       end;
   end;
end;  


function public.carpet_point_drop(num)
--  ld.LogTrace( "drop" );
  private.carpet_point_drag_flag=0;
  ld.SetCursor(CURSOR_DEFAULT);
  private.carpetmg_stand_on_pos();
  ObjSet( "spr_carpetmg_point_"..num, {pos_z=3});
  ObjSet( "spr_carpetmg_point_"..num.."_light", {alp=0} );
  SoundSfx( "aud_mg_carpetmg_set" );
end;

private.carpetmg_lvl1_win_ver_work_flag=0;
function private.carpetmg_lvl1_win_ver()
  -- if win -----
  local func_end = function()
  --  ld.LogTrace( "first_lvl win" );
    
    ObjSet("obj_carpetmg_lvl1_root",{active=0, input=0, visible=0});
    ld.Lock(0);
    gm.state[3]=2;  
    private.carpetmg_stand_on_pos();
  end;  
  ---------------  
  if private.carpetmg_lvl1_win_ver_work_flag==0 then 
     private.carpetmg_lvl1_win_ver_work_flag=1;
       
     local count=0;
     
   -- for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
   --   ObjSet( "spr_carpetmg_line_light_"..i, {alp=0} );
   -- end;  
     
     for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
       for j=1,#private.carpetmg_lvl1_parts_pos,1 do 
         if i~=j then
           if private.carpet_search_lines_per(i,j) then  count=count+1; --ld.LogTrace( "otr "..i.." per otr "..j );
           end; 
         end;
       end;
     end;  
     
     --  ld.LogTrace( " lines count = "..count );
     if count==0 then 
        ld.Lock(1);
        ObjAnimate( "obj_carpetmg_lvl1_root", 8, 0, 0, func_end, {0,0,1, 1,0,1, 1.5,0,0} );
        for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
          local cur_alp=ObjGet("spr_carpetmg_point_"..i.."_light").alp;
          ObjAnimate( "spr_carpetmg_point_"..i.."_light", 8, 0, 0, function() end, {0,0,cur_alp, 0.5,0,1, 1,0,0} );
          ObjAnimate( "spr_carpetmg_line_light_"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );  
        end;  
        SoundSfx( "aud_mg_carpetmg_win" );  
     else     
       private.carpetmg_lvl1_win_ver_work_flag=0;    
     end;
     
  end;   
end;  

------------------------------------------------------
function private.carpet_search_lines_per(l1,l2)
 -- if math.abs(l1-l2)==1 or  math.abs(l1-l2)==14 then return false end;
  
  
  local x1 = ObjGet("spr_carpetmg_point_"..l1).pos_x;
  local x2=0;
  local y1 = ObjGet("spr_carpetmg_point_"..l1).pos_y;
  local y2=0;
  if l1~=#private.carpetmg_lvl1_parts_pos then
     x2 = ObjGet("spr_carpetmg_point_"..(l1+1)).pos_x;
     y2 = ObjGet("spr_carpetmg_point_"..(l1+1)).pos_y;
  else   
     x2 = ObjGet("spr_carpetmg_point_1").pos_x;
     y2 = ObjGet("spr_carpetmg_point_1").pos_y;
  end; 
   
  local x3 = ObjGet("spr_carpetmg_point_"..l2).pos_x;
  local x4=0;
  local y3 = ObjGet("spr_carpetmg_point_"..l2).pos_y;
  local y4=0;
  if l2~=#private.carpetmg_lvl1_parts_pos then
     x4 = ObjGet("spr_carpetmg_point_"..(l2+1)).pos_x;
     y4 = ObjGet("spr_carpetmg_point_"..(l2+1)).pos_y;
  else   
     x4 = ObjGet("spr_carpetmg_point_1").pos_x;
     y4 = ObjGet("spr_carpetmg_point_1").pos_y;
  end;  
   
  local ua = ((x4-x3)*(y1-y3)-(y4-y3)*(x1-x3))/((y4-y3)*(x2-x1)-(x4-x3)*(y2-y1));
  local ub = ((x2-x1)*(y1-y3)-(y2-y1)*(x1-x3))/((y4-y3)*(x2-x1)-(x4-x3)*(y2-y1));
  
  if ua>=0 and ua<=1 and ub>=0 and ub<=1 then 
     local per_coor = {x1+ua*(x2-x1),y1+ua*(y2-y1)}
     if (per_coor[1]==x1 and per_coor[2]==y1) or (per_coor[1]==x2 and per_coor[2]==y2) or (per_coor[1]==x3 and per_coor[2]==y3) or (per_coor[1]==x4 and per_coor[2]==y4) then 
       return false;
     else 
       return true;
     end;  
  else return false end; 
end;  


------------------------------------------------------ 
local carpet_win_flag_for_drop=false;
local carpet_win_flag_for_drop_pos={};
 
local carpet_win_anim_flag = false;
function private.carpetmg_win_ver()
  if gm.state[2]>19 and carpet_win_anim_flag == false then carpet_win_anim_flag=1; ld.StartTimer( 0.5, function()  private.Win(); end); else ld.Lock(0); end;
end;  

 
------------------------------- mouse on point ------------------------- 
function public.carpetmg_point_menter(num)
 -- local func_end = function() 
 --   ld.Lock(0);
 -- end;
 -- 
 -- ld.Lock(1);
  if  gm.state[2]==num then 
    ObjSet( "spr_carpetmg_lig"..num, {alp=1, color_r=0, color_g=0, color_b=1} );
  else 
    ObjSet( "spr_carpetmg_lig"..num, {alp=1, color_r=1, color_g=0, color_b=0} );
  end;      
        
end;  

function public.carpetmg_point_mleave(num)
   ObjSet( "spr_carpetmg_lig"..num, {alp=0});
end;  

--------------------------------------------------------------------------
function public.carpetmg_needle_start_drag()
  ld.SetCursor(CURSOR_HAND);
  ObjSet( "spr_carpetmg_sh_needle", {visible=1} );
  ObjSet( "spr_carpetmg_sh_needle1", {visible = 0} );
  ObjSet( "spr_carpetmg_needle", {ang=0} );
  SoundSfx( "aud_mg_carpetmg_needle" );
end;  

function public.carpet_needle_drag()
  for i=1,#private.carpetmg_points_pos_array,1 do 
    if ApplyObj("obj_carpetmg_needle_zone","obj_carpetmg_a"..i) then public.carpetmg_point_menter(i); else public.carpetmg_point_mleave(i);  end;
  end;  
  if ApplyObj("obj_carpetmg_needle_zone","obj_carpetmp_pole_part1") or ApplyObj("obj_carpetmg_needle_zone","obj_carpetmp_pole_part2") then  ObjSet( "spr_carpetmg_sh_needle", {visible=1} ); else  ObjSet( "spr_carpetmg_sh_needle", {visible=0} ); end;
end;

function public.carpet_needle_dragdrop()
  local flag=false;
  for i=1,#private.carpetmg_points_pos_array,1 do 
    if ApplyObj("obj_carpetmg_needle_zone","obj_carpetmg_a"..i) then  ld.Lock(1); if gm.state[2]<19 then --ObjDoNotDrop("spr_carpetmg_needle");
    flag=true;else flag=false; end; public.carpetmg_point_mdown(i); break;end;
  end; 
  
  --  if flag==true then ld.LogTrace( "flag = true" ); else ld.LogTrace( "flag=false" ); end;
  
  if flag==false then 
    --  ld.LogTrace( "dragdrop" );
    
     local func_end = function()
       if gm.state[2]<=19 then  ld.Lock(0); end;
         ObjSet( "spr_carpetmg_sh_needle", {visible=0} );
         ObjSet( "spr_carpetmg_sh_needle1", {visible = 1} );
         ObjSet( "spr_carpetmg_needle", {ang=0.4} );
         ld.SetCursor(CURSOR_DEFAULT);
         SoundSfx( "aud_mg_carpetmg_put" );
     end;
       
     local pos = GetObjPosByObj("spr_carpetmg_needle");  
    --if carpet_win_flag_for_drop==true then ld.LogTrace( "new_pos" ); pos = ld.TableCopy(carpet_win_flag_for_drop_pos); end;
    --  ld.LogTrace( "pos = "..pos[1].." "..pos[2] );
     ld.Lock(1);
     ObjAnimate( "spr_carpetmg_needle", 3, 0, 0, func_end, {0,0,pos[1],pos[2], 0.2,0,231,661} );
     ObjAnimate( "spr_carpetmg_needle", 7, 0, 0, function() end, {0,0,0, 0.2,0,0.4} );
     if gm.state[2]>19 then  ObjSet( "spr_carpetmg_lig19", {visible=0, alp=0}); end;
  end; 
end;  


function public.carpetmg_point_mdown(num) 
  local func_end = function()
     private.carpetmg_stand_on_pos()
  end;
  
  if  gm.state[2]==num then 
     ld.Lock(1);
     ObjSet( "spr_carpetmg_a"..(num), {visible = 1, alp=0} );
     ObjAnimate( "spr_carpetmg_a"..(num), 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
     gm.state[2]=gm.state[2]+1;
     ng_global.progress["std"]["win_carpetmg"].state = gm.state;
     SoundSfx( "aud_mg_carpetmg_sew" );
  else 
     SoundSfx( "aud_mg_carpetmg_wrong" );
     ld.Lock(0);
  end;      
end;    
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_carpetmg"} ) then
    cmn.MiniGameShow( "carpetmg" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_bedroom_env" );
  iOS_NeedDrag(0);
  if not cmn.IsEventDone("win_carpetmg") then 
    private.carpetmg_parts_init()
    gm.load();
  end;
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_carpetmg"} ) then
    cmn.MiniGameHide( "carpetmg" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
  iOS_NeedDrag(1);
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local cur_lvl_roots={"obj_carpetmg_lvl1_root_for_anim","obj_carpetmg_lvl_2_parts_root"};
  
  local func_end = function()
      if gm.state[3]==1 then 
         private.carpetmg_lvl1_win_ver_work_flag=0;
         gm.state={};
         gm.state[3] = 1; 
         gm.state[2] = 1;
         gm.state[1]=ld.TableCopy(private.carpetmg_lvl1_parts_pos);  
      else 
         gm.state[2] = 1;
         gm.state[3] = 2;  
      end;  
         
      ng_global.progress["std"]["win_carpetmg"].state = gm.state;
      private.carpetmg_stand_on_pos();  
      ObjAnimate( cur_lvl_roots[gm.state[3] ], 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0,1} );
  end;

--  ld.LogTrace( "gm.state[3] = "..gm.state[3] );    
      
  ld.Lock(1);
  
  ObjAnimate( cur_lvl_roots[gm.state[3] ], 8, 0, 0, func_end, {0,0,1, 0.5,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function()
      private.Win();  
  end;
  
  local func_preend = function()
      for i=1,19,1 do
        ObjSet( "spr_carpetmg_a"..i, {visible = 1} ); 
        local my_alp=ObjGet("spr_carpetmg_a"..i).alp
        ObjAnimate( "spr_carpetmg_a"..i, 8, 0, 0, function() end, {0,0,my_alp, 0.5,0,1} );
      end; 
      ld.StartTimer( 0.5, func_end )
  end;
    
  ld.Lock(1);
  if gm.state[3]==1 then 
     ObjAnimate( "obj_carpetmg_lvl1_root", 8, 0, 0, function()  end, {0,0,1, 1,0,1, 1.5,0,0} );
     for i=1,#private.carpetmg_lvl1_parts_pos,1 do 
          local cur_alp=ObjGet("spr_carpetmg_point_"..i.."_light").alp;
          ObjAnimate( "spr_carpetmg_point_"..i.."_light", 8, 0, 0, function() end, {0,0,cur_alp, 0.5,0,1, 1,0,0} );
          ObjAnimate( "spr_carpetmg_line_light_"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );  
     end; 
     ld.StartTimer( 1.8, func_preend )     
  else 
    func_preend();
  end;  
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_carpetmg" );
  cmn.CallEventHandler( "win_carpetmg" );
  --cmn.GotoRoom( "rm_bedroom" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  ObjAnimate( "spr_carpetmg_needle", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ObjAnimate( "spr_carpetmg_sh_needle1", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ld.StartTimer( 0.5, function()
     SoundSfx( "aud_mg_carpetmg_win2" );
     ObjSet( "obj_carpetmg_lvl_2_parts_root", {visible=0, input=0} );
     ld.AnimPlay( "anm_carpetmg_anm_carpetmg", "idle", function() private.WinEnd(); end )
  end);
  
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  -- if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_carpetmg"].state then
      gm.state = ng_global.progress["std"]["win_carpetmg"].state
    else
      private.carpetmg_lvl1_win_ver_work_flag=0;
      gm.state={};
      gm.state[1]=ld.TableCopy(private.carpetmg_lvl1_parts_pos);
      gm.state[2] = 1;
      gm.state[3] = 1;    
      ng_global.progress["std"]["win_carpetmg"].state = gm.state;
    end
  
  --    gm.loaded  = true;
  --else
  
  private.carpetmg_stand_on_pos();  
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_carpetmg"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;