-- name=mg_clockmg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_clockmg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_clockmg" ] = {type = "win", use_place = "mg_clockmg", room = "rm_hall", zz = "mg_clockmg", zz_gate = "gmg_hall_clockmg" };

  local win_clockmg_logic = function()
    if ld.CheckRequirements( {"win_clockmg"} ) then
      ObjSet( "spr_clockmg_grapes", {input = 1, visible = 1} );
      ObjDelete("obj_clockmg_clk_win");
    end
  end;
  local win_clockmg = function()
    if ld.CheckRequirements( {"win_clockmg"} ) then
      ObjDelete("obj_clockmg_parts_root");
      ObjSet( "anm_clockmg_anm_clock", {animfunc = "open", frame = 999 } );
    end
  end;
  cmn.AddSubscriber("win_clockmg", win_clockmg, private.room_objname )
  cmn.AddSubscriber("win_clockmg", win_clockmg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_grapes" ] = { type = "get", get_obj = "spr_clockmg_grapes", room = "rm_hall", zz = "mg_clockmg", zz_gate = "gmg_hall_clockmg" };

private.get_grapes_logic = function()
  
end;
private.get_grapes_inv = function()
  interface.InventoryItemAdd("inv_grapes","spr_clockmg_grapes");
end;
private.get_grapes_beg = function()
  ObjDelete("gfx_clockmg_grapes")
end;
private.get_grapes_end = function()
  ObjDelete("spr_clockmg_sh_grapes");
end;

cmn.AddSubscriber( "get_grapes", private.get_grapes_inv );
cmn.AddSubscriber( "get_grapes", private.get_grapes_beg, private.room_objname );
cmn.AddSubscriber( "get_grapes", private.get_grapes_end, private.room_objname );
cmn.AddSubscriber( "get_grapes", private.get_grapes_logic );
--------------------------------------------------------------------
function public.get_grapes()
  cmn.SetEventDone( "get_grapes" );
  cmn.CallEventHandler( "get_grapes" );
  cmn.GotoRoom( "rm_hall" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_clockmg"} ) then
    cmn.MiniGameShow( "clockmg" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_hall_env" )
  if not cmn.IsEventDone("win_clockmg") then 
    private.clockmg_parts_init();
    gm.load();
 end;
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_clockmg"} ) then
    cmn.MiniGameHide( "clockmg" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
   private.clockmg_reset();
end;
--*********************************************************************************************************************
function public.Skip()
   private.clockmg_skip();
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_clockmg" );
  cmn.CallEventHandler( "win_clockmg" );
  --cmn.GotoRoom( "rm_hall" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  local func_end = function()
    private.WinEnd()
  end;
  
  
  ld.Lock(1);
  cmn.MiniGameHide(true);
  for i=1,12,1 do 
    ObjAnimate( "spr_clockmg_a"..i.."light", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  end;  
  ld.StartTimer( 0.5, function()  SoundSfx( "aud_mg_clock_win" ) end )  
  ld.StartTimer( 1, function()
     ObjSet( "anm_clockmg_anm_clock", {animfunc = "open", frame = 0 } );
     ObjSet( "obj_clockmg_parts_root", {visible=0, input=0} );
     ld.AnimPlay( "anm_clockmg_anm_clock", "open", func_end )
  end );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
local clockmg_parts_coord_array={{621,165},{708,251},{738,370},{707,486},{621,572},{504,604},{387,573},{301,487},{269,369},{301,252},{387,166},{505,134},{504,369}};
public.clockmg_parts_fp_array={9,4,12,6,8,10,1,11,3,5,7,2,0}
local clockmg_select_part=0;


function public.clockmg_show_array()
  local my_str="";
   for i=#clockmg_parts_coord_array,1,-1 do 
      my_str = my_str.. "{"..clockmg_parts_coord_array[i][1]..","..clockmg_parts_coord_array[i][2].."},";
   end;  
    -- ld.LogTrace( my_str );  
end;  

-------------------------------------------------------------------
function private.clockmg_return_pos_on_array(num, array)
  if array then 
    for i=1,#array,1 do 
      if num==array[i] then return i; end;
    end;  
 --   ld.LogTrace( "clockmg_return_pos_on_array return = "..0 );
    return 0;
  else  
 --   ld.LogTrace( "clockmg_return_pos_on_array return = "..0 ); 
    return 0;
  end;     
end;  
-------------------------------------------------------------------
private.clockmg_parts_init_flag=false;
function private.clockmg_parts_init()
  if private.clockmg_parts_init_flag==false then 
      for i=1,12,1 do  
         ObjCreate("spr_clockmg_a"..i,"spr");
         ObjAttach("spr_clockmg_a"..i,"obj_clockmg_parts_root");
         ObjSet("spr_clockmg_a"..i, {active=1, input=1, visible=1, pos_x=clockmg_parts_coord_array[private.clockmg_return_pos_on_array(i, public.clockmg_parts_fp_array)][1], pos_y=clockmg_parts_coord_array[private.clockmg_return_pos_on_array(i, public.clockmg_parts_fp_array)][2], res="assets/levels/level/mg_clockmg/a"..i,
         event_mdown="mg_clockmg.clockmg_part_mdown("..i..");", event_menter="mg_clockmg.clockmg_part_menter("..i..");", event_mleave="mg_clockmg.clockmg_part_mleave("..i..");"} );
         ObjCreate("spr_clockmg_a"..i.."light","spr");
         ObjAttach("spr_clockmg_a"..i.."light","spr_clockmg_a"..i);
         ObjSet("spr_clockmg_a"..i.."light", {active=1, input=0, visible=1,alp=0, res="assets/levels/level/mg_clockmg/lig"} );
      end;
       private.clockmg_parts_init_flag=true; 
  end; 
end;
-------------------------------------------------------------------
-------------------------for sounds ------------------------------
local mg_clockmg_true_parts_count=0;
local clockmg_true_parts_counter_first_start=0; 

function private.clockmg_true_parts_counter()
   local current_count = 0;
   for i=1,12,1 do  
     if gm.state[i]==i then current_count=current_count+1; end;
   end;  
   if clockmg_true_parts_counter_first_start==1 and mg_clockmg_true_parts_count<current_count then SoundSfx( "aud_mg_clock_true" ); end;
   mg_clockmg_true_parts_count = current_count;
   clockmg_true_parts_counter_first_start=1;
end;  
--------------------------------------------------------------------
function private.clockmg_stand_on_pos(without_win_ver)
   ng_global.progress["std"]["win_clockmg"].state = gm.state;
 -- ld.LogTrace( "clockmg_stand_on_pos" );
   for i=1,12,1 do 
      ObjSet( "spr_clockmg_a"..i, {pos_x=clockmg_parts_coord_array[private.clockmg_return_pos_on_array(i, gm.state)][1], pos_y=clockmg_parts_coord_array[private.clockmg_return_pos_on_array(i, gm.state)][2]} );
      if gm.state[i]==i then
         --if clockmg_select_part~=i then  
            ObjSet( "spr_clockmg_a"..i.."light", {alp=1, color_r=0, color_g=1, color_b=0} );
         --end;
      else 
         local next_alp=0;
       --  if clockmg_select_part==i then next_alp=1; end;
         ObjSet( "spr_clockmg_a"..i.."light", {alp=next_alp, color_r=1, color_g=1, color_b=0} );
      end; 
   end;  
   if without_win_ver~=1 then   
       private.clockmg_true_parts_counter();
       local win_flag=private.clockmg_win_ver();
       if win_flag==true then private.Win(); end;  
   end;
end;

-------------------------------------------------------------------   
function private.clockmg_win_ver()
  local count=0;
  for i=1,12,1 do 
    if gm.state[i]==i then count=count+1; end; 
  end;  
  
  if count==12 then return true; else return false; end;
end;  
-------------------------------------------------------------------
function private.clockmg_skip()

  local func_step1 = function()
     gm.state = {1,2,3,4,5,6,7,8,9,10,11,12,0};
     private.clockmg_stand_on_pos(1); 
     ObjAnimate( "obj_clockmg_parts_root", 8, 0, 0, function() private.Win(); end, {0,0,0, 0.25,0,1, 0.5,0,1} );  
  end;
  
  clockmg_select_part=0;
  ld.Lock(1);
  ObjAnimate( "obj_clockmg_parts_root", 8, 0, 0, func_step1, {0,0,1, 0.25,0,0} );  
end;  
-------------------------------------------------------------------
function private.clockmg_reset()

  local func_step1 = function()
     gm.state = ld.TableCopy(public.clockmg_parts_fp_array);
     private.clockmg_stand_on_pos(); 
     ObjAnimate( "obj_clockmg_parts_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );  
  end;
  
  clockmg_select_part=0;
  ld.Lock(1);
  ObjAnimate( "obj_clockmg_parts_root", 8, 0, 0, func_step1, {0,0,1, 0.25,0,0} );  
end;  
-------------------------------------------------------------------
function private.clockmg_search_empty_pos(num)
  local my_empty=0;
  local my_num = private.clockmg_return_pos_on_array(num, gm.state)
  
  for i=1,#gm.state,1 do 
    if  gm.state[i]==0 then my_empty=i; break; end;
  end;
  
 if my_empty~=0 then 
    if my_num==13 or my_empty==13 then return my_empty; end;
    if my_num==12 and (my_empty==11 or my_empty==1) then return my_empty end;
    if my_num==1 and my_empty==12 then return my_empty; end;
    if math.abs(my_num-my_empty)==1 then return my_empty; end;
  end;  
  return 0;
end;  
-------------------------------------------------------------------
--local clockmg_buf_obj_copy={};

local clockmg_dont_leave_flag=false;

function public.clockmg_part_menter(num)
--   clockmg_select_part=0;
-- -- if clockmg_dont_leave_flag==false then 
-- --  ld.LogTrace( "menter" );
--   local obj = ObjGet("spr_clockmg_a"..num.."light");
--    -- local obj_copy = ld.TableCopy(obj);
--    --  clockmg_buf_obj_copy=obj_copy;
--    --  ObjAnimate( obj.name, 8, 0, 0, function() end, {0,0,obj.alp, 0.05,0,1} );
--    -- ObjAnimate( obj.name, 12, 0, 0, function() end, {0,0,obj.color_r,obj.color_g,obj.color_b, 0.05,0,1,1,0} );
--  --  ObjSet( obj.name, {alp=1, color_r=1, color_g=1, color_b=0} );
    ld.SetCursor(CURSOR_HAND);
    -- end;
--    ---------------------- for other lights
--  --  for i=1,12,1 do 
--  --     local obj_copy = {};
--  --     if i~=num then
--  --        local first_alp = ObjGet("spr_clockmg_a"..i.."light").alp;
--  --        if private.clockmg_return_pos_on_array(i,gm.state) == i then 
--  --          obj_copy.alp=1;
--  --          obj_copy.color_r=0; obj_copy.color_g=1; obj_copy.color_b=0; 
--  --        else  
--  --          obj_copy.alp=0;
--  --          obj_copy.color_r=1; obj_copy.color_g=1; obj_copy.color_b=1; 
--  --        end;  
--  --        
--  --        ObjAnimate( "spr_clockmg_a"..i.."light", 8, 0, 0, function()  end, {0,0,first_alp, 0.05,0,obj_copy.alp} );
--  --     end;
--  --  end;  
end;

function public.clockmg_part_mleave(num)
--  if clockmg_dont_leave_flag==false then 
--    local obj = ObjGet("spr_clockmg_a"..num.."light");
--    local obj_copy = {};
--    if private.clockmg_return_pos_on_array(num,gm.state) == num then 
--      obj_copy.alp=1;
--      obj_copy.color_r=0; obj_copy.color_g=1; obj_copy.color_b=0; 
--    else  
--      obj_copy.alp=0;
--      obj_copy.color_r=1; obj_copy.color_g=1; obj_copy.color_b=1; 
--    end;  
--    --  ObjAnimate( obj.name, 8, 0, 0, function() clockmg_buf_obj_copy={}; end, {0,0,1, 0.05,0,obj_copy.alp} );
--    -- ObjAnimate( obj.name, 12, 0, 0, "", {0,0,1,1,0, 0.05,0,obj_copy.color_r,obj_copy.color_g,obj_copy.color_b} );
--    ObjSet( obj.name, {alp=obj_copy.alp, color_r=obj_copy.color_r, color_g=obj_copy.color_g, color_b=obj_copy.color_b} );
    ld.SetCursor(CURSOR_DEFAULT);
--    clockmg_select_part=0;
--   end;
  end;  
-------------------------------------------------------------------

function public.clockmg_part_mdown(num)
  local func_end = function()
    ld.Lock(0);
    private.clockmg_stand_on_pos();
    clockmg_dont_leave_flag=false;
  end;
  
  
  ld.Lock(1);
  clockmg_select_part = num;
  clockmg_dont_leave_flag=true;
  local new_pos_num = private.clockmg_search_empty_pos(num);
  
  if new_pos_num==0 then 
    SoundSfx( "aud_mg_clock_wrong" );
    ObjAnimate( "spr_clockmg_a"..num.."light", 8, 0, 0, function() end, {0,0,0, 0.2,0,1, 0.4,0,1, 0.5,0,0} );
    ObjSet( "spr_clockmg_a"..num.."light", {color_r=1, color_g=0, color_b=0} );
  --  ObjAnimate("spr_clockmg_a"..num.."light", 12, 0, 0, "", {0,0,1,1,0, 0.2,0,1,0,0, 0.4,0,1,1,0, 0.5,0,1,1,0} );
  --   ld.StartTimer( 0.5,function() ld.Lock(0); clockmg_dont_leave_flag=false; end )
     ld.StartTimer( 0.5,func_end )
  else 
     local cur_pos = {clockmg_parts_coord_array[private.clockmg_return_pos_on_array(num,gm.state)][1],clockmg_parts_coord_array[private.clockmg_return_pos_on_array(num,gm.state)][2]}
     local new_pos = {clockmg_parts_coord_array[new_pos_num][1],clockmg_parts_coord_array[new_pos_num][2]};
     local cur_pos_num = private.clockmg_return_pos_on_array(num,gm.state);
     local anm_time = 0.3;
     if new_pos_num == 13 or cur_pos_num==13 then
        anm_time = 0.5;
        SoundSfx( "aud_mg_clock_move_long" )
     else 
        SoundSfx( "aud_mg_clock_move_short" )
     end;
     gm.state[new_pos_num]=gm.state[cur_pos_num];
     gm.state[cur_pos_num]=0;
     ObjAnimate( "spr_clockmg_a"..num, 3, 0, 0, func_end, {0,0,cur_pos[1],cur_pos[2], anm_time,0,new_pos[1],new_pos[2]} );
     ObjSet( "spr_clockmg_a"..num.."light", {alp=1, color_r=1, color_g=1, color_b=0} );
     --ObjAnimate( "spr_clockmg_a"..num.."light", 8, 0, 0, function() end, {0,0,0, 0.1,0,1} );
  end;  
end;  


-------------------------------------------------------------------
function gm.load()
  public.clockmg_show_array();
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_clockmg"].state then
      gm.state = ng_global.progress["std"]["win_clockmg"].state 
      ng_global.progress["std"]["win_clockmg"].state = gm.state;
    else
      gm.state = ld.TableCopy(public.clockmg_parts_fp_array);
      ng_global.progress["std"]["win_clockmg"].state = gm.state;
    end
  
    private.clockmg_stand_on_pos();
    
    
    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_clockmg"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;