-- name=mg_fencepuzzle
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_fencepuzzle";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_fencepuzzle" ] = {type = "win", use_place = "mg_fencepuzzle", room = "rm_farm", zz = "mg_fencepuzzle", zz_gate = "gmg_farm_fencepuzzle" };

  local win_fencepuzzle_logic = function()
    if ld.CheckRequirements( {"win_fencepuzzle"} ) then
      ObjSet( "grm_farm_pond", {input = 1, visible = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_farm_pond_focus");
      end;
    end
  end;
  local win_fencepuzzle = function()
    if ld.CheckRequirements( {"win_fencepuzzle"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_fencepuzzle", win_fencepuzzle, private.room_objname )
  cmn.AddSubscriber("win_fencepuzzle", win_fencepuzzle_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
-----------------------------------------------------------------------------------------------------------------------
local fencepuzzle_loaded=0;

function private.fencepuzzle_parts_init() -- on load
  if fencepuzzle_loaded==0 then 
     for i=1,19,1 do  -- select part light
       ObjCreate("spr_fencepuzzle_lig_"..i, "spr");
       ObjAttach("spr_fencepuzzle_lig_"..i,"spr_fencepuzzle_c"..i)
       ObjSet("spr_fencepuzzle_lig_"..i,{input=0, visible=1, alp=0, res="assets/levels/level/mg_fencepuzzle/lig"}) --green
       ObjCreate("spr_fencepuzzle_lig1_"..i, "spr");
       ObjAttach("spr_fencepuzzle_lig1_"..i,"spr_fencepuzzle_c"..i)
       ObjSet("spr_fencepuzzle_lig1_"..i,{input=0, visible=1, alp=0, res="assets/levels/level/mg_fencepuzzle/lig1"}) --red
       ObjCreate("spr_fencepuzzle_lig2_"..i, "spr");
       ObjAttach("spr_fencepuzzle_lig2_"..i,"spr_fencepuzzle_c"..i)
       ObjSet("spr_fencepuzzle_lig2_"..i,{input=0, visible=1, alp=0, res="assets/levels/level/mg_fencepuzzle/lig2"}) --blue
     end;
     private.fencepuzzle_get_true_parts_pos()
     fencepuzzle_loaded=1;
   end;   
end;  

-----------------------------------------------------------------------------------------------------------------------
local fencepuzzle_pos_array={}; --array of positions
local fencepuzzle_selected_part=0;

function private.fencepuzzle_get_true_parts_pos() --on load before stand on pos
   for i=1,19,1 do
     local buf_obj = ObjGet("spr_fencepuzzle_c"..i);
     fencepuzzle_pos_array[i]={buf_obj.pos_x, buf_obj.pos_y};
   end;   
end;  
-----------------------------------------------------------------------------------------------------------------------
local fencepuzzle_parts_first_pos_array={9,18,8,7,16,2,17,3,1,19,12,5,6,15,4,10,11,14,13}; --first pos array
local fencepuzzle_parts_first_ang = {};
local fencepuzzle_right_second_parts={};
for i=1,19,1 do 
  fencepuzzle_right_second_parts[i]=0; 
end;  


function private.fencepuzzle_stand_on_first_pos(with_anim)  -- stand parts on firts postition
    for i=1,19,1 do 
       --stand parts_on random angle
       fencepuzzle_parts_first_ang[i]=(math.random(0,5)*60)*math.pi/180;
       --stand parts on positon and set angle
       ObjSet("spr_fencepuzzle_lig_"..i,{alp=0});
       ObjSet("spr_fencepuzzle_lig1_"..i,{alp=0});
       ObjSet("spr_fencepuzzle_lig2_"..i,{alp=0});
    end;
    for i=1,19,1 do 
      fencepuzzle_right_second_parts[i]=0; 
    end;   
    
    if with_anim==1 then 
       -- after anim
       local func_end = function()
          for i=1,19,1 do 
             ObjSet("spr_fencepuzzle_c"..i,{pos_x=fencepuzzle_pos_array[fencepuzzle_parts_first_pos_array[i]][1], pos_y=fencepuzzle_pos_array[fencepuzzle_parts_first_pos_array[i]][2], ang=fencepuzzle_parts_first_ang[i],
             input=1, event_mdown="mg_fencepuzzle.fencepuzzle_part_mdown("..i..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"});
          end;
           ld.StartTimer( 0.5, function()  ld.Lock(0); end );
          ng_global.progress["std"]["win_fencepuzzle"].state={ld.TableCopy(fencepuzzle_parts_first_pos_array), ld.TableCopy(fencepuzzle_parts_first_ang)};
       end; 
       ---------------------------
      
       -- anim third stape
       local func_end2=function() 
         for i=1,19,1 do 
           ObjAnimate( "spr_fencepuzzle_c"..i, 3, 0, 0, function() end, {0,0,fencepuzzle_pos_array[i][1],fencepuzzle_pos_array[i][2], 0.5,0,fencepuzzle_pos_array[fencepuzzle_parts_first_pos_array[i]][1],fencepuzzle_pos_array[fencepuzzle_parts_first_pos_array[i]][2]} );
         end;
         ld.StartTimer( 0.5, func_end );  
       end;
       ----------------------------
       --anim second stape
       local func_end1 = function()
         local time={};
         for i=1,19,1 do
           time[i]=fencepuzzle_parts_first_ang[i]/(3*60*math.pi/180);
           ObjAnimate( "spr_fencepuzzle_c"..i, 7, 0, 0, function() end, {0,0,0, time[i],0,fencepuzzle_parts_first_ang[i]} );
         end;
         ld.StartTimer( 2, func_end2 )  
       end;
       ----------------------------
      
      
      
       ld.Lock(1);
       --anim first stape
       for i=1,19,1 do 
          ObjSet("spr_fencepuzzle_c"..i,{pos_x=fencepuzzle_pos_array[i][1], pos_y=fencepuzzle_pos_array[i][2], ang=0});
          ObjAnimate( "spr_fencepuzzle_lig1_"..i, 8, 0, 0, function() end, {0,0,0, 1.5,0,0, 2,0,1, 4.5,0,1, 5,0,0} );
       end;  
       ld.StartTimer( 2, func_end1 ); 
       SoundSfx( "aud_mg_fencepuzzle_begin" );
    else 
       for i=1,19,1 do 
           ObjSet("spr_fencepuzzle_c"..i,{pos_x=fencepuzzle_pos_array[fencepuzzle_parts_first_pos_array[i]][1], pos_y=fencepuzzle_pos_array[fencepuzzle_parts_first_pos_array[i]][2], ang=fencepuzzle_parts_first_ang[i],
           input=1, event_mdown="mg_fencepuzzle.fencepuzzle_part_mdown("..i..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"});
       end;
    end;  
    
end;  
-----------------------------------------------------------------------------------------------------------------------
local fencepuzzle_on_true_pos = {};
local fencepuzzle_on_true_pos_ready=0;

function private.fencepuzzle_parts_stand_on_pos(without_win_ver)
  if fencepuzzle_on_true_pos_ready==0 then 
    for i=1,19,1 do 
      fencepuzzle_on_true_pos[i]=0;
    end;  
  end;
  
  for i=1,19,1 do 
    ObjSet("spr_fencepuzzle_c"..i,{pos_x=fencepuzzle_pos_array[ng_global.progress["std"]["win_fencepuzzle"].state[1][i]][1], pos_y=fencepuzzle_pos_array[ng_global.progress["std"]["win_fencepuzzle"].state[1][i]][2],
            ang=ng_global.progress["std"]["win_fencepuzzle"].state[2][i]})
    if ng_global.progress["std"]["win_fencepuzzle"].state[1][i]==i and ng_global.progress["std"]["win_fencepuzzle"].state[2][i]==0 then
       ObjSet("spr_fencepuzzle_lig_"..i,{visible=1, alp=1, color_r=0.5, color_g=0.5, color_b=0.5});
       
       if fencepuzzle_on_true_pos_ready==1 then 
         if  fencepuzzle_on_true_pos[i]~=1 then 
            SoundSfx( "aud_mg_fencepuzzle_true" );
            fencepuzzle_on_true_pos[i]=1;
         end;  
       else 
         fencepuzzle_on_true_pos[i]=1;
       end;  
    else 
       ObjSet("spr_fencepuzzle_lig_"..i,{visible=1, alp=0, color_r=0.5, color_g=0.5, color_b=0.5});
       if fencepuzzle_selected_part==i then ObjSet("spr_fencepuzzle_lig2_"..i,{alp=1, color_r=1, color_g=1, color_b=1}); else ObjSet("spr_fencepuzzle_lig2_"..i,{alp=0,color_r=1, color_g=1, color_b=1}); end; 
    end;
    ObjSet("spr_fencepuzzle_lig1_"..i,{alp=0});
    -- if fencepuzzle_right_second_parts[i]==1 then  ObjSet("spr_fencepuzzle_lig2_"..i,{alp=1}); else ObjSet("spr_fencepuzzle_lig2_"..i,{alp=0}); end;
  end;
  if without_win_ver~=1 then private.fencepuzzle_win_ver(); end;
  
  fencepuzzle_on_true_pos_ready=1;
end;  
-----------------------------------------------------------------------------------------------------------------------
local fencepuzzle_huy_array = {{1,2,3},{4,5,6,7},{8,9,10,11,12},{13,14,15,16},{17,18,19}};

function private.fencepuzzle_get_pos_on_huy_array(pos)
  --  ld.LogTrace("Pos = "..pos);
  for i=1,5,1 do
    for j=1,#fencepuzzle_huy_array[i],1 do 
      if fencepuzzle_huy_array[i][j]==pos then return i,j end;
    end;  
  end;  
  
  return 0;
end;  

function private.fencepuzzle_return_part_by_pos(pos)
  for i=1,19,1 do 
     if ng_global.progress["std"]["win_fencepuzzle"].state[1][i]==pos then return i; end;    
  end;  
  return 0; 
end;  




function private.fencepuzzle_search_true_second_parts()
  for i=1,19,1 do 
     fencepuzzle_right_second_parts[i]=0; 
  end;
--  -- ld.LogTrace("fencepuzzle_selected_part = "..fencepuzzle_selected_part);
-- 
-- if fencepuzzle_selected_part~=0 then 
-- 
--    local sel_part_pos =  ng_global.progress["std"]["win_fencepuzzle"].state[1][fencepuzzle_selected_part];
--    local set_i1, set_j1 = private.fencepuzzle_get_pos_on_huy_array(sel_part_pos); 
--    --   ld.LogTrace("set_i1 = "..set_i1.."/ set_j1 = "..set_j1)
--   
--    for i1=1,5,1 do 
--      for j1=1,#fencepuzzle_huy_array[i1],1 do 
--         if math.abs(set_i1-i1)<=1 then -- proverka po riyadu
--            if  math.abs(set_i1-i1)==0 then   -- v odnom ryadu
--                if math.abs(set_j1-j1)==1 then 
--                  fencepuzzle_right_second_parts[private.fencepuzzle_return_part_by_pos(fencepuzzle_huy_array[i1][j1])]=1;
--                end;  
--            else 
--                if set_j1==j1 then 
--                   fencepuzzle_right_second_parts[private.fencepuzzle_return_part_by_pos(fencepuzzle_huy_array[i1][j1])]=1;
--                else 
--                   if (set_j1==j1+1  and #fencepuzzle_huy_array[set_i1]>#fencepuzzle_huy_array[i1])  or (set_j1==j1-1 and #fencepuzzle_huy_array[set_i1]<#fencepuzzle_huy_array[i1]) then 
--                     fencepuzzle_right_second_parts[private.fencepuzzle_return_part_by_pos(fencepuzzle_huy_array[i1][j1])]=1;
--                   end;  
--                end;  
--            end;  
--         end  
--       end;
--    end;  
--   
-- end; 
-- ------------------- delete lock parts 
-- for i=1,19,1 do 
--    if fencepuzzle_right_second_parts[i]==1 and ng_global.progress["std"]["win_fencepuzzle"].state[1][i]==i and ng_global.progress["std"]["win_fencepuzzle"].state[2][i]==0 then 
--       fencepuzzle_right_second_parts[i]=0;
--    end;  
-- end;
-- 
--       
end;  


-----------------------------------------------------------------------------------------------------------------------
function public.fencepuzzle_part_mdown(num)
   local func_end = function()
     ObjSet( "spr_fencepuzzle_c"..num, {pos_z=0} );
     ObjSet( "spr_fencepuzzle_c"..fencepuzzle_selected_part, {pos_z=0} );
     ObjSet( "spr_fencepuzzle_lig_"..num, {alp=0} );
     ObjSet( "spr_fencepuzzle_lig2_"..num, {alp=0} );
     for i=1,19,1 do 
        fencepuzzle_right_second_parts[i]=0; 
     end;
      --fencepuzzle_selected_part=0; 
     ld.Lock(0);
     --  private.fencepuzzle_search_true_second_parts()
     private.fencepuzzle_parts_stand_on_pos();
   end;
  
   SoundSfx( "aud_mg_fencepuzzle_hexagon_click" );
  
   if fencepuzzle_selected_part==0 then 
     fencepuzzle_selected_part=num;
     private.fencepuzzle_search_true_second_parts()
     private.fencepuzzle_parts_stand_on_pos();
   elseif fencepuzzle_selected_part==num then 
     fencepuzzle_selected_part=0;
     for i=1,19,1 do 
        fencepuzzle_right_second_parts[i]=0; 
     end;
     private.fencepuzzle_parts_stand_on_pos();
   else 
      SoundSfx( "aud_mg_fencepuzzle_hexagon_move" );
     ld.Lock(1);
     --  if fencepuzzle_right_second_parts[num]==1 then 
        ng_global.progress["std"]["win_fencepuzzle"].state[1][fencepuzzle_selected_part],ng_global.progress["std"]["win_fencepuzzle"].state[1][num] = ng_global.progress["std"]["win_fencepuzzle"].state[1][num],ng_global.progress["std"]["win_fencepuzzle"].state[1][fencepuzzle_selected_part];
        ObjSet( "spr_fencepuzzle_lig2_"..num, {alp=1} );
        -- ObjSet( "spr_fencepuzzle_lig_"..num, {alp=1} );
        ObjSet( "spr_fencepuzzle_c"..num, {pos_z=10} );
        ObjSet( "spr_fencepuzzle_c"..fencepuzzle_selected_part, {pos_z=10} );
        ObjAnimate("spr_fencepuzzle_c"..num, 3, 0, 0, function()  end , {0, 0, ObjGet("spr_fencepuzzle_c"..num).pos_x, ObjGet("spr_fencepuzzle_c"..num).pos_y,   0.5, 0 , fencepuzzle_pos_array[ng_global.progress["std"]["win_fencepuzzle"].state[1][num]][1],fencepuzzle_pos_array[ng_global.progress["std"]["win_fencepuzzle"].state[1][num]][2]});
        ObjAnimate("spr_fencepuzzle_c"..fencepuzzle_selected_part, 3, 0, 0, "" , {0, 0, ObjGet("spr_fencepuzzle_c"..fencepuzzle_selected_part).pos_x, ObjGet("spr_fencepuzzle_c"..fencepuzzle_selected_part).pos_y,   0.5, 0 , fencepuzzle_pos_array[ng_global.progress["std"]["win_fencepuzzle"].state[1][fencepuzzle_selected_part]][1],fencepuzzle_pos_array[ng_global.progress["std"]["win_fencepuzzle"].state[1][fencepuzzle_selected_part]][2]});
        ld.StartTimer( 0.7, func_end )
   -- else 
   --    ObjAnimate("spr_fencepuzzle_lig1_"..num, 8, 0, 0, " ", {0, 0, 0, 0.25,0,1, 0.5,0,0});
   --    ObjAnimate("spr_fencepuzzle_lig1_"..fencepuzzle_selected_part, 8, 0, 0, " ", {0, 0, 0, 0.25,0,1, 0.5,0,0});
   --    ld.StartTimer( 0.7, func_end )
   --  end;  
   end;  
end;  
----------------------------------------------------------------------------------------------------------------------

function public.fencepuzzle_rotate_selected_part()
  local func_end = function()
    private.fencepuzzle_parts_stand_on_pos();
  end;
  
  local func_preend = function()
    new_ang = math.fmod(ng_global.progress["std"]["win_fencepuzzle"].state[2][fencepuzzle_selected_part] - (60/180-4)*math.pi ,2*math.pi);
    --if new_ang==2*math.pi then new_ang=0; end;
    if math.floor(new_ang)==0 or math.floor(new_ang)==6 then new_ang=0; end;
    ng_global.progress["std"]["win_fencepuzzle"].state[2][fencepuzzle_selected_part] = new_ang;
    ObjSet("spr_fencepuzzle_c"..fencepuzzle_selected_part,{ang = new_ang});
    func_end();
  end;
  
  SoundSfx( "aud_mg_fencepuzzle_button_click" );
  
  ld.Lock(1);
  local tr_ang = - 45*math.pi/180;
  local new_ang=0;
  ObjAnimate("spr_fencepuzzle_tr", 7, 0, 0, " ", {0, 0, 0,  0.25,0,tr_ang, 0.5,0,0 });
  ObjAnimate( "spr_fencepuzzle_tr1", 8, 0, 0, function() end, {0,0,0, 0.1,0,1, 0.4,0,1, 0.5,0,0} );
  if fencepuzzle_selected_part~=0 then 
     SoundSfx( "aud_mg_fencepuzzle_hexagon_rotate" );
     ObjAnimate("spr_fencepuzzle_c"..fencepuzzle_selected_part, 7, 0, 0, func_preend, {0, 0, ObjGet("spr_fencepuzzle_c"..fencepuzzle_selected_part).ang,  0.25,0,ObjGet("spr_fencepuzzle_c"..fencepuzzle_selected_part).ang-60*math.pi/180 });
  else 
     ld.StartTimer( 0.5, func_end);
  end;  
end;  
-----------------------------------------------------------------------------------------------------------------------
function private.fencepuzzle_win_ver()
  --  ld.LogTrace("win ver");
  local count=0;
  for i=1,19,1 do 
     --  ld.LogTrace("ang["..i.."] = "..ng_global.progress["std"]["win_fencepuzzle"].state[2][i].." pos = "..ng_global.progress["std"]["win_fencepuzzle"].state[1][i])
       if ng_global.progress["std"]["win_fencepuzzle"].state[1][i]==i and ng_global.progress["std"]["win_fencepuzzle"].state[2][i]==0 then 
          ObjSet( "spr_fencepuzzle_c"..i, {input = 0} );
          count=count+1; 
          if fencepuzzle_selected_part==i then 
              ObjSet( "spr_fencepuzzle_lig2_"..i, {alp=0} );
              for j=1,19,1 do 
                fencepuzzle_right_second_parts[j]=0; 
              end;
              fencepuzzle_selected_part=0; 
          end;
          private.fencepuzzle_parts_stand_on_pos(1);
      --    ld.LogTrace("sovp i="..i.." on pos = "..ng_global.progress["std"]["win_fencepuzzle"].state[1][i]);
          
       else
          ObjSet( "spr_fencepuzzle_c"..i, {input = 1} ); 
       end;  
   end;
   if count==19 then ObjSet( "spr_fencepuzzle_tr", {input = 0} ); private.Win(); else ld.Lock(0);  end;   
end;  

-----------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Open()
-- if not ld.CheckRequirements( {"win_fencepuzzle"} ) then
--   cmn.MiniGameShow( "fencepuzzle" );
-- end
  level.tutorial_mg.first() 
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_farm_env" );
  gm.load();
  if not ld.CheckRequirements( {"win_fencepuzzle"} ) then
    cmn.MiniGameShow( "fencepuzzle" );
  else
     port.TapDownTimer(0.75,function() end );
  end
--  interface.WidgetSetInput( InterfaceWidget_Inventory, false );
--  interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_fencepuzzle"} ) then
    cmn.MiniGameHide( "fencepuzzle" );
  end
  --  interface.WidgetSetInput( InterfaceWidget_Inventory, true );
  --interface.WidgetSetVisible( InterfaceWidget_Inventory, true, true );
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
 
  local func_preend = function()
  --  ng_global.progress["std"]["win_fencepuzzle"].state={ld.TableCopy(fencepuzzle_parts_first_pos_array), ld.TableCopy(fencepuzzle_parts_first_ang)};
     fencepuzzle_selected_part=0;
     for i=1,19,1 do 
        fencepuzzle_right_second_parts[i]=0; 
     end;
      -- private.fencepuzzle_parts_stand_on_pos();
     private.fencepuzzle_stand_on_first_pos(1) -- with start anim 
     ObjAnimate("obj_fencepuzzle_parts_root", 8, 0, 0, " ", {0, 0, 0, 0.25, 0, 1});
     fencepuzzle_on_true_pos_ready=0;
  end;
  
  ld.Lock(1);
  ObjAnimate("obj_fencepuzzle_parts_root", 8, 0, 0, func_preend, {0, 0, 1, 0.25, 0, 0});
end;
--*********************************************************************************************************************
function public.Skip()
  --  private.Win();
  local func_end=function()
  --ld.Lock(0);
  end;

  local func_preend = function()
  --  ng_global.progress["std"]["win_fencepuzzle"].state={ld.TableCopy(fencepuzzle_parts_first_pos_array), ld.TableCopy(fencepuzzle_parts_first_ang)};
     fencepuzzle_selected_part=0;
     for i=1,19,1 do 
        ng_global.progress["std"]["win_fencepuzzle"].state[1][i]=i;
        ng_global.progress["std"]["win_fencepuzzle"].state[2][i]=0;
        fencepuzzle_right_second_parts[i]=0; 
        --    ObjSet("spr_fencepuzzle_lig_"..i,{visible=1, alp=1, color_r=0.5, color_g=0.5, color_b=0.5});
     end;
     fencepuzzle_on_true_pos_ready=0; 
     private.fencepuzzle_parts_stand_on_pos();
     ObjAnimate("obj_fencepuzzle_parts_root", 8, 0, 0, func_end, {0, 0, 0, 0.25, 0, 1});
  end;
  
  ld.Lock(1);
  ObjAnimate("obj_fencepuzzle_parts_root", 8, 0, 0, func_preend, {0, 0, 1, 0.25, 0, 0});
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_fencepuzzle" );
  cmn.CallEventHandler( "win_fencepuzzle" );
  cmn.GotoRoom( "rm_farm" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  local func_end=function()
  --  ld.Lock(1);
     SoundSfx( "aud_open_fence_farm" );
     ld.StartTimer( 1, function()  cmn.MiniGameHide(true); private.WinEnd();  end);
  end;
   
  local func_preend = function()
    for i=1,19,1 do 
      ObjAnimate("spr_fencepuzzle_lig_"..i, 8, 0, 0, " ", {0,0,1, 1,1,1, 1.5,1,0});
    end;  
    ObjAnimate( "spr_fencepuzzle_tr", 7, 0, 0, function() end, {0,0,0, 1,0,-2*math.pi} ); 
    ld.StartTimer(1.8,func_end);
  end; 
   
  ld.Lock(1);
  for i=1,19,1 do 
     ObjAnimate("spr_fencepuzzle_lig2_"..i, 8, 0, 0, " ", {0, 0, ObjGet("spr_fencepuzzle_lig2_"..i),alp, 0.25,0,0});
  end
  ld.StartTimer(0.5,func_preend);
  SoundSfx( "aud_mg_fencepuzzle_win" );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  private.fencepuzzle_parts_init() 
  if not gm.loaded then
     gm.loaded  = true;
  else
   
  end;
  
   if not cmn.IsEventStart("win_fencepuzzle") then 
    private.fencepuzzle_stand_on_first_pos(1) --with start anim 
   -- cmn.SetEventStart("win_fencepuzzle");
    ng_global.progress["std"]["win_fencepuzzle"].state={ld.TableCopy(fencepuzzle_parts_first_pos_array), ld.TableCopy(fencepuzzle_parts_first_ang)};
  elseif not cmn.IsEventDone("win_fencepuzzle") then   
    --   ld.LogTrace("Loaded")
    fencepuzzle_selected_part=0;
    private.fencepuzzle_stand_on_first_pos(); 
    private.fencepuzzle_parts_stand_on_pos();
  end;  
end

function gm.save()

end;
function gm.mdown( num )
  
end
function gm.menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and obj.sender or obj or "";
  local o = ObjGet( obj.."_light" )
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
function gm.mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and obj.sender or obj or "";
  local o = ObjGet( obj.."_light" )
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;