-- name=mg_flow
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_flow";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_flow" ] = {type = "win", use_place = "mg_flow", room = "rm_beyondtower", zz = "mg_flow", zz_gate = "gmg_beyondtower_flow" };

  local win_flow_logic = function()
    if ld.CheckRequirements( {"win_flow"} ) then
      ObjSet("obj_flow_mg_root",{input=0})
      ObjSet( "spr_flow_butterfly", {active = 1, visible = 1, input = 1} );
      ObjSet("spr_beyondtower_tr_water",{alp=1})
      ObjSet( "spr_flow_sh_butterfly", {input = 1} );
    end
  end;
  local win_flow = function()
    if ld.CheckRequirements( {"win_flow"} ) then
      ObjSet("anm_mg_flow_flow",{animfunc="butter1",frame=0})
      ObjSet( "spr_flow_sh_butterfly", {visible = 1} );
      
    end
  end;
  cmn.AddSubscriber("win_flow", win_flow, private.room_objname )
  cmn.AddSubscriber("win_flow", win_flow_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_butterfly" ] = { type = "get", get_obj = "spr_flow_butterfly", room = "rm_beyondtower", zz = "mg_flow", zz_gate = "gmg_beyondtower_flow" };

private.get_butterfly_logic = function()
  
end;
private.get_butterfly_inv = function()
  interface.InventoryItemAdd("inv_butterfly","spr_flow_butterfly");
  ObjSet( "inv_butterfly", { drag = 0 } );
end;
private.get_butterfly_beg = function()
  ObjDelete("gfx_flow_butterfly")
end;
private.get_butterfly_end = function()
  ObjDelete("spr_flow_sh_butterfly")
end;

cmn.AddSubscriber( "get_butterfly", private.get_butterfly_inv );
cmn.AddSubscriber( "get_butterfly", private.get_butterfly_beg, private.room_objname );
cmn.AddSubscriber( "get_butterfly", private.get_butterfly_end, private.room_objname );
cmn.AddSubscriber( "get_butterfly", private.get_butterfly_logic );
--------------------------------------------------------------------
function public.get_butterfly()
  cmn.SetEventDone( "get_butterfly" );
  cmn.CallEventHandler( "get_butterfly" );
  cmn.GotoRoom( "rm_beyondtower" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_flow" );
  cmn.CallEventHandler( "win_flow" );
  --cmn.GotoRoom( "rm_beyondtower" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundSfx( "aud_mg_fountain_win" );
  ld.AnimPlay("anm_mg_flow_flow","butter",private.WinEnd)
  --ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_flow"} ) then
    cmn.MiniGameShow( "flow" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_beyondtower_env" )
  private.flow_load() 
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_flow"} ) then
    cmn.MiniGameHide( "flow" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
    ng_global.progress[ "std" ][ "win_flow" ].state_ang = 
    {0,2,0,0,1, 0,0,2,1,0, 0,3,0,0,3, 0,1,0,3,0, 0,1,2,0,2}
    ng_global.progress[ "std" ][ "win_flow" ].state_ray = { 
      {1,0,0,1},{1,1,1,0},{1,0,0,1},{1,1,1,1},{0,1,1,1},
      {1,1,1,1},{0,1,0,1},{1,1,1,0},{0,0,1,1},{1,0,0,1},
      {1,0,1,1},{1,1,0,0},{0,0,0,0},{1,0,0,1},{1,1,0,0},
      {1,0,1,1},{0,0,1,1},{1,0,0,1},{1,1,0,0},{1,0,1,1},
      {1,0,0,1},{1,0,1,0},{1,1,1,0},{1,0,0,1},{1,1,1,0},
      }
      local obj
      for i=1,25 do
        obj = "obj_flow_point_"..i
        local a_end = ng_global.progress[ "std" ][ "win_flow" ].state_ang[i]*math.pi/2
        local a_beg = private.flow_ang( ObjGet(obj).ang, a_end ) 
        ObjAnimate( obj, 7, 0, 0, "", {0,0,a_beg, 0.5,0,a_end} );
      end 
      ld.Lock(1)
      ld.StartTimer( "tmr_flow_skip", 0.5, function() ld.Lock(0)private.flow_load() end)
  
end;
--*********************************************************************************************************************
function public.Skip()
    ng_global.progress[ "std" ][ "win_flow" ].state_ang = 
    {1,2,3,0,1, 0,1,3,1,0, 3,3,0,0,1, 1,0,0,1,2, 2,1,0,3,2}
    ng_global.progress[ "std" ][ "win_flow" ].state_ray = { 
      {0,0,1,1},{1,1,1,0},{1,1,0,0},{1,1,1,1},{0,1,1,1},
      {1,1,1,1},{1,0,1,0},{1,1,0,1},{0,0,1,1},{1,0,0,1},
      {1,1,0,1},{1,1,0,0},{0,0,0,0},{1,0,0,1},{0,0,1,1},
      {0,1,1,1},{1,0,0,1},{1,0,0,1},{0,0,1,1},{1,1,1,0},
      {0,1,1,0},{1,0,1,0},{1,0,1,1},{1,1,0,0},{1,1,1,0},
                                                                }  
  local obj
  for i=1,25 do
    obj = "obj_flow_point_"..i
    local a_end = ng_global.progress[ "std" ][ "win_flow" ].state_ang[i]*math.pi/2
    local a_beg = private.flow_ang( ObjGet(obj).ang, a_end ) 
    ObjAnimate( obj, 7, 0, 0, "", {0,0,a_beg, 0.5,0,a_end} );
  end 
    ld.Lock(1)
    ld.StartTimer( "tmr_flow_skip", 0.5, function()
    ld.Lock(0);

    private.flow_load();
    end)
end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;

--*********************************************************************************************************************



function public.clk_flow_point(point)
  local s = ld.TableCopy(ng_global.progress[ "std" ][ "win_flow" ].state_ang)
  local func_end = function ()
    ld.Lock(0)
    ng_global.progress[ "std" ][ "win_flow" ].state_ang[point]=ng_global.progress[ "std" ][ "win_flow" ].state_ang[point]+1
    if ng_global.progress[ "std" ][ "win_flow" ].state_ang[point]==4 then
      ng_global.progress[ "std" ][ "win_flow" ].state_ang[point]=0
    end   
    local a= ng_global.progress[ "std" ][ "win_flow" ].state_ray [point][1] 
    for i=1,3 do
      ng_global.progress[ "std" ][ "win_flow" ].state_ray [point][i]=ng_global.progress[ "std" ][ "win_flow" ].state_ray [point][i+1]
    end
    ng_global.progress[ "std" ][ "win_flow" ].state_ray [point][4] = a
   -- ld.LogTrace( ng_global.progress[ "std" ][ "win_flow" ].state_ray [point] );
    if private.flow_check() then
      private.Win()
    end
  end

   ld.Lock(1)
  s[point]= s[point]+1
  if s[point]==4 then
    s[point]=0
  end 
  local obj = "obj_flow_point_"..point
  local a_end = s[point]*math.pi/2
  local a_beg = private.flow_ang( ObjGet(obj).ang, a_end ) 
  SoundSfx( "aud_mg_fountain_rotate" );
  ObjAnimate( obj, 7, 0, 0, func_end, {0,0,a_beg, 0.5,0,a_end} );
end

function private.flow_ang( a_beg, a_end )
  if math.abs(a_beg-a_end) > math.pi then
    if a_beg > a_end then
      a_beg = a_beg - math.pi * 2
    else
      a_beg = a_beg + math.pi * 2
    end;
  end;
  return a_beg;
end;


private.flow_load_flag=false --for sfx
function private.flow_load()
  if not ng_global.progress[ "std" ][ "win_flow" ].state then
      ng_global.progress[ "std" ][ "win_flow" ].state = {}
      ng_global.progress[ "std" ][ "win_flow" ].state_ang = 
      {0,2,0,0,1, 0,0,2,1,0, 0,3,0,0,3, 0,1,0,3,0, 0,1,2,0,2}
      ng_global.progress[ "std" ][ "win_flow" ].state_ray = { 
        {1,0,0,1},{1,1,1,0},{1,0,0,1},{1,1,1,1},{0,1,1,1},
        {1,1,1,1},{0,1,0,1},{1,1,1,0},{0,0,1,1},{1,0,0,1},
        {1,0,1,1},{1,1,0,0},{0,0,0,0},{1,0,0,1},{1,1,0,0},
        {1,0,1,1},{0,0,1,1},{1,0,0,1},{1,1,0,0},{1,0,1,1},
        {1,0,0,1},{1,0,1,0},{1,1,1,0},{1,0,0,1},{1,1,1,0},
                                                                  }
  end
  for i=1,25 do
    ObjSet( "obj_flow_point_"..i, {ang=ng_global.progress[ "std" ][ "win_flow" ].state_ang[i]*math.pi/2} );
  end

  if private.flow_check() and not ld.CheckRequirements( { "win_flow" } ) then 
    private.Win()
  end

end
private.flow_light = {false,false,false}
function private.flow_check_point(point,out_ray)

  -- local out_ray = 1 
  local in_ray = (out_ray+1)%4+1
  
  -- local point = 25 
  --DbgTrace(out_ray.." "..point.." "..in_ray)
  local new_point 
  local new_out
    
    if not  private.flow_points["spr_flow_small_point_"..point.."_light"] and  ng_global.progress[ "std" ][ "win_flow" ].state_ray[point] and  ng_global.progress[ "std" ][ "win_flow" ].state_ray[point][in_ray]==1 then
      private.flow_points["spr_flow_small_point_"..point.."_light"] = true
      ObjSet( "spr_flow_small_point_"..point.."_light", {alp=1} );
      for i = 1,4 do 
        if i~=in_ray and ng_global.progress[ "std" ][ "win_flow" ].state_ray[point][i]==1  then
          if     i == 1 and ((point-1)%5)~=0 then new_point = point - 1 
          elseif i == 2 then new_point = point - 5 
          elseif i == 3 and (point%5)~=0 then new_point = point + 1
          elseif i == 4 then new_point = point + 5
          else  
            new_point = nil
          end
          if new_point then
            private.flow_check_point(new_point,i)
          end
        end
      end

      if point == 11 and ng_global.progress[ "std" ][ "win_flow" ].state_ray[point][1]==1 then private.flow_light[1]=true end      
        if point == 3  and ng_global.progress[ "std" ][ "win_flow" ].state_ray[point][2]==1 then private.flow_light[2]=true end
          if point == 15 and ng_global.progress[ "std" ][ "win_flow" ].state_ray[point][3]==1 then private.flow_light[3]=true end
            if point == 23 and ng_global.progress[ "std" ][ "win_flow" ].state_ray[point][4]==1 then private.flow_light[4]=true end



    else 

    end
  
end

--------------------------------------------------------------
private.flow_light_copy={} --for sfx
--------------------------------------------------------------
        
function private.flow_check()

  for j=1,25 do 
    ObjSet( "spr_flow_small_point_"..j.."_light", {alp=0} );  
  end
  private.flow_check_points_sound_before() -- for sfx
  private.flow_light = {false,false,false,false}
  private.flow_points = {}
  private.flow_check_point(8,2)--начало проверки(входящя точка, исходящий луч])
  private.flow_light_copy = ld.TableCopy(private.flow_light); -- for sfx
  private.flow_check_points_sound() -- for sfx

  for i=1,4 do
    ObjSet( "spr_flow_big_point_"..i.."_light", {visible = private.flow_light[i]} );
  end
  
  local check = false
  if private.flow_light[1] and private.flow_light[2] and private.flow_light[3] and private.flow_light[4]then
    check = true
  end
  return check
end

--------------------------------------------- for sfx
local flow_check_points_for_sfx_array={};
local flow_check_big_points_for_sfx_array={};

function private.flow_check_points_sound_before()
   if private.flow_load_flag==true then 
     flow_check_points_for_sfx_array=ld.TableCopy(private.flow_points);
     flow_check_big_points_for_sfx_array = ld.TableCopy(private.flow_light_copy);
    --for i=1,25,1 do 
    --  if private.flow_points["spr_flow_small_point_"..i.."_light"]==true then flow_check_points_for_sfx_count=flow_check_points_for_sfx_count+1; end;
    --end; 
   end;  
end;  


function private.flow_check_points_sound()
  if private.flow_load_flag==true then 
    local my_flag = false;
    local my_flag_big = false;
    local my_flag_big_false = false;
    for i=1,25,1 do 
      --if private.flow_points["spr_flow_small_point_"..i.."_light"]==true then my_count=my_count+1; end;
      if flow_check_points_for_sfx_array["spr_flow_small_point_"..i.."_light"]~=private.flow_points["spr_flow_small_point_"..i.."_light"] and private.flow_points["spr_flow_small_point_"..i.."_light"]==true then
        my_flag=true;
      end;  
    end;
    
    for i=1,4,1 do  --for lamps 
      if flow_check_big_points_for_sfx_array[i]~=private.flow_light_copy[i] and private.flow_light_copy[i]==true then 
         my_flag_big=true;
      end; 
      if flow_check_big_points_for_sfx_array[i]~=private.flow_light_copy[i] and private.flow_light_copy[i]==false then 
        my_flag_big_false=true;
      end; 
    end;  
    
    if my_flag==true then SoundSfx( "aud_mg_fountain_true" ) end;  
    if my_flag_big==true then SoundSfx( "aud_mg_fountain_lamp_on" ) end;  
    if my_flag_big_false==true then SoundSfx( "aud_mg_fountain_lamp_off" ) end;  
  else 
    private.flow_load_flag=true;
  end;
end;  


