-- name=mg_vitragemg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_vitragemg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_vitragemg" ] = {type = "win", use_place = "mg_vitragemg", room = "rm_chapel", zz = "mg_vitragemg", zz_gate = "gmg_chapel_vitragemg" };

  local win_vitragemg_logic = function()
    if ld.CheckRequirements( {"win_vitragemg"} ) then
      ObjSet( "spr_vitragemg_wing2", {input = 1, visible = 1} );
    end
  end;
  local win_vitragemg = function()
    if ld.CheckRequirements( {"win_vitragemg"} ) then
      ObjDelete("spr_vitragemg_door")
      for i=1,3 do ObjDelete("obj_vitragemg_parts_root_"..i) end
    end
  end;
  cmn.AddSubscriber("win_vitragemg", win_vitragemg, private.room_objname )
  cmn.AddSubscriber("win_vitragemg", win_vitragemg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_wing2" ] = { type = "get", get_obj = "spr_vitragemg_wing2", room = "rm_chapel", zz = "mg_vitragemg", zz_gate = "gmg_chapel_vitragemg" };

private.get_wing2_logic = function()
  
end;
private.get_wing2_inv = function()
  interface.InventoryItemAdd("inv_wing2","spr_vitragemg_wing2");
end;
private.get_wing2_beg = function()
  ObjDelete("gfx_vitragemg_wing2")
end;
private.get_wing2_end = function()
  ObjDelete("spr_vitragemg_sh_wing2")
end;

cmn.AddSubscriber( "get_wing2", private.get_wing2_inv );
cmn.AddSubscriber( "get_wing2", private.get_wing2_beg, private.room_objname );
cmn.AddSubscriber( "get_wing2", private.get_wing2_end, private.room_objname );
cmn.AddSubscriber( "get_wing2", private.get_wing2_logic );
--------------------------------------------------------------------
function public.get_wing2()
  cmn.SetEventDone( "get_wing2" );
  cmn.CallEventHandler( "get_wing2" );
  cmn.GotoRoom( "rm_chapel" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_vitragemg"} ) then
    cmn.MiniGameShow( "vitragemg" );
  end
  --for i=1,3 do
  --  for j=1,8 do
  --   local obj =  "spr_vitragemg_part_"..i.."_"..j
  --   --ld.LogTrace(obj.."  {"..ObjGet(obj).pos_x..","..ObjGet(obj).pos_y..","..ObjGet(obj).ang.."}");
  --  end
  --end  
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_chapel_env" );
  gm.load();
  
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_vitragemg"} ) then
    cmn.MiniGameHide( "vitragemg" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local lvl = ng_global.progress["std"]["win_vitragemg"].state.lvl
  ng_global.progress["std"]["win_vitragemg"].state.parts[lvl]={0,0,0,0, 0,0,0,0}
    for j=1,8 do
      local obj =  "spr_vitragemg_part_"..lvl.."_"..j 
      ObjSet( obj, {input = 1} );
      ObjAnimate( obj, 7, 0, 0, "", {0,0,ObjGet(obj).ang, 0.5,0,private.startpos_parts[lvl][j][3]} );
      ObjAnimate( obj, 6, 0, 0, "", {0,0,ObjGet(obj).scale_x,ObjGet(obj).scale_y, 0.5,0,0.8,0.8} );
      ObjAnimate( obj, 3, 0, 0, "", {0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y, 0.5,0,private.startpos_parts[lvl][j][1],private.startpos_parts[lvl][j][2]} );      
    end
    ld.Lock(1)
    ObjAnimate("obj_vitragemg_parts_root_"..lvl,7,0,0,function()ld.Lock(0) end,{0,0,0,0.5,0,0})
end;
--*********************************************************************************************************************
private.skiped = false
function public.Skip()
  --private.Win();
  local lvl = ng_global.progress["std"]["win_vitragemg"].state.lvl
  cmn.MiniGameHide();
  interface.WidgetSetVisible(InterfaceWidget_Inventory, 0, true );
  cmn.SetEventDone( "win_vitragemg" );
  private.skip_anim()

end;
private.skiped_press = false
function private.skip_anim()
  private.skiped_press = true
  local lvl = ng_global.progress["std"]["win_vitragemg"].state.lvl
  ng_global.progress["std"]["win_vitragemg"].state.parts[lvl]={1,1,1,1, 1,1,1,1}
  for j=1,8 do
    local obj =  "spr_vitragemg_part_"..lvl.."_"..j 
    local obj_zone = ObjGet("obj_vitragemg_part_"..lvl.."_"..j.."_zone")
    ObjSet( obj, {input = 0} );
    ObjAnimate( obj, 7, 0, 0, "", {0,0,ObjGet(obj).ang, 0.5,0,0} );
    ObjAnimate( obj, 6, 0, 0, "", {0,0,ObjGet(obj).scale_x,ObjGet(obj).scale_y, 0.5,0,1,1} );
    ObjAnimate( obj, 3, 0, 0, "", {0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y, 0.5,0,obj_zone.pos_x,obj_zone.pos_y} );      
  end
  ld.Lock(1)
  ObjAnimate("obj_vitragemg_parts_root_"..lvl,7,0,0,function()ld.Lock(0);private.check_lvl(lvl,private.skip_anim)end,{0,0,0,0.5,0,0})
end
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_vitragemg" );
  cmn.CallEventHandler( "win_vitragemg" );
  --cmn.GotoRoom( "rm_chapel" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  ld.StartTimer(0.5,function() SoundSfx( "aud_mg_vitrage_win" ); end);
  ObjAnimate( "obj_vitragemg_parts_root_3", 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  ObjAnimate( "spr_vitragemg_door", 8, 0, 0, private.WinEnd, {0,0,1, 0.5,0,1,1,0,0} );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
    if not ng_global.progress["std"]["win_vitragemg"].state then
      ng_global.progress["std"]["win_vitragemg"].state = {}
      ng_global.progress["std"]["win_vitragemg"].state.lvl = 1
      ng_global.progress["std"]["win_vitragemg"].state.parts = {
                                                                {0,0,0,0, 0,0,0,0},
                                                                {0,0,0,0, 0,0,0,0},
                                                                {0,0,0,0, 0,0,0,0}
                                                               }
    end
    gm.loaded  = true;
    
  else
  
  end;
  private.load_state()
end

function gm.save()

end;

function private.load_state()
  if not ld.CheckRequirements( {"win_vitragemg"} ) then  
    private.load_lvl()
  end
end

private.cur_ang = 0
private.startpos_parts = {
{{108,468,0.92},{093,336,1.75},{960,342,0.34},{307,039,1.63},{551,013,1.69},{093,024,0.78},{735,020,1.57},{935,112,1.23}},
{{949,221,0.14},{075,461,0.26},{153,062,0.89},{048,277,0.05},{971,342,0.11},{413,-14,1.31},{670,027,0.99},{858,111,1.71}},
{{999,173,0.73},{096,291,0.63},{774,066,1.50},{132,037,1.76},{318,041,0.99},{981,320,0.11},{535,-10,0.00},{051,494,0.10}}, 
}
function public.mdown( obj )
  SoundSfx( "aud_mg_vitrage_get" );
  ObjSet( obj, {pos_z=10,inputrect_init = 1,inputrect_x = -15,inputrect_y = -15,inputrect_w = 30, inputrect_h = 30} );
  private.cur_ang = ObjGet(obj).ang or 0
  ObjAnimate( obj, 7, 0, 0, "", {0,0,private.cur_ang, 0.3,0,0} );
  ObjAnimate( obj, 6, 0, 0, "", {0,0,0.8,0.8, 0.3,0,1,1} );
end
function public.menter( obj )
  ld.ShCur(CURSOR_GET)
  obj = obj and obj.sender or obj or "";
  local o = ObjGet( obj.."_light" )
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
function public.mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and obj.sender or obj or "";
  local o = ObjGet( obj.."_light" )
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;
function public.drop( obj )
  local lvl = tonumber(ld.StringDivide(obj)[4])
  local part = tonumber(ld.StringDivide(obj)[5])
  local obj_zone = "obj_vitragemg_part_"..lvl.."_"..part.."_zone"
  
  if common_impl.ApplyCheck(obj,obj_zone) then
    SoundSfx( "aud_mg_vitrage_set" );
    ld.Lock(1)
    ng_global.progress["std"]["win_vitragemg"].state.parts[lvl][part] = 1 
    ObjSet( obj, {pos_z=0,input=0,inputrect_init = 0})
    ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); private.check_lvl(lvl) end,
    {0,0,GetObjPosByObj(obj,"mg_vitragemg")[1],GetObjPosByObj(obj,"mg_vitragemg")[2], 0.2,0,ObjGet(obj_zone).pos_x,ObjGet(obj_zone).pos_y}
    );
  else 
    SoundSfx( "aud_mg_vitrage_wrong" );
    ld.Lock(1)
    ObjSet( obj, {pos_z=1,inputrect_init = 0} );
    ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); end,
    {0,0,GetObjPosByObj(obj,"mg_vitragemg")[1],GetObjPosByObj(obj,"mg_vitragemg")[2], 0.2,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y}
    );
    ObjAnimate( obj, 6, 0, 0, "", {0,0,1,1, 0.2,0,0.8,0.8} );
    ObjAnimate( obj, 7, 0, 0, "", {0,0,ObjGet(obj).ang, 0.2,0,private.cur_ang} );
  end
  
end

function private.check_lvl(lvl,func_end)
  --lvl=tonumber(lvl)
  if private.check_arr_lvl(lvl)  then
    SoundSfx( "aud_mg_vitrage_win_part" )
    private.story_start(func_end)
  end
end

function private.load_lvl(anim)
  for i=1,3 do
    ObjDetach("obj_vitragemg_parts_root_"..i)
  end  

  local lvl = ng_global.progress["std"]["win_vitragemg"].state.lvl
  local obj_lvl 
     
  if anim then  
    SoundSfx( "aud_mg_vitrage_new" );
    obj_lvl = "obj_vitragemg_parts_root_"..lvl
    ObjAttach(obj_lvl,"mg_vitragemg")  
    ld.Lock(1)
    ObjAnimate(obj_lvl , 8, 0, 0, function() ld.Lock(0) end, {0,0,0, 0.3,0,1} );
    ObjSet(obj_lvl,{input=1})
  else 
    if private.check_arr_lvl(lvl)  then lvl = lvl + 1 end
    ng_global.progress["std"]["win_vitragemg"].state.lvl = lvl
    if lvl ~=4 then
      obj_lvl = "obj_vitragemg_parts_root_"..lvl
      ObjAttach(obj_lvl,"mg_vitragemg")  
      ObjSet(obj_lvl,{input=1,alp}) 
      for j=1,8 do
        if ng_global.progress["std"]["win_vitragemg"].state.parts[lvl][j] == 1 then
          local obj_zone = ObjGet("obj_vitragemg_part_"..lvl.."_"..j.."_zone")
          ObjSet("spr_vitragemg_part_"..lvl.."_"..j,{input=0,pos_x=obj_zone.pos_x,pos_y=obj_zone.pos_y,ang=0,scale_x=1,scale_y=1})
        else 
         -- ObjSet("spr_vitragemg_part_"..lvl.."_"..j,{input=1})
        end
      end
    else 
      private.Win()
    end
  end
end
function private.check_arr_lvl(lvl) 
  local s = ng_global.progress["std"]["win_vitragemg"].state
  local sum = 0
  for i=1,#s.parts[lvl] do
    sum=sum + s.parts[lvl][i]
  end
  if sum == #s.parts[lvl] then
    return true
  else 
    return false
  end
end

function private.story_start(f_end,lvl)
  local story = lvl or ng_global.progress["std"]["win_vitragemg"].state.lvl
  local dial_end
  if story == 3 then
    dial_end = function()
      SoundVoice( 0 );
      if private.skiped_press then
        interface.WidgetSetVisible( InterfaceWidget_BtnHint, 1, true );
      end
      private.skiped_press=false
      private.WidgetSetVisible("show")
      interface.DialogStoryHide();
      private.Win()
    end
  else 
    dial_end = function()
      SoundVoice( 0 );
      private.story_end(f_end)
    end
  end
  SoundVoice( 0 );
  ld.Lock(1); ld.StartTimer( 1, function() SoundVoice( "aud_gerald_"..story.."_voc" ); ld.Lock(0); end ) 
  private.WidgetSetVisible("hide")
  interface.DialogStoryShow( "", "str_vitragemg_flashback_"..story,dial_end,dial_end, 0.5 )

end
function private.story_end(f_end)
  interface.DialogStoryHide()
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );
  private.WidgetSetVisible("show")
  local fun_end = function ()
    ld.Lock(0)
    ng_global.progress["std"]["win_vitragemg"].state.lvl = ng_global.progress["std"]["win_vitragemg"].state.lvl + 1
    if f_end then
      private.load_lvl(1)
      f_end()
    else 
      private.load_lvl(1)
    end
    
  end
  ld.Lock(1)
  local lvl = ng_global.progress["std"]["win_vitragemg"].state.lvl 
  ObjAnimate( "obj_vitragemg_parts_root_"..lvl, 8, 0, 0, fun_end, {0,0,1, 0.3,0,0} );
end
private.skiped_showed = false



function private.WidgetSetVisible(param)

  local widget_settings = 
  {
  --,
    InterfaceWidget_BtnGuide,
    InterfaceWidget_BtnMenu,
    InterfaceWidget_BtnMap,
  }  
  if private.skiped_press then
    table.insert(widget_settings,InterfaceWidget_BtnHint)
    --table.insert(widget_settings,InterfaceWidget_Inventory)
  else 
    table.insert(widget_settings,InterfaceWidget_BtnSkip)
    table.insert(widget_settings,InterfaceWidget_BtnReset)
    table.insert(widget_settings,InterfaceWidget_BtnInfo)    
  end  
  if not private.skiped_press then
    
    if param == "show" then 
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 1, true );
      end;
    elseif param == "hide" then 
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 0, false );
      end;    
    end
  else 
    if param == "hide" and not private.skiped_showed then
      private.skiped_showed = true
      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 0, false );
        ld.LogTrace( widget_settings[i] );
      end;
    end
  end
end