-- name=rm_beyondtower
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_beyondtower";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_beyondtower()
  if not ( cmn.IsEventDone( "opn_beyondtower" ) ) then
    cmn.SetEventDone( "opn_beyondtower" );
    cmn.CallEventHandler( "opn_beyondtower" )
  end;
end;
--------------------------------------------------------------------
local opn_beyondtower = function() end;
local opn_beyondtower_logic = function() end;
cmn.AddSubscriber( "opn_beyondtower", opn_beyondtower_logic )
cmn.AddSubscriber( "opn_beyondtower", opn_beyondtower, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anmladder" ] = { type = "click", use_place = "gfx_beyondtower_clk_anmladder_zone", room = "rm_beyondtower" };

private.clk_anmladder_logic = function()
  ObjSet( "gzz_beyondtower_fountain", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_beyondtower_chatter", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_beyondtower_brokenladder", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_beyondtower_ladder_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_anmladder_beg = function()
  ObjDelete( "gfx_beyondtower_clk_anmladder_zone" );
end;
private.clk_anmladder_end = function()
  ObjDelete("vid_beyondtower_ladder")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anmladder", private.clk_anmladder_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmladder", private.clk_anmladder_end, private.room_objname );
cmn.AddSubscriber( "clk_anmladder", private.clk_anmladder_logic );
cmn.AddSubscriber( "clk_anmladder_beg", private.clk_anmladder_beg, private.room_objname );
cmn.AddSubscriber( "clk_anmladder_end", private.clk_anmladder_end, private.room_objname );
cmn.AddSubscriber( "clk_anmladder_end", private.clk_anmladder_logic );
--------------------------------------------------------------------------------------------
function public.clk_anmladder()

  local func_end = function()
    cmn.SetEventDone( "clk_anmladder" );
    cmn.CallEventHandler( "clk_anmladder_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_clk_anmladder");
    SoundTheme( "aud_danger_moment3_mus" );
  end;

  cmn.CallEventHandler( "clk_anmladder_beg" );
  common_impl.Lock(1);

  VidPlay("vid_beyondtower_ladder",func_end)
  SoundSfx( "aud_ladder_65" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brokenladder" ] = { type = "get", get_obj = "spr_beyondtower_brokenladder", room = "rm_beyondtower" };

private.get_brokenladder_logic = function()
  
end;
private.get_brokenladder_inv = function()
  interface.InventoryItemAdd("inv_brokenladder","spr_beyondtower_brokenladder");
  ObjSet( "inv_brokenladder", { drag = 0 } );
end;
private.get_brokenladder_beg = function()
  ObjDelete("gfx_beyondtower_brokenladder")
end;
private.get_brokenladder_end = function()
  
end;

cmn.AddSubscriber( "get_brokenladder", private.get_brokenladder_inv );
cmn.AddSubscriber( "get_brokenladder", private.get_brokenladder_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenladder", private.get_brokenladder_end, private.room_objname );
cmn.AddSubscriber( "get_brokenladder", private.get_brokenladder_logic );
--------------------------------------------------------------------
function public.get_brokenladder()
  cmn.SetEventDone( "get_brokenladder" );
  cmn.CallEventHandler( "get_brokenladder" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ladder" ] = { type = "use", inv_obj = "inv_ladder", use_place = "gfx_beyondtower_ladder_zone", room = "rm_beyondtower" };

private.use_ladder_logic = function()
  ObjSet( "gfx_beyondtower_clk_outrolvl2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_ladder_inv = function()
  common_impl.ProcessMultiUseAll("ladder", "ladder")
end;
private.use_ladder_beg = function()
  ObjDelete( "gfx_beyondtower_ladder_zone" );
end;
private.use_ladder_end = function()
  ObjSet("anm_beyondtower_anim_ladder",{animfunc="anim_ladder_end",frame=0})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ladder", private.use_ladder_inv );
cmn.AddSubscriber( "use_ladder", private.use_ladder_beg, private.room_objname );
cmn.AddSubscriber( "use_ladder", private.use_ladder_end, private.room_objname );
cmn.AddSubscriber( "use_ladder", private.use_ladder_logic );
cmn.AddSubscriber( "use_ladder_inv", private.use_ladder_inv, private.room_objname );
cmn.AddSubscriber( "use_ladder_beg", private.use_ladder_beg, private.room_objname );
cmn.AddSubscriber( "use_ladder_end", private.use_ladder_end, private.room_objname );
cmn.AddSubscriber( "use_ladder_end", private.use_ladder_logic );
--------------------------------------------------------------------------------------------
function public.use_ladder( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ladder" );
    cmn.CallEventHandler( "use_ladder_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ladder_inv" );
  cmn.CallEventHandler( "use_ladder_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_beyondtower_anim_ladder", "anim_ladder", func_end );
  SoundSfx( "aud_use_ladder_beyondtower" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outrolvl2" ] = { type = "click", use_place = "gfx_beyondtower_clk_outrolvl2_zone", room = "rm_beyondtower" };

private.clk_outrolvl2_logic = function()

end;
private.clk_outrolvl2_beg = function()
  ObjDelete( "gfx_beyondtower_clk_outrolvl2_zone" );
end;
private.clk_outrolvl2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outrolvl2", private.clk_outrolvl2_beg, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl2", private.clk_outrolvl2_end, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl2", private.clk_outrolvl2_logic );
cmn.AddSubscriber( "clk_outrolvl2_beg", private.clk_outrolvl2_beg, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl2_end", private.clk_outrolvl2_end, private.room_objname );
cmn.AddSubscriber( "clk_outrolvl2_end", private.clk_outrolvl2_logic );
--------------------------------------------------------------------------------------------
function public.clk_outrolvl2()

  local func_end = function()
    SoundVoice(0);
    int.DialogVideoHide();
    cmn.SetEventDone( "clk_outrolvl2" );
    cmn.CallEventHandler( "clk_outrolvl2_end" );
       ObjSet("rm_beyondtower",{color_r=0,color_g=0,color_b=0})
       local widget_settings = 
          {
            InterfaceWidget_Inventory,
            InterfaceWidget_BtnHint,
            InterfaceWidget_BtnGuide,
            InterfaceWidget_BtnMenu,
            InterfaceWidget_BtnMap,
          }
       for i = 1, #widget_settings do
          interface.WidgetSetVisible( widget_settings[i], 0, false );
       end;
        cmn.GotoRoom("rm_jail");
  end;

  cmn.CallEventHandler( "clk_outrolvl2_beg" );
  SoundEnv(0);
  --  ld.VidStaticPause( private.tower_vid_tower_conflict_array ); 
  ObjAttach("vid_beyondtower_outro_2_ch","rm_tower");
  SoundVid("aud_outro_2_ch");
  VidPlay("vid_beyondtower_outro_2_ch",func_end);
  SoundVoice("aud_outro_2_ch_voc");
  int.DialogVideoShow( "vid_beyondtower_outro_2_ch", 1, func_end, 1 ); 

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_fountain *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bird2" ] = { type = "get", get_obj = "spr_fountain_bird2", room = "rm_beyondtower", zz = "zz_fountain", zz_gate = "gzz_beyondtower_fountain" };

private.get_bird2_logic = function()
  
end;
private.get_bird2_inv = function()
  interface.InventoryItemAdd("inv_bird2","spr_fountain_bird2");
end;
private.get_bird2_beg = function()
  ObjDelete("gfx_fountain_bird2")
end;
private.get_bird2_end = function()
  ObjDelete("spr_fountain_sh_bird2")
  ObjDelete("spr_beyondtower_tr_bird2")
  if common_impl.ZzCompleteCheck("get_bird2") then ObjSet( common_impl.hint["get_bird2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bird2", private.get_bird2_inv );
cmn.AddSubscriber( "get_bird2", private.get_bird2_beg, private.room_objname );
cmn.AddSubscriber( "get_bird2", private.get_bird2_end, private.room_objname );
cmn.AddSubscriber( "get_bird2", private.get_bird2_logic );
--------------------------------------------------------------------
function public.get_bird2()
  cmn.SetEventDone( "get_bird2" );
  cmn.CallEventHandler( "get_bird2" );
  if common_impl.ZzCompleteCheck("get_bird2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_valve" ] = { type = "use", inv_obj = "inv_valve", use_place = "gfx_fountain_valve_zone", room = "rm_beyondtower", zz = "zz_fountain", zz_gate = "gzz_beyondtower_fountain" };

private.use_valve_logic = function()
  ObjSet( "gmg_beyondtower_flow", { visible = 1, input = 1, active = 1 } )

end;
private.use_valve_inv = function()
  common_impl.ProcessMultiUseAll("valve", "valve")
end;
private.use_valve_beg = function()
  ObjDelete( "gfx_fountain_valve_zone" );
end;
private.use_valve_end = function()
  ObjSet( "spr_beyondtower_crane1", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_valve") then ObjSet( common_impl.hint["use_valve"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_valve", private.use_valve_inv );
cmn.AddSubscriber( "use_valve", private.use_valve_beg, private.room_objname );
cmn.AddSubscriber( "use_valve", private.use_valve_end, private.room_objname );
cmn.AddSubscriber( "use_valve", private.use_valve_logic );
cmn.AddSubscriber( "use_valve_inv", private.use_valve_inv, private.room_objname );
cmn.AddSubscriber( "use_valve_beg", private.use_valve_beg, private.room_objname );
cmn.AddSubscriber( "use_valve_end", private.use_valve_end, private.room_objname );
cmn.AddSubscriber( "use_valve_end", private.use_valve_logic );
--------------------------------------------------------------------------------------------
function public.use_valve( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_valve" );
    cmn.CallEventHandler( "use_valve_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_valve") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_valve_inv" );
  cmn.CallEventHandler( "use_valve_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_fountain_anm_fontain", "use_crane", func_end );
  SoundSfx( "aud_use_valve_beyondtower" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_chatter *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletphoenix" ] = { type = "use", inv_obj = "inv_amuletphoenix", use_place = "gfx_chatter_amuletphoenix_zone", room = "rm_beyondtower", zz = "zz_chatter", zz_gate = "gzz_beyondtower_chatter" };

private.use_amuletphoenix_logic = function()
  ObjSet( "gho_beyondtower_chatterho", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletphoenix_inv = function()
  common_impl.ProcessMultiUseAll("amuletphoenix", "amuletphoenix")
end;
private.use_amuletphoenix_beg = function()
  ObjDelete( "gfx_chatter_amuletphoenix_zone" );
end;
private.use_amuletphoenix_end = function()
  ObjSet("spr_beyondtower_tr_door_open",{alp=1})
  ObjDelete("spr_beyondtower_tr_door")
  if common_impl.ZzCompleteCheck("use_amuletphoenix") then ObjSet( common_impl.hint["use_amuletphoenix"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletphoenix", private.use_amuletphoenix_inv );
cmn.AddSubscriber( "use_amuletphoenix", private.use_amuletphoenix_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletphoenix", private.use_amuletphoenix_end, private.room_objname );
cmn.AddSubscriber( "use_amuletphoenix", private.use_amuletphoenix_logic );
cmn.AddSubscriber( "use_amuletphoenix_inv", private.use_amuletphoenix_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletphoenix_beg", private.use_amuletphoenix_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletphoenix_end", private.use_amuletphoenix_end, private.room_objname );
cmn.AddSubscriber( "use_amuletphoenix_end", private.use_amuletphoenix_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletphoenix( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletphoenix" );
    cmn.CallEventHandler( "use_amuletphoenix_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletphoenix") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletphoenix_inv" );
  cmn.CallEventHandler( "use_amuletphoenix_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_chatter_anim", "anim_amulet", func_end );
  SoundSfx( "aud_use_bird_amulet_beyondtower" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local get_butterfly_for_beyondtower = function()
    if ld.CheckRequirements( {"get_butterfly"} ) then
      ObjSet( "gmg_beyondtower_flow", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_butterfly", get_butterfly_for_beyondtower, private.room_objname )
  local win_chatterho_for_beyondtower = function()
    if ld.CheckRequirements( {"win_chatterho"} ) then
      ObjSet( "gho_beyondtower_chatterho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_chatterho", win_chatterho_for_beyondtower, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_beyondtower();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_beyondtower_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_chatter" );
  function zz_chatter.Open()
  end;
  function zz_chatter.PreOpen()
  end;
  function zz_chatter.PreClose()
  end;
  function zz_chatter.Close()
  end;

  subroom.Define( "zz_fountain" );
  function zz_fountain.Open()
  end;
  function zz_fountain.PreOpen()
  end;
  function zz_fountain.PreClose()
  end;
  function zz_fountain.Close()
  end;
  
end;
--*********************************************************************************************************************