-- name=rm_chapel
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_chapel";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_altar_paper_small","spr_altar_paper_big","chapel_altar_note_clk");  
  --------------------------------------------------------------------------------------------
function private.opn_chapel()
  if not ( cmn.IsEventDone( "opn_chapel" ) ) then
    cmn.SetEventDone( "opn_chapel" );
    cmn.CallEventHandler( "opn_chapel" )
    ld.ShowBbt("opn_chapel")
    SoundTheme( "aud_adventure1_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_chapel = function() end;
local opn_chapel_logic = function() end;
cmn.AddSubscriber( "opn_chapel", opn_chapel_logic )
cmn.AddSubscriber( "opn_chapel", opn_chapel, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_altar *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_glassshard5" ] = { type = "get", get_obj = "spr_altar_glassshard5", room = "rm_chapel", zz = "zz_altar", zz_gate = "gzz_chapel_altar" };

private.get_glassshard5_logic = function()
  
end;
private.get_glassshard5_inv = function()
  interface.InventoryItemAdd("inv_glassshard","spr_altar_glassshard5",function() level_inv.ProcessGetGlassshardAll( "get_glassshard5" ) end);
end;
private.get_glassshard5_beg = function()
  ObjDelete("gfx_altar_glassshard5")
end;
private.get_glassshard5_end = function()
  ObjDelete("spr_altar_glasss_sh")
  ObjDelete("spr_chapel_te_glassshard5")
  if common_impl.ZzCompleteCheck("get_glassshard5") then ObjSet( common_impl.hint["get_glassshard5"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_glassshard5", private.get_glassshard5_inv );
cmn.AddSubscriber( "get_glassshard5", private.get_glassshard5_beg, private.room_objname );
cmn.AddSubscriber( "get_glassshard5", private.get_glassshard5_end, private.room_objname );
cmn.AddSubscriber( "get_glassshard5", private.get_glassshard5_logic );
--------------------------------------------------------------------
function public.get_glassshard5()
  cmn.SetEventDone( "get_glassshard5" );
  cmn.CallEventHandler( "get_glassshard5" );
  if common_impl.ZzCompleteCheck("get_glassshard5") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_book" ] = { type = "use", inv_obj = "inv_book", use_place = "gfx_altar_book_zone", room = "rm_chapel", zz = "zz_altar", zz_gate = "gzz_chapel_altar" };

private.use_book_logic = function()

  ObjSet( "spr_altar_greencrystal", { visible = 1, input = 1 } )

end;
private.use_book_inv = function()
  common_impl.ProcessMultiUseAll("book", "book")
end;
private.use_book_beg = function()
  ObjDelete( "gfx_altar_book_zone" );
end;
private.use_book_end = function()
  ObjSet( "spr_altar_rosary", { visible = 1} )
  ObjSet("anm_altar_anm",{animfunc="end_book1",frame=0})
  ObjSet( "spr_chapel_tr_book", {alp = 1} );
  ObjDelete("spr_chapel_tr_cover_altar")  
  if common_impl.ZzCompleteCheck("use_book") then ObjSet( common_impl.hint["use_book"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_book", private.use_book_inv );
cmn.AddSubscriber( "use_book", private.use_book_beg, private.room_objname );
cmn.AddSubscriber( "use_book", private.use_book_end, private.room_objname );
cmn.AddSubscriber( "use_book", private.use_book_logic );
cmn.AddSubscriber( "use_book_inv", private.use_book_inv, private.room_objname );
cmn.AddSubscriber( "use_book_beg", private.use_book_beg, private.room_objname );
cmn.AddSubscriber( "use_book_end", private.use_book_end, private.room_objname );
cmn.AddSubscriber( "use_book_end", private.use_book_logic );
--------------------------------------------------------------------------------------------
function public.use_book( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_book" );
    cmn.CallEventHandler( "use_book_end" );
    common_impl.Lock(0);
    
    if common_impl.ZzCompleteCheck("use_book") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_book_inv" );
  cmn.CallEventHandler( "use_book_beg" );
  common_impl.Lock(1);
  ld.StartTimer( 0.9, function() ObjSet( "fx_altar_book", {active = 1, visible = 1} ); end )
  ld.AnimPlay( "anm_altar_anm", "use_book", func_end );
  SoundSfx( "aud_use_book_altar" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_rosary" ] = { type = "get", get_obj = "spr_altar_rosary", room = "rm_chapel", zz = "zz_altar", zz_gate = "gzz_chapel_altar" };

private.get_rosary_logic = function()
  
end;
private.get_rosary_inv = function()
  interface.InventoryItemAdd("inv_rosary","spr_altar_rosary");
end;
private.get_rosary_beg = function()
  ObjDelete("gfx_altar_rosary")
end;
private.get_rosary_end = function()
  ObjDelete("spr_altar_rosary_sh")
  ObjDelete("spr_chapel_tr_cap")
  if common_impl.ZzCompleteCheck("get_rosary") then ObjSet( common_impl.hint["get_rosary"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_rosary", private.get_rosary_inv );
cmn.AddSubscriber( "get_rosary", private.get_rosary_beg, private.room_objname );
cmn.AddSubscriber( "get_rosary", private.get_rosary_end, private.room_objname );
cmn.AddSubscriber( "get_rosary", private.get_rosary_logic );
--------------------------------------------------------------------
function public.get_rosary()
  cmn.SetEventDone( "get_rosary" );
  cmn.CallEventHandler( "get_rosary" );
  if common_impl.ZzCompleteCheck("get_rosary") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_greencrystal" ] = { type = "get", get_obj = "spr_altar_greencrystal", room = "rm_chapel", zz = "zz_altar", zz_gate = "gzz_chapel_altar" };

private.get_greencrystal_logic = function()
  ObjSet( "spr_altar_rosary", {input = 1, visible = 1} );
end;
private.get_greencrystal_inv = function()
  interface.InventoryItemAdd("inv_greencrystal","spr_altar_greencrystal");
end;
private.get_greencrystal_beg = function()
  ObjDelete("gfx_altar_greencrystal")
end;
private.get_greencrystal_end = function()
  ObjSet( "gfx_altar_rosary", {visible = 1} );
  ObjDelete("spr_altar_greencr_sh")
  ObjDelete("spr_chapel_tr_greencrystal")  
  if common_impl.ZzCompleteCheck("get_greencrystal") then ObjSet( common_impl.hint["get_greencrystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_greencrystal", private.get_greencrystal_inv );
cmn.AddSubscriber( "get_greencrystal", private.get_greencrystal_beg, private.room_objname );
cmn.AddSubscriber( "get_greencrystal", private.get_greencrystal_end, private.room_objname );
cmn.AddSubscriber( "get_greencrystal", private.get_greencrystal_logic );
--------------------------------------------------------------------
function public.get_greencrystal()
  cmn.SetEventDone( "get_greencrystal" );
  cmn.CallEventHandler( "get_greencrystal" );
  if common_impl.ZzCompleteCheck("get_greencrystal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_vitrage *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_glassshard" ] = { type = "use", inv_obj = "inv_glassshard", use_place = "gfx_vitrage_glassshard_zone", room = "rm_chapel", zz = "zz_vitrage", zz_gate = "gzz_chapel_vitrage" };

private.use_glassshard_logic = function()
  ObjSet( "gmg_chapel_vitragemg", { visible = 1, input = 1 } )

end;
private.use_glassshard_inv = function()
  common_impl.ProcessMultiUseAll("glassshard", "glassshard")
end;
private.use_glassshard_beg = function()
  ObjDelete( "gfx_vitrage_glassshard_zone" );
end;
private.use_glassshard_end = function()
  if common_impl.ZzCompleteCheck("use_glassshard") then ObjSet( common_impl.hint["use_glassshard"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_glassshard", private.use_glassshard_inv );
cmn.AddSubscriber( "use_glassshard", private.use_glassshard_beg, private.room_objname );
cmn.AddSubscriber( "use_glassshard", private.use_glassshard_end, private.room_objname );
cmn.AddSubscriber( "use_glassshard", private.use_glassshard_logic );
cmn.AddSubscriber( "use_glassshard_inv", private.use_glassshard_inv, private.room_objname );
cmn.AddSubscriber( "use_glassshard_beg", private.use_glassshard_beg, private.room_objname );
cmn.AddSubscriber( "use_glassshard_end", private.use_glassshard_end, private.room_objname );
cmn.AddSubscriber( "use_glassshard_end", private.use_glassshard_logic );
--------------------------------------------------------------------------------------------
function public.use_glassshard( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_glassshard" );
    cmn.CallEventHandler( "use_glassshard_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_glassshard") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_glassshard_inv" );
  cmn.CallEventHandler( "use_glassshard_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_vitrage_anm_vitrage", "uae_c", func_end );
  SoundSfx( "aud_use_part_vitrage" );
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_statue *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wing1" ] = { type = "use", inv_obj = "inv_wing1", use_place = "gfx_statue_wing1_zone", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.use_wing1_logic = function()
  if ld.CheckRequirements( {"use_wing1","use_wing2"} ) then
    ObjSet( "spr_statue_shield", { visible = 1, input = 1 } )
  end;

end;
private.use_wing1_inv = function()
  common_impl.ProcessMultiUseAll("wing1", "wing1")
end;
private.use_wing1_beg = function()
  ObjDelete( "gfx_statue_wing1_zone" );
end;
private.use_wing1_end = function()
  if ld.CheckRequirements( {"use_wing1","use_wing2"} ) then
    ObjDelete("anm_statue_wing1")
    ObjDelete("anm_statue_wing2")
    ObjSet("anm_statue_anm",{animfunc="end_shield_amulethorse",frame=0})
    ObjSet( "spr_statue_sh_shield", {visible = 1} );
    ObjSet( "spr_statue_sh_amulethorse2", {visible = 1} );
    ObjSet( "spr_statue_amulethorse2", { visible = 1} )
    ObjSet( "spr_chapel_tr_hand_left1", {alp = 1} );
    ObjDelete("spr_chapel_tr_hand_left")
  else 
    ObjSet("anm_statue_wing1",{animfunc="end_wing",frame=0})
  end  
  ObjSet( "spr_chapel_tr_wing_left", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_wing1") then ObjSet( common_impl.hint["use_wing1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wing1", private.use_wing1_inv );
cmn.AddSubscriber( "use_wing1", private.use_wing1_beg, private.room_objname );
cmn.AddSubscriber( "use_wing1", private.use_wing1_end, private.room_objname );
cmn.AddSubscriber( "use_wing1", private.use_wing1_logic );
cmn.AddSubscriber( "use_wing1_inv", private.use_wing1_inv, private.room_objname );
cmn.AddSubscriber( "use_wing1_beg", private.use_wing1_beg, private.room_objname );
cmn.AddSubscriber( "use_wing1_end", private.use_wing1_end, private.room_objname );
cmn.AddSubscriber( "use_wing1_end", private.use_wing1_logic );
--------------------------------------------------------------------------------------------
function public.use_wing1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wing1" );
    cmn.CallEventHandler( "use_wing1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wing1") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    if cmn.IsEventDone("use_wing2") then
      ObjDelete("anm_statue_wing1")
      ObjDelete("anm_statue_wing2")
      ld.AnimPlay("anm_statue_anm","open_hand",func_end)
      SoundSfx( "aud_statue_move_hand" );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wing1_inv" );
  cmn.CallEventHandler( "use_wing1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_statue_wing1", "use_wing", f_step );
  SoundSfx( "aud_use_wing_statue" );


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wing2" ] = { type = "use", inv_obj = "inv_wing2", use_place = "gfx_statue_wing2_zone", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.use_wing2_logic = function()
  if ld.CheckRequirements( {"use_wing2","use_wing1"} ) then
    ObjSet( "spr_statue_shield", { visible = 1, input = 1 } )
  end;

end;
private.use_wing2_inv = function()
  common_impl.ProcessMultiUseAll("wing2", "wing2")
end;
private.use_wing2_beg = function()
  ObjDelete( "gfx_statue_wing2_zone" );
end;
private.use_wing2_end = function()
  if ld.CheckRequirements( {"use_wing1","use_wing2"} ) then
    ObjDelete("anm_statue_wing1")
    ObjDelete("anm_statue_wing2")
    ObjSet("anm_statue_anm",{animfunc="end_shield_amulethorse",frame=0})
    ObjSet( "spr_statue_sh_shield", {visible = 1} );
    ObjSet( "spr_statue_sh_amulethorse2", {visible = 1} );
    ObjSet( "spr_statue_amulethorse2", { visible = 1} )  
    ObjSet( "spr_chapel_tr_hand_left1", {alp = 1} );
    ObjDelete("spr_chapel_tr_hand_left")    
  else 
    ObjSet("anm_statue_wing2",{animfunc="end_wing1",frame=0})
  end 
  ObjSet( "spr_chapel_tr_wing_right", {alp = 1} );  
  if common_impl.ZzCompleteCheck("use_wing2") then ObjSet( common_impl.hint["use_wing2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wing2", private.use_wing2_inv );
cmn.AddSubscriber( "use_wing2", private.use_wing2_beg, private.room_objname );
cmn.AddSubscriber( "use_wing2", private.use_wing2_end, private.room_objname );
cmn.AddSubscriber( "use_wing2", private.use_wing2_logic );
cmn.AddSubscriber( "use_wing2_inv", private.use_wing2_inv, private.room_objname );
cmn.AddSubscriber( "use_wing2_beg", private.use_wing2_beg, private.room_objname );
cmn.AddSubscriber( "use_wing2_end", private.use_wing2_end, private.room_objname );
cmn.AddSubscriber( "use_wing2_end", private.use_wing2_logic );
--------------------------------------------------------------------------------------------
function public.use_wing2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wing2" );
    cmn.CallEventHandler( "use_wing2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wing2") then ld.CloseSubRoom() end;
  end;
  local f_step = function()
    if cmn.IsEventDone("use_wing1") then
      ObjDelete("anm_statue_wing1")
      ObjDelete("anm_statue_wing2")
      ld.AnimPlay("anm_statue_anm","open_hand",func_end)
      SoundSfx( "aud_statue_move_hand" );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wing2_inv" );
  cmn.CallEventHandler( "use_wing2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_statue_wing2", "use_wing1", f_step );
  SoundSfx( "aud_use_wing_statue" );



end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shield" ] = { type = "get", get_obj = "spr_statue_shield", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.get_shield_logic = function()
  ObjSet( "spr_statue_amulethorse2", { visible = 1, input = 1 } )
end;
private.get_shield_inv = function()
  interface.InventoryItemAdd("inv_shield","spr_statue_shield");
end;
private.get_shield_beg = function()
  ObjDelete("gfx_statue_shield")
end;
private.get_shield_end = function()
  ObjDelete("spr_statue_sh_shield")
  ObjSet( "gfx_statue_scottishstatue2", {visible = 1} );
  ObjDelete("spr_chapel_tr_shield")
  if common_impl.ZzCompleteCheck("get_shield") then ObjSet( common_impl.hint["get_shield"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_shield", private.get_shield_inv );
cmn.AddSubscriber( "get_shield", private.get_shield_beg, private.room_objname );
cmn.AddSubscriber( "get_shield", private.get_shield_end, private.room_objname );
cmn.AddSubscriber( "get_shield", private.get_shield_logic );
--------------------------------------------------------------------
function public.get_shield()
  cmn.SetEventDone( "get_shield" );
  cmn.CallEventHandler( "get_shield" );
  if common_impl.ZzCompleteCheck("get_shield") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amulethorse2" ] = { type = "get", get_obj = "spr_statue_amulethorse2", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.get_amulethorse2_logic = function()
  ObjSet( "gfx_statue_scepter_zone", {input = 1, visible = 1} );
end;
private.get_amulethorse2_inv = function()
  interface.InventoryItemAdd("inv_amulethorse","spr_statue_amulethorse2",function() level_inv.ProcessGetAmulethorseAll( "get_amulethorse2" ) end);
end;
private.get_amulethorse2_beg = function()
  ObjDelete("gfx_statue_amulethorse2")
end;
private.get_amulethorse2_end = function()
  ObjDelete("spr_statue_sh_amulethorse2")
  ObjDelete("spr_chapel_tr_amulethorse2")  
  if common_impl.ZzCompleteCheck("get_amulethorse2") then ObjSet( common_impl.hint["get_amulethorse2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amulethorse2", private.get_amulethorse2_inv );
cmn.AddSubscriber( "get_amulethorse2", private.get_amulethorse2_beg, private.room_objname );
cmn.AddSubscriber( "get_amulethorse2", private.get_amulethorse2_end, private.room_objname );
cmn.AddSubscriber( "get_amulethorse2", private.get_amulethorse2_logic );
--------------------------------------------------------------------
function public.get_amulethorse2()
  cmn.SetEventDone( "get_amulethorse2" );
  cmn.CallEventHandler( "get_amulethorse2" );
  if common_impl.ZzCompleteCheck("get_amulethorse2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scepter" ] = { type = "use", inv_obj = "inv_scepter", use_place = "gfx_statue_scepter_zone", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.use_scepter_logic = function()
  ObjSet( "spr_statue_casket", { visible = 1 } )
  ObjSet( "spr_statue_scottishstatue2", { visible = 1, input = 1 } )

end;
private.use_scepter_inv = function()
  common_impl.ProcessMultiUseAll("scepter", "scepter")
end;
private.use_scepter_beg = function()
  ObjDelete( "gfx_statue_scepter_zone" );
end;
private.use_scepter_end = function()
  ObjSet( "spr_statue_sh_scottishstatue2", {visible = 1} );
  ObjSet( "spr_statue_sh_casket", {visible = 1} );
  ObjSet("anm_statue_anm",{animfunc="end_scottishstatue_casket",frame=0})
  ObjSet( "spr_chapel_tr_scepter", {alp = 1} );
  ObjDelete("spr_chapel_tr_cover")
  if common_impl.ZzCompleteCheck("use_scepter") then ObjSet( common_impl.hint["use_scepter"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scepter", private.use_scepter_inv );
cmn.AddSubscriber( "use_scepter", private.use_scepter_beg, private.room_objname );
cmn.AddSubscriber( "use_scepter", private.use_scepter_end, private.room_objname );
cmn.AddSubscriber( "use_scepter", private.use_scepter_logic );
cmn.AddSubscriber( "use_scepter_inv", private.use_scepter_inv, private.room_objname );
cmn.AddSubscriber( "use_scepter_beg", private.use_scepter_beg, private.room_objname );
cmn.AddSubscriber( "use_scepter_end", private.use_scepter_end, private.room_objname );
cmn.AddSubscriber( "use_scepter_end", private.use_scepter_logic );
--------------------------------------------------------------------------------------------
function public.use_scepter( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scepter" );
    cmn.CallEventHandler( "use_scepter_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scepter") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scepter_inv" );
  cmn.CallEventHandler( "use_scepter_beg" );
  common_impl.Lock(1);

  ld.AnimPlay("anm_statue_anm","use_scepter",func_end)
  SoundSfx( "aud_use_scepter_statue" );


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_casket" ] = { type = "get", get_obj = "spr_statue_casket", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.get_casket_logic = function()
  
end;
private.get_casket_inv = function()
  interface.InventoryItemAdd("inv_casket","spr_statue_casket");
  ObjSet( "inv_casket", { drag = 0 } );
end;
private.get_casket_beg = function()
  ObjDelete("gfx_statue_casket")
end;
private.get_casket_end = function()
  ObjDelete("spr_chapel_tr_casket")
  if common_impl.ZzCompleteCheck("get_casket") then ObjSet( common_impl.hint["get_casket"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_casket", private.get_casket_inv );
cmn.AddSubscriber( "get_casket", private.get_casket_beg, private.room_objname );
cmn.AddSubscriber( "get_casket", private.get_casket_end, private.room_objname );
cmn.AddSubscriber( "get_casket", private.get_casket_logic );
--------------------------------------------------------------------
function public.get_casket()
  cmn.SetEventDone( "get_casket" );
  cmn.CallEventHandler( "get_casket" );
  if common_impl.ZzCompleteCheck("get_casket") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scottishstatue2" ] = { type = "get", get_obj = "spr_statue_scottishstatue2", room = "rm_chapel", zz = "zz_statue", zz_gate = "gzz_chapel_statue" };

private.get_scottishstatue2_logic = function()
    ObjSet( "spr_statue_casket", { visible = 1, input = 1 } )
end;
private.get_scottishstatue2_inv = function()
  interface.InventoryItemAdd("inv_scottishstatue2","spr_statue_scottishstatue2");
end;
private.get_scottishstatue2_beg = function()
  ObjDelete("gfx_statue_scottishstatue2")
end;
private.get_scottishstatue2_end = function()
  ObjDelete("spr_statue_sh_scottishstatue2")
  ObjSet( "gfx_statue_casket", {visible = 1} );
  ObjDelete("spr_chapel_tr_scottishstatue2")  
  if common_impl.ZzCompleteCheck("get_scottishstatue2") then ObjSet( common_impl.hint["get_scottishstatue2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_scottishstatue2", private.get_scottishstatue2_inv );
cmn.AddSubscriber( "get_scottishstatue2", private.get_scottishstatue2_beg, private.room_objname );
cmn.AddSubscriber( "get_scottishstatue2", private.get_scottishstatue2_end, private.room_objname );
cmn.AddSubscriber( "get_scottishstatue2", private.get_scottishstatue2_logic );
--------------------------------------------------------------------
function public.get_scottishstatue2()
  cmn.SetEventDone( "get_scottishstatue2" );
  cmn.CallEventHandler( "get_scottishstatue2" );
  if common_impl.ZzCompleteCheck("get_scottishstatue2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_vitragemg_for_chapel = function()
    if ld.CheckRequirements( {"win_vitragemg"} ) then
      ObjSet( "spr_chapel_tr_open", {alp = 1} );
      ObjSet( "spr_chapel_tr_wing2", {alp = 1} );      
    end   
  end;
  cmn.AddSubscriber("win_vitragemg", win_vitragemg_for_chapel, private.room_objname )
  
  local get_wing2_for_chapel = function()
    if ld.CheckRequirements( {"get_wing2"} ) then
      ObjSet( "gmg_chapel_vitragemg", {input = 0, visible = 0} );
      ObjDelete("spr_chapel_tr_wing2")
    end
   
  end;
  cmn.AddSubscriber("get_wing2", get_wing2_for_chapel, private.room_objname )  

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_chapel();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_chapel_env" );
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_statue" );
  function zz_statue.Open()
  end;
  function zz_statue.PreOpen()
  end;
  function zz_statue.PreClose()
  end;
  function zz_statue.Close()
  end;

  subroom.Define( "zz_vitrage" );
  function zz_vitrage.Open()
  end;
  function zz_vitrage.PreOpen()
  end;
  function zz_vitrage.PreClose()
  end;
  function zz_vitrage.Close()
  end;

  subroom.Define( "zz_altar" );
  function zz_altar.Open()
  end;
  function zz_altar.PreOpen()
  end;
  function zz_altar.PreClose()
  end;
  function zz_altar.Close()
  end;
  
end;
--*********************************************************************************************************************