-- name=rm_corridor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridor";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_corridor()
  if not ( cmn.IsEventDone( "opn_corridor" ) ) then
    cmn.SetEventDone( "opn_corridor" );
    cmn.CallEventHandler( "opn_corridor" )
    ld.ShowBbt("opn_corridor");
    SoundTheme( "aud_adventure2_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_corridor = function() end;
local opn_corridor_logic = function() end;
cmn.AddSubscriber( "opn_corridor", opn_corridor_logic )
cmn.AddSubscriber( "opn_corridor", opn_corridor, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tube *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
function public.tube_spider_zone_clk()
  local func_end = function()
    ObjSet( "obj_tube_spider_clk_zone", {input = 1} );
  end;
  
 ObjSet( "obj_tube_spider_clk_zone", {input = 0} );
 SoundSfx( "aud_touch_spider_corridor" );
 ld.AnimPlay( "anm_tube_anm_spider", "click_spider1", func_end ) 
end;  
--------------------------------------------------------------------

common_impl.hint[ "get_numeral" ] = { type = "get", get_obj = "spr_tube_numeral", room = "rm_corridor", zz = "zz_tube", zz_gate = "gzz_corridor_tube" };

private.get_numeral_logic = function()
  
end;
private.get_numeral_inv = function()
  interface.InventoryItemAdd("inv_numeral","spr_tube_numeral");
end;
private.get_numeral_beg = function()
  ObjDelete("gfx_tube_numeral")
end;
private.get_numeral_end = function()
  if common_impl.ZzCompleteCheck("get_numeral") then ObjSet( common_impl.hint["get_numeral"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tube_sh_numeral");
  --  ObjDelete("spr_tube_tr_tube2");
end;

cmn.AddSubscriber( "get_numeral", private.get_numeral_inv );
cmn.AddSubscriber( "get_numeral", private.get_numeral_beg, private.room_objname );
cmn.AddSubscriber( "get_numeral", private.get_numeral_end, private.room_objname );
cmn.AddSubscriber( "get_numeral", private.get_numeral_logic );
--------------------------------------------------------------------
function public.get_numeral()
  cmn.SetEventDone( "get_numeral" );
  cmn.CallEventHandler( "get_numeral" );
  if common_impl.ZzCompleteCheck("get_numeral") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_fiddlestick_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_fiddlestick' )
  end;
  
  ld.Lock(1);
  SoundSfx( "aud_touch_snake_corridor" );
  ld.AnimPlay( "anm_tube_anm", "idle_belt", func_end )
end;  


common_impl.hint[ "use_fiddlestick" ] = { type = "use", inv_obj = "inv_fiddlestick", use_place = "gfx_tube_fiddlestick_zone", room = "rm_corridor", zz = "zz_tube", zz_gate = "gzz_corridor_tube" };

private.use_fiddlestick_logic = function()
  ObjSet( "spr_tube_amuletlizard3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_tube_belt", { visible = 1, input = 1, active = 1 } )

end;
private.use_fiddlestick_inv = function()
  common_impl.ProcessMultiUseAll("fiddlestick", "fiddlestick")
end;
private.use_fiddlestick_beg = function()
  ObjDelete( "gfx_tube_fiddlestick_zone" );
end;
private.use_fiddlestick_end = function()
  if common_impl.ZzCompleteCheck("use_fiddlestick") then ObjSet( common_impl.hint["use_fiddlestick"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_tube_sh_belt", {visible = 1} );
  ObjSet( "spr_tube_sh_belt1", {visible = 1} );
  ObjSet( "spr_tube_sh_amuletlizard3", {visible = 1} );
  ObjDelete("anm_tube_anm");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fiddlestick", private.use_fiddlestick_inv );
cmn.AddSubscriber( "use_fiddlestick", private.use_fiddlestick_beg, private.room_objname );
cmn.AddSubscriber( "use_fiddlestick", private.use_fiddlestick_end, private.room_objname );
cmn.AddSubscriber( "use_fiddlestick", private.use_fiddlestick_logic );
cmn.AddSubscriber( "use_fiddlestick_inv", private.use_fiddlestick_inv, private.room_objname );
cmn.AddSubscriber( "use_fiddlestick_beg", private.use_fiddlestick_beg, private.room_objname );
cmn.AddSubscriber( "use_fiddlestick_end", private.use_fiddlestick_end, private.room_objname );
cmn.AddSubscriber( "use_fiddlestick_end", private.use_fiddlestick_logic );
--------------------------------------------------------------------------------------------
function public.use_fiddlestick( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fiddlestick" );
    cmn.CallEventHandler( "use_fiddlestick_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fiddlestick") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fiddlestick_inv" );
  cmn.CallEventHandler( "use_fiddlestick_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tube_anm", "use_fiddlestick1", func_end );
  SoundSfx( "aud_use_fiddlestick_corridor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletlizard3" ] = { type = "get", get_obj = "spr_tube_amuletlizard3", room = "rm_corridor", zz = "zz_tube", zz_gate = "gzz_corridor_tube" };

private.get_amuletlizard3_logic = function()
  
end;
private.get_amuletlizard3_inv = function()
  interface.InventoryItemAdd("inv_amuletlizard","spr_tube_amuletlizard3",function() level_inv.ProcessGetAmuletlizardAll( "get_amuletlizard3" ) end);
end;
private.get_amuletlizard3_beg = function()
  ObjDelete("gfx_tube_amuletlizard3")
end;
private.get_amuletlizard3_end = function()
  if common_impl.ZzCompleteCheck("get_amuletlizard3") then ObjSet( common_impl.hint["get_amuletlizard3"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tube_sh_amuletlizard3");
end;

cmn.AddSubscriber( "get_amuletlizard3", private.get_amuletlizard3_inv );
cmn.AddSubscriber( "get_amuletlizard3", private.get_amuletlizard3_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletlizard3", private.get_amuletlizard3_end, private.room_objname );
cmn.AddSubscriber( "get_amuletlizard3", private.get_amuletlizard3_logic );
--------------------------------------------------------------------
function public.get_amuletlizard3()
  cmn.SetEventDone( "get_amuletlizard3" );
  cmn.CallEventHandler( "get_amuletlizard3" );
  if common_impl.ZzCompleteCheck("get_amuletlizard3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_belt" ] = { type = "get", get_obj = "spr_tube_belt", room = "rm_corridor", zz = "zz_tube", zz_gate = "gzz_corridor_tube" };

private.get_belt_logic = function()
  
end;
private.get_belt_inv = function()
  interface.InventoryItemAdd("inv_belt","spr_tube_belt");
  ObjSet( "inv_belt", { drag = 0 } );
end;
private.get_belt_beg = function()
  ObjDelete("gfx_tube_belt")
end;
private.get_belt_end = function()
  if common_impl.ZzCompleteCheck("get_belt") then ObjSet( common_impl.hint["get_belt"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_tube_sh_belt");
  ObjDelete("spr_tube_sh_belt1");
end;

cmn.AddSubscriber( "get_belt", private.get_belt_inv );
cmn.AddSubscriber( "get_belt", private.get_belt_beg, private.room_objname );
cmn.AddSubscriber( "get_belt", private.get_belt_end, private.room_objname );
cmn.AddSubscriber( "get_belt", private.get_belt_logic );
--------------------------------------------------------------------
function public.get_belt()
  cmn.SetEventDone( "get_belt" );
  cmn.CallEventHandler( "get_belt" );
  if common_impl.ZzCompleteCheck("get_belt") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_hatch *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_handlebox" ] = { type = "get", get_obj = "spr_hatch_handlebox", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.get_handlebox_logic = function()
  ObjSet( "gfx_hatch_amuletlizard_zone", {active=1, input = 1, visible = 1} );
end;
private.get_handlebox_inv = function()
  interface.InventoryItemAdd("inv_handlebox","spr_hatch_handlebox");
end;
private.get_handlebox_beg = function()
  ObjDelete("gfx_hatch_handlebox")
end;
private.get_handlebox_end = function()
  if common_impl.ZzCompleteCheck("get_handlebox") then ObjSet( common_impl.hint["get_handlebox"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hatch_sh_handlebox");
end;

cmn.AddSubscriber( "get_handlebox", private.get_handlebox_inv );
cmn.AddSubscriber( "get_handlebox", private.get_handlebox_beg, private.room_objname );
cmn.AddSubscriber( "get_handlebox", private.get_handlebox_end, private.room_objname );
cmn.AddSubscriber( "get_handlebox", private.get_handlebox_logic );
--------------------------------------------------------------------
function public.get_handlebox()
  cmn.SetEventDone( "get_handlebox" );
  cmn.CallEventHandler( "get_handlebox" );
  if common_impl.ZzCompleteCheck("get_handlebox") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_spideramulet_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_spideramulet' );
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_hatch_anm_amuletspider", "idle_hatch", func_end )
  SoundSfx( "aud_touch_hatch_corridor" );
end;  



common_impl.hint[ "use_spideramulet" ] = { type = "use", inv_obj = "inv_spideramulet", use_place = "gfx_hatch_spideramulet_zone", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.use_spideramulet_logic = function()
  ObjSet( "spr_hatch_stoneleaf2", { visible = 1, input = 1, active = 1 } )

end;
private.use_spideramulet_inv = function()
  common_impl.ProcessMultiUseAll("spideramulet", "spideramulet")
end;
private.use_spideramulet_beg = function()
  ObjDelete( "gfx_hatch_spideramulet_zone" );
end;
private.use_spideramulet_end = function()
  if common_impl.ZzCompleteCheck("use_spideramulet") then ObjSet( common_impl.hint["use_spideramulet"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hatch_anm_amuletspider", {animfunc = "use_amuletspider", frame = 999 } );
  ObjSet( "spr_corridor_tr_hatch2", {pos_x=261, pos_y=523} );
  ObjSet( "spr_corridor_medallion1", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spideramulet", private.use_spideramulet_inv );
cmn.AddSubscriber( "use_spideramulet", private.use_spideramulet_beg, private.room_objname );
cmn.AddSubscriber( "use_spideramulet", private.use_spideramulet_end, private.room_objname );
cmn.AddSubscriber( "use_spideramulet", private.use_spideramulet_logic );
cmn.AddSubscriber( "use_spideramulet_inv", private.use_spideramulet_inv, private.room_objname );
cmn.AddSubscriber( "use_spideramulet_beg", private.use_spideramulet_beg, private.room_objname );
cmn.AddSubscriber( "use_spideramulet_end", private.use_spideramulet_end, private.room_objname );
cmn.AddSubscriber( "use_spideramulet_end", private.use_spideramulet_logic );
--------------------------------------------------------------------------------------------
function public.use_spideramulet( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spideramulet" );
    cmn.CallEventHandler( "use_spideramulet_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spideramulet") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spideramulet_inv" );
  cmn.CallEventHandler( "use_spideramulet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hatch_anm_amuletspider", "use_amuletspider", func_end );
  SoundSfx( "aud_use_spideramulet_corridor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stoneleaf2" ] = { type = "get", get_obj = "spr_hatch_stoneleaf2", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.get_stoneleaf2_logic = function()
  
end;
private.get_stoneleaf2_inv = function()
  interface.InventoryItemAdd("inv_stoneleaf2","spr_hatch_stoneleaf2");
end;
private.get_stoneleaf2_beg = function()
  ObjDelete("gfx_hatch_stoneleaf2")
end;
private.get_stoneleaf2_end = function()
  if common_impl.ZzCompleteCheck("get_stoneleaf2") then ObjSet( common_impl.hint["get_stoneleaf2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hatch_sh_stoneleaf2");
end;

cmn.AddSubscriber( "get_stoneleaf2", private.get_stoneleaf2_inv );
cmn.AddSubscriber( "get_stoneleaf2", private.get_stoneleaf2_beg, private.room_objname );
cmn.AddSubscriber( "get_stoneleaf2", private.get_stoneleaf2_end, private.room_objname );
cmn.AddSubscriber( "get_stoneleaf2", private.get_stoneleaf2_logic );
--------------------------------------------------------------------
function public.get_stoneleaf2()
  cmn.SetEventDone( "get_stoneleaf2" );
  cmn.CallEventHandler( "get_stoneleaf2" );
  if common_impl.ZzCompleteCheck("get_stoneleaf2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuletlizard_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuletlizard' )
  end;  
  
  ld.Lock(1);
  if ld.CheckRequirements( {"get_handlebox"} ) then
    SoundSfx( "aud_touch_hatch_corridor" );
    ld.AnimPlay( "anm_hatch_anm_lizardcharm", "idle_hatch2", func_end )
  else
    func_end();
  end;
end;  

common_impl.hint[ "use_amuletlizard" ] = { type = "use", inv_obj = "inv_amuletlizard", use_place = "gfx_hatch_amuletlizard_zone", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.use_amuletlizard_logic = function()
  ObjSet( "spr_hatch_chip", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_hatch_hammer", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_hatch_nails", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletlizard_inv = function()
  common_impl.ProcessMultiUseAll("amuletlizard", "amuletlizard")
end;
private.use_amuletlizard_beg = function()
  ObjDelete( "gfx_hatch_amuletlizard_zone" );
end;
private.use_amuletlizard_end = function()
  if common_impl.ZzCompleteCheck("use_amuletlizard") then ObjSet( common_impl.hint["use_amuletlizard"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hatch_anm_lizardcharm", {animfunc = "use_lizardcharm", frame = 999 } );
  ObjSet( "spr_corridor_tr_hatch3", {pos_x=400, pos_y=529 } );
  ObjSet( "spr_corridor_medallion2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletlizard", private.use_amuletlizard_inv );
cmn.AddSubscriber( "use_amuletlizard", private.use_amuletlizard_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletlizard", private.use_amuletlizard_end, private.room_objname );
cmn.AddSubscriber( "use_amuletlizard", private.use_amuletlizard_logic );
cmn.AddSubscriber( "use_amuletlizard_inv", private.use_amuletlizard_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletlizard_beg", private.use_amuletlizard_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletlizard_end", private.use_amuletlizard_end, private.room_objname );
cmn.AddSubscriber( "use_amuletlizard_end", private.use_amuletlizard_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletlizard( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletlizard" );
    cmn.CallEventHandler( "use_amuletlizard_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletlizard") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletlizard_inv" );
  cmn.CallEventHandler( "use_amuletlizard_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hatch_anm_lizardcharm", "use_lizardcharm", func_end );
  SoundSfx( "aud_use_amuletlizard_corridor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_chip" ] = { type = "get", get_obj = "spr_hatch_chip", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.get_chip_logic = function()
  
end;
private.get_chip_inv = function()
  interface.InventoryItemAdd("inv_chip","spr_hatch_chip");
end;
private.get_chip_beg = function()
  ObjDelete("gfx_hatch_chip")
end;
private.get_chip_end = function()
  if common_impl.ZzCompleteCheck("get_chip") then ObjSet( common_impl.hint["get_chip"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hatch_sh_chip");
end;

cmn.AddSubscriber( "get_chip", private.get_chip_inv );
cmn.AddSubscriber( "get_chip", private.get_chip_beg, private.room_objname );
cmn.AddSubscriber( "get_chip", private.get_chip_end, private.room_objname );
cmn.AddSubscriber( "get_chip", private.get_chip_logic );
--------------------------------------------------------------------
function public.get_chip()
  cmn.SetEventDone( "get_chip" );
  cmn.CallEventHandler( "get_chip" );
  if common_impl.ZzCompleteCheck("get_chip") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hammer" ] = { type = "get", get_obj = "spr_hatch_hammer", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.get_hammer_logic = function()
  
end;
private.get_hammer_inv = function()
  interface.InventoryItemAdd("inv_hammer","spr_hatch_hammer");
  ObjSet( "inv_hammer", { drag = 0 } );
end;
private.get_hammer_beg = function()
  ObjDelete("gfx_hatch_hammer")
end;
private.get_hammer_end = function()
  if common_impl.ZzCompleteCheck("get_hammer") then ObjSet( common_impl.hint["get_hammer"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hatch_sh_hammer");
end;

cmn.AddSubscriber( "get_hammer", private.get_hammer_inv );
cmn.AddSubscriber( "get_hammer", private.get_hammer_beg, private.room_objname );
cmn.AddSubscriber( "get_hammer", private.get_hammer_end, private.room_objname );
cmn.AddSubscriber( "get_hammer", private.get_hammer_logic );
--------------------------------------------------------------------
function public.get_hammer()
  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );
  if common_impl.ZzCompleteCheck("get_hammer") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_nails" ] = { type = "get", get_obj = "spr_hatch_nails", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.get_nails_logic = function()
  
end;
private.get_nails_inv = function()
  interface.InventoryItemAdd("inv_nails","spr_hatch_nails");
end;
private.get_nails_beg = function()
  ObjDelete("gfx_hatch_nails")
end;
private.get_nails_end = function()
  if common_impl.ZzCompleteCheck("get_nails") then ObjSet( common_impl.hint["get_nails"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hatch_sh_nails");
end;

cmn.AddSubscriber( "get_nails", private.get_nails_inv );
cmn.AddSubscriber( "get_nails", private.get_nails_beg, private.room_objname );
cmn.AddSubscriber( "get_nails", private.get_nails_end, private.room_objname );
cmn.AddSubscriber( "get_nails", private.get_nails_logic );
--------------------------------------------------------------------
function public.get_nails()
  cmn.SetEventDone( "get_nails" );
  cmn.CallEventHandler( "get_nails" );
  if common_impl.ZzCompleteCheck("get_nails") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_shardpictures_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_shardpictures' )
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_hatch_anm_shardpictures", "idle_hatch1", func_end )
  SoundSfx( "aud_touch_hatch_corridor" );
end;  


common_impl.hint[ "use_shardpictures" ] = { type = "use", inv_obj = "inv_shardpictures", use_place = "gfx_hatch_shardpictures_zone", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.use_shardpictures_logic = function()
  ObjSet( "spr_hatch_earlstamp", { visible = 1, input = 1, active = 1 } )

end;
private.use_shardpictures_inv = function()
  common_impl.ProcessMultiUseAll("shardpictures", "shardpictures")
end;
private.use_shardpictures_beg = function()
  ObjDelete( "gfx_hatch_shardpictures_zone" );
end;
private.use_shardpictures_end = function()
  if common_impl.ZzCompleteCheck("use_shardpictures") then ObjSet( common_impl.hint["use_shardpictures"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hatch_anm_shardpictures", {animfunc = "use_shardpictures", frame = 999 } );
  ObjSet( "spr_corridor_tr_hatch1", {pos_x=354, pos_y=483 } );
  ObjSet( "spr_corridor_medallion3", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_shardpictures", private.use_shardpictures_inv );
cmn.AddSubscriber( "use_shardpictures", private.use_shardpictures_beg, private.room_objname );
cmn.AddSubscriber( "use_shardpictures", private.use_shardpictures_end, private.room_objname );
cmn.AddSubscriber( "use_shardpictures", private.use_shardpictures_logic );
cmn.AddSubscriber( "use_shardpictures_inv", private.use_shardpictures_inv, private.room_objname );
cmn.AddSubscriber( "use_shardpictures_beg", private.use_shardpictures_beg, private.room_objname );
cmn.AddSubscriber( "use_shardpictures_end", private.use_shardpictures_end, private.room_objname );
cmn.AddSubscriber( "use_shardpictures_end", private.use_shardpictures_logic );
--------------------------------------------------------------------------------------------
function public.use_shardpictures( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_shardpictures" );
    cmn.CallEventHandler( "use_shardpictures_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_shardpictures") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_shardpictures_inv" );
  cmn.CallEventHandler( "use_shardpictures_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hatch_anm_shardpictures", "use_shardpictures", func_end );
  SoundSfx( "aud_use_shardpictures_corridor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_earlstamp" ] = { type = "get", get_obj = "spr_hatch_earlstamp", room = "rm_corridor", zz = "zz_hatch", zz_gate = "gzz_corridor_hatch" };

private.get_earlstamp_logic = function()
  
end;
private.get_earlstamp_inv = function()
  interface.InventoryItemAdd("inv_earlstamp","spr_hatch_earlstamp");
  ObjSet( "inv_earlstamp", { drag = 0 } );
end;
private.get_earlstamp_beg = function()
  ObjDelete("gfx_hatch_earlstamp")
end;
private.get_earlstamp_end = function()
  if common_impl.ZzCompleteCheck("get_earlstamp") then ObjSet( common_impl.hint["get_earlstamp"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hatch_sh_earlstamp");
end;

cmn.AddSubscriber( "get_earlstamp", private.get_earlstamp_inv );
cmn.AddSubscriber( "get_earlstamp", private.get_earlstamp_beg, private.room_objname );
cmn.AddSubscriber( "get_earlstamp", private.get_earlstamp_end, private.room_objname );
cmn.AddSubscriber( "get_earlstamp", private.get_earlstamp_logic );
--------------------------------------------------------------------
function public.get_earlstamp()
  cmn.SetEventDone( "get_earlstamp" );
  cmn.CallEventHandler( "get_earlstamp" );
  if common_impl.ZzCompleteCheck("get_earlstamp") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_hidingplace *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_moss" ] = { type = "click", use_place = "gfx_hidingplace_clk_moss_zone", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.clk_moss_logic = function()
  ObjSet( "gfx_hidingplace_screw_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_hidingplace_amuleteye_zone", {visible = 1, input=1, active=1} );
  ObjSet( "gfx_hidingplace_chip_zone", {visible = 1, input=1, active=1} );
end;
private.clk_moss_beg = function()
  ObjDelete( "gfx_hidingplace_clk_moss_zone" );
end;
private.clk_moss_end = function()
  if common_impl.ZzCompleteCheck("clk_moss") then ObjSet( common_impl.hint["clk_moss"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_hidingplace_anm");
  ObjDelete("obj_corridor_hidingplace_brush_root");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_moss", private.clk_moss_beg, private.room_objname );
cmn.AddSubscriber( "clk_moss", private.clk_moss_end, private.room_objname );
cmn.AddSubscriber( "clk_moss", private.clk_moss_logic );
cmn.AddSubscriber( "clk_moss_beg", private.clk_moss_beg, private.room_objname );
cmn.AddSubscriber( "clk_moss_end", private.clk_moss_end, private.room_objname );
cmn.AddSubscriber( "clk_moss_end", private.clk_moss_logic );
--------------------------------------------------------------------------------------------
function public.clk_moss()

  local func_end = function()
    cmn.SetEventDone( "clk_moss" );
    cmn.CallEventHandler( "clk_moss_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_moss") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_moss_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hidingplace_anm", "brushwood", func_end );
  SoundSfx( "aud_clk_moss" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_screw_zone_clk()
  local func_end = function()
    ld.Lock(0);    
    common_impl.ShowBbt( 'need_screw' )
  end;

  ld.Lock(1);
  ld.AnimPlay( "anm_hidingplace_anm_screw", "idle_cover", func_end )  
  SoundSfx( "aud_touch_hidingplance_corridor" );
end;  

common_impl.hint[ "use_screw" ] = { type = "use", inv_obj = "inv_screw", use_place = "gfx_hidingplace_screw_zone", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.use_screw_logic = function()
  ObjSet( "spr_hidingplace_numeral2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_hidingplace_pick_hidingplace_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_screw_inv = function()
  common_impl.ProcessMultiUseAll("screw", "screw")
end;
private.use_screw_beg = function()
  ObjDelete( "gfx_hidingplace_screw_zone" );
end;
private.use_screw_end = function()
  if common_impl.ZzCompleteCheck("use_screw") then ObjSet( common_impl.hint["use_screw"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hidingplace_anm_screw", {animfunc = "end_screw", frame = 0 } );
  ObjSet( "spr_hidingplace_sh_numeral2", {visible = 1} );
  ObjSet( "spr_corridor_tr_cover_open", {visible = 1} );
  ObjDelete("spr_corridor_tr_cover");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screw", private.use_screw_inv );
cmn.AddSubscriber( "use_screw", private.use_screw_beg, private.room_objname );
cmn.AddSubscriber( "use_screw", private.use_screw_end, private.room_objname );
cmn.AddSubscriber( "use_screw", private.use_screw_logic );
cmn.AddSubscriber( "use_screw_inv", private.use_screw_inv, private.room_objname );
cmn.AddSubscriber( "use_screw_beg", private.use_screw_beg, private.room_objname );
cmn.AddSubscriber( "use_screw_end", private.use_screw_end, private.room_objname );
cmn.AddSubscriber( "use_screw_end", private.use_screw_logic );
--------------------------------------------------------------------------------------------
function public.use_screw( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screw" );
    cmn.CallEventHandler( "use_screw_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screw") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screw_inv" );
  cmn.CallEventHandler( "use_screw_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hidingplace_anm_screw", "use_screw", func_end );
  SoundSfx( "aud_use_screw_corridor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_numeral2" ] = { type = "get", get_obj = "spr_hidingplace_numeral2", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.get_numeral2_logic = function()
  
end;
private.get_numeral2_inv = function()
  interface.InventoryItemAdd("inv_numeral2","spr_hidingplace_numeral2");
end;
private.get_numeral2_beg = function()
  ObjDelete("gfx_hidingplace_numeral2")
end;
private.get_numeral2_end = function()
  if common_impl.ZzCompleteCheck("get_numeral2") then ObjSet( common_impl.hint["get_numeral2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hidingplace_sh_numeral2");
  ObjDelete("spr_corridor_tr_numeral2");
end;

cmn.AddSubscriber( "get_numeral2", private.get_numeral2_inv );
cmn.AddSubscriber( "get_numeral2", private.get_numeral2_beg, private.room_objname );
cmn.AddSubscriber( "get_numeral2", private.get_numeral2_end, private.room_objname );
cmn.AddSubscriber( "get_numeral2", private.get_numeral2_logic );
--------------------------------------------------------------------
function public.get_numeral2()
  cmn.SetEventDone( "get_numeral2" );
  cmn.CallEventHandler( "get_numeral2" );
  if common_impl.ZzCompleteCheck("get_numeral2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pick_hidingplace" ] = { type = "use", inv_obj = "inv_pick", use_place = "gfx_hidingplace_pick_hidingplace_zone", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.use_pick_hidingplace_logic = function()
  ObjSet( "spr_hidingplace_sack", { visible = 1, input = 1, active = 1 } )

end;
private.use_pick_hidingplace_inv = function()
  common_impl.ProcessMultiUseAll("pick", "pick_hidingplace")
end;
private.use_pick_hidingplace_beg = function()
  ObjDelete( "gfx_hidingplace_pick_hidingplace_zone" );
end;
private.use_pick_hidingplace_end = function()
  if common_impl.ZzCompleteCheck("use_pick_hidingplace") then ObjSet( common_impl.hint["use_pick_hidingplace"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hidingplace_anm_screw", {animfunc = "end_pick", frame = 0 } );
  ObjSet( "spr_hidingplace_sh_sack", {visible = 1} );
  ObjDelete("spr_corridor_tr_wall");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pick_hidingplace", private.use_pick_hidingplace_inv );
cmn.AddSubscriber( "use_pick_hidingplace", private.use_pick_hidingplace_beg, private.room_objname );
cmn.AddSubscriber( "use_pick_hidingplace", private.use_pick_hidingplace_end, private.room_objname );
cmn.AddSubscriber( "use_pick_hidingplace", private.use_pick_hidingplace_logic );
cmn.AddSubscriber( "use_pick_hidingplace_inv", private.use_pick_hidingplace_inv, private.room_objname );
cmn.AddSubscriber( "use_pick_hidingplace_beg", private.use_pick_hidingplace_beg, private.room_objname );
cmn.AddSubscriber( "use_pick_hidingplace_end", private.use_pick_hidingplace_end, private.room_objname );
cmn.AddSubscriber( "use_pick_hidingplace_end", private.use_pick_hidingplace_logic );
--------------------------------------------------------------------------------------------
function public.use_pick_hidingplace( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pick_hidingplace" );
    cmn.CallEventHandler( "use_pick_hidingplace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pick_hidingplace") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pick_hidingplace_inv" );
  cmn.CallEventHandler( "use_pick_hidingplace_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hidingplace_anm_screw", "use_pick", func_end );
  SoundSfx( "aud_use_pick_hidingplace" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sack" ] = { type = "get", get_obj = "spr_hidingplace_sack", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.get_sack_logic = function()
  
end;
private.get_sack_inv = function()
  interface.InventoryItemAdd("inv_sack","spr_hidingplace_sack");
  ObjSet( "inv_sack", { drag = 0 } );
end;
private.get_sack_beg = function()
  ObjDelete("gfx_hidingplace_sack")
end;
private.get_sack_end = function()
  if common_impl.ZzCompleteCheck("get_sack") then ObjSet( common_impl.hint["get_sack"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hidingplace_sh_sack");
  ObjDelete("spr_corridor_tr_sack");
end;

cmn.AddSubscriber( "get_sack", private.get_sack_inv );
cmn.AddSubscriber( "get_sack", private.get_sack_beg, private.room_objname );
cmn.AddSubscriber( "get_sack", private.get_sack_end, private.room_objname );
cmn.AddSubscriber( "get_sack", private.get_sack_logic );
--------------------------------------------------------------------
function public.get_sack()
  cmn.SetEventDone( "get_sack" );
  cmn.CallEventHandler( "get_sack" );
  if common_impl.ZzCompleteCheck("get_sack") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_chip_zone_clk()
   local func_end = function()
      ld.Lock(0);
      common_impl.ShowBbt( 'need_chip' )   
   end;
 
   ld.Lock(1);
   ld.AnimPlay( "anm_hidingplace_anm_chip", "idle_cover_mmg", func_end )
   SoundSfx( "aud_touch_hidingplance_corridor" );
end;  

common_impl.hint[ "use_chip" ] = { type = "use", inv_obj = "inv_chip", use_place = "gfx_hidingplace_chip_zone", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.use_chip_logic = function()
  ObjSet( "obj_hidingplace_win_hidingplace_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_chip_inv = function()
  common_impl.ProcessMultiUseAll("chip", "chip")
end;
private.use_chip_beg = function()
  ObjDelete( "gfx_hidingplace_chip_zone" );
end;
private.use_chip_end = function()
  if common_impl.ZzCompleteCheck("use_chip") then ObjSet( common_impl.hint["use_chip"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "pfx_hidingplace_mmg_pm_light", {active=1, visible=1} );
  ObjSet( "anm_hidingplace_anm_chip", {animfunc = "chip_open", frame = 0 } );
  ObjSet( "pfx_hidingplace_pm_light", {alp=0, active=0, visible=0} );
  ObjSet( "spr_corridor_tr_chip", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_chip", private.use_chip_inv );
cmn.AddSubscriber( "use_chip", private.use_chip_beg, private.room_objname );
cmn.AddSubscriber( "use_chip", private.use_chip_end, private.room_objname );
cmn.AddSubscriber( "use_chip", private.use_chip_logic );
cmn.AddSubscriber( "use_chip_inv", private.use_chip_inv, private.room_objname );
cmn.AddSubscriber( "use_chip_beg", private.use_chip_beg, private.room_objname );
cmn.AddSubscriber( "use_chip_end", private.use_chip_end, private.room_objname );
cmn.AddSubscriber( "use_chip_end", private.use_chip_logic );
--------------------------------------------------------------------------------------------
function public.use_chip( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_chip" );
    cmn.CallEventHandler( "use_chip_end" );
    -- common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_chip") then ld.CloseSubRoom() end;
    private.init_hidingplace();
    -- cmn.MiniGameShow( "hidingplace" );
    ObjSet( "obj_hidingplace_win_hidingplace_root", {alp=0} );
    ObjAnimate( "obj_hidingplace_win_hidingplace_root", 8, 0, 0, function() common_impl.Lock(0);  cmn.MiniGameShow( "hidingplace" ); end, {0,0,0, 0.5,0,1} );  
  end;

 
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_chip_inv" );
  cmn.CallEventHandler( "use_chip_beg" );
  common_impl.Lock(1);

  ObjSet( "obj_hidingplace_win_hidingplace_root", {active=1, visible = 1, alp=0} );
  ld.AnimPlay( "anm_hidingplace_anm_chip", "use_chip", func_end );
  ObjAnimate( "pfx_hidingplace_pm_light", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ObjSet( "pfx_hidingplace_mmg_pm_light", {active=1, visible=1, alp=0} );  
  ObjAnimate( "pfx_hidingplace_mmg_pm_light", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );  
  SoundSfx( "aud_use_chip_corridor" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_hidingplace" ] = { type = "click", use_place = "obj_hidingplace_win_hidingplace_root", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.win_hidingplace_logic = function()
  if cmn.IsEventDone("win_hidingplace") then
     ObjSet( "spr_hidingplace_crystalball2", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.win_hidingplace_beg = function()
  -- ObjDelete( "gfx_hidingplace_win_hidingplace_zone" );
end;
private.win_hidingplace_end = function()
  if cmn.IsEventDone("win_hidingplace") then
    if common_impl.ZzCompleteCheck("win_hidingplace") then ObjSet( common_impl.hint["win_hidingplace"].zz_gate, { visible = 0, input = 0 } ); end;
    ObjDelete("obj_hidingplace_win_hidingplace_root");
    ObjDelete("pfx_hidingplace_mmg_pm_light");
    ObjSet( "anm_hidingplace_anm_chip", {animfunc = "end_chip", frame = 0 } );
    ObjSet( "spr_hidingplace_sh_crystalball2", {visible = 1} );
    ObjSet( "pfx_hidingplace_pm_light", {alp=1, active=1, visible=1} );
    ObjDelete("spr_corridor_tr_chip");
    ObjDelete("spr_corridor_tr_cover_mmg");
  end; 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_hidingplace", private.win_hidingplace_beg, private.room_objname );
cmn.AddSubscriber( "win_hidingplace", private.win_hidingplace_end, private.room_objname );
cmn.AddSubscriber( "win_hidingplace", private.win_hidingplace_logic );
cmn.AddSubscriber( "win_hidingplace_beg", private.win_hidingplace_beg, private.room_objname );
cmn.AddSubscriber( "win_hidingplace_end", private.win_hidingplace_end, private.room_objname );
cmn.AddSubscriber( "win_hidingplace_end", private.win_hidingplace_logic );
--------------------------------------------------------------------------------------------
function public.win_hidingplace()

  local func_end = function()
    cmn.SetEventDone( "win_hidingplace" );
    cmn.CallEventHandler( "win_hidingplace_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_hidingplace") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     ObjSet( "pfx_hidingplace_pm_light", {alp=0, active=1, visible=1} );
     ObjAnimate( "pfx_hidingplace_pm_light", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
     ObjAnimate( "pfx_hidingplace_mmg_pm_light", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );  
     ld.AnimPlay( "anm_hidingplace_anm_chip", "chip_open", func_end ) 
  end;  
  
  cmn.CallEventHandler( "win_hidingplace_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  cmn.MiniGameHide( "hidingplace",true ); 
 
  --func_end()
  
  ld.StartTimer( 0.7, function()
     SoundSfx( "aud_mg_hidingplace_win" );
     ObjAnimate( "obj_hidingplace_win_hidingplace_root", 8, 0, 0, func_preend, {0,0,1, 0.6,0,1, 1,0,0} );
     for i=1,3,1 do 
       local cur_alp = ObjGet("spr_hidingplace_part_light_1_"..i).alp; 
        ObjSet( "spr_hidingplace_part_light_1_"..i, {color_r=0, color_g=1, color_b=0} );
        ObjAnimate("spr_hidingplace_part_light_1_"..i, 8, 0, 0, function() end, {0,0,cur_alp, 0.5,0,1} );
     end;  
  end )
  
end;
-----------------------------------------------------------------------------------------
private.win_hidingplace_state={};
-- 0 empty, 1-yellow, 2-blue, 3-green, 4-purple, 5-wall
private.win_hidingplace_fp_array={{5,5,5,5,5,5,5,5,5},
                                  {5,2,0,0,0,0,1,1,5},
                                  {5,2,5,5,5,5,5,1,5},
                                  {5,2,0,0,0,0,5,5,5},
                                  {5,2,5,5,5,3,5,0,5},
                                  {5,2,5,0,0,3,5,0,5},
                                  {5,0,5,5,5,5,5,0,5},
                                  {5,0,0,4,4,4,0,0,5},
                                  {5,5,5,5,5,5,5,5,5}};
private.win_hidingplace_table_first_pos_coord = {-200,-200};
private.win_hidingplace_table_step=50;

function private.win_hideplace_show_state()
  local my_str="";
  ld.LogTrace( "_____________________________________________________________" );
  for i=1,#private.win_hidingplace_state,1 do 
     my_str="";
    for j=1,#private.win_hidingplace_state[i],1 do 
      my_str=my_str.." {"..private.win_hidingplace_state[i][j][1]..","..private.win_hidingplace_state[i][j][2].."}";
    end;  
    ld.LogTrace( my_str );
  end;  
end;  




function private.win_hidingplace_get_pos_coord(i,j)
  local coord={0,0};
  coord[1]=private.win_hidingplace_table_first_pos_coord[1]+(j-1)*private.win_hidingplace_table_step;
  coord[2]=private.win_hidingplace_table_first_pos_coord[2]+(i-1)*private.win_hidingplace_table_step;
  return coord;
end;  



private.win_hidingplace_parts_count={3,5,2,3};
private.win_hidingplace_parts_names={"chip","blue_1","green_1","pink_1"};                                  

private.win_hidingplace_parts_init_flag = false;
                                  
function private.win_hidingplace_parts_init()
  if private.win_hidingplace_parts_init_flag==false then
    for i=1,#private.win_hidingplace_parts_count,1 do 
      for j=1,private.win_hidingplace_parts_count[i],1 do
        ----------------------------------------------------------------
        --create roots for parts 
        ObjCreate("obj_hidingplace_mmg_part_"..i.."_"..j,"obj");
        ObjSet( "obj_hidingplace_mmg_part_"..i.."_"..j, {input=1} ); 
        ObjAttach("obj_hidingplace_mmg_part_"..i.."_"..j,"obj_hidingplace_win_hidingplace_parts_root") 
          
        ----------------------------------------------------------------    
        ObjCreate("spr_hidingplace_mmg_part_"..i.."_"..j,"spr");
        ObjAttach("spr_hidingplace_mmg_part_"..i.."_"..j,"obj_hidingplace_mmg_part_"..i.."_"..j);
        ObjSet( "spr_hidingplace_mmg_part_"..i.."_"..j, {input=0, res="assets/levels/level/rm_corridor/zz_hidingplace/mmg/"..private.win_hidingplace_parts_names[i], 
        event_mdown="rm_corridor.win_hidingplace_part_mdown("..i..","..j..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", pos_z=5} );
        --- init big drag zones for parts 
        ObjCreate("obj_hidingplace_mmg_part_big_zone_"..i.."_"..j,"obj");
        ObjSet( "obj_hidingplace_mmg_part_big_zone_"..i.."_"..j, {input=0,drag=0,visible=0,inputrect_init=1,inputrect_w=60, inputrect_h=60, inputrect_x=-30, inputrect_y=-30, event_mdown="rm_corridor.win_hidingplace_part_stopdrag("..i..","..j..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"} );  
        ObjAttach("obj_hidingplace_mmg_part_big_zone_"..i.."_"..j,"spr_hidingplace_mmg_part_"..i.."_"..j);
        ----------------------------------------
        --init 4 little zones for parts 
        -- 1 up,2 right,3 down,4 left  
        local little_parts_array={{0,-50},{50,0},{0,50},{-50,0}};
        for ii=1,4,1 do 
          ObjCreate("obj_hidingplace_mmg_part_little_zone_"..i.."_"..j.."_"..ii,"obj");
          ObjSet( "obj_hidingplace_mmg_part_little_zone_"..i.."_"..j.."_"..ii, {input=0, inputrect_init=1, inputrect_w=50, inputrect_h=50, inputrect_x=-25, inputrect_y=-25, pos_x=little_parts_array[ii][1], pos_y=little_parts_array[ii][2], event_mdown="rm_corridor.win_hidingplace_little_part_mdown("..i..","..j..","..ii..")", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
          ObjAttach( "obj_hidingplace_mmg_part_little_zone_"..i.."_"..j.."_"..ii,"obj_hidingplace_mmg_part_big_zone_"..i.."_"..j)
          -- lights for little zones
          ObjCreate("spr_hidingplace_part_light_"..i.."_"..j.." "..ii,"spr")
          ObjSet( "spr_hidingplace_part_light_"..i.."_"..j.." "..ii, {res="assets/levels/level/rm_corridor/zz_hidingplace/mmg/light", alp=1, input=0, visible=0, color_r=0, color_g=1, color_b=0} );
          ObjAttach( "spr_hidingplace_part_light_"..i.."_"..j.." "..ii, "obj_hidingplace_mmg_part_little_zone_"..i.."_"..j.."_"..ii ); 
        end;  
        -----------------------------------------------------------
        --init part drag zones 
      -- ObjCreate("obj_hidingplace_part_drag_zone_"..i.."_"..j,"obj");
      -- ObjAttach("obj_hidingplace_part_drag_zone_"..i.."_"..j,"obj_hidingplace_mmg_part_big_zone_"..i.."_"..j);
      -- ObjSet( "obj_hidingplace_part_drag_zone_"..i.."_"..j, {input=0, drag=0,inputrect_init=1, inputrect_w=10, inputrect_h=10, inputrect_x=-5, inputrect_y=-5,
      --    event_drag="rm_corridor.win_hidingplace_part_startdrag("..i..","..j..");", event_drag="rm_corridor.win_hidingplace_part_drag("..i..","..j..");", event_dragdrop="rm_corridor.win_hidingplace_part_stopdrag("..i..","..j..");"} );
        ----------------------------------------------------------------
        --init parts light
       ObjCreate("spr_hidingplace_part_light_"..i.."_"..j,"spr")
       ObjSet( "spr_hidingplace_part_light_"..i.."_"..j, {res="assets/levels/level/rm_corridor/zz_hidingplace/mmg/light", alp=0, input=0} );
       ObjAttach( "spr_hidingplace_part_light_"..i.."_"..j, "obj_hidingplace_mmg_part_"..i.."_"..j ); 
      end;  
    end;  
    private.win_hidingplace_parts_init_flag=true;
  end;
end;  

private.win_hidingplace_fp_array_modificator_flag=false;
function private.win_hidingplace_fp_array_modificator()
  if private.win_hidingplace_fp_array_modificator_flag == false then 
      local parts_count_array={0,0,0,0};
      for i=1,#private.win_hidingplace_fp_array,1 do 
        for j=1,#private.win_hidingplace_fp_array[i],1 do
          if private.win_hidingplace_fp_array[i][j]~=0 and private.win_hidingplace_fp_array[i][j]~=5 then 
            local cur_val = private.win_hidingplace_fp_array[i][j];
            parts_count_array[cur_val]= parts_count_array[cur_val]+1;
            private.win_hidingplace_fp_array[i][j]={private.win_hidingplace_fp_array[i][j],parts_count_array[cur_val]};
          else
            private.win_hidingplace_fp_array[i][j]={private.win_hidingplace_fp_array[i][j],0};
          end;  
        end;  
      end;  
    end;
   private.win_hidingplace_fp_array_modificator_flag = true;   
end;  



function private.init_hidingplace()
  private.win_hidingplace_parts_init();
  private.win_hidingplace_fp_array_modificator();
  if not (cmn.IsEventStart("win_hidingplace")) then
    -- private.win_hidingplace_fp_array_modificator();
    ng_global.progress["std"]["win_hidingplace"].state = {}
    private.win_hidingplace_state= ld.TableCopy(private.win_hidingplace_fp_array);
    ng_global.progress["std"]["win_hidingplace"].state =  private.win_hidingplace_state;
  else  
    
    private.win_hidingplace_state=ng_global.progress["std"]["win_hidingplace"].state;
  end
  private.win_hidingplace_stand_pos();  
end
-------------------------------------------
function private.win_hidingplace_stand_pos()
  for i=1,#private.win_hidingplace_state,1 do 
    for j=1,#private.win_hidingplace_state[i],1 do
      if private.win_hidingplace_state[i][j][1]~=0 and private.win_hidingplace_state[i][j][1]~=5 then 
        local cur_val = private.win_hidingplace_state[i][j][1];
        local coord = private.win_hidingplace_get_pos_coord(i,j);
      --  ld.LogTrace( "i = "..i.. "j = "..j );
        ObjSet( "obj_hidingplace_mmg_part_"..cur_val.."_"..private.win_hidingplace_state[i][j][2], {pos_x=coord[1], pos_y=coord[2]} );
        ObjSet( "obj_hidingplace_mmg_part_big_zone_"..cur_val.."_"..private.win_hidingplace_state[i][j][2], {input = 0, visible=0} );
        for ii=1,4,1 do 
          ObjSet( "obj_hidingplace_mmg_part_little_zone_"..cur_val.."_"..private.win_hidingplace_state[i][j][2].."_"..ii, {input = 0} );
          ObjSet( "spr_hidingplace_part_light_"..cur_val.."_"..private.win_hidingplace_state[i][j][2].."_"..ii, {visible = 0} );
        end;  
        ObjSet( "spr_hidingplace_part_light_"..cur_val.."_"..private.win_hidingplace_state[i][j][2], {alp=0} );
      end;  
    end;  
  end;  
  private.win_hidingplace_search_active_part();
 --  private.win_hideplace_show_state();
  private.win_hidingplace_win_ver();
end;  

local win_hidingplace_cur_type=0;
local win_hidingplace_cur_num=0;


function private.win_hidingplace_win_ver()
   if private.win_hidingplace_state[5][8][1]==1 and private.win_hidingplace_state[6][8][1]==1 and private.win_hidingplace_state[7][8][1]==1 then 
      if win_hidingplace_cur_num~=0 then 
        --  ObjStopDrag("obj_hidingplace_part_drag_zone_"..win_hidingplace_cur_num.."_"..win_hidingplace_cur_type);
        win_hidingplace_cur_type=0;
        win_hidingplace_cur_num=0;
      end;  
      for i=1,3,1 do 
       --local cur_alp = ObjGet("spr_hidingplace_part_light_1_"..i).alp; 
       ObjSet( "spr_hidingplace_part_light_1_"..i, {alp=1} );
      end; 
      public.win_hidingplace();
   end;  
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.win_hidingplace_search_active_part()
    for i=1,#private.win_hidingplace_state,1 do 
      for j=1,#private.win_hidingplace_state[i],1 do
        if private.win_hidingplace_state[i][j][1]~=0 and  private.win_hidingplace_state[i][j][1]~=5 then
           local empty_count=0;
           local flag_count=0;
           local searc_array={{-1,0},{0,1},{1,0},{0,-1}};
           for ii=1,4,1 do 
             local ki,kj = searc_array[ii][1], searc_array[ii][2];
             if private.win_hidingplace_state[i+ki][j+kj][1]==0 then 
                empty_count=empty_count+1;
             elseif private.win_hidingplace_state[i+ki][j+kj][1]~=0 and private.win_hidingplace_state[i+ki][j+kj][1]~=5 and private.win_hidingplace_state[i+ki][j+kj][1]==private.win_hidingplace_state[i][j][1] then
                flag_count=flag_count+1;
             end;  
           end;
           if flag_count==1 and empty_count>0 then 
              --------------------!!!!!!!!!!!!!!!
              ObjSet( "spr_hidingplace_mmg_part_"..private.win_hidingplace_state[i][j][1].."_"..private.win_hidingplace_state[i][j][2], {input=1});
           else    
              ObjSet( "spr_hidingplace_mmg_part_"..private.win_hidingplace_state[i][j][1].."_"..private.win_hidingplace_state[i][j][2], {input=0});
           end;  
        end;  
      end;
    end;  
end;
--------------------------------------------------------------------
function private.win_hidingplace_get_part_pos(part_type,num)
 -- ld.LogTrace( "part_type = "..part_type );
 -- ld.LogTrace( "num = "..num );
  local coord={0,0};
    for i=1,#private.win_hidingplace_state,1 do 
      for j=1,#private.win_hidingplace_state[i],1 do
        if private.win_hidingplace_state[i][j][1]==part_type and private.win_hidingplace_state[i][j][2]==num then 
          coord={i,j};
          return coord;
        end;  
      end;
    end; 
   ld.LogTrace( "part "..part_type.." "..num.." NOT FOUND!!!" ); 
   return false; 
end;  
--------------------------------------------------------------------
private.win_hidingplace_part_active_napr={0,0,0,0};
private.win_hidingplace_last_mdown = {0,0} -- part_type, num
function public.win_hidingplace_part_mdown(part_type,num, without_start_drag)
   -- clear last lights 
   if private.win_hidingplace_last_mdown[1]~=0 and private.win_hidingplace_last_mdown[2]~=0 then 
     ObjSet( "obj_hidingplace_mmg_part_big_zone_"..private.win_hidingplace_last_mdown[1].."_"..private.win_hidingplace_last_mdown[2], {input = 0, visible=0} );
     for i=1,4,1 do 
           ObjSet( "obj_hidingplace_mmg_part_little_zone_"..private.win_hidingplace_last_mdown[1].."_"..private.win_hidingplace_last_mdown[2].."_"..i, {input = 0} );
           ObjSet( "spr_hidingplace_part_light_"..private.win_hidingplace_last_mdown[1].."_"..private.win_hidingplace_last_mdown[2].." "..i, {visible = 0, alp=1} );
     end; 
     for i=1,private.win_hidingplace_parts_count[private.win_hidingplace_last_mdown[1] ],1 do 
        ObjSet( "spr_hidingplace_part_light_"..private.win_hidingplace_last_mdown[1].."_"..i, {alp=0, color_r=1, color_g=1, color_b=1} );
     end;     
   end; 
   private.win_hidingplace_last_mdown = {part_type, num}    
   ----------------------------------------
   private.win_hidingplace_part_active_napr={0,0,0,0};
   local searc_array={{-1,0},{0,1},{1,0},{0,-1}};
   local part_pos = private.win_hidingplace_get_part_pos(part_type,num);
   for i=1,4,1 do 
     local ki,kj = searc_array[i][1], searc_array[i][2];
     if private.win_hidingplace_state[part_pos[1]+ki][part_pos[2]+kj][1]==0 then 
       private.win_hidingplace_part_active_napr[i]=1;
     else  
       private.win_hidingplace_part_active_napr[i]=0;
     end;  
   end;
   --- set input
   
   local active_count = 0;
   ObjSet( "obj_hidingplace_mmg_part_big_zone_"..part_type.."_"..num, {input = 1, visible=1} );
   for i=1,4,1 do 
     if  private.win_hidingplace_part_active_napr[i]==1 then 
       ObjSet( "obj_hidingplace_mmg_part_little_zone_"..part_type.."_"..num.."_"..i, {input = 1} );
       ObjSet( "spr_hidingplace_part_light_"..part_type.."_"..num.." "..i, {visible = 1, alp=0.7} );
       active_count=active_count+1;
     else   
       ObjSet( "obj_hidingplace_mmg_part_little_zone_"..part_type.."_"..num.."_"..i, {input = 0} );
       ObjSet( "spr_hidingplace_part_light_"..part_type.."_"..num.." "..i, {visible = 0, alp=0.7} );
     end     
   end;  
   if active_count==0 then public.win_hidingplace_part_stopdrag(part_type,num); return; end;
 -- ------------------------------------------------
 -- local my_str="part_type = "..part_type.."num = "..num.." Naprs:";
 -- for i=1,4,1 do 
 --   my_str=my_str.." napr"..i.." = "..private.win_hidingplace_part_active_napr[i];
 -- end;
 -- ld.LogTrace( my_str  );  
 --if without_start_drag~=true then ObjStartDrag("obj_hidingplace_part_drag_zone_"..part_type.."_"..num); end;
 
 --ObjStartDrag("obj_hidingplace_part_drag_zone_"..part_type.."_"..num);
 for i=1,private.win_hidingplace_parts_count[part_type],1 do 
   ObjSet( "spr_hidingplace_part_light_"..part_type.."_"..i, {alp=1, color_r=1, color_g=1, color_b=1} );
 end;  
 SoundSfx( "aud_mg_hidingplace_select" );
end;
------------------------------------------------

function public.win_hidingplace_little_part_mdown(part_type,num,ii)
  
  local func_end = function()
    SoundSfx( "aud_mg_hidingplace_move" )
    local buf_array = private.win_hidingplace_get_part_pos(part_type,num);
    -- 1 up,2 right,3 down,4 left  
    local my_ii_array = {{-1,0},{0,1},{1,0},{0,-1}}; 
    local new_i, new_j = buf_array[1]+my_ii_array[ii][1],buf_array[2]+my_ii_array[ii][2] ;
    private.win_hidingplace_part_move_to_new_pos(num,part_type,new_i,new_j);
  end;  
  
  ld.Lock(1);
  ObjAnimate( "spr_hidingplace_part_light_"..part_type.."_"..num.." "..ii, 8, 0, 0, func_end, {0,0,0.7, 0.1,0,0} );
end;  
------------------------------------------------
------------------------------------------------
------------------------------------------------
-- CREATE PARTS LIST FOR MOTION

private.win_hidingplace_motion_list={};
private.win_hidingplace_motion_list_count=0;
private.win_hidingplace_motion_list_start_num=0;

function private.win_hidingplace_list_used_ver(num)
  for i=1,#private.win_hidingplace_motion_list,1 do 
    if private.win_hidingplace_motion_list[i]==num then return true end;
  end;  
  return false;
end;  


function private.win_hidingplace_start_list_creat(num,part_type)
  private.win_hidingplace_motion_list={num};
  private.win_hidingplace_motion_list_count=1;
  private.win_hidingplace_motion_list_start_num=num;
  private.win_hidingplace_start_list_search(num,part_type)
end;

function  private.win_hidingplace_start_list_search(num,part_type)
  local first_pos=private.win_hidingplace_get_part_pos(part_type,num);
  local searc_array={{-1,0},{0,1},{1,0},{0,-1}};
  for i=1,4,1 do 
    if private.win_hidingplace_state[first_pos[1]+searc_array[i][1] ][first_pos[2]+searc_array[i][2] ][1] == part_type and  not private.win_hidingplace_list_used_ver(private.win_hidingplace_state[first_pos[1]+searc_array[i][1] ][first_pos[2]+searc_array[i][2] ][2]) then 
      private.win_hidingplace_motion_list_count= private.win_hidingplace_motion_list_count+1;
      private.win_hidingplace_motion_list[private.win_hidingplace_motion_list_count]= private.win_hidingplace_state[first_pos[1]+searc_array[i][1] ][first_pos[2]+searc_array[i][2] ][2];
      private.win_hidingplace_start_list_search( private.win_hidingplace_motion_list[private.win_hidingplace_motion_list_count],part_type);
    end;  
  end;  
   
end;  
------------------------------------------------
------------------------------------------------
------------------------------------------------
private.win_hidingplace_part_move_to_new_pos_flag=false;
function private.win_hidingplace_part_move_to_new_pos(num,part_type,new_i,new_j)
--   ld.LogTrace( "new_i = "..new_i.." new_j="..new_j );
   if private.win_hidingplace_part_move_to_new_pos_flag==false then 
 --    ld.LogTrace( "select part type="..part_type.." num = "..num );
     private.win_hidingplace_start_list_creat(num,part_type);
 --    ld.LogTrace( private.win_hidingplace_motion_list );
     private.win_hidingplace_part_move_to_new_pos_flag=true;
     local first_pos=private.win_hidingplace_get_part_pos(part_type,num);
     local cur_pos=private.win_hidingplace_get_pos_coord(first_pos[1], first_pos[2])
     local new_pos=private.win_hidingplace_get_pos_coord(new_i,new_j);
     local cur_pos_array={}; -- sort by private.win_hidingplace_motion_list
     local new_pos_array={};  -- sort by private.win_hidingplace_motion_list
     
     -----------------------------------------------------------------------------------------
     local func_end = function()
       ld.Lock(0);
       
     
       local cur_pos_ij={};
       for i=1,private.win_hidingplace_parts_count[part_type],1 do 
         cur_pos_ij[i]=private.win_hidingplace_get_part_pos(part_type,private.win_hidingplace_motion_list[i]);
       end;  
       
       local last_part_last_pos =  private.win_hidingplace_get_part_pos(part_type,private.win_hidingplace_motion_list[private.win_hidingplace_motion_list_count]);     
       private.win_hidingplace_state[last_part_last_pos[1] ][last_part_last_pos[2] ] = {0,0}; 
       
       for i=1,private.win_hidingplace_parts_count[part_type]-1,1 do
          private.win_hidingplace_state[cur_pos_ij[i][1] ][cur_pos_ij[i][2] ] = {part_type,private.win_hidingplace_motion_list[i+1]};
       end;
       
      -- private.win_hidingplace_state[new_i ][new_j ] = ld.TableCopy(private.win_hidingplace_state[first_pos[1] ][first_pos[2] ]); 
       private.win_hidingplace_state[new_i ][new_j ] = {part_type,private.win_hidingplace_motion_list[1]};
      
       private.win_hidingplace_part_move_to_new_pos_flag=false;
       private.win_hidingplace_stand_pos();
       public.win_hidingplace_part_mdown(part_type,num, true)
     end;  
     -----------------------------------------------------------------------------------------
     
     ld.Lock(1); 
    
    for i=1,#private.win_hidingplace_motion_list,1 do
       local pos_on_table = private.win_hidingplace_get_part_pos(part_type,private.win_hidingplace_motion_list[i]); 
       cur_pos_array[i]= private.win_hidingplace_get_pos_coord(pos_on_table[1], pos_on_table[2]);
     end;  
     
     new_pos_array[1]=ld.TableCopy(new_pos);
     
     for i=2,#private.win_hidingplace_motion_list,1 do
        new_pos_array[i]=ld.TableCopy(cur_pos_array[i-1]);
     end;  
     
  --   ld.LogTrace( "cur_pos_array" );
  --   ld.LogTrace( cur_pos_array );
  --   ld.LogTrace( "new_pos_array" );
  --   ld.LogTrace( new_pos_array );
      
     for i=1,#private.win_hidingplace_motion_list,1 do
       --local cur_num = private.win_hidingplace_motion_list[i];
       ObjAnimate( "obj_hidingplace_mmg_part_"..part_type.."_"..private.win_hidingplace_motion_list[i], 3, 0, 0, function() end, {0,0,cur_pos_array[i][1],cur_pos_array[i][2], 0.1,0,new_pos_array[i][1],new_pos_array[i][2]} );
     end;
       ld.StartTimer( 0.11, func_end );  
   else
     return;
   end;  
end;

 
--function public.win_hidingplace_part_startdrag(part_type,num) 
--  ld.SetCursor(CURSOR_HAND);
--  win_hidingplace_cur_type = part_type;
--  win_hidingplace_cur_num = num;
--end;  
 
 
 
--function public.win_hidingplace_part_drag(part_type,num)
--  ld.SetCursor(CURSOR_HAND);
--  local searc_array={{-1,0},{0,1},{1,0},{0,-1}};
--  
--  if not ApplyObj("obj_hidingplace_part_drag_zone_"..part_type.."_"..num,"obj_hidingplace_mmg_part_big_zone_"..part_type.."_"..num) then 
--    ObjStopDrag("obj_hidingplace_part_drag_zone_"..part_type.."_"..num);
--  else 
--    for i=1,4,1 do 
--      if ApplyObj("obj_hidingplace_part_drag_zone_"..part_type.."_"..num, "obj_hidingplace_mmg_part_little_zone_"..part_type.."_"..num.."_"..i) and private.win_hidingplace_part_active_napr[i]==1 then 
--        local part_pos = private.win_hidingplace_get_part_pos(part_type,num);
--        private.win_hidingplace_part_move_to_new_pos(num,part_type,part_pos[1]+searc_array[i][1],part_pos[2]+searc_array[i][2]);
--      end;  
--    end;  
--  end;  
--end;  

function public.win_hidingplace_part_stopdrag(part_type,num)
  SoundSfx( "aud_mg_hidingplace_select" );
  ld.SetCursor(CURSOR_DEFAULT);
  private.win_hidingplace_part_active_napr={0,0,0,0};
  for i=1,private.win_hidingplace_parts_count[part_type],1 do 
    ObjSet( "spr_hidingplace_part_light_"..part_type.."_"..i, {alp=0, color_r=1, color_g=1, color_b=0.5} );
  end; 
  win_hidingplace_cur_type = 0;
  win_hidingplace_cur_num = 0;
  
   ObjSet( "obj_hidingplace_mmg_part_big_zone_"..part_type.."_"..num, {input = 0, visible=0} );
   for i=1,4,1 do 
       ObjSet( "obj_hidingplace_mmg_part_little_zone_"..part_type.."_"..num.."_"..i, {input = 0} );
       ObjSet( "spr_hidingplace_part_light_"..part_type.."_"..num.." "..i, {visible = 0} );
   end;  
end;  
--------------------------------------------------------------------
function private.win_hidingplace_skip()
 
  local func_end = function()
      
     private.win_hidingplace_state = {{{5,0},{5,0},{5,0},{5,0},{5,0},{5,0},{5,0},{5,0},{5,0}},
                                     {{5,0},{0,0},{0,0},{4,3},{4,2},{4,1},{0,0},{3,2},{5,0}},
                                     {{5,0},{0,0},{5,0},{5,0},{5,0},{5,0},{5,0},{3,1},{5,0}},
                                     {{5,0},{0,0},{0,0},{0,0},{0,0},{2,5},{5,0},{5,0},{5,0}},
                                     {{5,0},{0,0},{5,0},{5,0},{5,0},{2,4},{5,0},{1,1},{5,0}},
                                     {{5,0},{0,0},{5,0},{2,1},{2,2},{2,3},{5,0},{1,2},{5,0}},
                                     {{5,0},{0,0},{5,0},{5,0},{5,0},{5,0},{5,0},{1,3},{5,0}},
                                     {{5,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{5,0}},
                                     {{5,0},{5,0},{5,0},{5,0},{5,0},{5,0},{5,0},{5,0},{5,0}}}
    ng_global.progress["std"]["win_hidingplace"].state =  private.win_hidingplace_state;
    private.win_hidingplace_stand_pos();
    ObjAnimate( "obj_hidingplace_win_hidingplace_parts_root", 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );    
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_hidingplace_win_hidingplace_parts_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;

function private.win_hidingplace_reset()
  local func_end = function()
 --   private.win_hidingplace_fp_array_modificator();
    ng_global.progress["std"]["win_hidingplace"].state = {}
    private.win_hidingplace_state= ld.TableCopy(private.win_hidingplace_fp_array);
    ng_global.progress["std"]["win_hidingplace"].state =  private.win_hidingplace_state;
    private.win_hidingplace_stand_pos();
    ObjAnimate( "obj_hidingplace_win_hidingplace_parts_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );    
  end;  
  
  
  ld.Lock(1);
  ObjAnimate( "obj_hidingplace_win_hidingplace_parts_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crystalball2" ] = { type = "get", get_obj = "spr_hidingplace_crystalball2", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.get_crystalball2_logic = function()
  
end;
private.get_crystalball2_inv = function()
  interface.InventoryItemAdd("inv_crystalball2","spr_hidingplace_crystalball2");
end;
private.get_crystalball2_beg = function()
  ObjDelete("gfx_hidingplace_crystalball2")
end;
private.get_crystalball2_end = function()
  if common_impl.ZzCompleteCheck("get_crystalball2") then ObjSet( common_impl.hint["get_crystalball2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hidingplace_sh_crystalball2");
  ObjDelete("spr_corridor_tr_crystalball2");
end;

cmn.AddSubscriber( "get_crystalball2", private.get_crystalball2_inv );
cmn.AddSubscriber( "get_crystalball2", private.get_crystalball2_beg, private.room_objname );
cmn.AddSubscriber( "get_crystalball2", private.get_crystalball2_end, private.room_objname );
cmn.AddSubscriber( "get_crystalball2", private.get_crystalball2_logic );
--------------------------------------------------------------------
function public.get_crystalball2()
  cmn.SetEventDone( "get_crystalball2" );
  cmn.CallEventHandler( "get_crystalball2" );
  if common_impl.ZzCompleteCheck("get_crystalball2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_amuleteye_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_amuleteye' );
  end;  

  ld.Lock(1);
  ld.AnimPlay( "anm_hidingplace_anm_eye", "idle_cover_eye", func_end )
  SoundSfx( "aud_touch_hidingplance_corridor" );
end;  

common_impl.hint[ "use_amuleteye" ] = { type = "use", inv_obj = "inv_amuleteye", use_place = "gfx_hidingplace_amuleteye_zone", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.use_amuleteye_logic = function()
  ObjSet( "spr_hidingplace_folio", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_hidingplace_bank", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuleteye_inv = function()
  common_impl.ProcessMultiUseAll("amuleteye", "amuleteye")
end;
private.use_amuleteye_beg = function()
  ObjDelete( "gfx_hidingplace_amuleteye_zone" );
end;
private.use_amuleteye_end = function()
  if common_impl.ZzCompleteCheck("use_amuleteye") then ObjSet( common_impl.hint["use_amuleteye"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_hidingplace_anm_eye", {animfunc = "end_amuleteye", frame = 0 } );
  ObjSet( "spr_hidingplace_sh_folio", {visible = 1} );
  ObjSet( "spr_hidingplace_sh_bank", {visible = 1} );
  ObjDelete("spr_corridor_tr_cover_eye_1");
  ObjDelete("spr_corridor_tr_cover_eye_2");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuleteye", private.use_amuleteye_inv );
cmn.AddSubscriber( "use_amuleteye", private.use_amuleteye_beg, private.room_objname );
cmn.AddSubscriber( "use_amuleteye", private.use_amuleteye_end, private.room_objname );
cmn.AddSubscriber( "use_amuleteye", private.use_amuleteye_logic );
cmn.AddSubscriber( "use_amuleteye_inv", private.use_amuleteye_inv, private.room_objname );
cmn.AddSubscriber( "use_amuleteye_beg", private.use_amuleteye_beg, private.room_objname );
cmn.AddSubscriber( "use_amuleteye_end", private.use_amuleteye_end, private.room_objname );
cmn.AddSubscriber( "use_amuleteye_end", private.use_amuleteye_logic );
--------------------------------------------------------------------------------------------
function public.use_amuleteye( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuleteye" );
    cmn.CallEventHandler( "use_amuleteye_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuleteye") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuleteye_inv" );
  cmn.CallEventHandler( "use_amuleteye_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_hidingplace_anm_eye", "use_amuleteye", func_end );
  SoundSfx( "aud_use_amuleteye_corridor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_folio" ] = { type = "get", get_obj = "spr_hidingplace_folio", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.get_folio_logic = function()
  
end;
private.get_folio_inv = function()
  interface.InventoryItemAdd("inv_folio","spr_hidingplace_folio");
  ObjSet( "inv_folio", { drag = 0 } );
end;
private.get_folio_beg = function()
  ObjDelete("gfx_hidingplace_folio")
end;
private.get_folio_end = function()
  if common_impl.ZzCompleteCheck("get_folio") then ObjSet( common_impl.hint["get_folio"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hidingplace_sh_folio");
  ObjDelete("spr_corridor_tr_folio");
end;

cmn.AddSubscriber( "get_folio", private.get_folio_inv );
cmn.AddSubscriber( "get_folio", private.get_folio_beg, private.room_objname );
cmn.AddSubscriber( "get_folio", private.get_folio_end, private.room_objname );
cmn.AddSubscriber( "get_folio", private.get_folio_logic );
--------------------------------------------------------------------
function public.get_folio()
  cmn.SetEventDone( "get_folio" );
  cmn.CallEventHandler( "get_folio" );
  if common_impl.ZzCompleteCheck("get_folio") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bank" ] = { type = "get", get_obj = "spr_hidingplace_bank", room = "rm_corridor", zz = "zz_hidingplace", zz_gate = "gzz_corridor_hidingplace" };

private.get_bank_logic = function()
  
end;
private.get_bank_inv = function()
  interface.InventoryItemAdd("inv_bank","spr_hidingplace_bank");
end;
private.get_bank_beg = function()
  ObjDelete("gfx_hidingplace_bank")
end;
private.get_bank_end = function()
  if common_impl.ZzCompleteCheck("get_bank") then ObjSet( common_impl.hint["get_bank"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_hidingplace_sh_bank")
  ObjDelete("spr_corridor_tr_bank");
end;

cmn.AddSubscriber( "get_bank", private.get_bank_inv );
cmn.AddSubscriber( "get_bank", private.get_bank_beg, private.room_objname );
cmn.AddSubscriber( "get_bank", private.get_bank_end, private.room_objname );
cmn.AddSubscriber( "get_bank", private.get_bank_logic );
--------------------------------------------------------------------
function public.get_bank()
  cmn.SetEventDone( "get_bank" );
  cmn.CallEventHandler( "get_bank" );
  if common_impl.ZzCompleteCheck("get_bank") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_slush *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bucket" ] = { type = "click", use_place = "gfx_slush_clk_bucket_zone", room = "rm_corridor", zz = "zz_slush", zz_gate = "gzz_corridor_slush" };

private.clk_bucket_logic = function()
  ObjSet( "gho_corridor_puddle", { visible = 1, input = 1, active = 1 } )

end;
private.clk_bucket_beg = function()
  ObjDelete( "gfx_slush_clk_bucket_zone" );
end;
private.clk_bucket_end = function()
  if common_impl.ZzCompleteCheck("clk_bucket") then ObjSet( common_impl.hint["clk_bucket"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_slush_anm", {animfunc = "click_stoneflower", frame = 999 } );
  ObjDelete("spr_corridor_bucket")
  ObjSet( "spr_corridor_bucket2", {visible = 1} );
  ObjSet( "spr_corridor_puddle", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bucket", private.clk_bucket_beg, private.room_objname );
cmn.AddSubscriber( "clk_bucket", private.clk_bucket_end, private.room_objname );
cmn.AddSubscriber( "clk_bucket", private.clk_bucket_logic );
cmn.AddSubscriber( "clk_bucket_beg", private.clk_bucket_beg, private.room_objname );
cmn.AddSubscriber( "clk_bucket_end", private.clk_bucket_end, private.room_objname );
cmn.AddSubscriber( "clk_bucket_end", private.clk_bucket_logic );
--------------------------------------------------------------------------------------------
function public.clk_bucket()

  local func_end = function()
    cmn.SetEventDone( "clk_bucket" );
    cmn.CallEventHandler( "clk_bucket_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_bucket") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_bucket_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_slush_anm", "click_stoneflower", function() ld.StartTimer( 0.5, func_end ) end );
  SoundSfx( "aud_clk_bucket" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_upstairs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_pick" ] = { type = "get", get_obj = "spr_upstairs_pick", room = "rm_corridor", zz = "zz_upstairs", zz_gate = "gzz_corridor_upstairs" };

private.get_pick_logic = function()
  
end;
private.get_pick_inv = function()
  interface.InventoryItemAdd("inv_pick","spr_upstairs_pick");
end;
private.get_pick_beg = function()
  ObjDelete("gfx_upstairs_pick")
end;
private.get_pick_end = function()
  if common_impl.ZzCompleteCheck("get_pick") then ObjSet( common_impl.hint["get_pick"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_upstairs_sh_pick");
  ObjDelete("spr_corridor_pick");
end;

cmn.AddSubscriber( "get_pick", private.get_pick_inv );
cmn.AddSubscriber( "get_pick", private.get_pick_beg, private.room_objname );
cmn.AddSubscriber( "get_pick", private.get_pick_end, private.room_objname );
cmn.AddSubscriber( "get_pick", private.get_pick_logic );
--------------------------------------------------------------------
function public.get_pick()
  cmn.SetEventDone( "get_pick" );
  cmn.CallEventHandler( "get_pick" );
  if common_impl.ZzCompleteCheck("get_pick") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_wrench_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_wrench' )  
  end;

  ld.Lock(1);
  SoundSfx( "aud_touch_moon_corridor" );
  ld.AnimPlay( "anm_upstairs_anm_wrench", "idle_stonemoon", func_end )
end;  


common_impl.hint[ "use_wrench" ] = { type = "use", inv_obj = "inv_wrench", use_place = "gfx_upstairs_wrench_zone", room = "rm_corridor", zz = "zz_upstairs", zz_gate = "gzz_corridor_upstairs" };

private.use_wrench_logic = function()
  ObjSet( "spr_upstairs_stonemoon", { visible = 1, input = 1, active = 1 } )

end;
private.use_wrench_inv = function()
  common_impl.ProcessMultiUseAll("wrench", "wrench")
end;
private.use_wrench_beg = function()
  ObjDelete( "gfx_upstairs_wrench_zone" );
end;
private.use_wrench_end = function()
  if common_impl.ZzCompleteCheck("use_wrench") then ObjSet( common_impl.hint["use_wrench"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_upstairs_anm_wrench");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wrench", private.use_wrench_inv );
cmn.AddSubscriber( "use_wrench", private.use_wrench_beg, private.room_objname );
cmn.AddSubscriber( "use_wrench", private.use_wrench_end, private.room_objname );
cmn.AddSubscriber( "use_wrench", private.use_wrench_logic );
cmn.AddSubscriber( "use_wrench_inv", private.use_wrench_inv, private.room_objname );
cmn.AddSubscriber( "use_wrench_beg", private.use_wrench_beg, private.room_objname );
cmn.AddSubscriber( "use_wrench_end", private.use_wrench_end, private.room_objname );
cmn.AddSubscriber( "use_wrench_end", private.use_wrench_logic );
--------------------------------------------------------------------------------------------
function public.use_wrench( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wrench" );
    cmn.CallEventHandler( "use_wrench_end" );
    cmn.SetEventDone( "get_stonemoon" );
    cmn.CallEventHandler( "get_stonemoon" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wrench") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wrench_inv" );
  cmn.CallEventHandler( "use_wrench_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_upstairs_anm_wrench", "use_wrench", func_end );
  SoundSfx( "aud_use_wrench_corridor" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stonemoon" ] = { type = "get", get_obj = "spr_upstairs_stonemoon", room = "rm_corridor", zz = "zz_upstairs", zz_gate = "gzz_corridor_upstairs" };

private.get_stonemoon_logic = function()
  
end;
private.get_stonemoon_inv = function()
  interface.InventoryItemAdd("inv_stonemoon","spr_upstairs_stonemoon");
end;
private.get_stonemoon_beg = function()
  ObjDelete("gfx_upstairs_stonemoon")
end;
private.get_stonemoon_end = function()
  if common_impl.ZzCompleteCheck("get_stonemoon") then ObjSet( common_impl.hint["get_stonemoon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_corridor_stonemoon");
end;

cmn.AddSubscriber( "get_stonemoon", private.get_stonemoon_inv );
cmn.AddSubscriber( "get_stonemoon", private.get_stonemoon_beg, private.room_objname );
cmn.AddSubscriber( "get_stonemoon", private.get_stonemoon_end, private.room_objname );
cmn.AddSubscriber( "get_stonemoon", private.get_stonemoon_logic );
--------------------------------------------------------------------
function public.get_stonemoon()
  cmn.SetEventDone( "get_stonemoon" );
  cmn.CallEventHandler( "get_stonemoon" );
  if common_impl.ZzCompleteCheck("get_stonemoon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_flower_zone_clk()
 local func_end = function()
   ld.Lock(0);
 end;
-- 
-- if ld.CheckRequirements( {"get_pick"} ) and not (ld.CheckRequirements( {"use_stoneflower"} ) or ld.CheckRequirements( {"use_stoneleaf1"} ) or ld.CheckRequirements( {"use_stoneleaf2"} )) then  
--   ld.Lock(1);
--      ObjSet( "obj_upstairs_anim_root", {visible = 0} );
--   ObjSet( "anm_upstairs_anm_idle", {visible = 1} );
--   ld.AnimPlay( "anm_upstairs_anm_idle", "idle_door", func_end );
-- end;

 --  if ld.CheckRequirements( {"get_pick"} ) then
     if not ld.CheckRequirements( {"use_stoneflower"} ) then
       ld.AnimPlay( "anm_upstairs_anm_use_stoneflower", "idle_door1", function() end );
     end;  
     if not   ld.CheckRequirements( {"use_stoneleaf1"} ) then 
       ld.AnimPlay( "anm_upstairs_anm_use_stsheet1", "idle_door2", function() end);
     end;  
     if not ld.CheckRequirements( {"use_stoneleaf2"} ) then 
       ld.AnimPlay( "anm_upstairs_anm_use_stsheet2", "idle_door", function() end);
     end; 
     ld.StartTimer( 0.4, func_end )  
 --  end;  
     SoundSfx( "aud_touch_lock_corridor" );
end;  
 -----------------------------------------------------------------------
function public.use_stoneflower_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_stoneflower' );
  end;

  ld.Lock(1);
  ld.AnimPlay( "anm_upstairs_anm_use_stoneflower", "idle_door1", func_end )
  SoundSfx( "aud_touch_lock_corridor" );
end;  

common_impl.hint[ "use_stoneflower" ] = { type = "use", inv_obj = "inv_stoneflower", use_place = "gfx_upstairs_stoneflower_zone", room = "rm_corridor", zz = "zz_upstairs", zz_gate = "gzz_corridor_upstairs" };

private.use_stoneflower_logic = function()
  if ld.CheckRequirements( {"use_stoneflower","use_stoneleaf1","use_stoneleaf2"} ) then
    ObjSet( "grm_corridor_rungs", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_corridor_rungs_focus");
    end;
  end;

end;
private.use_stoneflower_inv = function()
  common_impl.ProcessMultiUseAll("stoneflower", "stoneflower")
end;
private.use_stoneflower_beg = function()
  ObjDelete( "gfx_upstairs_stoneflower_zone" );
end;
private.use_stoneflower_end = function()
  if common_impl.ZzCompleteCheck("use_stoneflower") then ObjSet( common_impl.hint["use_stoneflower"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_stoneflower","use_stoneleaf1","use_stoneleaf2"} ) then
    ObjDelete("obj_upstairs_anim_root");
    ObjSet( "anm_upstairs_anm_idle", {visible = 1, animfunc="opendoor", frame=999} );
    ObjDelete("obj_corridor_upstair_close_door_tr_root");
    ObjSet( "spr_corridor_open_door", {visible = 1} );
  else 
    ObjSet( "anm_upstairs_anm_use_stoneflower", {animfunc = "use_stoneflower", frame = 999 } );
    ObjSet( "spr_corridor_stoneflower", {visible = 1} );
    ObjSet( "spr_corridor_lock1", {pos_x=544} );
  end;  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stoneflower", private.use_stoneflower_inv );
cmn.AddSubscriber( "use_stoneflower", private.use_stoneflower_beg, private.room_objname );
cmn.AddSubscriber( "use_stoneflower", private.use_stoneflower_end, private.room_objname );
cmn.AddSubscriber( "use_stoneflower", private.use_stoneflower_logic );
cmn.AddSubscriber( "use_stoneflower_inv", private.use_stoneflower_inv, private.room_objname );
cmn.AddSubscriber( "use_stoneflower_beg", private.use_stoneflower_beg, private.room_objname );
cmn.AddSubscriber( "use_stoneflower_end", private.use_stoneflower_end, private.room_objname );
cmn.AddSubscriber( "use_stoneflower_end", private.use_stoneflower_logic );
--------------------------------------------------------------------------------------------
function public.use_stoneflower( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stoneflower" );
    cmn.CallEventHandler( "use_stoneflower_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stoneflower") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
      ObjSet( "anm_upstairs_anm_use_stoneflower", {pos_z=5} );
      if ld.CheckRequirements( {"use_stoneleaf1","use_stoneleaf2"} )  then
        ObjSet( "obj_upstairs_anim_root", {visible = 0} );
        ObjSet( "anm_upstairs_anm_idle", {visible = 1, animfunc="opendoor", frame=0} );
        ld.StartTimer( 0.5, function()  ld.AnimPlay( "anm_upstairs_anm_idle", "opendoor", func_end ); SoundSfx( "aud_open_door_corridor" ); end )
      else 
        func_end();
      end;  
  end;
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stoneflower_inv" );
  cmn.CallEventHandler( "use_stoneflower_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_upstairs_anm_use_stoneflower", {pos_z=15} );
  ld.AnimPlay( "anm_upstairs_anm_use_stoneflower", "use_stoneflower", func_preend );
  SoundSfx( "aud_use_stoneflower_corridor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_stoneleaf1_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_stoneleaf1' ); 
  end;

  ld.Lock(1);
  ld.AnimPlay( "anm_upstairs_anm_use_stsheet1", "idle_door2", func_end )
  SoundSfx( "aud_touch_lock_corridor" );
end;  

common_impl.hint[ "use_stoneleaf1" ] = { type = "use", inv_obj = "inv_stoneleaf1", use_place = "gfx_upstairs_stoneleaf1_zone", room = "rm_corridor", zz = "zz_upstairs", zz_gate = "gzz_corridor_upstairs" };

private.use_stoneleaf1_logic = function()
  if ld.CheckRequirements( {"use_stoneleaf1","use_stoneflower","use_stoneleaf2"} ) then
    ObjSet( "grm_corridor_rungs", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_corridor_rungs_focus");
    end;
  end;

end;
private.use_stoneleaf1_inv = function()
  common_impl.ProcessMultiUseAll("stoneleaf1", "stoneleaf1")
end;
private.use_stoneleaf1_beg = function()
  ObjDelete( "gfx_upstairs_stoneleaf1_zone" );
end;
private.use_stoneleaf1_end = function()
  if common_impl.ZzCompleteCheck("use_stoneleaf1") then ObjSet( common_impl.hint["use_stoneleaf1"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_stoneflower","use_stoneleaf1","use_stoneleaf2"} ) then
    ObjDelete("obj_upstairs_anim_root");
    ObjSet( "anm_upstairs_anm_idle", {visible = 1, animfunc="opendoor", frame=999} );
    ObjDelete("obj_corridor_upstair_close_door_tr_root");
    ObjSet( "spr_corridor_open_door", {visible = 1} );
  else 
    ObjSet( "anm_upstairs_anm_use_stsheet1", {animfunc = "use_stsheet1", frame = 999 } );
    ObjSet( "spr_corridor_stonesheet_1", {visible=1} );
    ObjSet( "spr_corridor_lock3", {pos_x=543} );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stoneleaf1", private.use_stoneleaf1_inv );
cmn.AddSubscriber( "use_stoneleaf1", private.use_stoneleaf1_beg, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf1", private.use_stoneleaf1_end, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf1", private.use_stoneleaf1_logic );
cmn.AddSubscriber( "use_stoneleaf1_inv", private.use_stoneleaf1_inv, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf1_beg", private.use_stoneleaf1_beg, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf1_end", private.use_stoneleaf1_end, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf1_end", private.use_stoneleaf1_logic );
--------------------------------------------------------------------------------------------
function public.use_stoneleaf1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stoneleaf1" );
    cmn.CallEventHandler( "use_stoneleaf1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stoneleaf1") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
      ObjSet( "anm_upstairs_anm_use_stsheet1", {pos_z=5} );
      if ld.CheckRequirements( {"use_stoneflower","use_stoneleaf2"} )  then
        ObjSet( "obj_upstairs_anim_root", {visible = 0} );
        ObjSet( "anm_upstairs_anm_idle", {visible = 1, animfunc="opendoor", frame=0} );
        ld.StartTimer( 0.5, function()  ld.AnimPlay( "anm_upstairs_anm_idle", "opendoor", func_end ); SoundSfx( "aud_open_door_corridor" );  end )
      else 
        func_end();
      end;  
  end;
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stoneleaf1_inv" );
  cmn.CallEventHandler( "use_stoneleaf1_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_upstairs_anm_use_stsheet1", {pos_z=15} );
  ld.AnimPlay( "anm_upstairs_anm_use_stsheet1", "use_stsheet1", func_preend );
  SoundSfx( "aud_use_stoneleaf1_corridor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_stoneleaf2_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_stoneleaf2' ); 
  end;

  ld.Lock(1);
  ld.AnimPlay( "anm_upstairs_anm_use_stsheet2", "idle_door", func_end )
  SoundSfx( "aud_touch_lock_corridor" );
end;  

common_impl.hint[ "use_stoneleaf2" ] = { type = "use", inv_obj = "inv_stoneleaf2", use_place = "gfx_upstairs_stoneleaf2_zone", room = "rm_corridor", zz = "zz_upstairs", zz_gate = "gzz_corridor_upstairs" };

private.use_stoneleaf2_logic = function()
  if ld.CheckRequirements( {"use_stoneleaf2","use_stoneflower","use_stoneleaf1"} ) then
    ObjSet( "grm_corridor_rungs", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_corridor_rungs_focus");
    end;
  end;

end;
private.use_stoneleaf2_inv = function()
  common_impl.ProcessMultiUseAll("stoneleaf2", "stoneleaf2")
end;
private.use_stoneleaf2_beg = function()
  ObjDelete( "gfx_upstairs_stoneleaf2_zone" );
end;
private.use_stoneleaf2_end = function()
  if common_impl.ZzCompleteCheck("use_stoneleaf2") then ObjSet( common_impl.hint["use_stoneleaf2"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_stoneflower","use_stoneleaf1","use_stoneleaf2"} ) then
    ObjDelete("obj_upstairs_anim_root");
    ObjSet( "anm_upstairs_anm_idle", {visible = 1, animfunc="opendoor", frame=999} );
    ObjDelete("obj_corridor_upstair_close_door_tr_root");
    ObjSet( "spr_corridor_open_door", {visible = 1} );
  else 
    ObjSet( "anm_upstairs_anm_use_stsheet2", {animfunc = "use_stsheet2", frame = 999 } );
    ObjSet( "spr_corridor_stonesheet2", {visible=1} );
    ObjSet( "spr_corridor_lock2", {pos_x=543} );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stoneleaf2", private.use_stoneleaf2_inv );
cmn.AddSubscriber( "use_stoneleaf2", private.use_stoneleaf2_beg, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf2", private.use_stoneleaf2_end, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf2", private.use_stoneleaf2_logic );
cmn.AddSubscriber( "use_stoneleaf2_inv", private.use_stoneleaf2_inv, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf2_beg", private.use_stoneleaf2_beg, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf2_end", private.use_stoneleaf2_end, private.room_objname );
cmn.AddSubscriber( "use_stoneleaf2_end", private.use_stoneleaf2_logic );
--------------------------------------------------------------------------------------------
function public.use_stoneleaf2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stoneleaf2" );
    cmn.CallEventHandler( "use_stoneleaf2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stoneleaf2") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
      ObjSet( "anm_upstairs_anm_use_stsheet2", {pos_z=5} );
      if ld.CheckRequirements( {"use_stoneleaf1","use_stoneflower"} )  then
        ObjSet( "obj_upstairs_anim_root", {visible = 0} );
        ObjSet( "anm_upstairs_anm_idle", {visible = 1, animfunc="opendoor", frame=0} );
        ld.StartTimer( 0.5, function()  ld.AnimPlay( "anm_upstairs_anm_idle", "opendoor", func_end ); SoundSfx( "aud_open_door_corridor" );  end )
      else 
        func_end();
      end;  
  end;
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stoneleaf2_inv" );
  cmn.CallEventHandler( "use_stoneleaf2_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_upstairs_anm_use_stsheet2", {pos_z=15} );
  ld.AnimPlay( "anm_upstairs_anm_use_stsheet2", "use_stsheet2", func_preend );
  SoundSfx( "aud_use_stoneleaf2_corridor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_puddle_for_corridor = function()
    if ld.CheckRequirements( {"win_puddle"} ) then
      ObjSet( "gho_corridor_puddle", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_puddle", win_puddle_for_corridor, private.room_objname )

end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_hidingplace" ) and not ld.CheckRequirements( { "win_hidingplace" } ) then  
     private.win_hidingplace_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_hidingplace" ) and not ld.CheckRequirements( { "win_hidingplace" } ) then
    private.win_hidingplace_skip()
  end;
  
end
--*********************************************************************************************************************


function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_corridor();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_corridor_env" );
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_upstairs" );
  function zz_upstairs.Open()
  end;
  function zz_upstairs.PreOpen()
  end;
  function zz_upstairs.PreClose()
  end;
  function zz_upstairs.Close()
  end;

  subroom.Define( "zz_slush" );
  function zz_slush.Open()
  end;
  function zz_slush.PreOpen()
  end;
  function zz_slush.PreClose()
  end;
  function zz_slush.Close()
  end;

  subroom.Define( "zz_hidingplace" );
  function zz_hidingplace.Open()
  end;
  function zz_hidingplace.PreOpen()
     if cmn.IsEventStart("win_hidingplace") and not cmn.IsEventDone("win_hidingplace") then 
        cmn.MiniGameShow( "hidingplace" ); 
        private.init_hidingplace();
        iOS_NeedDrag(0);
     end;  
  end;
  function zz_hidingplace.PreClose()
    iOS_NeedDrag(1);
  end;
  function zz_hidingplace.Close()
     if cmn.IsEventStart("win_hidingplace") and not cmn.IsEventDone("win_hidingplace") then 
       cmn.MiniGameHide( "hidingplace" ); 
    end; 
  end;

  subroom.Define( "zz_hatch" );
  function zz_hatch.Open()
  end;
  function zz_hatch.PreOpen()
  end;
  function zz_hatch.PreClose()
  end;
  function zz_hatch.Close()
  end;

  subroom.Define( "zz_tube" );
  function zz_tube.Open()
  end;
  function zz_tube.PreOpen()
  end;
  function zz_tube.PreClose()
  end;
  function zz_tube.Close()
  end;
  
end;
--*********************************************************************************************************************
-- other funcs

function public.corridor_pillow_clk_zone_clk()
  local func_end = function()
    ObjSet( "obj_corridor_pillow_clk_zone", {input = 1} ); 
  end;

  ObjSet( "obj_corridor_pillow_clk_zone", {input = 0} ); 
  SoundSfx( "aud_touch_pillow_corridor" );
  ld.AnimPlay( "anm_corridor_anm_pillow", "pillow", func_end ) 
end;  