-- name=rm_mansion
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mansion";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  
  ld.NoteInit("spr_worktable_paper","spr_worktable_paper_big","mansion_worktable_paper_clk"); 
  ld.NoteRelaseLock( "spr_worktable_paper" )
  ld.NoteInit("spr_underground_paper","spr_underground_paper_big","mansion_underground_paper_clk");   
  --------------------------------------------------------------------------------------------
function private.opn_mansion()
  if not ( cmn.IsEventDone( "opn_mansion" ) ) then
    cmn.SetEventDone( "opn_mansion" );
    cmn.CallEventHandler( "opn_mansion" )
    ld.ShowBbt("opn_mansion");
    SoundTheme( "aud_adventure2_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_mansion = function() end;
local opn_mansion_logic = function() end;
cmn.AddSubscriber( "opn_mansion", opn_mansion_logic )
cmn.AddSubscriber( "opn_mansion", opn_mansion, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_worktable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_smallchest" ] = { type = "get", get_obj = "spr_worktable_smallchest", room = "rm_mansion", zz = "zz_worktable", zz_gate = "gzz_mansion_worktable" };

private.get_smallchest_logic = function()
  
end;
private.get_smallchest_inv = function()
  interface.InventoryItemAdd("inv_smallchest","spr_worktable_smallchest");
  ObjSet( "inv_smallchest", { drag = 0 } );
end;
private.get_smallchest_beg = function()
  ObjDelete("gfx_worktable_smallchest")
end;
private.get_smallchest_end = function()
  ObjDelete("spr_wardrobe_smallchest_shadow")
  if common_impl.ZzCompleteCheck("get_smallchest") then ObjSet( common_impl.hint["get_smallchest"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_smallchest", private.get_smallchest_inv );
cmn.AddSubscriber( "get_smallchest", private.get_smallchest_beg, private.room_objname );
cmn.AddSubscriber( "get_smallchest", private.get_smallchest_end, private.room_objname );
cmn.AddSubscriber( "get_smallchest", private.get_smallchest_logic );
--------------------------------------------------------------------
function public.get_smallchest()
  cmn.SetEventDone( "get_smallchest" );
  cmn.CallEventHandler( "get_smallchest" );
  if common_impl.ZzCompleteCheck("get_smallchest") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_greencrystal" ] = { type = "use", inv_obj = "inv_greencrystal", use_place = "gfx_worktable_greencrystal_zone", room = "rm_mansion", zz = "zz_worktable", zz_gate = "gzz_mansion_worktable" };

private.use_greencrystal_logic = function()
  if ld.CheckRequirements( {"use_greencrystal","use_redcrystal","use_yellowcrystal","use_bluecrystal"} ) then
  ObjSet( "gho_mansion_bookho", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mansion_tr_book_open", {alp = 1} );  
  end;

end;
private.use_greencrystal_inv = function()
  common_impl.ProcessMultiUseAll("greencrystal", "greencrystal")
end;
private.use_greencrystal_beg = function()
  ObjDelete( "gfx_worktable_greencrystal_zone" );
end;
private.use_greencrystal_end = function()
  ObjSet("anm_worktable_anim_green_cristal",{animfunc="anim_green_cristal_end",frame=0})
  
  if common_impl.ZzCompleteCheck("use_greencrystal") then ObjSet( common_impl.hint["use_greencrystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_greencrystal", private.use_greencrystal_inv );
cmn.AddSubscriber( "use_greencrystal", private.use_greencrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_greencrystal", private.use_greencrystal_end, private.room_objname );
cmn.AddSubscriber( "use_greencrystal", private.use_greencrystal_logic );
cmn.AddSubscriber( "use_greencrystal_inv", private.use_greencrystal_inv, private.room_objname );
cmn.AddSubscriber( "use_greencrystal_beg", private.use_greencrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_greencrystal_end", private.use_greencrystal_end, private.room_objname );
cmn.AddSubscriber( "use_greencrystal_end", private.use_greencrystal_logic );
--------------------------------------------------------------------------------------------
function public.use_greencrystal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_greencrystal" );
    cmn.CallEventHandler( "use_greencrystal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_greencrystal") then ld.CloseSubRoom() end;
  end;
  local func_step = function()
    if ld.CheckRequirements({"use_greencrystal","use_redcrystal","use_yellowcrystal","use_bluecrystal"},1)==3 then
      ObjDelete("anm_worktable_anim_red_cristal")
      ObjDelete("anm_worktable_anim_blue_cristal")
      ObjDelete("anm_worktable_anim_green_cristal")
      ObjDelete("anm_worktable_anim_yellow_cristal")    
      ObjSet( "anm_worktable_anim_open_book", {visible = 1} ); 
      SoundSfx( "aud_open_book_mansion" );         
      ld.AnimPlay( "anm_worktable_anim_open_book", "anim_openbook", func_end );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_greencrystal_inv" );
  cmn.CallEventHandler( "use_greencrystal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anim_green_cristal", "anim_green_cristal", func_step );
  SoundSfx( "aud_use_diamonds_mansion" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_redcrystal" ] = { type = "use", inv_obj = "inv_redcrystal", use_place = "gfx_worktable_redcrystal_zone", room = "rm_mansion", zz = "zz_worktable", zz_gate = "gzz_mansion_worktable" };

private.use_redcrystal_logic = function()
  if ld.CheckRequirements( {"use_redcrystal","use_greencrystal","use_yellowcrystal","use_bluecrystal"} ) then
  ObjSet( "gho_mansion_bookho", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mansion_tr_book_open", {alp = 1} );  
  end;

end;
private.use_redcrystal_inv = function()
  common_impl.ProcessMultiUseAll("redcrystal", "redcrystal")
end;
private.use_redcrystal_beg = function()
  ObjDelete( "gfx_worktable_redcrystal_zone" );
end;
private.use_redcrystal_end = function()
  ObjSet("anm_worktable_anim_red_cristal",{animfunc="anim_red_cristal_end",frame=0})
  if common_impl.ZzCompleteCheck("use_redcrystal") then ObjSet( common_impl.hint["use_redcrystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_redcrystal", private.use_redcrystal_inv );
cmn.AddSubscriber( "use_redcrystal", private.use_redcrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_redcrystal", private.use_redcrystal_end, private.room_objname );
cmn.AddSubscriber( "use_redcrystal", private.use_redcrystal_logic );
cmn.AddSubscriber( "use_redcrystal_inv", private.use_redcrystal_inv, private.room_objname );
cmn.AddSubscriber( "use_redcrystal_beg", private.use_redcrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_redcrystal_end", private.use_redcrystal_end, private.room_objname );
cmn.AddSubscriber( "use_redcrystal_end", private.use_redcrystal_logic );
--------------------------------------------------------------------------------------------
function public.use_redcrystal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_redcrystal" );
    cmn.CallEventHandler( "use_redcrystal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_redcrystal") then ld.CloseSubRoom() end;
  end;
  local func_step = function()
    if ld.CheckRequirements({"use_greencrystal","use_redcrystal","use_yellowcrystal","use_bluecrystal"},1)==3 then
      ObjDelete("anm_worktable_anim_red_cristal")
      ObjDelete("anm_worktable_anim_blue_cristal")
      ObjDelete("anm_worktable_anim_green_cristal")
      ObjDelete("anm_worktable_anim_yellow_cristal")      
      ObjSet( "anm_worktable_anim_open_book", {visible = 1} );
      SoundSfx( "aud_open_book_mansion" );    
      ld.AnimPlay( "anm_worktable_anim_open_book", "anim_openbook", func_end );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_redcrystal_inv" );
  cmn.CallEventHandler( "use_redcrystal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anim_red_cristal", "anim_red_cristal", func_step );
  SoundSfx( "aud_use_diamonds_mansion" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_yellowcrystal" ] = { type = "use", inv_obj = "inv_yellowcrystal", use_place = "gfx_worktable_yellowcrystal_zone", room = "rm_mansion", zz = "zz_worktable", zz_gate = "gzz_mansion_worktable" };

private.use_yellowcrystal_logic = function()
  if ld.CheckRequirements( {"use_yellowcrystal","use_greencrystal","use_redcrystal","use_bluecrystal"} ) then
  ObjSet( "gho_mansion_bookho", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mansion_tr_book_open", {alp = 1} );  
  end;

end;
private.use_yellowcrystal_inv = function()
  common_impl.ProcessMultiUseAll("yellowcrystal", "yellowcrystal")
end;
private.use_yellowcrystal_beg = function()
  ObjDelete( "gfx_worktable_yellowcrystal_zone" );
end;
private.use_yellowcrystal_end = function()
  ObjSet("anm_worktable_anim_yellow_cristal",{animfunc="anim_yellow_cristal_end",frame=0})
  if common_impl.ZzCompleteCheck("use_yellowcrystal") then ObjSet( common_impl.hint["use_yellowcrystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_yellowcrystal", private.use_yellowcrystal_inv );
cmn.AddSubscriber( "use_yellowcrystal", private.use_yellowcrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowcrystal", private.use_yellowcrystal_end, private.room_objname );
cmn.AddSubscriber( "use_yellowcrystal", private.use_yellowcrystal_logic );
cmn.AddSubscriber( "use_yellowcrystal_inv", private.use_yellowcrystal_inv, private.room_objname );
cmn.AddSubscriber( "use_yellowcrystal_beg", private.use_yellowcrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowcrystal_end", private.use_yellowcrystal_end, private.room_objname );
cmn.AddSubscriber( "use_yellowcrystal_end", private.use_yellowcrystal_logic );
--------------------------------------------------------------------------------------------
function public.use_yellowcrystal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_yellowcrystal" );
    cmn.CallEventHandler( "use_yellowcrystal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_yellowcrystal") then ld.CloseSubRoom() end;
  end;
  local func_step = function()
    if ld.CheckRequirements({"use_greencrystal","use_redcrystal","use_yellowcrystal","use_bluecrystal"},1)==3 then
      ObjDelete("anm_worktable_anim_red_cristal")
      ObjDelete("anm_worktable_anim_blue_cristal")
      ObjDelete("anm_worktable_anim_green_cristal")
      ObjDelete("anm_worktable_anim_yellow_cristal")  
      ObjSet( "anm_worktable_anim_open_book", {visible = 1} );  
      SoundSfx( "aud_open_book_mansion" );        
      ld.AnimPlay( "anm_worktable_anim_open_book", "anim_openbook", func_end );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_yellowcrystal_inv" );
  cmn.CallEventHandler( "use_yellowcrystal_beg" );
  common_impl.Lock(1);

    ld.AnimPlay( "anm_worktable_anim_yellow_cristal", "anim_yellow_cristal", func_step );
    SoundSfx( "aud_use_diamonds_yellow_mansion" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bluecrystal" ] = { type = "use", inv_obj = "inv_bluecrystal", use_place = "gfx_worktable_bluecrystal_zone", room = "rm_mansion", zz = "zz_worktable", zz_gate = "gzz_mansion_worktable" };

private.use_bluecrystal_logic = function()
  if ld.CheckRequirements( {"use_bluecrystal","use_greencrystal","use_redcrystal","use_yellowcrystal"} ) then
  ObjSet( "gho_mansion_bookho", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mansion_tr_book_open", {alp = 1} );  
  end;

end;
private.use_bluecrystal_inv = function()
  common_impl.ProcessMultiUseAll("bluecrystal", "bluecrystal")
end;
private.use_bluecrystal_beg = function()
  ObjDelete( "gfx_worktable_bluecrystal_zone" );
end;
private.use_bluecrystal_end = function()
  ObjSet("anm_worktable_anim_blue_cristal",{animfunc="anim_blue_cristal_end",frame=0})
  if common_impl.ZzCompleteCheck("use_bluecrystal") then ObjSet( common_impl.hint["use_bluecrystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bluecrystal", private.use_bluecrystal_inv );
cmn.AddSubscriber( "use_bluecrystal", private.use_bluecrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_bluecrystal", private.use_bluecrystal_end, private.room_objname );
cmn.AddSubscriber( "use_bluecrystal", private.use_bluecrystal_logic );
cmn.AddSubscriber( "use_bluecrystal_inv", private.use_bluecrystal_inv, private.room_objname );
cmn.AddSubscriber( "use_bluecrystal_beg", private.use_bluecrystal_beg, private.room_objname );
cmn.AddSubscriber( "use_bluecrystal_end", private.use_bluecrystal_end, private.room_objname );
cmn.AddSubscriber( "use_bluecrystal_end", private.use_bluecrystal_logic );
--------------------------------------------------------------------------------------------
function public.use_bluecrystal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bluecrystal" );
    cmn.CallEventHandler( "use_bluecrystal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bluecrystal") then ld.CloseSubRoom() end;
  end;
  local func_step = function()
    if ld.CheckRequirements({"use_greencrystal","use_redcrystal","use_yellowcrystal","use_bluecrystal"},1)==3 then
      ObjDelete("anm_worktable_anim_red_cristal")
      ObjDelete("anm_worktable_anim_blue_cristal")
      ObjDelete("anm_worktable_anim_green_cristal")
      ObjDelete("anm_worktable_anim_yellow_cristal")   
      ObjSet( "anm_worktable_anim_open_book", {visible = 1} ); 
      SoundSfx( "aud_open_book_mansion" );     
      ld.AnimPlay( "anm_worktable_anim_open_book", "anim_openbook", func_end );
    else 
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bluecrystal_inv" );
  cmn.CallEventHandler( "use_bluecrystal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anim_blue_cristal", "anim_blue_cristal", func_step );
  SoundSfx( "aud_use_diamonds_mansion" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_collection *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scissors_collection" ] = { type = "use", inv_obj = "inv_scissors", use_place = "gfx_collection_scissors_collection_zone", room = "rm_mansion", zz = "zz_collection", zz_gate = "gzz_mansion_collection" };

private.use_scissors_collection_logic = function()
  ObjSet( "spr_collection_amuletskull", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_collection_sword_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_scissors_collection_inv = function()
  common_impl.ProcessMultiUseAll("scissors", "scissors_collection")
end;
private.use_scissors_collection_beg = function()
  ObjDelete( "gfx_collection_scissors_collection_zone" );
end;
private.use_scissors_collection_end = function()
  ObjSet("anm_collection_collect",{animfunc="end_collec",frame=0})
  if common_impl.ZzCompleteCheck("use_scissors_collection") then ObjSet( common_impl.hint["use_scissors_collection"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissors_collection", private.use_scissors_collection_inv );
cmn.AddSubscriber( "use_scissors_collection", private.use_scissors_collection_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_collection", private.use_scissors_collection_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_collection", private.use_scissors_collection_logic );
cmn.AddSubscriber( "use_scissors_collection_inv", private.use_scissors_collection_inv, private.room_objname );
cmn.AddSubscriber( "use_scissors_collection_beg", private.use_scissors_collection_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_collection_end", private.use_scissors_collection_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_collection_end", private.use_scissors_collection_logic );
--------------------------------------------------------------------------------------------
function public.use_scissors_collection( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    public.get_amuletskull()
    cmn.SetEventDone( "use_scissors_collection" );
    cmn.CallEventHandler( "use_scissors_collection_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_scissors_collection") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissors_collection_inv" );
  cmn.CallEventHandler( "use_scissors_collection_beg" );
  common_impl.Lock(1);

  ld.AnimPlay("anm_collection_collect","use_scissors",func_end)
  SoundSfx( "aud_use_scissors_knives" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletskull" ] = { type = "get", get_obj = "spr_collection_amuletskull", room = "rm_mansion", zz = "zz_collection", zz_gate = "gzz_mansion_collection" };

private.get_amuletskull_logic = function()
  
end;
private.get_amuletskull_inv = function()
  interface.InventoryItemAdd("inv_amuletskull","spr_collection_amuletskull");
end;
private.get_amuletskull_beg = function()
  ObjDelete("gfx_collection_amuletskull")
end;
private.get_amuletskull_end = function()
  if common_impl.ZzCompleteCheck("get_amuletskull") then ObjSet( common_impl.hint["get_amuletskull"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletskull", private.get_amuletskull_inv );
cmn.AddSubscriber( "get_amuletskull", private.get_amuletskull_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletskull", private.get_amuletskull_end, private.room_objname );
cmn.AddSubscriber( "get_amuletskull", private.get_amuletskull_logic );
--------------------------------------------------------------------
function public.get_amuletskull()
  cmn.SetEventDone( "get_amuletskull" );
  cmn.CallEventHandler( "get_amuletskull" );
  if common_impl.ZzCompleteCheck("get_amuletskull") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sword" ] = { type = "use", inv_obj = "inv_sword", use_place = "gfx_collection_sword_zone", room = "rm_mansion", zz = "zz_collection", zz_gate = "gzz_mansion_collection" };

private.use_sword_logic = function()
  ObjSet( "gfx_collection_win_swords_zone", {  input = 1 } )
end;
private.use_sword_inv = function()
  common_impl.ProcessMultiUseAll("sword", "sword")
end;
private.use_sword_beg = function()
  ObjDelete( "gfx_collection_sword_zone" );
end;
private.use_sword_end = function()
  ObjSet("anm_collection_collect",{animfunc="end_door",frame=0})
  ObjSet( "obj_collection_mmg_root", {input = 1, alp=1} );
  ObjSet( "spr_mansion_tr_sword5", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_sword") then ObjSet( common_impl.hint["use_sword"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sword", private.use_sword_inv );
cmn.AddSubscriber( "use_sword", private.use_sword_beg, private.room_objname );
cmn.AddSubscriber( "use_sword", private.use_sword_end, private.room_objname );
cmn.AddSubscriber( "use_sword", private.use_sword_logic );
cmn.AddSubscriber( "use_sword_inv", private.use_sword_inv, private.room_objname );
cmn.AddSubscriber( "use_sword_beg", private.use_sword_beg, private.room_objname );
cmn.AddSubscriber( "use_sword_end", private.use_sword_end, private.room_objname );
cmn.AddSubscriber( "use_sword_end", private.use_sword_logic );
--------------------------------------------------------------------------------------------
function public.use_sword( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    private.init_swords()    
    cmn.MiniGameShow( "swords" );    
    cmn.SetEventDone( "use_sword" );
    cmn.CallEventHandler( "use_sword_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sword") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sword_inv" );
  cmn.CallEventHandler( "use_sword_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_collection_collect", "use_sword", func_end );
  SoundSfx( "aud_use_knives_mansion" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_swords" ] = { type = "click", use_place = "gfx_collection_win_swords_zone", room = "rm_mansion", zz = "zz_collection", zz_gate = "gzz_mansion_collection" };

private.win_swords_logic = function()
  if cmn.IsEventDone("win_swords") then
    ObjSet( "spr_collection_ink", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_swords_beg = function()
  if cmn.IsEventDone("win_swords") then
    ObjDelete( "gfx_collection_win_swords_zone" );
  end
end;
private.win_swords_end = function()
  if cmn.IsEventDone("win_swords") then
    ObjDelete("obj_collection_mmg_root")    
    ObjSet("anm_collection_collect",{animfunc="open1",frame=0})
    ObjSet( "anm_collection_idle_spider", {input = 1} );
    ObjSet( "gfx_collection_ink", {visible = 1} );
    ObjSet("spr_mansion_tr_doors",{pos_x=425})
    ObjSet("spr_mansion_tr_doors2",{pos_x=360})
    
    ObjSet("spr_mansion_tr_sword", {pos_x=431})
    ObjSet("spr_mansion_tr_sword2",{pos_x=350})    
    ObjSet("spr_mansion_tr_sword3",{pos_x=351})    
    ObjSet("spr_mansion_tr_sword4",{pos_x=434})        
    ObjSet("spr_mansion_tr_sword5",{pos_x=434})         
  end
  if common_impl.ZzCompleteCheck("win_swords") then ObjSet( common_impl.hint["win_swords"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_swords", private.win_swords_beg, private.room_objname );
cmn.AddSubscriber( "win_swords", private.win_swords_end, private.room_objname );
cmn.AddSubscriber( "win_swords", private.win_swords_logic );
cmn.AddSubscriber( "win_swords_beg", private.win_swords_beg, private.room_objname );
cmn.AddSubscriber( "win_swords_end", private.win_swords_end, private.room_objname );
cmn.AddSubscriber( "win_swords_end", private.win_swords_logic );
--------------------------------------------------------------------------------------------
function public.win_swords()

  local func_end = function()
    cmn.SetEventDone( "win_swords" );
    cmn.CallEventHandler( "win_swords_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_swords") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_swords_beg" );
  common_impl.Lock(1);
  ObjDelete("obj_collection_mmg_root")
  ld.AnimPlay( "anm_collection_collect", "open", func_end );
  SoundSfx( "aud_mg_knives_win" );
  --func_end()
  ld.LogTrace( "win_swords" );
end;
--------------------------------------------------------------------------------------------
function private.init_swords()
  if not (cmn.IsEventStart("win_swords")) then
    ng_global.progress["std"]["win_swords"].state = {}
  end
end

private.state_swords = {}

function public.clk_sword(num)
  local param = ObjGet("spr_collection_sword"..num)
  local direction = 1  
  ld.Lock(1)
  ObjSet( param.name, {input = 0} );
  if math.fmod (num, 2) == 0 then direction = -1 end
  SoundSfx( "aud_mg_knives_move" );
  ObjAnimate( param.name, 0, 0, 0, function()ld.Lock(0);private.check_swords()end, {0,0,param.pos_x, 0.5,0,param.pos_x+(direction*100)} );
 table.insert(private.state_swords,#private.state_swords+1,num)

end
function public.menter_sword(obj)
  SetCursor( CURSOR_HAND );
  local obj = obj.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( 0.3 * ( 1 - alp ) ), 0, 1 } );    
end
function public.mleave_sword(obj)
  SetCursor( CURSOR_DEFAULT );
  local obj = obj.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( 0.3 * alp ), 0, 0 } );
end
function private.check_swords()
  local arr_win = {3,5,2,4,1}
  local check
  if #private.state_swords == 5 then
    cmn.MiniGameHide( "swords", true ); 
    public.win_swords()
  else 
    for i=1,#private.state_swords do 
      if private.state_swords[i] ~= arr_win[i] then
        private.win_swords_reset()
        break
      end
    end
    
  end
end
function private.win_swords_reset()
  
  for i=1,#private.state_swords do
    SoundSfx( "aud_mg_knives_wrong" );
    local param = ObjGet("spr_collection_sword"..private.state_swords[i])
    local direction = 1  
    ObjSet( param.name, {input = 1} );
    if math.fmod (private.state_swords[i], 2) == 0 then direction = -1 end
    ObjAnimate( param.name, 0, 0, 0, "", {0,0,param.pos_x, 0.5,0,param.pos_x-(direction*100)} );
  end
  if #private.state_swords >0 then  
    ld.Lock(1)
    ld.StartTimer( 0.5, function()ld.Lock(0)end )
  end
  private.state_swords = {}

end
function private.win_swords_skip()
  
  local check_swords = function (param)
    for i=1,#private.state_swords do
      if param == private.state_swords[i] then
        return true
      end
    end
    return false
  end
  
  for i=1,5 do
    local param = ObjGet("spr_collection_sword"..i)
    local direction = 1  
    ObjSet( param.name, {input = 1} );
    if math.fmod (i, 2) == 0 then 
      direction = -1 
    end
    if check_swords(i) then direction = 0 else   SoundSfx( "aud_mg_knives_move" );   end
    ObjAnimate( param.name, 0, 0, 0, "", {0,0,param.pos_x, 0.5,0,param.pos_x+(direction*100)} );
    ld.Lock(1)
    cmn.MiniGameHide( "swords",true ); 
  end  
  ld.StartTimer( 0.5, function()ld.Lock(0);public.win_swords()end )     
end
--------------------------------------------------------------------
common_impl.hint[ "get_ink" ] = { type = "get", get_obj = "spr_collection_ink", room = "rm_mansion", zz = "zz_collection", zz_gate = "gzz_mansion_collection" };

private.get_ink_logic = function()
  
end;
private.get_ink_inv = function()
  interface.InventoryItemAdd("inv_ink","spr_collection_ink");
end;
private.get_ink_beg = function()
  ObjDelete("gfx_collection_ink")
end;
private.get_ink_end = function()
  ObjDelete("spr_collection_sh_ink")
  ObjDelete("spr_mansion_tr_ink")
  if common_impl.ZzCompleteCheck("get_ink") then ObjSet( common_impl.hint["get_ink"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ink", private.get_ink_inv );
cmn.AddSubscriber( "get_ink", private.get_ink_beg, private.room_objname );
cmn.AddSubscriber( "get_ink", private.get_ink_end, private.room_objname );
cmn.AddSubscriber( "get_ink", private.get_ink_logic );
--------------------------------------------------------------------
function public.get_ink()
  cmn.SetEventDone( "get_ink" );
  cmn.CallEventHandler( "get_ink" );
  if common_impl.ZzCompleteCheck("get_ink") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wardrobe *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_brush" ] = { type = "use", inv_obj = "inv_brush", use_place = "gfx_wardrobe_brush_zone", room = "rm_mansion", zz = "zz_wardrobe", zz_gate = "gzz_mansion_wardrobe" };

private.use_brush_logic = function()
  ObjSet( "spr_wardrobe_dragon1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_wardrobe_feather", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_wardrobe_jar", { visible = 1, input = 1, active = 1 } )

end;
private.use_brush_inv = function()
  common_impl.ProcessMultiUseAll("brush", "brush")
end;
private.use_brush_beg = function()
  ObjDelete( "gfx_wardrobe_brush_zone" );
end;
private.use_brush_end = function()
  ObjSet( "gfx_wardrobe_jar", {visible = 1} );
  ObjSet( "gfx_wardrobe_feather", {visible = 1} );
  ObjSet( "gfx_wardrobe_dragon1", {visible = 1} );  
  ObjDelete("spr_mansion_tr_cobweb")
  ObjDelete("spr_mansion_tr_cobweb2")
  ObjDelete("anm_wardrobe_anm")
  if common_impl.ZzCompleteCheck("use_brush") then ObjSet( common_impl.hint["use_brush"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_brush", private.use_brush_inv );
cmn.AddSubscriber( "use_brush", private.use_brush_beg, private.room_objname );
cmn.AddSubscriber( "use_brush", private.use_brush_end, private.room_objname );
cmn.AddSubscriber( "use_brush", private.use_brush_logic );
cmn.AddSubscriber( "use_brush_inv", private.use_brush_inv, private.room_objname );
cmn.AddSubscriber( "use_brush_beg", private.use_brush_beg, private.room_objname );
cmn.AddSubscriber( "use_brush_end", private.use_brush_end, private.room_objname );
cmn.AddSubscriber( "use_brush_end", private.use_brush_logic );
--------------------------------------------------------------------------------------------
function public.use_brush( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_brush" );
    cmn.CallEventHandler( "use_brush_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_brush") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_brush_inv" );
  cmn.CallEventHandler( "use_brush_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wardrobe_anm", "use_brush", func_end );
  SoundSfx( "aud_use_brush_mansion" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dragon1" ] = { type = "get", get_obj = "spr_wardrobe_dragon1", room = "rm_mansion", zz = "zz_wardrobe", zz_gate = "gzz_mansion_wardrobe" };

private.get_dragon1_logic = function()
  
end;
private.get_dragon1_inv = function()
  interface.InventoryItemAdd("inv_dragon","spr_wardrobe_dragon1",function() level_inv.ProcessGetDragonAll( "get_dragon1" ) end);
end;
private.get_dragon1_beg = function()
  ObjDelete("gfx_wardrobe_dragon1")
end;
private.get_dragon1_end = function()
  ObjDelete("spr_wardrobe_sh_dragon1")
  if common_impl.ZzCompleteCheck("get_dragon1") then ObjSet( common_impl.hint["get_dragon1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_dragon1", private.get_dragon1_inv );
cmn.AddSubscriber( "get_dragon1", private.get_dragon1_beg, private.room_objname );
cmn.AddSubscriber( "get_dragon1", private.get_dragon1_end, private.room_objname );
cmn.AddSubscriber( "get_dragon1", private.get_dragon1_logic );
--------------------------------------------------------------------
function public.get_dragon1()
  cmn.SetEventDone( "get_dragon1" );
  cmn.CallEventHandler( "get_dragon1" );
  if common_impl.ZzCompleteCheck("get_dragon1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_feather" ] = { type = "get", get_obj = "spr_wardrobe_feather", room = "rm_mansion", zz = "zz_wardrobe", zz_gate = "gzz_mansion_wardrobe" };

private.get_feather_logic = function()
  
end;
private.get_feather_inv = function()
  interface.InventoryItemAdd("inv_feather","spr_wardrobe_feather");
end;
private.get_feather_beg = function()
  ObjDelete("gfx_wardrobe_feather")
end;
private.get_feather_end = function()
  ObjDelete("spr_wardrobe_sh_feather")
  if common_impl.ZzCompleteCheck("get_feather") then ObjSet( common_impl.hint["get_feather"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_feather", private.get_feather_inv );
cmn.AddSubscriber( "get_feather", private.get_feather_beg, private.room_objname );
cmn.AddSubscriber( "get_feather", private.get_feather_end, private.room_objname );
cmn.AddSubscriber( "get_feather", private.get_feather_logic );
--------------------------------------------------------------------
function public.get_feather()
  cmn.SetEventDone( "get_feather" );
  cmn.CallEventHandler( "get_feather" );
  if common_impl.ZzCompleteCheck("get_feather") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_jar" ] = { type = "get", get_obj = "spr_wardrobe_jar", room = "rm_mansion", zz = "zz_wardrobe", zz_gate = "gzz_mansion_wardrobe" };

private.get_jar_logic = function()
  
end;
private.get_jar_inv = function()
  interface.InventoryItemAdd("inv_jar","spr_wardrobe_jar");
  ObjSet( "inv_jar", { drag = 0 } );
end;
private.get_jar_beg = function()
  ObjDelete("gfx_wardrobe_jar")
end;
private.get_jar_end = function()
  ObjDelete("spr_wardrobe_sh_jar")
  ObjDelete("spr_mansion_tr_jar")
  if common_impl.ZzCompleteCheck("get_jar") then ObjSet( common_impl.hint["get_jar"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_jar", private.get_jar_inv );
cmn.AddSubscriber( "get_jar", private.get_jar_beg, private.room_objname );
cmn.AddSubscriber( "get_jar", private.get_jar_end, private.room_objname );
cmn.AddSubscriber( "get_jar", private.get_jar_logic );
--------------------------------------------------------------------
function public.get_jar()
  cmn.SetEventDone( "get_jar" );
  cmn.CallEventHandler( "get_jar" );
  if common_impl.ZzCompleteCheck("get_jar") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_underground *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dragon" ] = { type = "use", inv_obj = "inv_dragon", use_place = "gfx_underground_dragon_zone", room = "rm_mansion", zz = "zz_underground", zz_gate = "gzz_mansion_underground" };

private.use_dragon_logic = function()
    ObjSet( "gfx_underground_clk_undergroundopn_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_dragon_inv = function()
  common_impl.ProcessMultiUseAll("dragon", "dragon")
end;
private.use_dragon_beg = function()
  ObjDelete( "gfx_underground_dragon_zone" );
end;
private.use_dragon_end = function()
  ObjSet("anm_underground_anm",{animfunc="open",frame=0})
  ObjSet( "spr_mansion_tr_dragon", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_dragon") then ObjSet( common_impl.hint["use_dragon"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dragon", private.use_dragon_inv );
cmn.AddSubscriber( "use_dragon", private.use_dragon_beg, private.room_objname );
cmn.AddSubscriber( "use_dragon", private.use_dragon_end, private.room_objname );
cmn.AddSubscriber( "use_dragon", private.use_dragon_logic );
cmn.AddSubscriber( "use_dragon_inv", private.use_dragon_inv, private.room_objname );
cmn.AddSubscriber( "use_dragon_beg", private.use_dragon_beg, private.room_objname );
cmn.AddSubscriber( "use_dragon_end", private.use_dragon_end, private.room_objname );
cmn.AddSubscriber( "use_dragon_end", private.use_dragon_logic );
--------------------------------------------------------------------------------------------
function public.use_dragon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dragon" );
    cmn.CallEventHandler( "use_dragon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dragon") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dragon_inv" );
  cmn.CallEventHandler( "use_dragon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_underground_anm", "use_dragon", func_end );
  SoundSfx( "aud_use_dragon_mansion" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_undergroundopn" ] = { type = "click", use_place = "gfx_underground_clk_undergroundopn_zone", room = "rm_mansion", zz = "zz_underground", zz_gate = "gzz_mansion_underground" };

private.clk_undergroundopn_logic = function()
  ObjSet( "spr_underground_lionfigure", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_underground_paper", {input = 1} );
end;
private.clk_undergroundopn_beg = function()
  ObjDelete( "gfx_underground_clk_undergroundopn_zone" );
end;
private.clk_undergroundopn_end = function()
  ObjSet("anm_underground_anm",{animfunc="end_open",frame=0})
  ObjSet( "gfx_underground_lionfigure", {visible = 1} );  
  ObjDelete("spr_mansion_tr_cover")
  ObjSet( "spr_mansion_tr_open", {alp = 1} );
  ObjDelete("spr_mansion_tr_cover")
  ObjDelete("spr_mansion_tr_dragon")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_undergroundopn", private.clk_undergroundopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_undergroundopn", private.clk_undergroundopn_end, private.room_objname );
cmn.AddSubscriber( "clk_undergroundopn", private.clk_undergroundopn_logic );
cmn.AddSubscriber( "clk_undergroundopn_beg", private.clk_undergroundopn_beg, private.room_objname );
cmn.AddSubscriber( "clk_undergroundopn_end", private.clk_undergroundopn_end, private.room_objname );
cmn.AddSubscriber( "clk_undergroundopn_end", private.clk_undergroundopn_logic );
--------------------------------------------------------------------------------------------
function public.clk_undergroundopn()

  local func_end = function()
    cmn.SetEventDone( "clk_undergroundopn" );
    cmn.CallEventHandler( "clk_undergroundopn_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "clk_undergroundopn_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_underground_anm", "open", func_end );
  SoundSfx( "aud_touch_dragon_mansion" );
  --func_end()

end;
--------------------------------------------------------------------
common_impl.hint[ "get_keystar" ] = { type = "get", get_obj = "spr_underground_keystar", room = "rm_mansion", zz = "zz_underground", zz_gate = "gzz_mansion_underground" };

private.get_keystar_logic = function()
  
end;
private.get_keystar_inv = function()
  interface.InventoryItemAdd("inv_keystar","spr_underground_keystar");
end;
private.get_keystar_beg = function()
  ObjDelete("gfx_underground_keystar")
end;
private.get_keystar_end = function()
  ObjDelete("spr_underground_keystar_shadow")
  ObjDelete("spr_mansion_tr_keystar")
  if common_impl.ZzCompleteCheck("get_keystar") then ObjSet( common_impl.hint["get_keystar"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_keystar", private.get_keystar_inv );
cmn.AddSubscriber( "get_keystar", private.get_keystar_beg, private.room_objname );
cmn.AddSubscriber( "get_keystar", private.get_keystar_end, private.room_objname );
cmn.AddSubscriber( "get_keystar", private.get_keystar_logic );
--------------------------------------------------------------------
function public.get_keystar()
  cmn.SetEventDone( "get_keystar" );
  cmn.CallEventHandler( "get_keystar" );
  if common_impl.ZzCompleteCheck("get_keystar") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lionfigure" ] = { type = "get", get_obj = "spr_underground_lionfigure", room = "rm_mansion", zz = "zz_underground", zz_gate = "gzz_mansion_underground" };

private.get_lionfigure_logic = function()
    ObjSet( "spr_underground_keystar", { visible = 1, input = 1, active = 1 } )
end;
private.get_lionfigure_inv = function()
  interface.InventoryItemAdd("inv_lionfigure","spr_underground_lionfigure");
end;
private.get_lionfigure_beg = function()
  ObjDelete("gfx_underground_lionfigure")
end;
private.get_lionfigure_end = function()
  ObjDelete("spr_underground_sh_lionfigure")
  ObjDelete("spr_mansion_tr_lionfigure")
    ObjSet( "gfx_underground_keystar", {visible = 1} );
  if common_impl.ZzCompleteCheck("get_lionfigure") then ObjSet( common_impl.hint["get_lionfigure"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lionfigure", private.get_lionfigure_inv );
cmn.AddSubscriber( "get_lionfigure", private.get_lionfigure_beg, private.room_objname );
cmn.AddSubscriber( "get_lionfigure", private.get_lionfigure_end, private.room_objname );
cmn.AddSubscriber( "get_lionfigure", private.get_lionfigure_logic );
--------------------------------------------------------------------
function public.get_lionfigure()
  cmn.SetEventDone( "get_lionfigure" );
  cmn.CallEventHandler( "get_lionfigure" );
  if common_impl.ZzCompleteCheck("get_lionfigure") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_bookho_for_mansion = function()
    if ld.CheckRequirements( {"win_bookho"} ) then
      ObjSet( "gho_mansion_bookho", {input = 0, visible = 0} );
      ObjSet( "anm_mansion_anim_light", {input = 1, visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_bookho", win_bookho_for_mansion, private.room_objname )

end;
--*********************************************************************************************************************
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_collection" ) and not ld.CheckRequirements( { "win_swords" } ) then  
    private.win_swords_reset()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_collection" ) and not ld.CheckRequirements( { "win_swords" } ) then
    private.win_swords_skip();
  end;
  
end
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_mansion();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mansion_env" );
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_underground" );
  function zz_underground.Open()
  end;
  function zz_underground.PreOpen()
  end;
  function zz_underground.PreClose()
  end;
  function zz_underground.Close()
  end;

  subroom.Define( "zz_wardrobe" );
  function zz_wardrobe.Open()
  end;
  function zz_wardrobe.PreOpen()
  end;
  function zz_wardrobe.PreClose()
  end;
  function zz_wardrobe.Close()
  end;

  subroom.Define( "zz_collection" );
  function zz_collection.Open()
  end;
  function zz_collection.PreOpen()
     if cmn.IsEventStart("win_swords") and not cmn.IsEventDone("win_swords") then 
      cmn.MiniGameShow( "swords" ); 
      private.init_swords()
     end;       
  end;
  function zz_collection.PreClose()
  end;
  function zz_collection.Close()
     --if cmn.IsEventStart("win_swords") and not cmn.IsEventDone("win_swords") then 
     --  cmn.MiniGameHide( "swords" ); 
     --end;     
  end;

  subroom.Define( "zz_worktable" );
  function zz_worktable.Open()
  end;
  function zz_worktable.PreOpen()
  end;
  function zz_worktable.PreClose()
  end;
  function zz_worktable.Close()
  end;
  
end;
--*********************************************************************************************************************