-- name=rm_rungs
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_rungs";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  ld.NoteInit("spr_understairs_paper_small","spr_understairs_paper_big");
  ld.NoteRelaseLock( "spr_understairs_paper_small" )
  --------------------------------------------------------------------------------------------  
function private.opn_rungs()
  if not ( cmn.IsEventDone( "opn_rungs" ) ) then
    cmn.SetEventDone( "opn_rungs" );
    cmn.CallEventHandler( "opn_rungs" )
    SoundTheme( "aud_danger_moment1_mus" );
  end;
end;
--------------------------------------------------------------------
local opn_rungs = function() end;
local opn_rungs_logic = function() end;
cmn.AddSubscriber( "opn_rungs", opn_rungs_logic )
cmn.AddSubscriber( "opn_rungs", opn_rungs, private.room_objname )
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "storm2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    end        
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_rungs_storm2" ] = { type = "click", use_place = "gfx_rungs_dlg_rungs_storm2_zone", room = "rm_rungs" };

private.dlg_rungs_storm2_logic = function()
  ObjSet( "gzz_rungs_picture", {visible = 1, input = 1, active = 1} );
  ObjSet( "gzz_rungs_understairs", {visible = 1, input = 1, active = 1} );
  ObjSet( "gzz_rungs_halldoor", {visible = 1, input = 1, active = 1} );
  ObjSet( "gzz_rungs_bedroomdoor", {visible = 1, input = 1, active = 1} );  
  ObjSet( "gzz_rungs_table", {visible = 1, input = 1, active = 1} );    
end;
private.dlg_rungs_storm2_beg = function()
  ObjDelete( "gfx_rungs_dlg_rungs_storm2_zone" );
end;
private.dlg_rungs_storm2_end = function()
  ObjDelete("anm_rungs_daren")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_rungs_storm2", private.dlg_rungs_storm2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_rungs_storm2", private.dlg_rungs_storm2_end, private.room_objname );
cmn.AddSubscriber( "dlg_rungs_storm2", private.dlg_rungs_storm2_logic );
cmn.AddSubscriber( "dlg_rungs_storm2_beg", private.dlg_rungs_storm2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_rungs_storm2_end", private.dlg_rungs_storm2_end, private.room_objname );
cmn.AddSubscriber( "dlg_rungs_storm2_end", private.dlg_rungs_storm2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_rungs_storm2( obj )

  cmn.CallEventHandler( "dlg_rungs_storm2_beg" );
  --common_impl.Lock(1);
  common_impl.dialog_character_loc = "anm_rungs_daren"
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  common_impl.Start( "storm2", 2, nil, nil, true, "dlg_rungs_storm2_end",{"aud_storm_3_voc"} );
  common_impl.dialog_character_loc = nill
end;

private.dlg_rungs_storm2_end = function()
  ObjSet( "dlg_rungs_storm2", {bake=1} );
  cmn.SetEventDone( "dlg_rungs_storm2" );
  cmn.CallEventHandler( "dlg_rungs_storm2_end" );
  --common_impl.Lock(0);
  --common_impl.Lock(0);
  ld.ShowBbt("after_dlg_storm2")
end;
function public.dlg_rungs_storm2_end()
  private.dlg_rungs_storm2_end()
end
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_table *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_shawl" ] = { type = "get", get_obj = "spr_table_shawl", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.get_shawl_logic = function()
  ObjSet( "gfx_table_lionfigure_zone", {active = 1, visible = 1, input = 1} );
end;
private.get_shawl_inv = function()
  interface.InventoryItemAdd("inv_shawl","spr_table_shawl");
end;
private.get_shawl_beg = function()
  ObjDelete("gfx_table_shawl")
end;
private.get_shawl_end = function()
  ObjDelete("spr_table_sh_shawl")
  ObjDelete("spr_rungs_shawl_tr")
  if common_impl.ZzCompleteCheck("get_shawl") then ObjSet( common_impl.hint["get_shawl"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_shawl", private.get_shawl_inv );
cmn.AddSubscriber( "get_shawl", private.get_shawl_beg, private.room_objname );
cmn.AddSubscriber( "get_shawl", private.get_shawl_end, private.room_objname );
cmn.AddSubscriber( "get_shawl", private.get_shawl_logic );
--------------------------------------------------------------------
function public.get_shawl()
  cmn.SetEventDone( "get_shawl" );
  cmn.CallEventHandler( "get_shawl" );
  if common_impl.ZzCompleteCheck("get_shawl") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lionfigure" ] = { type = "use", inv_obj = "inv_lionfigure", use_place = "gfx_table_lionfigure_zone", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.use_lionfigure_logic = function()
  ObjSet( "spr_table_amuletlizard1", { visible = 1, input = 1, active = 1 } )
end;
private.use_lionfigure_inv = function()
  common_impl.ProcessMultiUseAll("lionfigure", "lionfigure")
end;
private.use_lionfigure_beg = function()
  ObjDelete( "gfx_table_lionfigure_zone" );
end;
private.use_lionfigure_end = function()
  ObjSet("anm_table_anm_lion",{animfunc="end_lioness",frame=0})
  ObjDelete("spr_rungs_cap_tr")
  ObjSet( "spr_rungs_lioness", {alp = 1} );
  ObjSet( "spr_table_sh_amuletlizard1", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_lionfigure") then ObjSet( common_impl.hint["use_lionfigure"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lionfigure", private.use_lionfigure_inv );
cmn.AddSubscriber( "use_lionfigure", private.use_lionfigure_beg, private.room_objname );
cmn.AddSubscriber( "use_lionfigure", private.use_lionfigure_end, private.room_objname );
cmn.AddSubscriber( "use_lionfigure", private.use_lionfigure_logic );
cmn.AddSubscriber( "use_lionfigure_inv", private.use_lionfigure_inv, private.room_objname );
cmn.AddSubscriber( "use_lionfigure_beg", private.use_lionfigure_beg, private.room_objname );
cmn.AddSubscriber( "use_lionfigure_end", private.use_lionfigure_end, private.room_objname );
cmn.AddSubscriber( "use_lionfigure_end", private.use_lionfigure_logic );
--------------------------------------------------------------------------------------------
function public.use_lionfigure( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lionfigure" );
    cmn.CallEventHandler( "use_lionfigure_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lionfigure") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lionfigure_inv" );
  cmn.CallEventHandler( "use_lionfigure_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_table_anm_lion", "use_lioness", func_end );
  SoundSfx( "aud_use_lionessfigure_rungs" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletlizard1" ] = { type = "get", get_obj = "spr_table_amuletlizard1", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.get_amuletlizard1_logic = function()
  
end;
private.get_amuletlizard1_inv = function()
  interface.InventoryItemAdd("inv_amuletlizard","spr_table_amuletlizard1",function() level_inv.ProcessGetAmuletlizardAll( "get_amuletlizard1" ) end);
end;
private.get_amuletlizard1_beg = function()
  ObjDelete("gfx_table_amuletlizard1")
end;
private.get_amuletlizard1_end = function()
  ObjDelete("spr_table_sh_amuletlizard1")
  if common_impl.ZzCompleteCheck("get_amuletlizard1") then ObjSet( common_impl.hint["get_amuletlizard1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletlizard1", private.get_amuletlizard1_inv );
cmn.AddSubscriber( "get_amuletlizard1", private.get_amuletlizard1_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletlizard1", private.get_amuletlizard1_end, private.room_objname );
cmn.AddSubscriber( "get_amuletlizard1", private.get_amuletlizard1_logic );
--------------------------------------------------------------------
function public.get_amuletlizard1()
  cmn.SetEventDone( "get_amuletlizard1" );
  cmn.CallEventHandler( "get_amuletlizard1" );
  if common_impl.ZzCompleteCheck("get_amuletlizard1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crystalball1" ] = { type = "use", inv_obj = "inv_crystalball1", use_place = "gfx_table_crystalball1_zone", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.use_crystalball1_logic = function()
  if ld.CheckRequirements( {"use_crystalball1","use_crystalball2"} ) then
    ObjSet( "spr_table_bedroomkey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_crystalball1_inv = function()
  common_impl.ProcessMultiUseAll("crystalball1", "crystalball1")
end;
private.use_crystalball1_beg = function()
  ObjDelete( "gfx_table_crystalball1_zone" );
end;
private.use_crystalball1_end = function()
  if ld.CheckRequirements( {"use_crystalball2"}) then
    ObjDelete("anm_table_anm_use_crystalball_1")
    ObjDelete("anm_table_anm_use_crystalball_2")
    ObjSet( "spr_table_sh_bedroomkey", {visible = 1} );
    ObjSet( "anm_table_anm_end_crystalball_start",{animfunc="end_crystalball2",frame=0} );
    ObjDelete("spr_rungs_left_paw")
    ObjSet( "spr_rungs_open_left_paw", {alp = 1} );    
  else 
    ObjSet("anm_table_anm_use_crystalball_1",{animfunc="end_crystalball",frame=0})
    
  end  
  ObjSet( "spr_rungs_tr_crystalball1", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_crystalball1") then ObjSet( common_impl.hint["use_crystalball1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crystalball1", private.use_crystalball1_inv );
cmn.AddSubscriber( "use_crystalball1", private.use_crystalball1_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalball1", private.use_crystalball1_end, private.room_objname );
cmn.AddSubscriber( "use_crystalball1", private.use_crystalball1_logic );
cmn.AddSubscriber( "use_crystalball1_inv", private.use_crystalball1_inv, private.room_objname );
cmn.AddSubscriber( "use_crystalball1_beg", private.use_crystalball1_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalball1_end", private.use_crystalball1_end, private.room_objname );
cmn.AddSubscriber( "use_crystalball1_end", private.use_crystalball1_logic );
--------------------------------------------------------------------------------------------
function public.use_crystalball1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crystalball1" );
    cmn.CallEventHandler( "use_crystalball1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crystalball1") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    if ld.CheckRequirements( {"use_crystalball2"}) then
      ObjDelete("anm_table_anm_use_crystalball_1")
      ObjDelete("anm_table_anm_use_crystalball_2")
      ld.AnimPlay( "anm_table_anm_end_crystalball_start", "use_crystalball2", func_end );
      SoundSfx( "aud_lion_paw" );
    else 
      func_end()
    end  
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crystalball1_inv" );
  cmn.CallEventHandler( "use_crystalball1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_table_anm_use_crystalball_1", "use_crystalball", f_step );
  SoundSfx( "aud_use_crystalball1_rungs" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crystalball2" ] = { type = "use", inv_obj = "inv_crystalball2", use_place = "gfx_table_crystalball2_zone", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.use_crystalball2_logic = function()
  if ld.CheckRequirements( {"use_crystalball2","use_crystalball1"} ) then
    ObjSet( "spr_table_bedroomkey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_crystalball2_inv = function()
  common_impl.ProcessMultiUseAll("crystalball2", "crystalball2")
end;
private.use_crystalball2_beg = function()
  ObjDelete( "gfx_table_crystalball2_zone" );
end;
private.use_crystalball2_end = function()
  if ld.CheckRequirements( {"use_crystalball1"}) then
    ObjDelete("anm_table_anm_use_crystalball_1")
    ObjDelete("anm_table_anm_use_crystalball_2")
    ObjSet( "spr_table_sh_bedroomkey", {visible = 1} );
    ObjSet( "anm_table_anm_end_crystalball_start",{animfunc="end_crystalball2",frame=0} );
    ObjDelete("spr_rungs_left_paw")
    ObjSet( "spr_rungs_open_left_paw", {alp = 1} );
  else 
    ObjSet("anm_table_anm_use_crystalball_2",{animfunc="end_crystalball1",frame=0})
    
  end   
  ObjSet( "spr_rungs_tr_crystalball2", {alp = 1} );  
  if common_impl.ZzCompleteCheck("use_crystalball2") then ObjSet( common_impl.hint["use_crystalball2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crystalball2", private.use_crystalball2_inv );
cmn.AddSubscriber( "use_crystalball2", private.use_crystalball2_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalball2", private.use_crystalball2_end, private.room_objname );
cmn.AddSubscriber( "use_crystalball2", private.use_crystalball2_logic );
cmn.AddSubscriber( "use_crystalball2_inv", private.use_crystalball2_inv, private.room_objname );
cmn.AddSubscriber( "use_crystalball2_beg", private.use_crystalball2_beg, private.room_objname );
cmn.AddSubscriber( "use_crystalball2_end", private.use_crystalball2_end, private.room_objname );
cmn.AddSubscriber( "use_crystalball2_end", private.use_crystalball2_logic );
--------------------------------------------------------------------------------------------
function public.use_crystalball2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crystalball2" );
    cmn.CallEventHandler( "use_crystalball2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crystalball2") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    if ld.CheckRequirements( {"use_crystalball1"}) then
      ObjDelete("anm_table_anm_use_crystalball_1")
      ObjDelete("anm_table_anm_use_crystalball_2")
      ld.AnimPlay( "anm_table_anm_end_crystalball_start", "use_crystalball2", func_end );
      SoundSfx( "aud_lion_paw" );
    else 
      func_end()
    end  
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crystalball2_inv" );
  cmn.CallEventHandler( "use_crystalball2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_table_anm_use_crystalball_2", "use_crystalball1", f_step );
  SoundSfx( "aud_use_crystalball2_rungs" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bedroomkey" ] = { type = "get", get_obj = "spr_table_bedroomkey", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.get_bedroomkey_logic = function()
  
end;
private.get_bedroomkey_inv = function()
  interface.InventoryItemAdd("inv_bedroomkey","spr_table_bedroomkey");
end;
private.get_bedroomkey_beg = function()
  ObjDelete("gfx_table_bedroomkey")
end;
private.get_bedroomkey_end = function()
  ObjDelete("spr_table_sh_bedroomkey")
  ObjDelete("spr_rungs_keybed")
  if common_impl.ZzCompleteCheck("get_bedroomkey") then ObjSet( common_impl.hint["get_bedroomkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bedroomkey", private.get_bedroomkey_inv );
cmn.AddSubscriber( "get_bedroomkey", private.get_bedroomkey_beg, private.room_objname );
cmn.AddSubscriber( "get_bedroomkey", private.get_bedroomkey_end, private.room_objname );
cmn.AddSubscriber( "get_bedroomkey", private.get_bedroomkey_logic );
--------------------------------------------------------------------
function public.get_bedroomkey()
  cmn.SetEventDone( "get_bedroomkey" );
  cmn.CallEventHandler( "get_bedroomkey" );
  if common_impl.ZzCompleteCheck("get_bedroomkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lionfang" ] = { type = "use", inv_obj = "inv_lionfang", use_place = "gfx_table_lionfang_zone", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.use_lionfang_logic = function()
  ObjSet( "spr_table_hammerhandle", {  input = 1, active = 1 } )

end;
private.use_lionfang_inv = function()
  common_impl.ProcessMultiUseAll("lionfang", "lionfang")
end;
private.use_lionfang_beg = function()
  ObjDelete( "gfx_table_lionfang_zone" );
end;
private.use_lionfang_end = function()
  ObjSet("anm_table_anm_lionfang",{animfunc="end_fang",frame=0})
  ObjSet( "gfx_table_hammerhandle", {visible = 1} );
  ObjSet( "spr_rungs_fang_tr", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_lionfang") then ObjSet( common_impl.hint["use_lionfang"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lionfang", private.use_lionfang_inv );
cmn.AddSubscriber( "use_lionfang", private.use_lionfang_beg, private.room_objname );
cmn.AddSubscriber( "use_lionfang", private.use_lionfang_end, private.room_objname );
cmn.AddSubscriber( "use_lionfang", private.use_lionfang_logic );
cmn.AddSubscriber( "use_lionfang_inv", private.use_lionfang_inv, private.room_objname );
cmn.AddSubscriber( "use_lionfang_beg", private.use_lionfang_beg, private.room_objname );
cmn.AddSubscriber( "use_lionfang_end", private.use_lionfang_end, private.room_objname );
cmn.AddSubscriber( "use_lionfang_end", private.use_lionfang_logic );
--------------------------------------------------------------------------------------------
function public.use_lionfang( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lionfang" );
    cmn.CallEventHandler( "use_lionfang_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lionfang") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lionfang_inv" );
  cmn.CallEventHandler( "use_lionfang_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_table_anm_lionfang", "use_fang", func_end );
  SoundSfx( "aud_use_lionfang_rungs" );
 

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hammerhandle" ] = { type = "get", get_obj = "spr_table_hammerhandle", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.get_hammerhandle_logic = function()
  
end;
private.get_hammerhandle_inv = function()
  interface.InventoryItemAdd("inv_hammerhandle","spr_table_hammerhandle");
end;
private.get_hammerhandle_beg = function()
  ObjDelete("gfx_table_hammerhandle")
end;
private.get_hammerhandle_end = function()
  ObjSet( "spr_table_hammerhandle", {visible = 1} );
  ObjSet("anm_table_anm_lionfang",{animfunc="end_fang1",frame=0})
  ObjDelete("spr_rungs_hammerhandle")
  if common_impl.ZzCompleteCheck("get_hammerhandle") then ObjSet( common_impl.hint["get_hammerhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_hammerhandle", private.get_hammerhandle_inv );
cmn.AddSubscriber( "get_hammerhandle", private.get_hammerhandle_beg, private.room_objname );
cmn.AddSubscriber( "get_hammerhandle", private.get_hammerhandle_end, private.room_objname );
cmn.AddSubscriber( "get_hammerhandle", private.get_hammerhandle_logic );
--------------------------------------------------------------------
function public.get_hammerhandle()
  cmn.SetEventDone( "get_hammerhandle" );
  cmn.CallEventHandler( "get_hammerhandle" );
  if common_impl.ZzCompleteCheck("get_hammerhandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_earlion" ] = { type = "use", inv_obj = "inv_earlion", use_place = "gfx_table_earlion_zone", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.use_earlion_logic = function()
  ObjSet( "spr_table_piececrystal", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_table_chimeraeye1", { visible = 1, input = 1, active = 1 } )

end;
private.use_earlion_inv = function()
  common_impl.ProcessMultiUseAll("earlion", "earlion")
end;
private.use_earlion_beg = function()
  ObjDelete( "gfx_table_earlion_zone" );
end;
private.use_earlion_end = function()
  ObjSet("anm_table_anm_earlion",{animfunc="end_ear",frame=0})
  ObjDelete("spr_rungs_right_paw")
  ObjSet( "spr_rungs_open_right_paw", {alp = 1} );
  ObjSet( "spr_rungs_ear_tr", {alp = 1} );
  ObjSet( "spr_table_sh_chimeraeye1", {visible = 1} );
  ObjSet( "spr_table_sh_piececrystal", {visible = 1} );  
  if common_impl.ZzCompleteCheck("use_earlion") then ObjSet( common_impl.hint["use_earlion"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_earlion", private.use_earlion_inv );
cmn.AddSubscriber( "use_earlion", private.use_earlion_beg, private.room_objname );
cmn.AddSubscriber( "use_earlion", private.use_earlion_end, private.room_objname );
cmn.AddSubscriber( "use_earlion", private.use_earlion_logic );
cmn.AddSubscriber( "use_earlion_inv", private.use_earlion_inv, private.room_objname );
cmn.AddSubscriber( "use_earlion_beg", private.use_earlion_beg, private.room_objname );
cmn.AddSubscriber( "use_earlion_end", private.use_earlion_end, private.room_objname );
cmn.AddSubscriber( "use_earlion_end", private.use_earlion_logic );
--------------------------------------------------------------------------------------------
function public.use_earlion( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_earlion" );
    cmn.CallEventHandler( "use_earlion_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_earlion") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_earlion_inv" );
  cmn.CallEventHandler( "use_earlion_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_table_anm_earlion", "use_ear", func_end );
  SoundSfx( "aud_use_earlion_rungs" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_piececrystal" ] = { type = "get", get_obj = "spr_table_piececrystal", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.get_piececrystal_logic = function()
  
end;
private.get_piececrystal_inv = function()
  interface.InventoryItemAdd("inv_piececrystal","spr_table_piececrystal");
end;
private.get_piececrystal_beg = function()
  ObjDelete("gfx_table_piececrystal")
end;
private.get_piececrystal_end = function()
  ObjDelete("spr_rungs_piececrystal")
  ObjDelete("spr_table_sh_piececrystal")
  if common_impl.ZzCompleteCheck("get_piececrystal") then ObjSet( common_impl.hint["get_piececrystal"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_piececrystal", private.get_piececrystal_inv );
cmn.AddSubscriber( "get_piececrystal", private.get_piececrystal_beg, private.room_objname );
cmn.AddSubscriber( "get_piececrystal", private.get_piececrystal_end, private.room_objname );
cmn.AddSubscriber( "get_piececrystal", private.get_piececrystal_logic );
--------------------------------------------------------------------
function public.get_piececrystal()
  cmn.SetEventDone( "get_piececrystal" );
  cmn.CallEventHandler( "get_piececrystal" );
  if common_impl.ZzCompleteCheck("get_piececrystal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_chimeraeye1" ] = { type = "get", get_obj = "spr_table_chimeraeye1", room = "rm_rungs", zz = "zz_table", zz_gate = "gzz_rungs_table" };

private.get_chimeraeye1_logic = function()
  
end;
private.get_chimeraeye1_inv = function()
  interface.InventoryItemAdd("inv_chimeraeye1","spr_table_chimeraeye1");
end;
private.get_chimeraeye1_beg = function()
  ObjDelete("gfx_table_chimeraeye1")
end;
private.get_chimeraeye1_end = function()
  ObjDelete("spr_table_sh_chimeraeye1")
  ObjDelete("spr_rungs_chimeraeye1")
  if common_impl.ZzCompleteCheck("get_chimeraeye1") then ObjSet( common_impl.hint["get_chimeraeye1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_chimeraeye1", private.get_chimeraeye1_inv );
cmn.AddSubscriber( "get_chimeraeye1", private.get_chimeraeye1_beg, private.room_objname );
cmn.AddSubscriber( "get_chimeraeye1", private.get_chimeraeye1_end, private.room_objname );
cmn.AddSubscriber( "get_chimeraeye1", private.get_chimeraeye1_logic );
--------------------------------------------------------------------
function public.get_chimeraeye1()
  cmn.SetEventDone( "get_chimeraeye1" );
  cmn.CallEventHandler( "get_chimeraeye1" );
  if common_impl.ZzCompleteCheck("get_chimeraeye1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bedroomdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shouts" ] = { type = "click", use_place = "gfx_bedroomdoor_clk_shouts_zone", room = "rm_rungs", zz = "zz_bedroomdoor", zz_gate = "gzz_rungs_bedroomdoor" };

private.clk_shouts_logic = function()
  ObjSet( "gfx_bedroomdoor_bedroomkey_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_shouts_beg = function()
  ObjDelete( "gfx_bedroomdoor_clk_shouts_zone" );
end;
private.clk_shouts_end = function()
  ObjDelete("vid_bedroomdoor_bedroomdoor")
  if common_impl.ZzCompleteCheck("clk_shouts") then ObjSet( common_impl.hint["clk_shouts"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shouts", private.clk_shouts_beg, private.room_objname );
cmn.AddSubscriber( "clk_shouts", private.clk_shouts_end, private.room_objname );
cmn.AddSubscriber( "clk_shouts", private.clk_shouts_logic );
cmn.AddSubscriber( "clk_shouts_beg", private.clk_shouts_beg, private.room_objname );
cmn.AddSubscriber( "clk_shouts_end", private.clk_shouts_end, private.room_objname );
cmn.AddSubscriber( "clk_shouts_end", private.clk_shouts_logic );
--------------------------------------------------------------------------------------------
function public.clk_shouts()

  local func_end = function()
    cmn.SetEventDone( "clk_shouts" );
    cmn.CallEventHandler( "clk_shouts_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shouts") then ld.CloseSubRoom() end;
    ld.ShowBbt("after_vid_bedroomdoor");
    SoundTheme("aud_danger2_mus");
  end;

  cmn.CallEventHandler( "clk_shouts_beg" );
  common_impl.Lock(1);
  VidPlay("vid_bedroomdoor_bedroomdoor",func_end)
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_shouts" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bedroomkey" ] = { type = "use", inv_obj = "inv_bedroomkey", use_place = "gfx_bedroomdoor_bedroomkey_zone", room = "rm_rungs", zz = "zz_bedroomdoor", zz_gate = "gzz_rungs_bedroomdoor" };

private.use_bedroomkey_logic = function()
  ObjSet( "gfx_bedroomdoor_clk_bedroomdoor_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_bedroomkey_inv = function()
  common_impl.ProcessMultiUseAll("bedroomkey", "bedroomkey")
end;
private.use_bedroomkey_beg = function()
  ObjDelete( "gfx_bedroomdoor_bedroomkey_zone" );
end;
private.use_bedroomkey_end = function()
  ObjSet("anm_bedroomdoor_anim_bedroom",{frame=0,animfunc="use_keyklik"})
  if common_impl.ZzCompleteCheck("use_bedroomkey") then ObjSet( common_impl.hint["use_bedroomkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bedroomkey", private.use_bedroomkey_inv );
cmn.AddSubscriber( "use_bedroomkey", private.use_bedroomkey_beg, private.room_objname );
cmn.AddSubscriber( "use_bedroomkey", private.use_bedroomkey_end, private.room_objname );
cmn.AddSubscriber( "use_bedroomkey", private.use_bedroomkey_logic );
cmn.AddSubscriber( "use_bedroomkey_inv", private.use_bedroomkey_inv, private.room_objname );
cmn.AddSubscriber( "use_bedroomkey_beg", private.use_bedroomkey_beg, private.room_objname );
cmn.AddSubscriber( "use_bedroomkey_end", private.use_bedroomkey_end, private.room_objname );
cmn.AddSubscriber( "use_bedroomkey_end", private.use_bedroomkey_logic );
--------------------------------------------------------------------------------------------
function public.use_bedroomkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bedroomkey" );
    cmn.CallEventHandler( "use_bedroomkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bedroomkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bedroomkey_inv" );
  cmn.CallEventHandler( "use_bedroomkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bedroomdoor_anim_bedroom", "use_key", func_end );
  SoundSfx( "aud_use_bedroomkey_rungs" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_bedroomdoor" ] = { type = "click", use_place = "gfx_bedroomdoor_clk_bedroomdoor_zone", room = "rm_rungs", zz = "zz_bedroomdoor", zz_gate = "gzz_rungs_bedroomdoor" };

private.clk_bedroomdoor_logic = function()
  ObjSet( "grm_rungs_bedroom", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_rungs_bedroom_focus");
    end;
end;
private.clk_bedroomdoor_beg = function()
  ObjDelete( "gfx_bedroomdoor_clk_bedroomdoor_zone" );
end;
private.clk_bedroomdoor_end = function()
  ObjSet("spr_rungs_open_bedroom",{alp=1})
  ObjDelete("anm_rungs_open_bedroom")
  if common_impl.ZzCompleteCheck("clk_bedroomdoor") then ObjSet( common_impl.hint["clk_bedroomdoor"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_bedroomdoor", private.clk_bedroomdoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_bedroomdoor", private.clk_bedroomdoor_end, private.room_objname );
cmn.AddSubscriber( "clk_bedroomdoor", private.clk_bedroomdoor_logic );
cmn.AddSubscriber( "clk_bedroomdoor_beg", private.clk_bedroomdoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_bedroomdoor_end", private.clk_bedroomdoor_end, private.room_objname );
cmn.AddSubscriber( "clk_bedroomdoor_end", private.clk_bedroomdoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_bedroomdoor()

  local func_end = function()
    cmn.SetEventDone( "clk_bedroomdoor" );
    cmn.CallEventHandler( "clk_bedroomdoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_bedroomdoor") then ld.CloseSubRoom() end;
  end;
  local f_step = function ()
    ld.CloseSubRoom()
    ld.AnimPlay("anm_rungs_open_bedroom","open_bedroom",func_end)
  end
  cmn.CallEventHandler( "clk_bedroomdoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bedroomdoor_anim_bedroom", "use_keyklik", f_step );
  SoundSfx( "aud_clk_bedroomdoor" );
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_halldoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_crystalball1" ] = { type = "get", get_obj = "spr_halldoor_crystalball1", room = "rm_rungs", zz = "zz_halldoor", zz_gate = "gzz_rungs_halldoor" };

private.get_crystalball1_logic = function()
  
end;
private.get_crystalball1_inv = function()
  interface.InventoryItemAdd("inv_crystalball1","spr_halldoor_crystalball1");
end;
private.get_crystalball1_beg = function()
  ObjDelete("gfx_halldoor_crystalball1")
end;
private.get_crystalball1_end = function()
  ObjDelete("spr_halldoor_sh_crystalball1")
  ObjDelete("spr_rungs_eyas")
  if common_impl.ZzCompleteCheck("get_crystalball1") then ObjSet( common_impl.hint["get_crystalball1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_crystalball1", private.get_crystalball1_inv );
cmn.AddSubscriber( "get_crystalball1", private.get_crystalball1_beg, private.room_objname );
cmn.AddSubscriber( "get_crystalball1", private.get_crystalball1_end, private.room_objname );
cmn.AddSubscriber( "get_crystalball1", private.get_crystalball1_logic );
--------------------------------------------------------------------
function public.get_crystalball1()
  cmn.SetEventDone( "get_crystalball1" );
  cmn.CallEventHandler( "get_crystalball1" );
  if common_impl.ZzCompleteCheck("get_crystalball1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hallkey" ] = { type = "use", inv_obj = "inv_hallkey", use_place = "gfx_halldoor_hallkey_zone", room = "rm_rungs", zz = "zz_halldoor", zz_gate = "gzz_rungs_halldoor" };

private.use_hallkey_logic = function()
  ObjSet( "gfx_halldoor_clk_hallkeydoor_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_hallkey_inv = function()
  common_impl.ProcessMultiUseAll("hallkey", "hallkey")
end;
private.use_hallkey_beg = function()
  ObjDelete( "gfx_halldoor_hallkey_zone" );
end;
private.use_hallkey_end = function()
  ObjSet("anm_halldoor_use_key",{frame=0,animfunc="use_open"})
  ObjSet( "spr_rungs_key1", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_hallkey") then ObjSet( common_impl.hint["use_hallkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hallkey", private.use_hallkey_inv );
cmn.AddSubscriber( "use_hallkey", private.use_hallkey_beg, private.room_objname );
cmn.AddSubscriber( "use_hallkey", private.use_hallkey_end, private.room_objname );
cmn.AddSubscriber( "use_hallkey", private.use_hallkey_logic );
cmn.AddSubscriber( "use_hallkey_inv", private.use_hallkey_inv, private.room_objname );
cmn.AddSubscriber( "use_hallkey_beg", private.use_hallkey_beg, private.room_objname );
cmn.AddSubscriber( "use_hallkey_end", private.use_hallkey_end, private.room_objname );
cmn.AddSubscriber( "use_hallkey_end", private.use_hallkey_logic );
--------------------------------------------------------------------------------------------
function public.use_hallkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hallkey" );
    cmn.CallEventHandler( "use_hallkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hallkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hallkey_inv" );
  cmn.CallEventHandler( "use_hallkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_halldoor_use_key", "use_key", func_end );
  SoundSfx( "aud_use_hallkey_rungs" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_hallkeydoor" ] = { type = "click", use_place = "gfx_halldoor_clk_hallkeydoor_zone", room = "rm_rungs", zz = "zz_halldoor", zz_gate = "gzz_rungs_halldoor" };

private.clk_hallkeydoor_logic = function()
  ObjSet( "grm_rungs_hall", { visible = 1, input = 1, active = 1 } )
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_rungs_hall_focus");
    end;
end;
private.clk_hallkeydoor_beg = function()
  ObjDelete( "gfx_halldoor_clk_hallkeydoor_zone" );
end;
private.clk_hallkeydoor_end = function()
  ObjSet( "spr_rungs_open_open_hall", {alp = 1} );
  ObjDelete("anm_rungs_open_hall")
  ObjDelete("spr_rungs_key1")
  if common_impl.ZzCompleteCheck("clk_hallkeydoor") then ObjSet( common_impl.hint["clk_hallkeydoor"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_hallkeydoor", private.clk_hallkeydoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_hallkeydoor", private.clk_hallkeydoor_end, private.room_objname );
cmn.AddSubscriber( "clk_hallkeydoor", private.clk_hallkeydoor_logic );
cmn.AddSubscriber( "clk_hallkeydoor_beg", private.clk_hallkeydoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_hallkeydoor_end", private.clk_hallkeydoor_end, private.room_objname );
cmn.AddSubscriber( "clk_hallkeydoor_end", private.clk_hallkeydoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_hallkeydoor()

  local func_end = function()
    cmn.SetEventDone( "clk_hallkeydoor" );
    cmn.CallEventHandler( "clk_hallkeydoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_hallkeydoor") then ld.CloseSubRoom() end;
  end;
  
  local f_step = function ()
    ld.CloseSubRoom()
    ObjDelete("spr_rungs_key1")
    ld.AnimPlay("anm_rungs_open_hall","open_hall",func_end)
  end
  cmn.CallEventHandler( "clk_hallkeydoor_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_touch_hallkey_rungs" )
  ld.AnimPlay( "anm_halldoor_use_key", "use_open", f_step );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_understairs *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuletlizard2" ] = { type = "get", get_obj = "spr_understairs_amuletlizard2", room = "rm_rungs", zz = "zz_understairs", zz_gate = "gzz_rungs_understairs" };

private.get_amuletlizard2_logic = function()
  
end;
private.get_amuletlizard2_inv = function()
  interface.InventoryItemAdd("inv_amuletlizard","spr_understairs_amuletlizard2",function() level_inv.ProcessGetAmuletlizardAll( "get_amuletlizard2" ) end);
end;
private.get_amuletlizard2_beg = function()
  ObjDelete("gfx_understairs_amuletlizard2")
end;
private.get_amuletlizard2_end = function()
  ObjDelete("spr_halldoor_sh_amuletlizard2")
  ObjDelete("spr_rungs_amuletlizard2")
  if common_impl.ZzCompleteCheck("get_amuletlizard2") then 
    ObjSet( common_impl.hint["get_amuletlizard2"].zz_gate, { visible = 0, input = 0 } );
    ObjSet( "gho_rungs_suitcase", { visible = 1, input = 1, active = 1 } );
  end;
end;

cmn.AddSubscriber( "get_amuletlizard2", private.get_amuletlizard2_inv );
cmn.AddSubscriber( "get_amuletlizard2", private.get_amuletlizard2_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletlizard2", private.get_amuletlizard2_end, private.room_objname );
cmn.AddSubscriber( "get_amuletlizard2", private.get_amuletlizard2_logic );
--------------------------------------------------------------------
function public.get_amuletlizard2()
  cmn.SetEventDone( "get_amuletlizard2" );
  cmn.CallEventHandler( "get_amuletlizard2" );
  if common_impl.ZzCompleteCheck("get_amuletlizard2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shardpictures1" ] = { type = "get", get_obj = "spr_understairs_shardpictures1", room = "rm_rungs", zz = "zz_understairs", zz_gate = "gzz_rungs_understairs" };

private.get_shardpictures1_logic = function()
  
end;
private.get_shardpictures1_inv = function()
  interface.InventoryItemAdd("inv_shardpictures","spr_understairs_shardpictures1",function() level_inv.ProcessGetShardpicturesAll( "get_shardpictures1" ) end);
end;
private.get_shardpictures1_beg = function()
  ObjDelete("gfx_understairs_shardpictures1")
end;
private.get_shardpictures1_end = function()
  ObjDelete("spr_halldoor_sh_shardpictures1")
  ObjDelete("spr_rungs_shard_pictures_1")
  if common_impl.ZzCompleteCheck("get_shardpictures1") then 
    ObjSet( common_impl.hint["get_shardpictures1"].zz_gate, { visible = 0, input = 0 } ); 
    ObjSet( "gho_rungs_suitcase", { visible = 1, input = 1, active = 1 } );
  end;
end;

cmn.AddSubscriber( "get_shardpictures1", private.get_shardpictures1_inv );
cmn.AddSubscriber( "get_shardpictures1", private.get_shardpictures1_beg, private.room_objname );
cmn.AddSubscriber( "get_shardpictures1", private.get_shardpictures1_end, private.room_objname );
cmn.AddSubscriber( "get_shardpictures1", private.get_shardpictures1_logic );
--------------------------------------------------------------------
function public.get_shardpictures1()
  cmn.SetEventDone( "get_shardpictures1" );
  cmn.CallEventHandler( "get_shardpictures1" );
  if common_impl.ZzCompleteCheck("get_shardpictures1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_latch" ] = { type = "use", inv_obj = "inv_latch", use_place = "gfx_understairs_latch_zone", room = "rm_rungs", zz = "zz_understairs", zz_gate = "gzz_rungs_understairs" };

private.use_latch_logic = function()
  if common_impl.ZzCompleteCheck("use_latch") then
    ObjSet( "gho_rungs_suitcase", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_latch_inv = function()
  common_impl.ProcessMultiUseAll("latch", "latch")
end;
private.use_latch_beg = function()
  ObjDelete( "gfx_understairs_latch_zone" );
end;
private.use_latch_end = function()
  ObjSet( "spr_rungs_open_cover", {alp = 1} );
  ObjDelete("spr_rungs_box_cap_tr")
  ObjSet( "spr_rungs_tr_ho", {alp = 1} );
  if common_impl.ZzCompleteCheck("use_latch") then ObjSet( common_impl.hint["use_latch"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_latch", private.use_latch_inv );
cmn.AddSubscriber( "use_latch", private.use_latch_beg, private.room_objname );
cmn.AddSubscriber( "use_latch", private.use_latch_end, private.room_objname );
cmn.AddSubscriber( "use_latch", private.use_latch_logic );
cmn.AddSubscriber( "use_latch_inv", private.use_latch_inv, private.room_objname );
cmn.AddSubscriber( "use_latch_beg", private.use_latch_beg, private.room_objname );
cmn.AddSubscriber( "use_latch_end", private.use_latch_end, private.room_objname );
cmn.AddSubscriber( "use_latch_end", private.use_latch_logic );
--------------------------------------------------------------------------------------------
function public.use_latch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_latch" );
    cmn.CallEventHandler( "use_latch_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_latch") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_latch_inv" );
  cmn.CallEventHandler( "use_latch_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_understairs_anm", "use_latch", func_end );
  SoundSfx( "aud_use_latch_rungs" )
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_picture *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_fiddlestick" ] = { type = "get", get_obj = "spr_picture_fiddlestick", room = "rm_rungs", zz = "zz_picture", zz_gate = "gzz_rungs_picture" };

private.get_fiddlestick_logic = function()
  ObjSet( "gfx_picture_scissors_picture_zone", {input = 1, visible = 1, active = 1} );
end;
private.get_fiddlestick_inv = function()
  interface.InventoryItemAdd("inv_fiddlestick","spr_picture_fiddlestick");
end;
private.get_fiddlestick_beg = function()
  ObjDelete("gfx_picture_fiddlestick")
end;
private.get_fiddlestick_end = function()
  ObjDelete("spr_picture_fiddlestick_shadow")
  ObjDelete("obj_picture_fiddlestick")
  ObjDelete("spr_rungs_fiddlestick")
  if common_impl.ZzCompleteCheck("get_fiddlestick") then ObjSet( common_impl.hint["get_fiddlestick"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fiddlestick", private.get_fiddlestick_inv );
cmn.AddSubscriber( "get_fiddlestick", private.get_fiddlestick_beg, private.room_objname );
cmn.AddSubscriber( "get_fiddlestick", private.get_fiddlestick_end, private.room_objname );
cmn.AddSubscriber( "get_fiddlestick", private.get_fiddlestick_logic );
--------------------------------------------------------------------
function public.get_fiddlestick()
  cmn.SetEventDone( "get_fiddlestick" );
  cmn.CallEventHandler( "get_fiddlestick" );
  if common_impl.ZzCompleteCheck("get_fiddlestick") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scissors_picture" ] = { type = "use", inv_obj = "inv_scissors", use_place = "gfx_picture_scissors_picture_zone", room = "rm_rungs", zz = "zz_picture", zz_gate = "gzz_rungs_picture" };

private.use_scissors_picture_logic = function()
  ObjSet( "gfx_picture_win_corners_zone", {  input = 1} )
  
end;
private.use_scissors_picture_inv = function()
  common_impl.ProcessMultiUseAll("scissors", "scissors_picture")
end;
private.use_scissors_picture_beg = function()
  ObjDelete( "gfx_picture_scissors_picture_zone" );
end;
private.use_scissors_picture_end = function()
  ObjSet( "obj_picture_corners_mmg_root", {input = 1, visible = 1} );
  ObjSet("anm_picture_anm",{frame=0,animfunc="open_door"})
  ObjDelete("spr_rungs_picture_tr")
  if common_impl.ZzCompleteCheck("use_scissors_picture") then ObjSet( common_impl.hint["use_scissors_picture"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scissors_picture", private.use_scissors_picture_inv );
cmn.AddSubscriber( "use_scissors_picture", private.use_scissors_picture_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_picture", private.use_scissors_picture_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_picture", private.use_scissors_picture_logic );
cmn.AddSubscriber( "use_scissors_picture_inv", private.use_scissors_picture_inv, private.room_objname );
cmn.AddSubscriber( "use_scissors_picture_beg", private.use_scissors_picture_beg, private.room_objname );
cmn.AddSubscriber( "use_scissors_picture_end", private.use_scissors_picture_end, private.room_objname );
cmn.AddSubscriber( "use_scissors_picture_end", private.use_scissors_picture_logic );
--------------------------------------------------------------------------------------------
function public.use_scissors_picture( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scissors_picture" );
    cmn.CallEventHandler( "use_scissors_picture_end" );
    common_impl.Lock(0);
    private.init_corners()
    cmn.MiniGameShow( "corners" );     
    if common_impl.ZzCompleteCheck("use_scissors_picture") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scissors_picture_inv" );
  cmn.CallEventHandler( "use_scissors_picture_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_picture_anm", "use_scissor", func_end );
  SoundSfx( "aud_use_scissors_picture" );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_corners" ] = { type = "click", use_place = "gfx_picture_win_corners_zone", room = "rm_rungs", zz = "zz_picture", zz_gate = "gzz_rungs_picture" };

private.win_corners_logic = function()
  if ld.CheckRequirements( {"win_corners"} ) then    
    ObjSet( "spr_picture_swan", { visible = 1, input = 1, active = 1 } )
    ObjSet( "gfx_picture_dragonfly_zone", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_corners_beg = function()
  if ld.CheckRequirements( {"win_corners"} ) then  
    ObjDelete( "gfx_picture_win_corners_zone" );
  end
end;
private.win_corners_end = function()
  if ld.CheckRequirements( {"win_corners"} ) then   
    ObjSet("obj_picture_corners_mmg_root",{alp=0,input=0})
    ObjSet( "anm_picture_anm", {animfunc="open_door1_static",frame=0} );
    ObjSet( "spr_rungs_open_mmg", {alp = 1} );
    ObjDelete("spr_rungs_picture_mmg")
  end
  if common_impl.ZzCompleteCheck("win_corners") then ObjSet( common_impl.hint["win_corners"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_corners", private.win_corners_beg, private.room_objname );
cmn.AddSubscriber( "win_corners", private.win_corners_end, private.room_objname );
cmn.AddSubscriber( "win_corners", private.win_corners_logic );
cmn.AddSubscriber( "win_corners_beg", private.win_corners_beg, private.room_objname );
cmn.AddSubscriber( "win_corners_end", private.win_corners_end, private.room_objname );
cmn.AddSubscriber( "win_corners_end", private.win_corners_logic );
--------------------------------------------------------------------------------------------
function public.win_corners()

  local func_end = function()
    cmn.SetEventDone( "win_corners" );
    cmn.CallEventHandler( "win_corners_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_corners") then ld.CloseSubRoom() end;
  end;
  local func_step= function()
    ld.AnimPlay( "anm_picture_anm", "open_door", func_end );    
  end
  cmn.MiniGameHide("corners", true)
  cmn.CallEventHandler( "win_corners_beg" );
  common_impl.Lock(1);

  ld.StartTimer( 0.5, function()  --for win sound
    for i=1,6 do
      ObjAnimate( "anm_picture_corners_light_"..i, 8, 0, 0, "", {0,0,ObjGet("anm_picture_corners_light_"..i).alp, 0.3,0,1} );
    end
    ObjAnimate( "obj_picture_corners_mmg_root", 8, 0, 0, func_step, {0,0,1, 0.3,0,1,0.6,0,0} );
    SoundSfx( "aud_mg_picture_win" );
  --func_end()
  end )


end;
--------------------------------------------------------------------------------------------
function private.init_corners()
  if not (cmn.IsEventStart("win_corners")) then  
    ng_global.progress[ "std" ][ "win_corners" ].state = {}
    ng_global.progress[ "std" ][ "win_corners" ].state.cur_corner = 3
    ng_global.progress[ "std" ][ "win_corners" ].state.state_line = {}
    --{line_12=false,line_14=false,line_15=false,line_16=false,line_23=false,
    --line_24=false,line_25=false,line_45=false,line_34=false,line_36=false,line_56=false}
  end
  private.load_corners()
end
function private.load_corners()
  local s = ng_global.progress[ "std" ][ "win_corners" ].state
  for k,v in pairs(s.state_line) do
    if s.state_line[k] then
      ObjSet("obj_picture_corners_mmg_"..k,{alp=1})
    end
  end  
  ObjSet( "anm_picture_corners_light_"..s.cur_corner, {alp = 1} );
  private.check_corners()
end

function public.clk_corner(num)
  local s = ng_global.progress[ "std" ][ "win_corners" ].state
  local param_line = ObjGet("obj_picture_corners_mmg_line_"..s.cur_corner..num) or ObjGet("obj_picture_corners_mmg_line_"..num..s.cur_corner)
  if param_line and not s.state_line["line_"..ld.StringDivide(param_line.name)[6] ] then
    ng_global.progress[ "std" ][ "win_corners" ].state.state_line["line_"..ld.StringDivide(param_line.name)[6] ] = true
    --ObjSet( "anm_picture_corners_light_"..s.cur_corner, {input = 1} );
    ld.Lock(1)
    ObjAnimate( "anm_picture_corners_light_"..s.cur_corner, 8, 0, 0, "", {0,0,1, 0.5,0,0} );
    ObjAnimate( "anm_picture_corners_light_"..num, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
    ObjAnimate( param_line.name, 8, 0, 0, function()ld.Lock(0); private.check_corners() end, {0,0,0, 0.5,0,1} );
    
    ng_global.progress[ "std" ][ "win_corners" ].state.cur_corner = num
    SoundSfx( "aud_mg_picture_click" );
  end
end

function private.check_corners()
  local win_count=0
  local s = ng_global.progress[ "std" ][ "win_corners" ].state.state_line
  for k,v in pairs(s) do
    if s[k] then
      win_count=win_count+1
    end
  end
  if win_count == 11 then
    public.win_corners()
  end
end

function private.win_corners_skip()
    ng_global.progress[ "std" ][ "win_corners" ].state = {}
    ng_global.progress[ "std" ][ "win_corners" ].state.cur_corner = 3
    ng_global.progress[ "std" ][ "win_corners" ].state.state_line = 
      {line_12=true,line_14=true,line_15=true,line_16=true,line_23=true,
       line_24=true,line_25=true,line_45=true,line_34=true,line_36=true,line_56=true}
  local s = ng_global.progress[ "std" ][ "win_corners" ].state.state_line
  ld.Lock(1)
  for k,v in pairs(s) do
    if s[k] then
      local obj = "obj_picture_corners_mmg_"..k
      ObjAnimate(obj, 8, 0, 0, "", {0,0,ObjGet(obj).alp, 0.3,0,1} );
    end
  end  
  ld.StartTimer(0.3, function()ld.Lock(0);public.win_corners()end )  
end

function private.win_corners_reset()
    ng_global.progress[ "std" ][ "win_corners" ].state = {}
    ng_global.progress[ "std" ][ "win_corners" ].state.cur_corner = 3
    ng_global.progress[ "std" ][ "win_corners" ].state.state_line = {}
    local relations = ObjGetRelations( "obj_picture_corners_mmg_root" );
    for i = 1, #relations.childs do
      local obj = relations.childs[i]
      ObjAnimate( obj, 8, 0, 0, "", {0,0,ObjGet(obj).alp, 0.3,0,0} );
    end

    ld.Lock(1)
    ObjAnimate( "anm_picture_corners_light_3", 8, 0, 0, function()ld.Lock(0)end,
       {0,0,ObjGet("anm_picture_corners_light_3").alp, 0.3,0,ObjGet("anm_picture_corners_light_3").alp, 0.6,0,1} );
end



--------------------------------------------------------------------
common_impl.hint[ "get_swan" ] = { type = "get", get_obj = "spr_picture_swan", room = "rm_rungs", zz = "zz_picture", zz_gate = "gzz_rungs_picture" };

private.get_swan_logic = function()
  
end;
private.get_swan_inv = function()
  interface.InventoryItemAdd("inv_swan","spr_picture_swan");
  ObjSet( "inv_swan", { drag = 0 } );
end;
private.get_swan_beg = function()
  ObjDelete("gfx_picture_swan")
end;
private.get_swan_end = function()
  ObjDelete("spr_picture_swan_shadow")
  ObjDelete("spr_rungs_swan_tr")
  if common_impl.ZzCompleteCheck("get_swan") then ObjSet( common_impl.hint["get_swan"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_swan", private.get_swan_inv );
cmn.AddSubscriber( "get_swan", private.get_swan_beg, private.room_objname );
cmn.AddSubscriber( "get_swan", private.get_swan_end, private.room_objname );
cmn.AddSubscriber( "get_swan", private.get_swan_logic );
--------------------------------------------------------------------
function public.get_swan()
  cmn.SetEventDone( "get_swan" );
  cmn.CallEventHandler( "get_swan" );
  if common_impl.ZzCompleteCheck("get_swan") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dragonfly" ] = { type = "use", inv_obj = "inv_dragonfly", use_place = "gfx_picture_dragonfly_zone", room = "rm_rungs", zz = "zz_picture", zz_gate = "gzz_rungs_picture" };

private.use_dragonfly_logic = function()
  ObjSet( "spr_picture_keylock", { input = 1, active = 1 } )

end;
private.use_dragonfly_inv = function()
  common_impl.ProcessMultiUseAll("dragonfly", "dragonfly")
end;
private.use_dragonfly_beg = function()
  ObjDelete( "gfx_picture_dragonfly_zone" );
end;
private.use_dragonfly_end = function()
  ObjSet( "gfx_picture_keylock", {visible = 1} );
  ObjSet("anm_picture_anm_keylock",{animfunc="keylock",frame=0})
  if common_impl.ZzCompleteCheck("use_dragonfly") then ObjSet( common_impl.hint["use_dragonfly"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dragonfly", private.use_dragonfly_inv );
cmn.AddSubscriber( "use_dragonfly", private.use_dragonfly_beg, private.room_objname );
cmn.AddSubscriber( "use_dragonfly", private.use_dragonfly_end, private.room_objname );
cmn.AddSubscriber( "use_dragonfly", private.use_dragonfly_logic );
cmn.AddSubscriber( "use_dragonfly_inv", private.use_dragonfly_inv, private.room_objname );
cmn.AddSubscriber( "use_dragonfly_beg", private.use_dragonfly_beg, private.room_objname );
cmn.AddSubscriber( "use_dragonfly_end", private.use_dragonfly_end, private.room_objname );
cmn.AddSubscriber( "use_dragonfly_end", private.use_dragonfly_logic );
--------------------------------------------------------------------------------------------
function public.use_dragonfly( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dragonfly" );
    cmn.CallEventHandler( "use_dragonfly_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dragonfly") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dragonfly_inv" );
  cmn.CallEventHandler( "use_dragonfly_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_picture_anm_keylock", "use_keylockpart", func_end );
  SoundSfx( "aud_use_dragonfly_rungs" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_keylock" ] = { type = "get", get_obj = "spr_picture_keylock", room = "rm_rungs", zz = "zz_picture", zz_gate = "gzz_rungs_picture" };

private.get_keylock_logic = function()
  
end;
private.get_keylock_inv = function()
  interface.InventoryItemAdd("inv_keylock","spr_picture_keylock");
end;
private.get_keylock_beg = function()
  ObjDelete("gfx_picture_keylock")
end;
private.get_keylock_end = function()
  ObjSet("spr_picture_keylock",{visible=1})
  ObjDelete("anm_picture_anm_keylock")
  if common_impl.ZzCompleteCheck("get_keylock") then ObjSet( common_impl.hint["get_keylock"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_keylock", private.get_keylock_inv );
cmn.AddSubscriber( "get_keylock", private.get_keylock_beg, private.room_objname );
cmn.AddSubscriber( "get_keylock", private.get_keylock_end, private.room_objname );
cmn.AddSubscriber( "get_keylock", private.get_keylock_logic );
--------------------------------------------------------------------
function public.get_keylock()
  local func_end = function()  
    ld.Lock(0)
    cmn.SetEventDone( "get_keylock" );
    cmn.CallEventHandler( "get_keylock" );
    if common_impl.ZzCompleteCheck("get_keylock") then ld.CloseSubRoom() end;
  end
  ld.Lock(1)
   ld.AnimPlay( "anm_picture_anm_keylock", "keylock", func_end );
   SoundSfx( "aud_touch_dragonfly_rungs" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_suitcase_for_rungs = function()
    if ld.CheckRequirements( {"win_suitcase"} ) then
      ObjSet( "gho_rungs_suitcase", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_suitcase", win_suitcase_for_rungs, private.room_objname )
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_picture" ) and not ld.CheckRequirements( { "win_corners" } ) then  
    private.win_corners_reset();
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_picture" ) and not ld.CheckRequirements( { "win_corners" } ) then
    private.win_corners_skip();
  end;
  
end
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_rungs();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_rungs_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_picture" );
  function zz_picture.Open()
  end;
  function zz_picture.PreOpen()
     if cmn.IsEventStart("win_corners") and not cmn.IsEventDone("win_corners") then 
       cmn.MiniGameShow( "corners" ); 
       private.init_corners()
     end;     
  end;
  function zz_picture.PreClose()
  end;
  function zz_picture.Close()
  end;

  subroom.Define( "zz_understairs" );
  function zz_understairs.Open()
  end;
  function zz_understairs.PreOpen()
  end;
  function zz_understairs.PreClose()
  end;
  function zz_understairs.Close()
  end;

  subroom.Define( "zz_halldoor" );
  function zz_halldoor.Open()
  end;
  function zz_halldoor.PreOpen()
  end;
  function zz_halldoor.PreClose()
  end;
  function zz_halldoor.Close()
  end;

  subroom.Define( "zz_bedroomdoor" );
  function zz_bedroomdoor.Open()
  end;
  function zz_bedroomdoor.PreOpen()
  end;
  function zz_bedroomdoor.PreClose()
  end;
  function zz_bedroomdoor.Close()
  end;

  subroom.Define( "zz_table" );
  function zz_table.Open()
  end;
  function zz_table.PreOpen()
  end;
  function zz_table.PreClose()
  end;
  function zz_table.Close()
  end;
  
end;
--*********************************************************************************************************************