-- name=ho_innerporchhoext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "innerporchhoext" );
  game.relations[ "ho_innerporchhoext" ].exitroom = "rm_barnext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_innerporchhoext" ] = { type = "win", room = "rm_barnext", zz = "ho_innerporchhoext", zz_gate = "gho_barnext_innerporchhoext" };
 
  local win_innerporchhoext_func = function ()

    if ( cmn.IsEventDone( "win_innerporchhoext" ) ) then
      interface.InventoryItemAdd( "inv_amuletanchorext", "spr_innerporchhoext_win" );
      ObjDelete( "gho_barnext_innerporchhoext" );
    end;

  end;
  cmn.AddSubscriber( "win_innerporchhoext", win_innerporchhoext_func );
  
  local unmark_lll = function () 
    ObjSet( "spr_innerporchhoext_lll", {alp = 1,input=1} );
    ObjSet( "spr_innerporchhoext_open_box", {alp = 1} );
    ObjDelete("gfx_innerporchhoext_unmark_lll_zone")
  end;
  cmn.AddSubscriber( "innerporchhoext_unmark_lll", unmark_lll, "ho_innerporchhoext" );
  
  local start_innerporchhoext_func = function ()
  if not cmn.IsEventDone("win_innerporchhoext") then
    if cmn.IsUnmarkedTask("innerporchhoext","lll") then 
      unmark_lll()
    end 
  end
  end;
  cmn.AddSubscriber( "win_innerporchhoext", start_innerporchhoext_func, "ho_innerporchhoext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_barnext_env" )

  if ( not cmn.IsEventDone( "opn_innerporchhoext" ) ) then

    cmn.InitHo( "innerporchhoext" );
    cmn.SetMarkedTask( "innerporchhoext", "lll" );
    cmn.SetEventDone( "opn_innerporchhoext" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_innerporchhoext_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_innerporchhoext_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_innerporchhoext_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_innerporchhoext_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_innerporchhoext_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_innerporchhoext_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_innerporchhoext_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_innerporchhoext_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_innerporchhoext_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_innerporchhoext_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_innerporchhoext_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 1, { { "spr_innerporchhoext_lll" },{"gfx_innerporchhoext_unmark_lll_zone"},
  {"spr_innerporchhoext_aaa"},{"spr_innerporchhoext_bbb"},{"spr_innerporchhoext_ccc"},
  {"spr_innerporchhoext_ddd"},{"spr_innerporchhoext_eee"},{"spr_innerporchhoext_fff"},
  {"spr_innerporchhoext_ggg"},{"spr_innerporchhoext_hhh"},{"spr_innerporchhoext_iii"},
  {"spr_innerporchhoext_jjj"},{"spr_innerporchhoext_kkk"},
 } );
  

  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["ext"]["win_innerporchhoext"].found do

    local name = tostring( ng_global.progress["ext"]["win_innerporchhoext"].found[j]["object"] );
    local task = tostring( ng_global.progress["ext"]["win_innerporchhoext"].found[j]["task"]);
    ObjDelete( name );
    ObjSet( "spr_innerporchhoext_lll_part_"..task, {alp = 1} );

  end;
  if #ng_global.progress["ext"]["win_innerporchhoext"].found == 11 then
    ObjSet( "gfx_innerporchhoext_unmark_lll_zone", {input = 1,visible=1} );
  end

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  if item_name ~= "lll" then
    local obj = "spr_innerporchhoext_lll_part_"..item_name
    local x1 = ObjGet("spr_innerporchhoext_"..item_name).pos_x
    local y1 = ObjGet("spr_innerporchhoext_"..item_name).pos_y  
    local x2 = ObjGet(obj).pos_x
    local y2 = ObjGet(obj).pos_y
    
    local f_end = function()
      ld.LockRm(0)
      if #ng_global.progress["ext"]["win_innerporchhoext"].found == 11 then
        ObjSet( "gfx_innerporchhoext_unmark_lll_zone", {input = 1,visible=1} );
      end
      ObjSet( "fx_innerporchhoext_pshik_fx", {active = 0, visible = 0, alp=0} );
    end
    local f_step = function ()
      SoundSfx( "aud_ho_innerporchhoext_insert" )
      ObjSet( "fx_innerporchhoext_pshik_fx", {active = 1, visible = 1,alp=1} );
      PartSysStart("fx_innerporchhoext_pshik_fx")
      ObjAnimate( "fx_innerporchhoext_fly_fx", 8, 0, 0,function()ObjSet( "fx_innerporchhoext_fly_fx", {visible=0,active=0} );end, {0,0,1, 0.3,0,0} );
      ObjAnimate( obj, 8, 0, 0,f_end, {0,0,0, 0.3,0,1} );

    end
    
    ld.LockRm(1)
    ObjStopAnimate("fx_innerporchhoext_fly_fx",3)
    ObjSet( "fx_innerporchhoext_fly_fx", {active = 1, visible = 1,alp=1} );
    PartSysRestart("fx_innerporchhoext_fly_fx")
    ObjSet( "fx_innerporchhoext_pshik_fx", {pos_x = x2,pos_y = y2} );
    ObjAnimate( "fx_innerporchhoext_fly_fx", 3, 0, 0, f_step, {0,0,x1,y1, 0.3,0,x2,y2} ); 
   
    
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_innerporchhoext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_innerporchhoext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_lll()
  local f_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "innerporchhoext", "lll" );
    cmn.CallEventHandler( "innerporchhoext_unmark_lll" );      
  end
  
  SoundSfx( "aud_ho_innerporchhoext_open" );
  ld.Lock(1)  
  ObjAnimate("spr_innerporchhoext_open_box" , 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
  ObjAnimate("spr_innerporchhoext_lll" , 8, 0, 0, "", {0,0,0, 0.5,0,1} );
end
