-- name=ho_rootshoext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "rootshoext" );
  game.relations[ "ho_rootshoext" ].exitroom = "rm_houseext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_rootshoext" ] = { type = "win", room = "rm_houseext", zz = "ho_rootshoext", zz_gate = "gho_houseext_rootshoext" };
 
  local win_rootshoext_func = function ()

    if ( cmn.IsEventDone( "win_rootshoext" ) ) then
      interface.InventoryItemAdd( "inv_diaryext", "spr_rootshoext_win" );
      ObjSet( "inv_diaryext", {drag=0} );
      ObjDelete( "gho_houseext_rootshoext" );
    end;

  end;
  cmn.AddSubscriber( "win_rootshoext", win_rootshoext_func );

  local unmark_fff = function () 
    ObjSet( "spr_rootshoext_fff", {alp = 1,input=1} );
    ObjSet("anm_rootshoext_fff",{animfunc="end_knife1",frame=0})
    ObjDelete("gfx_rootshoext_fff_part_1")
    ObjDelete("spr_rootshoext_fff_part_2_sh")
    ObjDelete( "spr_rootshoext_fff_part_2");
  end;
  cmn.AddSubscriber( "rootshoext_unmark_fff", unmark_fff, "ho_rootshoext" );

  local unmark_jjj = function () 
    ObjSet( "spr_rootshoext_jjj", {alp = 1,input=1} );
    ObjSet("anm_rootshoext_jjj",{animfunc="end_pen1",frame=0})
    ObjDelete("gfx_rootshoext_jjj_part_1")
  end;
  cmn.AddSubscriber( "rootshoext_unmark_jjj", unmark_jjj, "ho_rootshoext" );
  
  local unmark_eee = function () 
    ObjSet( "spr_rootshoext_eee", {alp = 1,input=1} );
    ObjSet( "spr_rootshoext_tr_eee", {alp = 1} );
    ObjSet("anm_rootshoext_eee",{animfunc="end_casket1",frame=0})
    ObjDelete("gfx_rootshoext_eee_part_1")
  end;
  cmn.AddSubscriber( "rootshoext_unmark_eee", unmark_eee, "ho_rootshoext" );
  
  local start_rootshoext_func = function ()
  if not cmn.IsEventDone("win_rootshoext") then
    if cmn.IsUnmarkedTask("rootshoext","fff") then 
      unmark_fff()
    end 
    if cmn.IsUnmarkedTask("rootshoext","jjj") then 
      unmark_jjj()
    end  
    if cmn.IsUnmarkedTask("rootshoext","eee") then 
      unmark_eee()
    end     
  end
  end;
  cmn.AddSubscriber( "win_rootshoext", start_rootshoext_func, "ho_rootshoext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_houseext_env" )

  if ( not cmn.IsEventDone( "opn_rootshoext" ) ) then

    cmn.InitHo( "rootshoext" );

    cmn.SetMarkedTask( "rootshoext", "fff" );
    cmn.SetMarkedTask( "rootshoext", "jjj" );
    cmn.SetMarkedTask( "rootshoext", "eee" );
    
    cmn.SetEventDone( "opn_rootshoext" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_rootshoext_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_rootshoext_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_rootshoext_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_rootshoext_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_rootshoext_eee" },{"gfx_rootshoext_eee_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_rootshoext_fff" },{"spr_rootshoext_fff_part_2","gfx_rootshoext_fff_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_rootshoext_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_rootshoext_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_rootshoext_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 1, { { "spr_rootshoext_jjj" },{"gfx_rootshoext_jjj_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_rootshoext_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_rootshoext_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["ext"]["win_rootshoext"].found do

    local name = tostring( ng_global.progress["ext"]["win_rootshoext"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

  if cmn.IsEventDone("win_rootshoext") then SoundTheme( "aud_adventure2_mus" )  end;
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_rootshoext_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_rootshoext_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------

----------------------------------------------------------------------------
function public.unmark_fff()
  if ApplyObj("spr_rootshoext_fff_part_2","gfx_rootshoext_fff_part_1") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "rootshoext", "fff" );
      cmn.CallEventHandler( "rootshoext_unmark_fff" );      
    end
    ld.Lock(1)
    ObjDelete("spr_rootshoext_fff_part_2")
    ld.AnimPlay("anm_rootshoext_fff","use_knife",f_end)

    SoundSfx( "aud_ho_rootshoext_cut" );
  else
    ObjSet("spr_rootshoext_fff_part_2",{pos_z = 14})
    ObjSet("spr_rootshoext_fff_part_2_sh", {alp = 1} );
    --SoundSfx( "" );
  end
end
----------------------------------------------------------------------------
function public.unmark_jjj()
  local f_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "rootshoext", "jjj" );
    cmn.CallEventHandler( "rootshoext_unmark_jjj" );      
  end
  ld.Lock(1)  
  ld.AnimPlay("anm_rootshoext_jjj","click_pen",f_end)
  SoundSfx( "aud_ho_rootshoext_basket" );
end
----------------------------------------------------------------------------
function public.unmark_eee()
  local f_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "rootshoext", "eee" );
    cmn.CallEventHandler( "rootshoext_unmark_eee" );      
  end
  ld.Lock(1)  
  ld.AnimPlay("anm_rootshoext_eee","use_casket",f_end)
  SoundSfx( "aud_ho_rootshoext_casket" );
end