-- name=mg_pubmgext
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_pubmgext";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pubmgext" ] = {type = "win", use_place = "mg_pubmgext", room = "rm_nearpubext", zz = "mg_pubmgext", zz_gate = "gmg_nearpubext_pubmgext" };

  local win_pubmgext_logic = function()
    if ld.CheckRequirements( {"win_pubmgext"} ) then
      ObjSet( "obj_pubmgext_parts_root", {input = 0} );
      for i=1,4 do
        ObjSet( "obj_pubmgext_dropzone_"..i, {input = 0} );
      end
    end
  end;
  local win_pubmgext = function()
    if ld.CheckRequirements( {"win_pubmgext"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_pubmgext", win_pubmgext, private.room_objname )
  cmn.AddSubscriber("win_pubmgext", win_pubmgext_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_pubmgext"} ) then
    cmn.MiniGameShow( "pubmgext" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearpubext_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_pubmgext"} ) then
    cmn.MiniGameHide( "pubmgext" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  for i=1,4 do 
    public.clk_dropzone(i)
  end
end;
--*********************************************************************************************************************
function public.Skip()
  private.skip_anim()
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_pubmgext" );
  cmn.CallEventHandler( "win_pubmgext" );
  if common_impl.ZzCompleteCheck( "win_pubmgext" ) then cmn.GotoRoom( "rm_nearpubext" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  SoundSfx( "aud_mg_pubmgext_win" )
  cmn.MiniGameHide(true);
  for i=1,4 do
    ObjAnimate( "spr_pubmgext_c"..i, 0, 0, 0, "", {0,0,775, 0.5,0,875} );
  end
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.startpos_parts = {
  {296,202, 1.0472},
  {361,202,-1.0472},
  {333,264, 0     },
  {225,325, 1.0472},
  {291,317,-1.0472},
  {367,317, 1.0472},
  {432,325,-1.0472},
  {263,384, 0     },
  {405,384, 0     },
  {223,436,-1.0472},
  {296,440, 1.0472},
  {362,440,-1.0472},
  {434,436, 1.0472},
  {333,501,0      },
  {295,558,-1.0472},
  {363,558, 1.0472},
}


  
function gm.load()
  if not gm.loaded then
    if not ng_global.progress["ext"]["win_pubmgext"].state then
      ng_global.progress["ext"]["win_pubmgext"].state = {0,0,0,0}
    else 
      for i=1,4 do 
        if ng_global.progress["ext"]["win_pubmgext"].state[i] ~= 0 then
          ObjSet( "spr_pubmgext_a_"..ng_global.progress["ext"]["win_pubmgext"].state[i], {alp = 0,input=0} );
          ObjSet( "spr_pubmgext_metal_"..i,{alp=1})
        end
      end
      private.check_triangles()
    end
  
    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["ext"]["win_pubmgext"].state = ld.TableCopy( gm.state )
end;

--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;

function public.get_part(obj)
  ObjSet(obj,{pos_z=10})
  ObjAnimate( obj,7,0,0,"",{0,0,ObjGet(obj).ang,0.1,0,0})
  SoundSfx( "aud_mg_pubmgext_get" );
end
function public.drop_part(param)
  local obj = "spr_pubmgext_a_"..param
  local check = true
      if common_impl.ApplyCheck(obj,"obj_pubmgext_dropzone_1") then
        if ng_global.progress["ext"]["win_pubmgext"].state[1]~=0 then
          public.clk_dropzone(1,true)
        end
        ng_global.progress["ext"]["win_pubmgext"].state[1]=param
        ObjSet( obj, {alp = 0,input=0} );
        ld.Lock(1)
        SoundSfx( "aud_mg_pubmgext_set" )
        ObjAnimate( "spr_pubmgext_metal_1", 8, 0, 0, function()ld.Lock(0);private.check_triangles()end, {0,0,0, 0.5,0,1} );
      elseif common_impl.ApplyCheck(obj,"obj_pubmgext_dropzone_2") then
        if ng_global.progress["ext"]["win_pubmgext"].state[2]~=0 then
          public.clk_dropzone(2,true)
        end        
        ng_global.progress["ext"]["win_pubmgext"].state[2]=param
        ObjSet( obj, {alp = 0,input=0} );
        ld.Lock(1)
        SoundSfx( "aud_mg_pubmgext_set" )
        ObjAnimate( "spr_pubmgext_metal_2", 8, 0, 0, function()ld.Lock(0);private.check_triangles()end, {0,0,0, 0.5,0,1} );      
      elseif common_impl.ApplyCheck(obj,"obj_pubmgext_dropzone_3") then
          if ng_global.progress["ext"]["win_pubmgext"].state[3]~=0 then
          public.clk_dropzone(3,true)
        end      
        ng_global.progress["ext"]["win_pubmgext"].state[3]=param 
        ObjSet( obj, {alp = 0,input=0} );
        ld.Lock(1)
        SoundSfx( "aud_mg_pubmgext_set" )
        ObjAnimate( "spr_pubmgext_metal_3", 8, 0, 0, function()ld.Lock(0);private.check_triangles()end, {0,0,0, 0.5,0,1} );      
      elseif common_impl.ApplyCheck(obj,"obj_pubmgext_dropzone_4") then
          if ng_global.progress["ext"]["win_pubmgext"].state[4]~=0 then
            public.clk_dropzone(4,true)
        end  
        ng_global.progress["ext"]["win_pubmgext"].state[4]=param  
        ObjSet( obj, {alp = 0,input=0} );
        ld.Lock(1)
        SoundSfx( "aud_mg_pubmgext_set" )
        ObjAnimate( "spr_pubmgext_metal_4", 8, 0, 0, function()ld.Lock(0);private.check_triangles()end, {0,0,0, 0.5,0,1} );      
    else 
      SoundSfx( "aud_mg_pubmgext_away" );    
      ld.Lock(1)
      ObjSet( obj, {pos_z=1,input=1} );
      ObjAnimate( obj,7,0,0,"",{0,0,ObjGet(obj).ang,0.1,0,private.startpos_parts[param][3]})
      ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); end,
      {0,0,GetObjPosByObj(obj,"obj_pubmgext_parts_root")[1],GetObjPosByObj(obj,"obj_pubmgext_parts_root")[2], 0.2,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y}
      );
  end

end


function public.clk_dropzone(num,drop)
  if ng_global.progress["ext"]["win_pubmgext"].state[num]~=0 then
    if not drop then ld.Lock(1) end
    local param = ng_global.progress["ext"]["win_pubmgext"].state[num]
    local obj = "spr_pubmgext_a_"..param
    ng_global.progress["ext"]["win_pubmgext"].state[num] = 0
    
    SoundSfx( "aud_mg_pubmgext_away" )
    ObjAnimate("spr_pubmgext_metal_"..num,8,0,0,"",{0,0,1,0.2,0,0})
    ObjAnimate( obj,7,0,0,"",{0,0,ObjGet(obj).ang, 0.1,0,private.startpos_parts[param][3]})
    ObjAnimate( obj,8,0,0,"",{0,0,0, 0.2,0,1})
    ObjAnimate( obj, 3, 0, 0, function()ObjSet( obj, {input = 1,pos_z = 1} );if not drop then ld.Lock(0);end end,
      {0,0,ObjGet("obj_pubmgext_dropzone_"..num).pos_x,ObjGet("obj_pubmgext_dropzone_"..num).pos_y,
     0.3,0,private.startpos_parts[param][1],private.startpos_parts[param][2]}
      );    

  end
end


function  private.check_triangles()
  local a={6,7,10,11}
  local b={4,5,12,13}
  
  -- ld.LogTrace( ng_global.progress["ext"]["win_pubmgext"].state );
  local s = {}
  for k, v in pairs(ng_global.progress["ext"]["win_pubmgext"].state ) do
    table.insert( s, v )
  end;
  table.sort(s)

  if private.check_arr(s,a)==4 then
    private.Win()
  elseif private.check_arr(s,b)==4 then
    private.Win()
  end
  
end

function private.check_arr(arr,correct_arr)
  local check = 0
  for i=1,4 do
    if arr[i]==correct_arr[i] then
      check = check + 1
    end
  end  
  return check
end

function private.skip_anim()
  ld.Lock(1)
  for i=1,4 do 
    public.clk_dropzone(i,1)
  end
  local f_end=function()
    for j=1,4 do 
      ObjAnimate("spr_pubmgext_metal_"..j,8,0,0,"",{0,0,0, 0.5,0,1})
    end
    ld.Lock(1)
  ObjAnimate("spr_pubmgext_a_4",8,0,0,"",{0,0,1, 0.5,0,0})
  ObjAnimate("spr_pubmgext_a_5",8,0,0,"",{0,0,1, 0.5,0,0})
  ObjAnimate("spr_pubmgext_a_12",8,0,0,"",{0,0,1, 0.5,0,0})
  ObjAnimate("spr_pubmgext_a_13",8,0,0,private.Win,{0,0,1, 0.5,0,0, 1,0,0})  
  end
  ld.StartTimer( "tmr_pubmgext_skip_anm", 0.3, f_end )
  
end


