-- name=ho_barnscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "barnscr" );
  game.relations[ "ho_barnscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_barnscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_barnscr", zz_gate = "gho_house_barnscr" };
 
  local win_barnscr_func = function ()

    if ( cmn.IsEventDone( "win_barnscr" ) ) then
    ObjDetach("spr_barnscr_win")
    end;
       

  end;
  cmn.AddSubscriber( "win_barnscr", win_barnscr_func );
  
  local opn_chest = function () 
    ObjSet( "spr_barnscr_ccc", {visible = 1,input=1} );
    ObjSet( "spr_barnscr_fff", {visible = 1,input=1} );
    ObjSet( "spr_barnscr_hhh", {visible = 1,input=1} );
    ObjSet( "spr_barnscr_aaa", {visible = 1,input=1} );    
    ObjSet( "spr_barnscr_ddd", {visible = 1,input=1} );
    ObjSet( "anm_barnscr_open_chest", {animfunc="open_chest_end",frame=0} );
    ObjDelete("gfx_barnscr_opn_chest_zone")
  end;
  cmn.AddSubscriber( "barnscr_opn_chest", opn_chest, "ho_barnscr" ); 

  local unmark_eee = function () 
    ObjSet( "spr_barnscr_eee", {visible = 1,input=1} );
    ObjDelete("gfx_barnscr_unmark_eee_zone")
    ObjDelete("spr_barnscr_sh_nailpuller")
    ObjDelete("spr_barnscr_unmark_eee_part_1")
    ObjSet( "anm_barnscr_open_cover", {animfunc="open_cover_end",frame=0} );    
  end;
  cmn.AddSubscriber( "barnscr_unmark_eee", unmark_eee, "ho_barnscr" ); 

  local unmark_iii = function () 
    ObjSet( "spr_barnscr_iii", {visible = 1,input=1} );
    ObjDelete("gfx_barnscr_unmark_iii_zone")
    ObjDelete("spr_barnscr_unmark_iii_part_1")
    ObjDelete("spr_barnscr_sh_runner")
    ObjSet( "anm_barnscr_open_bag", {animfunc="open_bag1_end",frame=0} );    
  end;
  cmn.AddSubscriber( "barnscr_unmark_iii", unmark_iii, "ho_barnscr" ); 
  
  local start_barnscr_func = function ()
  if not cmn.IsEventDone("win_barnscr") then
    if cmn.IsUnmarkedTask("barnscr","ccc") then -- сундук
      opn_chest()
    end   
    if cmn.IsUnmarkedTask("barnscr","eee") then -- ящик
      unmark_eee()
    end 
    if cmn.IsUnmarkedTask("barnscr","iii") then -- сумка
      unmark_iii()
    end     
  end
  end;
  cmn.AddSubscriber( "win_barnscr", start_barnscr_func, "ho_barnscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_house_env" )

  if ( not cmn.IsEventDone( "opn_barnscr" ) ) then

    cmn.InitHo( "barnscr" );
    cmn.SetMarkedTask( "barnscr", "ccc" );--сундук
    cmn.SetMarkedTask( "barnscr", "fff" );
    cmn.SetMarkedTask( "barnscr", "ddd" );
    cmn.SetMarkedTask( "barnscr", "hhh" );
    cmn.SetMarkedTask( "barnscr", "aaa" );
    cmn.SetMarkedTask( "barnscr", "eee" );--ящик   
    cmn.SetMarkedTask( "barnscr", "iii" );--сумка     
    cmn.SetEventDone( "opn_barnscr" );
    
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 1, { { "spr_barnscr_aaa" },{"gfx_barnscr_opn_chest_zone"} });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_barnscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 1, { { "spr_barnscr_ccc" },{"gfx_barnscr_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_barnscr_ddd" },{"gfx_barnscr_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_barnscr_eee" },{"gfx_barnscr_unmark_eee_zone","spr_barnscr_unmark_eee_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_barnscr_fff" },{"gfx_barnscr_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_barnscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 1, { { "spr_barnscr_hhh" },{"gfx_barnscr_opn_chest_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 1, { { "spr_barnscr_iii" },{"gfx_barnscr_unmark_iii_zone","spr_barnscr_unmark_iii_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_barnscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_barnscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          4, 0, { { "spr_barnscr_lll_mul_1" },{ "spr_barnscr_lll_mul_2" },{ "spr_barnscr_lll_mul_3" },{ "spr_barnscr_lll_mul_4" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_barnscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_barnscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
   --if cmn.IsEventDone( "win_barnscr" ) then
   --   ng_global.progress["scr"]["win_barnscr"]={}
   --   ng_global.progress["scr"]["win_barnscr"].done = 0
   --   ng_global.progress["scr"]["opn_barnscr"].done = 0
   --  common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   --end

end;
--*********************************************************************************************************************
function public.HoComplete()

  --  common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_barnscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_barnscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
----------------------------------------------------------------------------

function public.opn_chest() 

  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "barnscr", "ccc" );
    cmn.UnmarkTask( "barnscr", "fff" );
    cmn.UnmarkTask( "barnscr", "hhh" );
    cmn.UnmarkTask( "barnscr", "aaa" );      
    cmn.UnmarkTask( "barnscr", "ddd" );      
    cmn.CallEventHandler( "barnscr_opn_chest" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_barnscr_opn_chest_zone")
  SoundSfx( "aud_ho_barn_suitcase" );
  ld.AnimPlay("anm_barnscr_open_chest","open_chest",func_end)
end;

----------------------------------------------------------------------------

function public.unmark_eee() 
  if ApplyObj("spr_barnscr_unmark_eee_part_1","gfx_barnscr_unmark_eee_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "barnscr", "eee" );
    cmn.CallEventHandler( "barnscr_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("spr_barnscr_unmark_eee_part_1")
  ObjDelete("gfx_barnscr_unmark_eee_zone")  
  SoundSfx( "aud_ho_barn_box" )
  ld.AnimPlay("anm_barnscr_open_cover","open_cover",func_end)
  else 
    ObjSet("spr_barnscr_unmark_eee_part_1",{pos_z = 4})
    ObjSet( "spr_barnscr_sh_nailpuller", {alp = 1} );    
  end  
end;
----------------------------------------------------------------------------

function public.unmark_iii() 
  if ApplyObj("spr_barnscr_unmark_iii_part_1","gfx_barnscr_unmark_iii_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "barnscr", "iii" );
    cmn.CallEventHandler( "barnscr_unmark_iii" );
  end
  ld.Lock(1) 
  ObjDelete("spr_barnscr_unmark_iii_part_1")
  ObjDelete("gfx_barnscr_unmark_iii_zone")
  SoundSfx( "aud_ho_barn_bag" )
  ld.AnimPlay("anm_barnscr_open_bag","open_bag",func_end)
  else 
  ObjSet("spr_barnscr_unmark_iii_part_1",{pos_z = 1})
    ObjSet( "spr_barnscr_sh_runner", {alp = 1} );    
  end
end;