-- name=ho_chatterhoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chatterhoscr" );
  game.relations[ "ho_chatterhoscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chatterhoscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_chatterhoscr", zz_gate = "gho_beyondtower_chatterhoscr" };
 
  local win_chatterhoscr_func = function ()

    if ( cmn.IsEventDone( "win_chatterhoscr" ) ) then
      ObjDetach("spr_chatterhoscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_chatterhoscr", win_chatterhoscr_func );

  local unmark_hhh = function () 
    ObjSet( "spr_chatterhoscr_hhh", {alp = 1,input=1} );
    ObjDelete("spr_chatterhoscr_hhh_part_1")
    ObjDelete("spr_chatterhoscr_hhh_part_2")
    ObjDelete( "spr_chatterhoscr_hhh_part_2_sh");
  end;
  cmn.AddSubscriber( "chatterhoscr_unmark_hhh", unmark_hhh, "ho_chatterhoscr" );

  local unmark_ccc = function () 
    ObjSet( "spr_chatterhoscr_ccc", {alp = 1,input=1} );
    ObjDelete("spr_chatterhoscr_ccc_part_1")
    ObjDelete("spr_chatterhoscr_ccc_part_2")
    ObjDelete( "spr_chatterhoscr_ccc_part_2_sh");
  end;
  cmn.AddSubscriber( "chatterhoscr_unmark_ccc", unmark_ccc, "ho_chatterhoscr" );
  
  local start_chatterhoscr_func = function ()
  if not cmn.IsEventDone("win_chatterhoscr") then
    if cmn.IsUnmarkedTask("chatterhoscr","hhh") then 
      unmark_hhh()
    end 
    if cmn.IsUnmarkedTask("chatterhoscr","ccc") then 
      unmark_ccc()
    end     
  end
  end;
  cmn.AddSubscriber( "win_chatterhoscr", start_chatterhoscr_func, "ho_chatterhoscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( 0 )

  if ( not cmn.IsEventDone( "opn_chatterhoscr" ) ) then

    cmn.InitHo( "chatterhoscr" );
    cmn.SetMarkedTask( "chatterhoscr", "hhh" );
    cmn.SetMarkedTask( "chatterhoscr", "ccc" );    
    cmn.SetEventDone( "opn_chatterhoscr" );
    ObjSet("txt_chatterhoscr_panel",{param0=12})
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_chatterhoscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_chatterhoscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 1, { { "spr_chatterhoscr_ccc" },{"spr_chatterhoscr_ccc_part_1","spr_chatterhoscr_ccc_part_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_chatterhoscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_chatterhoscr_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_chatterhoscr_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_chatterhoscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 1, { { "spr_chatterhoscr_hhh" },{"spr_chatterhoscr_hhh_part_1","spr_chatterhoscr_hhh_part_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_chatterhoscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_chatterhoscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_chatterhoscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_chatterhoscr_lll" } } );
  
  SoundHoTheme( true );
  ObjAttach("spr_chatterhoscr_panel","int_taskpanel_impl")
  ObjSet("spr_chatterhoscr_panel",{pos_x=0,pos_y=0})
  interface.TaskPanelShow( ho_items );

  for j = 1, #ng_global.progress["scr"]["win_chatterhoscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_chatterhoscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  if ng_global.progress["scr"]["win_chatterhoscr"].found then
    ObjSet("txt_chatterhoscr_panel",{param0=12-#ng_global.progress["scr"]["win_chatterhoscr"].found})
  end
   

  
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
   if cmn.IsEventDone( "win_chatterhoscr" ) then
      ng_global.progress["scr"]["win_chatterhoscr"]={}
      ng_global.progress["scr"]["win_chatterhoscr"].done = 0
      ng_global.progress["scr"]["opn_chatterhoscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.Close()
  ObjDetach("spr_chatterhoscr_panel")
end
--*********************************************************************************************************************
function public.HoComplete()

  -- common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  local sum = 12 - #ng_global.progress["scr"]["win_chatterhoscr"].found
   
  ObjSet("txt_chatterhoscr_panel",{param0=sum})
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )

  ObjSet( "spr_chatterhoscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_chatterhoscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.unmark_hhh()
  if ApplyObj("spr_chatterhoscr_hhh_part_1","spr_chatterhoscr_hhh_part_2") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "chatterhoscr", "hhh" );
      cmn.CallEventHandler( "chatterhoscr_unmark_hhh" );      
    end
    ld.Lock(1)
    ObjDelete("spr_chatterhoscr_hhh_part_2")
    ObjAnimate( "spr_chatterhoscr_hhh", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_chatterho_maraca" );
  else
    SoundSfx( "aud_wrongapply"..math.random(1,3) );
    ObjSet("spr_chatterhoscr_hhh_part_2",{pos_z = 5})
    ObjSet( "spr_chatterhoscr_hhh_part_2_sh", {alp = 1} );
  end
end
----------------------------------------------------------------------------
function public.unmark_ccc()
  if ApplyObj("spr_chatterhoscr_ccc_part_1","spr_chatterhoscr_ccc_part_2") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "chatterhoscr", "ccc" );
      cmn.CallEventHandler( "chatterhoscr_unmark_ccc" );      
    end
    ld.Lock(1)
    ObjDelete("spr_chatterhoscr_ccc_part_1")
    ObjAnimate( "spr_chatterhoscr_ccc", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_chatterho_handle" )
  else
    SoundSfx( "aud_wrongapply"..math.random(1,3) );
    ObjSet("spr_chatterhoscr_ccc_part_1",{pos_z = 5})
    ObjSet( "spr_chatterhoscr_ccc_part_1_sh", {alp = 1} );
  end
end