-- name=ho_commodehoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "commodehoscr" );
  game.relations[ "ho_commodehoscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_commodehoscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_commodehoscr", zz_gate = "gho_cellar_commodehoscr" };
 
  local win_commodehoscr_func = function ()

    if ( cmn.IsEventDone( "win_commodehoscr" ) ) then
      ObjDetach("spr_commodehoscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_commodehoscr", win_commodehoscr_func );
  
  local unmark_aaa = function () 
    ObjSet( "spr_commodehoscr_aaa", {alp = 1,input=1} );
    ObjDelete("spr_commodehoscr_aaa_part_1")
    ObjDelete("spr_commodehoscr_aaa_part_2")
    ObjDelete( "spr_commodehoscr_aaa_part_2_sh");
  end;
  cmn.AddSubscriber( "commodehoscr_unmark_aaa", unmark_aaa, "ho_commodehoscr" );
  
  local start_commodehoscr_func = function ()
  if not cmn.IsEventDone("win_commodehoscr") then
    if cmn.IsUnmarkedTask("commodehoscr","aaa") then -- ящик
      unmark_aaa()
    end   
  end
  end;
  cmn.AddSubscriber( "win_commodehoscr", start_commodehoscr_func, "ho_commodehoscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_cellar_env" );

  if ( not cmn.IsEventDone( "opn_commodehoscr" ) ) then

    cmn.InitHo( "commodehoscr" );
    cmn.SetMarkedTask( "commodehoscr", "aaa" );
    cmn.SetMarkedTask( "commodehoscr", "lll" );
    cmn.SetMarkedTask( "commodehoscr", "ddd" );
    cmn.SetMarkedTask( "commodehoscr", "jjj" );
    cmn.SetMarkedTask( "commodehoscr", "eee" );
    cmn.SetMarkedTask( "commodehoscr", "hhh" );
    cmn.SetMarkedTask( "commodehoscr", "fff" );
    cmn.SetMarkedTask( "commodehoscr", "iii" );
    cmn.SetMarkedTask( "commodehoscr", "ggg" );
    cmn.SetMarkedTask( "commodehoscr", "kkk" );


    
    cmn.SetEventDone( "opn_commodehoscr" );
    ng_global.progress["scr"]["win_commodehoscr"].state = {}
    ng_global.progress["scr"]["win_commodehoscr"].state.open_box = {0,0}
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 1, { { "spr_commodehoscr_aaa" },{"spr_commodehoscr_aaa_part_1","spr_commodehoscr_aaa_part_2"} });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_commodehoscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_commodehoscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_commodehoscr_ddd" },  {"obj_commodehoscr_openbox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_commodehoscr_eee" },  {"obj_commodehoscr_openbox_2"},{"obj_commodehoscr_closebox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_commodehoscr_fff" },  {"obj_commodehoscr_openbox_2"},{"obj_commodehoscr_closebox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 1, { { "spr_commodehoscr_ggg" },{"obj_commodehoscr_closebox_1"},{"obj_commodehoscr_closebox_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 1, { { "spr_commodehoscr_hhh" },  {"obj_commodehoscr_openbox_2"},{"obj_commodehoscr_closebox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 1, { { "spr_commodehoscr_iii" },{"obj_commodehoscr_closebox_1"},{"obj_commodehoscr_closebox_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 1, { { "spr_commodehoscr_jjj" },  {"obj_commodehoscr_openbox_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 1, { { "spr_commodehoscr_kkk" },  {"obj_commodehoscr_closebox_1"},{"obj_commodehoscr_closebox_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 1, { { "spr_commodehoscr_lll" },  {"obj_commodehoscr_openbox_1"} } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

  for j = 1, #ng_global.progress["scr"]["win_commodehoscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_commodehoscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  private.CheckBox()
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
   if cmn.IsEventDone( "win_commodehoscr" ) then
      ng_global.progress["scr"]["win_commodehoscr"]={}
      ng_global.progress["scr"]["win_commodehoscr"].done = 0
      ng_global.progress["scr"]["opn_commodehoscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.HoComplete()
  ObjDelete("grm_commodehoscr_cellar") 
  -- common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_commodehoscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_commodehoscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;
function private.CheckFound(task)

  local check = false
  for i =1,#ng_global.progress["scr"]["win_commodehoscr"].found do 
    if ng_global.progress["scr"]["win_commodehoscr"].found[i].task == task then
      check = true 
      break
    end
  end
  
  return check
end

private.mark_task_arr = {
    {"lll","ddd","jjj"},
    {"eee","fff","hhh"},
    {"iii","ggg","kkk"},
  }
function private.UnmarkTask(box)
  ObjSet( "obj_commodehoscr_box_"..box, {input = 1} );
  for i=1,#private.mark_task_arr[box] do
    if not private.CheckFound(private.mark_task_arr[box][i]) then
      ObjSet( "spr_commodehoscr_"..private.mark_task_arr[box][i], {input = 1} );      
      cmn.UnmarkTask( "commodehoscr", private.mark_task_arr[box][i] );
    end
  end
end
function private.MarkTask(box)
  ObjSet( "obj_commodehoscr_box_"..box, {input = 0} );
  for i=1,#private.mark_task_arr[box] do
    if not private.CheckFound(private.mark_task_arr[box][i]) then    
      cmn.SetMarkedTask( "commodehoscr", private.mark_task_arr[box][i] );
      ObjSet( "spr_commodehoscr_"..private.mark_task_arr[box][i], {input = 0} );
      interface.TaskPanelTaskMark( "commodehoscr", private.mark_task_arr[box][i] )
    end
  end
end
----------------------------------------------------------------------------

function private.CheckBox()
  local state_box = ng_global.progress["scr"]["win_commodehoscr"].state.open_box
  for i=1,2 do
    ObjSet( "obj_commodehoscr_box_"..i, {alp = state_box[i]} );
  end
  if state_box[1]==1 then
    private.MarkTask(2)
    private.MarkTask(3)
    private.UnmarkTask(1)
    ObjSet( "obj_commodehoscr_openbox_2", {input = 0} );    
    ObjSet( "obj_commodehoscr_openbox_1", {input = 0} );  
  elseif state_box[1]==0 and state_box[2]==1 then 
    ObjSet( "obj_commodehoscr_openbox_2", {input = 0} );    
    ObjSet( "obj_commodehoscr_openbox_1", {input = 1} );   
    private.MarkTask(1)
    private.MarkTask(3)  
    private.UnmarkTask(2)      
  elseif state_box[1]==0 and state_box[2]==0 then 
    ObjSet( "obj_commodehoscr_openbox_2", {input = 1} );    
    ObjSet( "obj_commodehoscr_openbox_1", {input = 1} );   
    private.MarkTask(1)
    private.MarkTask(2)  
    private.UnmarkTask(3)     
  end
end

function public.open_box(num)
  local f_end=function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_commodehoscr"].state.open_box[num]=1
    private.CheckBox()
  end
  ld.Lock(1)
  ObjAnimate( "obj_commodehoscr_box_"..num, 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
  SoundSfx( "aud_ho_commode_drawer_open" );
end
----------------------------------------------------------------------------

function public.close_box(num)
  local s = ng_global.progress["scr"]["win_commodehoscr"].state
  local f_end=function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_commodehoscr"].state.open_box[num]=0
    private.CheckBox()
    --if ng_global.progress["scr"]["win_commodehoscr"].state.open_box[1]+ng_global.progress["scr"]["win_commodehoscr"].state.open_box[2] == 0 then
    --  ObjSet( "obj_commodehoscr_box_3", {input = 1} );
    --  private.UnmarkTask(3)
    --end
  end
  ld.Lock(1)
  ObjAnimate( "obj_commodehoscr_box_"..num, 8, 0, 0, f_end, {0,0,1, 0.5,0,0} );
  SoundSfx( "aud_ho_commode_drawer_close" );
end


----------------------------------------------------------------------------
function public.unmark_aaa()
  if ApplyObj("spr_commodehoscr_aaa_part_1","spr_commodehoscr_aaa_part_2") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "commodehoscr", "aaa" );
      cmn.CallEventHandler( "commodehoscr_unmark_aaa" );      
    end
    ld.Lock(1)
    ObjDelete("spr_commodehoscr_aaa_part_2")
    ObjAnimate( "spr_commodehoscr_aaa", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_ho_commode_brush" );
  else
    ObjSet("spr_commodehoscr_aaa_part_2",{pos_z = 5})
    ObjSet( "spr_commodehoscr_aaa_part_2_sh", {alp = 1} );
    SoundSfx( "aud_ho_commode_put" );
  end
end