-- name=ho_innerporchhoextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "innerporchhoextscr" );
  game.relations[ "ho_innerporchhoextscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_innerporchhoextscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_innerporchhoextscr", zz_gate = "gho_barnext_innerporchhoextscr" };
 
  local win_innerporchhoextscr_func = function ()

    if ( cmn.IsEventDone( "win_innerporchhoextscr" ) ) then
      ObjDetach("spr_innerporchhoextscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_innerporchhoextscr", win_innerporchhoextscr_func );
  
  local unmark_lll = function () 
    ObjSet( "spr_innerporchhoextscr_lll", {alp = 1,input=1} );
    ObjSet( "spr_innerporchhoextscr_open_box", {alp = 1} );
    ObjDelete("gfx_innerporchhoextscr_unmark_lll_zone")
  end;
  cmn.AddSubscriber( "innerporchhoextscr_unmark_lll", unmark_lll, "ho_innerporchhoextscr" );
  
  local start_innerporchhoextscr_func = function ()
  if not cmn.IsEventDone("win_innerporchhoextscr") then
    if cmn.IsUnmarkedTask("innerporchhoextscr","lll") then 
      unmark_lll()
    end 
  end
  end;
  cmn.AddSubscriber( "win_innerporchhoextscr", start_innerporchhoextscr_func, "ho_innerporchhoextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_barnext_env" )

  if ( not cmn.IsEventDone( "opn_innerporchhoextscr" ) ) then

    cmn.InitHo( "innerporchhoextscr" );
    cmn.SetMarkedTask( "innerporchhoextscr", "lll" );
    cmn.SetEventDone( "opn_innerporchhoextscr" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_innerporchhoextscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_innerporchhoextscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_innerporchhoextscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_innerporchhoextscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_innerporchhoextscr_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_innerporchhoextscr_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_innerporchhoextscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_innerporchhoextscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_innerporchhoextscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_innerporchhoextscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_innerporchhoextscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 1, { { "spr_innerporchhoextscr_lll" },{"gfx_innerporchhoextscr_unmark_lll_zone"},
  {"spr_innerporchhoextscr_aaa"},{"spr_innerporchhoextscr_bbb"},{"spr_innerporchhoextscr_ccc"},
  {"spr_innerporchhoextscr_ddd"},{"spr_innerporchhoextscr_eee"},{"spr_innerporchhoextscr_fff"},
  {"spr_innerporchhoextscr_ggg"},{"spr_innerporchhoextscr_hhh"},{"spr_innerporchhoextscr_iii"},
  {"spr_innerporchhoextscr_jjj"},{"spr_innerporchhoextscr_kkk"},
 } );
  

  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_innerporchhoextscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_innerporchhoextscr"].found[j]["object"] );
    local task = tostring( ng_global.progress["scr"]["win_innerporchhoextscr"].found[j]["task"]);
    ObjDelete( name );
    ObjSet( "spr_innerporchhoextscr_lll_part_"..task, {alp = 1} );

  end;
  if #ng_global.progress["scr"]["win_innerporchhoextscr"].found == 11 then
    ObjSet( "gfx_innerporchhoextscr_unmark_lll_zone", {input = 1,visible=1} );
  end

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
   if cmn.IsEventDone( "win_innerporchhoextscr" ) then
      ng_global.progress["scr"]["win_innerporchhoextscr"]={}
      ng_global.progress["scr"]["win_innerporchhoextscr"].done = 0
      ng_global.progress["scr"]["opn_innerporchhoextscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  if item_name ~= "lll" then
    local obj = "spr_innerporchhoextscr_lll_part_"..item_name
    local x1 = ObjGet("spr_innerporchhoextscr_"..item_name).pos_x
    local y1 = ObjGet("spr_innerporchhoextscr_"..item_name).pos_y  
    local x2 = ObjGet(obj).pos_x
    local y2 = ObjGet(obj).pos_y
    
    local f_end = function()
      ld.LockRm(0)
      if #ng_global.progress["scr"]["win_innerporchhoextscr"].found == 11 then
        ObjSet( "gfx_innerporchhoextscr_unmark_lll_zone", {input = 1,visible=1} );
      end
      ObjSet( "fx_innerporchhoextscr_pshik_fx", {active = 0, visible = 0, alp=0} );
    end
    local f_step = function ()
      SoundSfx( "aud_ho_innerporchhoext_insert" )
      ObjSet( "fx_innerporchhoextscr_pshik_fx", {active = 1, visible = 1,alp=1} );
      PartSysStart("fx_innerporchhoextscr_pshik_fx")
      ObjAnimate( "fx_innerporchhoextscr_fly_fx", 8, 0, 0,function()ObjSet( "fx_innerporchhoextscr_fly_fx", {visible=0,active=0} );end, {0,0,1, 0.3,0,0} );
      ObjAnimate( obj, 8, 0, 0,f_end, {0,0,0, 0.3,0,1} );

    end
    
    ld.LockRm(1)
    ObjStopAnimate("fx_innerporchhoextscr_fly_fx",3)
    ObjSet( "fx_innerporchhoextscr_fly_fx", {active = 1, visible = 1,alp=1} );
    PartSysRestart("fx_innerporchhoextscr_fly_fx")
    ObjSet( "fx_innerporchhoextscr_pshik_fx", {pos_x = x2,pos_y = y2} );
    ObjAnimate( "fx_innerporchhoextscr_fly_fx", 3, 0, 0, f_step, {0,0,x1,y1, 0.3,0,x2,y2} ); 
   
    
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_innerporchhoextscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_innerporchhoextscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_lll()
  local f_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "innerporchhoextscr", "lll" );
    cmn.CallEventHandler( "innerporchhoextscr_unmark_lll" );      
  end
  
  SoundSfx( "aud_ho_innerporchhoext_open" );
  ld.Lock(1)  
  ObjAnimate("spr_innerporchhoextscr_open_box" , 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
  ObjAnimate("spr_innerporchhoextscr_lll" , 8, 0, 0, "", {0,0,0, 0.5,0,1} );
end
