-- name=ho_pantryscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "pantryscr" );
  game.relations[ "ho_pantryscr" ].exitroom = "rm_secretroomscr";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------
  ObjMultiSet( {

    { "spr_pantryscr_aaa", { input = 0; event_mdown = function() private.TaskComplete( 'aaa', 1 ) end } };
    { "spr_pantryscr_bbb", { input = 0; event_mdown = function() private.TaskComplete( 'bbb', 1 ) end } };
    { "spr_pantryscr_ccc", { input = 0; event_mdown = function() private.TaskComplete( 'ccc', 1 ) end } };
    { "spr_pantryscr_ddd", { input = 0; event_mdown = function() private.TaskComplete( 'ddd', 2 ) end } };
    { "spr_pantryscr_eee", { input = 0; event_mdown = function() private.TaskComplete( 'eee', 2 ) end } };
    { "spr_pantryscr_fff", { input = 0; event_mdown = function() private.TaskComplete( 'fff', 2 ) end } };
    { "spr_pantryscr_ggg", { input = 0; event_mdown = function() private.TaskComplete( 'ggg', 3 ) end } };
    { "spr_pantryscr_hhh", { input = 0; event_mdown = function() private.TaskComplete( 'hhh', 3 ) end } };
    { "spr_pantryscr_iii", { input = 0; event_mdown = function() private.TaskComplete( 'iii', 3 ) end } };
    { "spr_pantryscr_jjj", { input = 0; event_mdown = function() private.TaskComplete( 'jjj', 4 ) end } };
    { "spr_pantryscr_kkk", { input = 0; event_mdown = function() private.TaskComplete( 'kkk', 4 ) end } };
    { "spr_pantryscr_lll", { input = 0; event_mdown = function() private.TaskComplete( 'lll', 4 ) end } };

    { "spr_pantryscr_mmm", { input = 0; event_mdown = function() cmn.HoTaskFind( "spr_pantryscr_mmm", 'mmm' ); end } };
 
    --{ "obj_pantryscr_eee_unmark", { 
    --  input = 1;
    --  event_mdown = private.unmark_mmm;
    --  event_menter = function() ld.ShCur(CURSOR_HAND) end;
    --  event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
    --} };
 
    --{ "spr_pantryscr_stalk", { event_startdrag = function() private.GetItem( 'stalk' ) end, event_dragdrop = function() private.unmark_harpoon() end } },
    --{ "spr_pantryscr_hammer", { event_startdrag = function() private.GetItem( 'hammer' ) end, event_dragdrop = function() private.unmark_ship() end } },
 
    { "spr_pantryscr_taskpanel_item_1", { event_startdrag = function() private.GetPanelItem( 1 ) end ,event_dragdrop = function() private.UseItem( 1 ) end } };
    { "spr_pantryscr_taskpanel_item_2", { event_startdrag = function() private.GetPanelItem( 2 ) end, event_dragdrop = function() private.UseItem( 2 ) end } };
    { "spr_pantryscr_taskpanel_item_3", { event_startdrag = function() private.GetPanelItem( 3 ) end, event_dragdrop = function() private.UseItem( 3 ) end } };
    { "spr_pantryscr_taskpanel_item_4", { event_startdrag = function() private.GetPanelItem( 4 ) end, event_dragdrop = function() private.UseItem( 4 ) end } };

    { "spr_pantryscr_item_lock_1", { event_startdrag = function() private.GetLockItem( 1 ) end ,event_dragdrop = function() private.UseLockItem( 1 ) end } };
    { "spr_pantryscr_item_lock_2", { event_startdrag = function() private.GetLockItem( 2 ) end, event_dragdrop = function() private.UseLockItem( 2 ) end } };
    { "spr_pantryscr_item_lock_3", { event_startdrag = function() private.GetLockItem( 3 ) end, event_dragdrop = function() private.UseLockItem( 3 ) end } };
    { "spr_pantryscr_item_lock_4", { event_startdrag = function() private.GetLockItem( 4 ) end, event_dragdrop = function() private.UseLockItem( 4 ) end } };

  } );
--------------------------------------------------------------------------------------------------
  private.taskpanel = 
  {
    { "spr_pantryscr_aaa",    "spr_pantryscr_bbb",      "spr_pantryscr_ccc" },
    { "spr_pantryscr_ddd",    "spr_pantryscr_eee",      "spr_pantryscr_fff" },
    { "spr_pantryscr_ggg",    "spr_pantryscr_hhh",      "spr_pantryscr_iii" },
    { "spr_pantryscr_jjj",    "spr_pantryscr_kkk",      "spr_pantryscr_lll" }
  }
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pantryscr" ] = {
        type = "win",
        room = "rm_secretroomscr",
        zz = "ho_pantryscr",
        zz_gate = "gho_pub_pantryscr"
    };

  local win_pantryscr_func = function ()

    if ( cmn.IsEventDone( "win_pantryscr" ) ) then

      ObjDetach("spr_pantryscr_win") 

    end;

  end;
  cmn.AddSubscriber( "win_pantryscr", win_pantryscr_func );
  
  --------------------------------------------------------------------------------------------------
  local win_pantryscr_func = function ()

    local table_multiset = {};
    if ( not cmn.IsEventDone( "win_pantryscr" ) ) then

      local ho_progress = ng_global.progress[ "scr" ][ "win_pantryscr" ];

      for key, value in pairs( private.taskpanel ) do

        local flag_complete = true;
        for i = 1, #private.taskpanel[ key ] do

          if ( not ho_progress.items[ private.taskpanel[ key ][ i ] ] ) then
            flag_complete = false;
            break;
          end;

        end;

        ObjSet( "spr_pantryscr_item_"..key.."_safe", { alp = 0 } )

        if ( ho_progress.parts[ key ] )then
          
          ObjDelete( "obj_pantryscr_taskpanel_item_"..key );
          ObjSet( "spr_pantryscr_item_"..key.."_safe", { alp = 1 } )
          
        elseif ( flag_complete ) then

          table.insert( table_multiset, { "spr_pantryscr_taskpanel_item_"..key, { input = true } } );
          table.insert( table_multiset, { "obj_pantryscr_item_"..key.."_hint", { input = true } } );         
          ObjDelete( "spr_pantryscr_taskpanel_part_"..key );         
         
        end;

        if ng_global.progress[ "scr" ][ "win_pantryscr" ].locks[ key ] > 0 then
          ObjDelete( "spr_pantryscr_item_lock_"..ng_global.progress[ "scr" ][ "win_pantryscr" ].locks[ key ] )
          ObjDelete( "spr_pantryscr_taskpanel_lock_"..key )
          for i = 1, #private.taskpanel[ key ] do
            ObjSet( private.taskpanel[ key ][ i ], { input = 1 } )
          end
        end

      end;

      --regular
      for j = 1, #ng_global.progress["scr"]["win_pantryscr"].found do
        local name = tostring( ng_global.progress[ "scr" ][ "win_pantryscr" ].found[ j ][ "task" ] );
        ObjDelete( "txt_pantryscr_taskpanel_"..name );
        ObjDelete( "spr_pantryscr_"..name );
        ObjDelete( "spr_pantryscr_"..name.."_shadow" );
      end;

      --final
      local good = true
      for k, v in pairs( ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ].parts ) do
        if not v then
          good = false
          break
        end
      end;
      if good then
        ObjSet("anm_pantryscr_door_open",{animfunc="door_open_end",frame=0})
        ObjDelete("spr_pantryscr_door")        
        ObjSet( "spr_pantryscr_mmm", { alp = 1, input = 1 } )
        for i=1,4 do ObjDelete("spr_pantryscr_item_"..i.."_safe") end
        ObjSet( "txt_pantryscr_taskpanel_mmm", { alp = 1 } )
        ObjSet( "obj_pantryscr_item_root", { inputrect_init = 0 } )
      else
        ObjSet( "spr_pantryscr_mmm", { alp = 0, input = 0 } )
        ObjSet( "spr_pantryscr_mmm", { input = 0 } )
        ObjSet( "txt_pantryscr_taskpanel_mmm", { alp = 0 } )
      end;
      
      --mark
      --for k, v in pairs( ng_global.progress["scr"]["win_pantryscr"].marked ) do
      --  if v == false then
      --    cmn.CallEventHandler( "unmark_"..k );
      --  end;
      --end

    end;
    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
    end;

  end;
  cmn.AddSubscriber( "win_pantryscr", win_pantryscr_func, "ho_pantryscr" );
  
  --------------------------------------------------------------------------------------------------
  local win_pantryscr_pub = function ()

    if ( cmn.IsEventDone( "win_pantryscr" ) ) then
      
      --ObjDelete( "gho_pub_pantryscr" );

    end;

  end;
  cmn.AddSubscriber( "win_pantryscr", win_pantryscr_pub, "rm_pub" );
  
  --------------------------------------------------------------------------------------------------
--  local unmark_mmm = function () 
--   
--    ObjDelete( "obj_pantryscr_eee_unmark" )
--    --ObjSet( "spr_pantryscr_eee", { input = 1 } )
--    ObjSet( "anm_pantryscr_anim_tr_eee_up", { animfunc = "anim_tr_eee_down", frame = 0 } )
--    ld.LogTrace( "unmark_mmm" )
--
--  end;
--
--  cmn.AddSubscriber( "unmark_mmm", unmark_mmm, "ho_pantryscr" );  

  --------------------------------------------------------------------------------------------------
--  local unmark_harpoon = function () 
--   
--    ObjDelete( "spr_pantryscr_stalk" );
--    ObjDelete( "obj_pantryscr_use_stalk" );
--    ObjSet( "spr_pantryscr_stalk_2", { alp = 1, input = true } );
--    ObjSet( "spr_pantryscr_harpoon", { input = true } );
--
--  end;
--
--  cmn.AddSubscriber( "unmark_harpoon", unmark_harpoon, "ho_pantryscr" );  
  --------------------------------------------------------------------------------------------------
  local start_pantryscr_func = function ()
        
      if not cmn.IsEventDone( "win_pantryscr" ) then
       
--        if ( cmn.IsUnmarkedTask( "pantryscr", "ship" ) ) then
--          unmark_ship();
--        end;
--
--        if ( cmn.IsUnmarkedTask( "pantryscr", "harpoon" ) ) then
--          unmark_harpoon();
--      
--        end;

      end;

  end;    
  
  cmn.AddSubscriber( "win_pantryscr", start_pantryscr_func, "ho_pantryscr" );  


end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_pantryscr" ) ) then

    cmn.InitHo( "pantryscr" );
   
    cmn.SetEventDone( "opn_pantryscr" );
    --cmn.SetMarkedTask( "pantryscr", "ship" );
    --cmn.SetMarkedTask( "pantryscr", "harpoon" );
    --cmn.SetMarkedTask( "pantryscr", "canister" );
    --cmn.SetMarkedTask( "pantryscr", "pen_1" );
    --cmn.SetMarkedTask( "pantryscr", "pen" );
    --cmn.SetMarkedTask( "pantryscr", "sew" );

    cmn.SetMarkedTask( "pantryscr", "part1" );
    cmn.SetMarkedTask( "pantryscr", "part2" );
    cmn.SetMarkedTask( "pantryscr", "part3" );
    cmn.SetMarkedTask( "pantryscr", "part4" );

    --ng_global.progress["scr"]["win_pantryscr"].marked = {
    --  mmm = true;
    --};
    ng_global.progress["scr"]["win_pantryscr"].items = {};
    ng_global.progress["scr"]["win_pantryscr"].locks = {0,0,0,0};
    ng_global.progress["scr"]["win_pantryscr"].parts = {false,false,false,false};
    
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "item_lock_1",  1, 0, { { "spr_pantryscr_item_lock_1", "spr_pantryscr_taskpanel_lock_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "item_lock_2",  1, 0, { { "spr_pantryscr_item_lock_2", "spr_pantryscr_taskpanel_lock_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "item_lock_3",  1, 0, { { "spr_pantryscr_item_lock_3", "spr_pantryscr_taskpanel_lock_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "item_lock_4",  1, 0, { { "spr_pantryscr_item_lock_4", "spr_pantryscr_taskpanel_lock_4" } } );

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_pantryscr_aaa" } } );
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_pantryscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_pantryscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_pantryscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_pantryscr_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_pantryscr_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_pantryscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_pantryscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_pantryscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_pantryscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_pantryscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_pantryscr_lll" } } );

  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "spr_pantryscr_mmm" } } );

  interface.TaskPanelTaskAdd( ho_items,   "part1",          1, 1, { { "spr_pantryscr_taskpanel_item_1", "obj_pantryscr_item_1_hint" } } );
  interface.TaskPanelTaskAdd( ho_items,   "part2",          1, 1, { { "spr_pantryscr_taskpanel_item_2", "obj_pantryscr_item_2_hint" } } );
  interface.TaskPanelTaskAdd( ho_items,   "part3",          1, 1, { { "spr_pantryscr_taskpanel_item_3", "obj_pantryscr_item_3_hint" } } );
  interface.TaskPanelTaskAdd( ho_items,   "part4",          1, 1, { { "spr_pantryscr_taskpanel_item_4", "obj_pantryscr_item_4_hint" } } );


  --interface.TaskPanelTaskAdd( ho_items, "canister",          1, 1, { { "spr_pantryscr_taskpanel_item_canister", "obj_pantryscr_use_item_canister_hint" } } );
  --interface.TaskPanelTaskAdd( ho_items, "pen_1",          1, 1, { { "spr_pantryscr_taskpanel_item_pen_1", "obj_pantryscr_use_item_pen_1_hint" } } );
  --interface.TaskPanelTaskAdd( ho_items, "pen",          1, 1, { { "spr_pantryscr_taskpanel_item_pen", "obj_pantryscr_use_item_pen_hint" } } );
  --interface.TaskPanelTaskAdd( ho_items, "sew",          1, 1, { { "spr_pantryscr_taskpanel_item_sew", "obj_pantryscr_use_item_sew_hint" } } );
  
  private.ho_items = ho_items

  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "pantryscr" );


  private.SetTexts();


  private.SetLockHints()
  
  SoundHoTheme(true)
  SoundEnv( "aud_pub_env" );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  SoundHoTheme(false)
   if cmn.IsEventDone( "win_pantryscr" ) then
      ng_global.progress["scr"]["win_pantryscr"]={}
      ng_global.progress["scr"]["win_pantryscr"].done = 0
      ng_global.progress["scr"]["opn_pantryscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.Open ()
  
end;
--*********************************************************************************************************************
function public.Close ()

  int_taskpanel_impl.ShowTextPanel( "pantryscr" );
  if ld.CheckRequirements( { "win_pantryscr" } ) then
    --SoundTheme( "aud_adventure_mus" )
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  ObjAnimate( "anm_pantryscr_anm_item_full", 8,0,0, _, { 0,0,1, 0.35,0,0 } )
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, part )

  cmn.HoTaskFind( "spr_pantryscr_"..task_name, task_name );

  local func_after = function()

    --common_impl.Lock(false);

--    if ( task_name == "harpoon" or task_name == "ship" ) then
--
--      ObjSet( "spr_pantryscr_"..task_name, { input = false } );
--  
--    end;
  
    
  end;
  if part > 0 then
    private.check_task( "spr_pantryscr_"..task_name, part ) 
  else

  end 

  ObjAnimate( "txt_pantryscr_taskpanel_"..task_name, "alp", 0, 0, func_after, { 0,3,1,  0.8,3,0 } );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  common_impl.PlayAudio("sfx","common/audio/aud_get");
  ObjSet( "spr_pantryscr_"..name, { pos_z = 20 } );
  ObjSet( "spr_pantryscr_"..name.."_shadow", { visible = false } );

end;

function private.GetLockItem( name )
  
  private.lock_items_parent = private.lock_items_parent or {}
  private.lock_items_parent[ name ] = ObjGetRelations( "spr_pantryscr_item_lock_"..name ).parent
  common_impl.PlayAudio("sfx","common/audio/aud_get_inv");
  ObjSet( "spr_pantryscr_item_lock_"..name, { pos_z = 39 } );
  ObjAttach( "spr_pantryscr_item_lock_"..name, InterfaceWidget_Top_Name )
  ObjSet( "spr_pantryscr_item_lock_"..name.."_shadow", { visible = false } );

end;

-------------------------------------------------------------------------
function private.check_task( obj, part )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ];
  ho_progress.items[ obj ] = true;

  local flag_complete = true;
  for i = 1, #private.taskpanel[ part ] do

    if ( not ho_progress.items[ private.taskpanel[ part ][ i ] ] ) then

      flag_complete = false;
      break;

    end;

  end;

  if ( flag_complete ) then    
    
    local func_after = function()
    
      --common_impl.Lock(false);

      ObjSet( "spr_pantryscr_taskpanel_item_"..part, { input = true } );
      ObjSet( "obj_pantryscr_item_"..part.."_hint", { input = true } );      

    end;

    --common_impl.Lock(true);



    local o = ObjGet( "spr_pantryscr_taskpanel_part_"..part )
    ObjAnimate( o.name, "pos_y", 0, 0, func_after, { 0,0,o.pos_y, 0.4,1,o.pos_y + o.draw_height } );
     SoundSfx( "aud_ho_pantry_panel" );
  end;
  
end;
-------------------------------------------------------------------------------------
function private.SetLockHints()
  --ld.LogTrace( ng_global.progress["scr"]["win_pantryscr"].locks )
  --interface.TaskPanelTaskAdd( ho_items, "item_lock_1",  1, 0, { { "spr_pantryscr_item_lock_1", "spr_pantryscr_taskpanel_lock_1" } } );
  --ng_global.progress["scr"]["win_pantryscr"].locks
  for i = 1, #ng_global.progress["scr"]["win_pantryscr"].locks do
    if ng_global.progress["scr"]["win_pantryscr"].locks[ i ] > 0 and ng_global.progress["scr"]["win_pantryscr"].locks[ i ] ~= i then
      local ho_tasks_now
      local ho_tasks_next
      for j = 1, #private.ho_items do
        --ld.LogTrace( private.ho_items[ j ] )
        if private.ho_items[ j ].name == "tsk_pantryscr_item_lock_"..i then
          ho_tasks_now = private.ho_items[ j ]
        end
        if private.ho_items[ j ].name == "tsk_pantryscr_item_lock_"..ng_global.progress["scr"]["win_pantryscr"].locks[ i ] then
          ho_tasks_next = private.ho_items[ j ]
        end
      end
      --ld.LogTrace( ho_tasks_now, ho_tasks_next )
      local spr1 = ld.StringDivide( ho_tasks_now.hint[ 1 ][ 2 ] )
      spr1 = tonumber(  spr1[ #spr1 ] )
      local spr2 = ld.StringDivide( ho_tasks_next.hint[ 1 ][ 2 ] )
      spr2 = tonumber(  spr2[ #spr2 ] )
      --ld.LogTrace( "\n\n*********************", i,ng_global.progress["scr"]["win_pantryscr"].locks[ i ], ho_tasks_now.hint[ 1 ][ 2 ], ho_tasks_next.hint[ 1 ][ 2 ], spr1, spr2 )
      if ng_global.progress["scr"]["win_pantryscr"].locks[ i ] ~= spr1 then
        --ld.LogTrace( ">>>",ho_tasks_now, ho_tasks_next )
        ho_tasks_now.hint[ 1 ][ 2 ], ho_tasks_next.hint[ 1 ][ 2 ] = ho_tasks_next.hint[ 1 ][ 2 ], ho_tasks_now.hint[ 1 ][ 2 ]
        --ld.LogTrace( "***",ho_tasks_now, ho_tasks_next )
        --ld.LogTrace( "<<<" )
      end

    end;
  end;
end
-------------------------------------------------------------------------------------
function private.SetTexts()
  ng_global.progress["scr"]["win_pantryscr"].marked = ng_global.progress["scr"]["win_pantryscr"].marked or {}
  local tsk 
  for key, value in pairs( private.taskpanel ) do
    for i = 1, #private.taskpanel[ key ] do
      tsk = ld.StringDivide( private.taskpanel[ key ][ i ] )
      tsk = tsk[ #tsk ]
      if ObjGet( "txt_pantryscr_taskpanel_"..tsk ) then
        local set = ObjGet( "txt_int_taskpanel_task_1" )
        set.name = "txt_pantryscr_taskpanel_"..tsk
        set.text = "tsk_pantryscr_"..tsk
        set.pos_x = 0
        set.pos_y = - 13 + 23 * ( i - 1 )
        set.alp = nil;
        ObjSet( set.name, set )
        if not ng_global.progress["scr"]["win_pantryscr"].marked[ tsk ] then
          ObjSet( set.name, int_taskpanel_impl.GetTaskColors() )
        else
          ObjSet( set.name, int_taskpanel_impl.GetTaskMarkedColors() )
        end
        local panel = ObjGet( "spr_pantryscr_taskpanel_part_"..key )
        while ( ObjGet( set.name ).draw_width + 30 ) > panel.draw_width do
          set.fontsize = set.fontsize - 1
          ObjSet( set.name, { fontsize = set.fontsize }  )
        end
      end
    end;
  end;
  local set = ObjGet( "txt_int_taskpanel_task_1" )
  set.name = "txt_pantryscr_taskpanel_mmm"
  set.text = "tsk_pantryscr_mmm"
  set.pos_x = 0
  set.pos_y = 0
  set.alp = nil;
  ObjSet( "txt_pantryscr_taskpanel_mmm", set )
  ObjSet( "txt_pantryscr_taskpanel_mmm", int_taskpanel_impl.GetTaskColors() )
end;
-------------------------------------------------------------------------------------
function private.GetPanelItem( name )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv", 0, "", 0 );
  local item = "obj_pantryscr_taskpanel_item_"..name;
  
  ObjSet( item, { pos_z = 5 } );

end;
-------------------------------------------------------------------------------------
function private.UseItem( name )

  local item = "spr_pantryscr_taskpanel_item_"..name;
  
  if ( ObjIntersect( item, "obj_pantryscr_item_root" ) ) then

    ObjDelete( item );

    local func_end = function() 
      ld.Lock( 0 )
      cmn.HoTaskFind( "spr_pantryscr_item_"..name.."_hint", "part"..tostring( name ), true );
      ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ].parts[ name ] = true;
    end

    local func_step = function()

      local bads = 0
      for k, v in pairs( ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ].parts ) do
        if not v then
          bads = bads + 1
        end
      end;

      if bads > 1 then

        func_end()

      else
        ld.Lock(1)
        SoundSfx( "aud_ho_pantry_cabinet" )
        ld.AnimPlay("anm_pantryscr_door_open","door_open",function()ld.Lock(1)ObjSet("anm_pantryscr_door_open",{animfunc="door_open_end",frame=0})func_end()end)
        ObjDelete("spr_pantryscr_door")
        for i=1,4 do ObjDelete("spr_pantryscr_item_"..i.."_safe") end
        ObjSet( "spr_pantryscr_mmm", { input = 1 } )

        ObjSet( "obj_pantryscr_item_root", { inputrect_init = 0 } )
        ObjAnimate( "txt_pantryscr_taskpanel_mmm", 8,0,0, _, { 0,0,0, 0.4,0,1 } )
        ObjAnimate( "spr_pantryscr_mmm", 8,0,0, "func_end", { 0,0,0, 0.4,2,1 } )

      end;

    end;

    sfx = { 
      "aud_use_ho_pantry_1";
      "aud_use_ho_pantry_2";
      "aud_use_ho_pantry_3";
      "aud_use_ho_pantry_4";
    }
    --SoundSfx( sfx[ tonumber( name ) ], -1 )
    local t = 0.4
    ld.Lock( 1 )
    local o = ObjGet( "spr_pantryscr_item_"..name.."_safe" )
    SoundSfx( "aud_ho_pantry_insert" )
    ObjSet( o.name, { pos_z = o.pos_z + 10 } )
    ObjAnimate( o.name, 8,0,0, _, { 0,0,0, t,0,1 } )
    ObjAnimate( o.name, 6,0,0, function() 
      ObjSet( o.name, { pos_z = o.pos_z } )
      func_step()
    end, { 0,0,1.5,1.5, t,0,1,1 } )


  else
    
    SoundSfx( "aud_wrongapply"..math.random(1,3) );
    ObjSet( "obj_pantryscr_taskpanel_item_"..name, { pos_z = 1 } );
    
  end;

end;
----------------------------------------------------------------------------
function private.UseLockItem( name )

  local item = "spr_pantryscr_item_lock_"..name;
  local place

  for i = 1, #ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ].locks do
    if ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ].locks[ i ] == 0 then

      place = "spr_pantryscr_taskpanel_lock_"..i.."_item"

      if ( ObjIntersect( item, place ) ) then

        SoundSfx( "aud_ho_pantry_pretzel" )
        ObjDelete( item );

        local func_end = function()

          ld.Lock( 0 )
          cmn.HoTaskFind( "spr_pantryscr_item_"..name.."_hint", "item_lock_"..name, true );
          ng_global.progress[ ng_global.currentprogress ][ "win_pantryscr" ].locks[ i ] = name;

          private.SetLockHints()

          for j = 1, #private.taskpanel[ i ] do
            ObjSet( private.taskpanel[ i ][ j ], { input = 1 } )
            --local unmark = private.taskpanel[ i ][ j ]:gsub( "^spr_", "obj_" ).."_unmurk"
            --if ObjGet( unmark ) then
            --  ObjSet( unmark, { input = 1 } )
            --end;
          end

        end;

        sfx = { 
          "aud_use_ho_pantry_1";
          "aud_use_ho_pantry_2";
          "aud_use_ho_pantry_3";
          "aud_use_ho_pantry_4";
        }
        --SoundSfx( sfx[ tonumber( name ) ], -1 )
        local t = 0.4
        ld.Lock( 1 )
        local o = ObjGet( place )
        ObjSet( o.name, { pos_z = o.pos_z + 10 } )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,0, t,0,1 } )
        ObjAnimate( o.name, 6,0,0, function() 
          SoundSfx( "aud_ho_pantry_panel" )
          ObjSet( o.name, { pos_z = o.pos_z } )
          local o = ObjGet( "spr_pantryscr_taskpanel_lock_"..i )
          ObjAnimate( o.name, 1,0,0, func_end, { 0,0,o.pos_y, t,1,o.pos_y+o.draw_height } )
          --common_impl.PlayAudio( "sfx", "common/audio/aud_task_list_outerwood_out", 0, "", 0 );
        end, { 0,0,1.25,1.25, t,0,1,1 } )

        return

      end;

    end;
  end
  
  SoundSfx( "aud_ho_pantry_set_pretzel" )
  ObjSet( "spr_pantryscr_item_lock_"..name, { pos_z = 0 } );
  ObjAttach( "spr_pantryscr_item_lock_"..name, private.lock_items_parent[ name ] )

end;
----------------------------------------------------------------------------
--function private.unmark_mmm()
--  local func_end = function () 
--    ng_global.progress["scr"]["win_pantryscr"].marked[ "mmm" ] = false
--    private.SetTexts()
--    cmn.CallEventHandler( "unmark_mmm" );
--    ld.Lock( 0 )
--  end;
--  ld.Lock( 1 )
--  ld.AnimPlay( "anm_pantryscr_anim_tr_eee_up", "anim_tr_eee_up", func_end )
--end
----------------------------------------------------------------------------