-- name=ho_puddlescr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "puddlescr" );
  game.relations[ "ho_puddlescr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
 common_impl.hint[ "win_puddlescr" ] = {
    type = "win",
    room = "rm_secretroomscr",
    zz = "ho_puddlescr",
    zz_gate = "gho_corridor_puddlescr"
  };
 
  local win_puddlescr_func = function ()

    if ( cmn.IsEventDone( "win_puddlescr" ) ) then
      ObjDetach("spr_puddlescr_win")
    end;

  end;
  cmn.AddSubscriber( "win_puddlescr", win_puddlescr_func );
  
  local start_puddlescr_func = function ()
  if not cmn.IsEventDone("win_puddlescr") then
      common_impl.ProcessHoStart( "puddlescr" );

      local ho_found = ng_global.progress[ "scr" ][ "win_puddlescr" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;

  end
  end;
  cmn.AddSubscriber( "win_puddlescr", start_puddlescr_func, "ho_puddlescr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_corridor_env" );

  if ( not cmn.IsEventDone( "opn_puddlescr" ) ) then

    cmn.InitHo( "puddlescr" );

    cmn.SetEventDone( "opn_puddlescr" );

  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_puddlescr_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_puddlescr_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_puddlescr_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_puddlescr_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_puddlescr_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_puddlescr_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_puddlescr_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_puddlescr_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_puddlescr_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_puddlescr_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_puddlescr_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_puddlescr_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false )
  interface.ItemPanelHide();
   if cmn.IsEventDone( "win_puddlescr" ) then
      ng_global.progress["scr"]["win_puddlescr"]={}
      ng_global.progress["scr"]["win_puddlescr"].done = 0
      ng_global.progress["scr"]["opn_puddlescr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show()
  ObjDelete("grm_puddlescr_corridor") 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )


end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_puddlescr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_puddlescr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
   SoundSfx("aud_get_inv");

end;