-- name=ho_rootshoextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "rootshoextscr" );
  game.relations[ "ho_rootshoextscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_rootshoextscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_rootshoextscr", zz_gate = "gho_houseext_rootshoextscr" };
 
  local win_rootshoextscr_func = function ()

    if ( cmn.IsEventDone( "win_rootshoextscr" ) ) then
      ObjDetach("spr_rootshoextscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_rootshoextscr", win_rootshoextscr_func );

  local unmark_fff = function () 
    ObjSet( "spr_rootshoextscr_fff", {alp = 1,input=1} );
    ObjSet("anm_rootshoextscr_fff",{animfunc="end_knife1",frame=0})
    ObjDelete("gfx_rootshoextscr_fff_part_1")
    ObjDelete("spr_rootshoextscr_fff_part_2_sh")
    ObjDelete( "spr_rootshoextscr_fff_part_2");
  end;
  cmn.AddSubscriber( "rootshoextscr_unmark_fff", unmark_fff, "ho_rootshoextscr" );

  local unmark_jjj = function () 
    ObjSet( "spr_rootshoextscr_jjj", {alp = 1,input=1} );
    ObjSet("anm_rootshoextscr_jjj",{animfunc="end_pen1",frame=0})
    ObjDelete("gfx_rootshoextscr_jjj_part_1")
  end;
  cmn.AddSubscriber( "rootshoextscr_unmark_jjj", unmark_jjj, "ho_rootshoextscr" );
  
  local unmark_eee = function () 
    ObjSet( "spr_rootshoextscr_eee", {alp = 1,input=1} );
    ObjSet( "spr_rootshoextscr_tr_eee", {alp = 1} );
    ObjSet("anm_rootshoextscr_eee",{animfunc="end_casket1",frame=0})
    ObjDelete("gfx_rootshoextscr_eee_part_1")
  end;
  cmn.AddSubscriber( "rootshoextscr_unmark_eee", unmark_eee, "ho_rootshoextscr" );
  
  local start_rootshoextscr_func = function ()
  if not cmn.IsEventDone("win_rootshoextscr") then
    if cmn.IsUnmarkedTask("rootshoextscr","fff") then 
      unmark_fff()
    end 
    if cmn.IsUnmarkedTask("rootshoextscr","jjj") then 
      unmark_jjj()
    end  
    if cmn.IsUnmarkedTask("rootshoextscr","eee") then 
      unmark_eee()
    end     
  end
  end;
  cmn.AddSubscriber( "win_rootshoextscr", start_rootshoextscr_func, "ho_rootshoextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_houseext_env" )

  if ( not cmn.IsEventDone( "opn_rootshoextscr" ) ) then

    cmn.InitHo( "rootshoextscr" );

    cmn.SetMarkedTask( "rootshoextscr", "fff" );
    cmn.SetMarkedTask( "rootshoextscr", "jjj" );
    cmn.SetMarkedTask( "rootshoextscr", "eee" );
    
    cmn.SetEventDone( "opn_rootshoextscr" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_rootshoextscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_rootshoextscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_rootshoextscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_rootshoextscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_rootshoextscr_eee" },{"gfx_rootshoextscr_eee_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_rootshoextscr_fff" },{"spr_rootshoextscr_fff_part_2","gfx_rootshoextscr_fff_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_rootshoextscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_rootshoextscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_rootshoextscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 1, { { "spr_rootshoextscr_jjj" },{"gfx_rootshoextscr_jjj_part_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_rootshoextscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_rootshoextscr_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_rootshoextscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_rootshoextscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

   if cmn.IsEventDone( "win_rootshoextscr" ) then
      ng_global.progress["scr"]["win_rootshoextscr"]={}
      ng_global.progress["scr"]["win_rootshoextscr"].done = 0
      ng_global.progress["scr"]["opn_rootshoextscr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_rootshoextscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_rootshoextscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------

----------------------------------------------------------------------------
function public.unmark_fff()
  if ApplyObj("spr_rootshoextscr_fff_part_2","gfx_rootshoextscr_fff_part_1") then 
    local f_end = function()
      ld.Lock(0)
      cmn.UnmarkTask( "rootshoextscr", "fff" );
      cmn.CallEventHandler( "rootshoextscr_unmark_fff" );      
    end
    ld.Lock(1)
    ObjDelete("spr_rootshoextscr_fff_part_2")
    ld.AnimPlay("anm_rootshoextscr_fff","use_knife",f_end)

    SoundSfx( "aud_ho_rootshoext_cut" );
  else
    ObjSet("spr_rootshoextscr_fff_part_2",{pos_z = 14})
    ObjSet("spr_rootshoextscr_fff_part_2_sh", {alp = 1} );
    --SoundSfx( "" );
  end
end
----------------------------------------------------------------------------
function public.unmark_jjj()
  local f_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "rootshoextscr", "jjj" );
    cmn.CallEventHandler( "rootshoextscr_unmark_jjj" );      
  end
  ld.Lock(1)  
  ld.AnimPlay("anm_rootshoextscr_jjj","click_pen",f_end)
  SoundSfx( "aud_ho_rootshoext_basket" );
end
----------------------------------------------------------------------------
function public.unmark_eee()
  local f_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "rootshoextscr", "eee" );
    cmn.CallEventHandler( "rootshoextscr_unmark_eee" );      
  end
  ld.Lock(1)  
  ld.AnimPlay("anm_rootshoextscr_eee","use_casket",f_end)
  SoundSfx( "aud_ho_rootshoext_casket" );
end