-- name=ho_suitcasescr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "suitcasescr" );
  game.relations[ "ho_suitcasescr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_suitcasescr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_suitcasescr", zz_gate = "gho_rungs_suitcasescr" };
 
  local win_suitcasescr_func = function ()

    if ( cmn.IsEventDone( "win_suitcasescr" ) ) then
      ObjDetach("spr_suitcasescr_win")
    end;

  end;
  cmn.AddSubscriber( "win_suitcasescr", win_suitcasescr_func );
  
  local start_suitcasescr_func = function ()
  if not cmn.IsEventDone("win_suitcasescr") then
  
  end
  end;
  cmn.AddSubscriber( "win_suitcasescr", start_suitcasescr_func, "ho_suitcasescr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_rungs_env" )

  if ( not cmn.IsEventDone( "opn_suitcasescr" ) ) then

    cmn.InitHo( "suitcasescr" );

    cmn.SetEventDone( "opn_suitcasescr" );
  end;

    local arr = {
                "aaa",
                "bbb",
                "ccc",
                "ddd",
                "eee",
                "fff",
              }
    for i = 1,#arr do 
      local item_name = "spr_suitcasescr_panel_"..arr[i].."_siluet"        
      local item_params = ObjGet( item_name );  
      --ld.LogTrace( item_name );      
      ObjSet( item_name, {
        event_menter = function () interface.PopupShow("tsk_suitcase_"..arr[i] ) end,
        event_mleave = function () interface.PopupHide() end,
        inputrect_init = 1,
        inputrect_x    = - ( 0.5 * item_params.draw_width  ),
        inputrect_y    = - ( 0.5 * item_params.draw_height ),
        inputrect_w    = item_params.draw_width,
        inputrect_h    = item_params.draw_height               
      } );
    end   
  
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          2, 0, { { "spr_suitcasescr_aaa_mul_1" },{ "spr_suitcasescr_aaa_mul_2" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          2, 0, { { "spr_suitcasescr_bbb_mul_1" },{ "spr_suitcasescr_bbb_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          2, 0, { { "spr_suitcasescr_ccc_mul_1" },{ "spr_suitcasescr_ccc_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          2, 0, { { "spr_suitcasescr_ddd_mul_1" },{ "spr_suitcasescr_ddd_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          2, 0, { { "spr_suitcasescr_eee_mul_1" },{ "spr_suitcasescr_eee_mul_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          2, 0, { { "spr_suitcasescr_fff_mul_1" },{ "spr_suitcasescr_fff_mul_2" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

  ObjAttach("spr_suitcasescr_panel","int_taskpanel_impl")
  ObjSet("spr_suitcasescr_panel",{pos_x=0,pos_y=0})
  
  for j = 1, #ng_global.progress["scr"]["win_suitcasescr"].found do

    local name = tostring( ng_global.progress["scr"]["win_suitcasescr"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  private.LoadState()
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
   if cmn.IsEventDone( "win_suitcasescr" ) then
      ng_global.progress["scr"]["win_suitcasescr"]={}
      ng_global.progress["scr"]["win_suitcasescr"].done = 0
      ng_global.progress["scr"]["opn_suitcasescr"].done = 0
     common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter )
   end
end;

function public.Close()
  ObjDetach("spr_suitcasescr_panel")
end
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  --ld.LogTrace( item_name );
  private.LoadState()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_suitcasescr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_suitcasescr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------

function private.LoadState()
  public.state = {}
  for j = 1, #ng_global.progress["scr"]["win_suitcasescr"].found do

    local task = tostring( ng_global.progress["scr"]["win_suitcasescr"].found[j]["task"] );
    if public.state[task] then
      public.state[task] = public.state[task] + 1
    else 
      public.state[task] = 1
    end
  end;
  for k,v in pairs(public.state) do
    if public.state[k] then
      ObjSet("txt_suitcasescr_panel_"..k.."_text",{text="x"..(2-tonumber(v))})
    end
  end 
end
----------------------------------------------------------------------------