-- name=rm_cards
--******************************************************************************************
function public.Init()
              
  ObjAttach( "rm_cards", "rooms_hub" );


  ObjSet("spr_cards_button_main_menu",{ 
    event_mdown =  function () private.Exit()           end,
    event_menter = function () public.MouseEnter( "button_main_menu" ); end,
    event_mleave = function () public.MouseLeave( "button_main_menu" ); end 
                    })
 
end;
--******************************************************************************************
function public.PreOpen()
  --interface.InterfaceSetInput( false ); 
  --interface.InterfaceSetVisible( false );

  if not cmn.is_inmenunow then

      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Btn_Diary
      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], false,true );
        interface.WidgetSetInput(widget_settings[i],false)
      end;
  end

  private.LoadCards()
end;
--******************************************************************************************
function public.Open()
  SoundEnv("aud_bonus_env");
  SoundTheme( "aud_ho_mus",1 );
  
  private.current_room = common.GetCurrentRoom();

end;

function public.Close()
  SoundTheme(0);
  SoundEnv(0);
  --interface.InterfaceSetInput( true );
  --interface.InterfaceSetVisible( true );

  if not cmn.is_inmenunow then
    local widget_settings = 
    {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Btn_Diary
    }

    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], true, true );
      interface.WidgetSetInput(widget_settings[i],true)
    end;
  end
end
--******************************************************************************************
function public.MouseEnter ( name )

  SetCursor( CURSOR_HAND );
SoundSfx( "aud_guidance" );
  local obj = "spr_cards_"..name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function public.MouseLeave ( name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_cards_"..name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.Exit()
  SoundSfx( "aud_click_menu" );
  if ( not private.current_room ) then

    private.current_room = "rm_extra";

  end;
    common.GotoRoom( private.current_room );
end


function private.LoadCards()

  for i = 1,#ng_global.achievements.card do
    if ng_global.achievements.card[i] then 
      ObjSet( "spr_cards_card"..i, {input = 1, visible = 1} );
    else
      ObjSet( "spr_cards_card"..i, {input = 0, visible = 0} );
    end
  end
end



function public.ClkCard(name)
  SoundSfx( "aud_paper_open" );
  local obj = "spr_cards_"..name
  local obj_big = "spr_cards_"..name.."_big"
  ld.Lock(1)
  ObjSet( obj_big, {input = 1} );
  ObjAttach(obj_big,"rm_cards")
  ObjAnimate( obj, 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  ObjAnimate( obj_big, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
  ObjAnimate( obj_big, "scale_xy", 0,0,"",{0,0,0.2,0.2,0.5,0,1,1})
  ObjAnimate( obj_big, "pos_xy", 0,0,function() ld.Lock(0) end,{0,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y,0.5,0,512,384})
  
end

function public.CloseCard(name)
  SoundSfx( "aud_paper_close" ); 
  local obj = "spr_cards_"..name
  local obj_big = "spr_cards_"..name.."_big"
  ld.Lock(1)
  ObjSet( obj_big, {input = 0} );
  ObjAnimate( obj, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
  ObjAnimate( obj_big, 8, 0, 0, "", {0,0,1, 0.5,0,0} );
  ObjAnimate( obj_big, "scale_xy", 0,0,"",{0,0,1,1,0.5,0,0.2,0.2})
  ObjAnimate( obj_big, "pos_xy", 0,0,function() ObjAttach(obj_big,"obj_cards_card_big_root") ld.Lock(0) end ,{0,0,512,384,0.5,0,ObjGet(obj).pos_x,ObjGet(obj).pos_y})
end



----------------------------------------------------------------------------------------------------
private.page_current       = 1;
function public.PageNext( inc )

  inc = tonumber( inc );
  local max_count = 4  ;
  local new_num;

  if private.page_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.page_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.page_current + inc;
  end;

  local name     = "obj_cards_page_";
  local name_arr = "obj_cards_page_arrows";
  local tme      = 0.3;

  ObjSet( name_arr, { input = 0 });
  ObjSet( 'rm_cards', {  input = 0 } );
  ObjSet( name..private.page_current, {input = 0} );
  ObjSet( name..new_num, {input = 1} );  
  ObjAnimate( name..new_num, "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    tme, 0, 1
  } );

  ObjAnimate( name..private.page_current, "alp", 0, 0, function() ObjSet( name_arr, { input = 1 });ObjSet( 'rm_cards', {  input = 1 } );end, 
  {
    0.0, 0, 1,
    tme, 0, 0
  } );
    
  ObjSet( "txt_cards_page_counter", { text = new_num.."/"..max_count } );
  private.page_current = new_num;

  --SoundSfx( "aud_click_menu" )
  SoundSfx( "aud_turn_page_"..math.random(1,3) );
end




