-- name=rm_collectibles
--******************************************************************************************
function public.Init()
              
  ObjAttach( "rm_collectibles", "rooms_hub" );


  ObjSet("spr_collectibles_button_main_menu",{ 
    event_mdown =  function () private.Exit()           end,
    event_menter = function () private.ButtonMouseEnter( "main_menu" ); end,
    event_mleave = function () private.ButtonMouseLeave( "main_menu" ); end 
                    })


end;
--******************************************************************************************
function public.PreOpen()
  if not cmn.is_inmenunow then
    --DbgTrace("screensaver open game")
      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Dialog_Task,

      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], false,true );
        interface.WidgetSetInput(widget_settings[i],false)
      end;
  end

  private.Load()  
  SoundTheme( "aud_ho_mus", 1 )
end;
--******************************************************************************************
function public.Open()
  SoundEnv( "aud_extra_env" )
  private.current_room = common.GetCurrentRoom();
end;

function public.Close()
  if not cmn.is_inmenunow then
    local widget_settings = 
    {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Dialog_Task,
    }

    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], true, true );
      interface.WidgetSetInput(widget_settings[i],true)
    end;
  end
  SoundTheme( 0 )
end
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );
  interface.PopupShow( 'str_menu_back')
  local obj = "spr_collectibles_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;


function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );
  interface.PopupHide()
  local obj = "spr_collectibles_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
--port.
function public.Hide()
  private.Exit();
end;
--******************************************************************************************
function private.Exit()
  if ( not private.current_room ) then

    private.current_room = "rm_extra";

  end;
    common.GotoRoom( private.current_room );
  SoundSfx( "aud_click_menu" )
end

function private.Load()
  for i=1,#ng_global.achievements.miniature do
    local obj = "spr_collectibles_mouse_"..i
    if ng_global.achievements.miniature[i] then
      if ng_global.achievements.show_miniature[i] then
        ld.Lock(1)
        ObjAnimate( obj, 8, 0, 0, function() ObjSet( obj, {input = 1} ); ld.Lock(0);end, {0,0,0, 0.5,0,1} );
      else
        ObjSet( obj, {input = 1, alp = 1} );
      end
    else
      ObjSet( obj, {input = 0, alp = 0} );
    end
  end

end



