-- name=rm_credits
--******************************************************************************************
function public.Init()

  private.screen_current = 0;

  private.screen_max = 26;
  private.screen_countline = { 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3 };

  SetCursor(CURSOR_DEFAULT);

  ObjSet("obj_credits_btn_quit", {
    event_mdown = function () private.QuitClk(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end
  }); 

end;
--******************************************************************************************
function public.PreOpen()
 
  ObjSet( "rm_credits", { alp = 1 });

  interface.InterfaceSetInput( false ); 
  interface.InterfaceSetVisible( false );

  if IsCollectorsEdition() then

    ObjSet( "spr_credits_colectorsedition", { visible  = 1, alp = 1 } );

  else

    ObjSet( "spr_credits_colectorsedition", { visible = 0 } );

  end;

  ObjSet( "obj_credits_btn_quit", { alp = 0, input = 0 } );

  for i = 1, private.screen_max do

    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );

  end;

  ObjSet( "txt_credits_title_1", { alp = 0 } );
  ObjSet( "txt_credits_title_2", { alp = 0 } );

end;
--******************************************************************************************
function public.Open()
  SoundTheme( "aud_adventure2_mus" )
  private.current_room = common.GetCurrentRoom();

  private.screen_current = 0;

  private.Screen();

  local prg  = ng_global.currentprogress;  

  local func_end = function ()

    ObjSet( "obj_credits_btn_quit", { alp = 1, input = 1 } );

  end;

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,  0,  0, 
    2,  0,  0, 
    3,  0,  1 
  });

  common_impl.StopAllMus( "common/audio/mus/aud_credits_mus" );
  --common_impl.PlayAudio( "mus", "common/audio/mus/aud_credits_mus", 1 );

  if  ( not cmn.is_inmenunow ) then
  if prg == "std" then 
    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "std" ][ "clk_outrolvl3" ] and 
       cmn.IsEventDone( "clk_outrolvl3" ) --[[ng_global.progress[ "std" ][ "vid_fork_3_autro" ].done == 1]]  then
      ng_global.progress[ "std" ].common.gamewin   = true; 
      ng_global.progress[ "std" ].common.gamestart = false;
      SaveProfiles();
      SaveSettings();

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "ext" ][ "clk_outroext" ] and
       cmn.IsEventDone( "clk_outroext" ) then
      ng_global.progress[ "ext" ].common.gamewin   = true; 
      ng_global.progress[ "ext" ].common.gamestart = false;
      SaveProfiles();
      SaveSettings();
    end;
  end;
  end

end;
--******************************************************************************************
function public.Close()

  interface.InterfaceSetInput( true );
  interface.InterfaceSetVisible( true );

  for i = 1, private.screen_max do

    ObjStopAnimate( "obj_credits_screen_"..i, "alp" );
    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );

  end;

end;
--******************************************************************************************
function public.PreClose()
  SoundTheme( 0 )
end;
--******************************************************************************************
function private.Screen ()

  ObjSet( "rm_credits", { input = true } );

  local line_time = 1.7;
  local time = 0;

  local func_exit = function ()

    private.Exit();
  
  end;

  local func_continue = function ()

    private.Screen();
  
  end;

  if private.screen_current > 0 then

    ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, "", { 
      0,  0,  1, 
      1,  0,  0, 
    })

    private.screen_current = private.screen_current + 1;

    if private.screen_current > private.screen_max then

      ObjAnimate( "rm_credits", "alp", 0, 0, func_exit, { 0,0,1, 2,0,0 });

    else

      time = private.screen_countline[ private.screen_current ] * line_time;

      ObjAnimate("obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
        0,     0,  0, 
        1,     0,  0, 
        1.5,   0,  1,
        time,  0,  1 
      });

    end;

    if private.screen_current == 16 then

      ObjAnimate( "txt_credits_title_1", "alp", 0, 0, "", { 
        0,   0, 1,   
        0.5, 0, 0 
      });

      ObjAnimate( "txt_credits_title_2", "alp", 0, 0, "", { 
        0,   0, 0,   
        1.0, 0, 1 
      });

    elseif private.screen_current == private.screen_max then

      ObjAnimate("txt_credits_title_2", "alp", 0, 0, "", { 
        0,0,1, 
        0.5,0,0 
      });

    end;

  else
    private.screen_current = private.screen_current + 1;
    if private.screen_current == 1  then

      ObjAnimate( "txt_credits_title_1", "alp", 0, 0, "", { 
        0,0,0, 
        1,0,1 
      });

    end;

    ObjAnimate( "obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
      0,     0,  0, 
      1,     0,  1, 
      1.5,   0,  1,
      time,  0,  1

    });
--    
    
--
--    ObjAnimate( "obj_credits_screen_"..private.screen_current, "alp", 0, 0, func_continue, { 
--      0,     0,  0, 
--      1,     0,  0, 
--      1.5,   0,  0,
--      time,  0,  0,
--      time+1,0,  0,
--    time+1.5,0,  1,
--      2*time,0,  1 
--    });
--


  end;

end;
--******************************************************************************************
function private.ButtonMouseEnter ()

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_HAND );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,               0,    alp, 
    tme *( 1 - alp ),  0,    1
  } );



end;
--******************************************************************************************
function private.ButtonMouseLeave ()

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_DEFAULT );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,                      0, alp, 
    tme * alp, 0,    0
  } );

end;
--******************************************************************************************
--port.
function public.Exit()
  private.QuitClk();
end;
--******************************************************************************************
function private.QuitClk ()

  ObjSet( "rm_credits", { input = 0 } );

  ObjStopAnimate( "obj_credits_screen_"..private.screen_current, "alp" );

  local func_end = function ()

    private.Exit();

  end;

  ObjAnimate("obj_credits_screen_"..private.screen_current - 1, "alp", 0, 0, "", { 
    0,    0,  ObjGet( "obj_credits_screen_"..private.screen_current-1 ).alp, 
    0.5,  0,  0 
  });

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,    0,  1, 
    0.5,  0,  1, 
    0.8,  0,  0 
  });

  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu" );

end;
--******************************************************************************************
function private.Exit ()

  local prg  = ng_global.currentprogress; 

  local flag = true;
if  ( not cmn.is_inmenunow ) then
  ld.LogTrace( "not cmn.is_inmenunow" ); 
  local flag = true;
  if prg == "std" then 

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "std" ][ "clk_outrolvl3" ] and 
       cmn.IsEventDone( "clk_outrolvl3" ) --[[ng_global.progress[ "std" ][ "vid_fork_3_autro" ].done == 1]]  then
        
        private.Skip();
        flag = false;

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ng_global.progress[ "ext" ][ "clk_outroext" ] and
       cmn.IsEventDone( "clk_outroext" ) then
        
      private.SkipExt();
      flag = false;
      
    end;
  elseif prg == "scr" then 
    private.current_room = rm_secretroomscr.GetCurrentRoom()
  end;
end

  common_impl.StopAllMus();

  if ( not private.current_room ) then

    private.current_room = "rm_menu";

  end;

  if ( flag ) and prg ~= "scr" then 

    common.GotoRoom( private.current_room );
    
  elseif ( flag ) and prg == "scr" then 
    rm_secretroomscr.GotoRoom(private.current_room)
  end;

end;
--******************************************************************************************
function private.Skip ()

--  ng_global.progress[ "std" ].common.gamewin   = true; 
--  ng_global.progress[ "std" ].common.gamestart = false;
--
--  SaveProfiles();
--  SaveSettings();
----
  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.SkipExt ()

--  ng_global.progress[ "ext" ].common.gamewin   = true; 
--  ng_global.progress[ "ext" ].common.gamestart = false;
--
--  SaveProfiles();
--  SaveSettings();
--
  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;