-- name=rm_menu
--******************************************************************************************
function public.Init()

  ObjSet("menu_but_play", 
  {
    event_mdown = private.PlayDown,
    event_menter = function () private.ButtonMouseEnter('play'); end,
    event_mleave = function () private.ButtonMouseLeave('play'); end
  });
    
  ObjSet("menu_but_options", 
  {
    event_mdown = private.OptionsDown
  });
  
  ObjSet( "menu_but_credits", 
  {
    event_mdown = private.CreditsDown
  } );

  ObjSet( "menu_but_profile", 
  {
    event_mdown = private.ProfileDown
  } );
  ObjSet( "menu_but_moregames", 
  {
    event_mdown = private.MoreGamesDown
  } );
  ObjSet( "menu_but_forum", 
  {
    event_mdown = private.ForumDown
  } );
 
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
  
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown,
    event_menter = function() private.ButMouseEnter( "unlock" ); end,
    event_mleave = function() private.ButMouseLeave( "unlock" ); end
    });
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end,
    event_menter = function() private.ButMouseEnter( "close_gear" ); end,
    event_mleave = function() private.ButMouseLeave( "close_gear" ); end
    });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end,
    event_menter = function() private.ButMouseEnter( "gear" ); end,
    event_mleave = function() private.ButMouseLeave( "gear" ); end 
    });
  
  ObjSet( "menu_but_extra", 
  {
    event_mdown = private.ExtraDown,
    event_menter = function() private.ButMouseEnter( "extra" ); end,
      event_mleave = function() private.ButMouseLeave( "extra" ); end 
  } );
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
  if GetPlatform() == "android" then
    ObjSet("menu_but_forum",{ alp = 0, input = false, visible = false });  
    ObjSet("menu_but_credits",{ pos_x = 512 });  
  end;
  
end;

--******************************************************************************************
function private.ButMouseEnter(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1.1, scale_y = 1.1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1.1, scale_y = 1.1 }); 
  end;
end;
--******************************************************************************************
function private.ButMouseLeave(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1, scale_y = 1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1, scale_y = 1 }); 
  end;
end;
--******************************************************************************************
local wait_gear;
public.sub_menu_active = false;
--******************************************************************************************
function public.closeGearSubMenu()
  public.sub_menu_active = false;
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
end;
--******************************************************************************************
function public.openGearSubMenu()
  port.TapDownTimer(0.5,
    function() 
      public.sub_menu_active = true;
      ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
      private.ButMouseLeave("gear");
    end
  );
  
end;
--******************************************************************************************
function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
function public.PreOpen()
    
  --ObjSet( "menu_ce_buttons_left",  { active = false, visible = false, input = false } );
  --ObjSet( "menu_ce_buttons_right", { active = false, visible = false, input = false } );

  if ( IsCollectorsEdition()) then
    ObjSet( "menu_ce_buttons_left", { active = true, visible = true, input = true } );
    ObjSet( "menu_ce_buttons_right", { active = true, visible = true, input = true } )
    ObjSet( "spr_menu_logo_ce", {visible = 1} );
    ObjSet( "menu_but_strguide", {active = true, visible=true, input = true} );
  else
    ObjSet( "menu_ce_buttons_left", { active = false, visible = false, input = false } );
    ObjSet( "menu_ce_buttons_right", { active = false, visible = false, input = false } )
    ObjSet( "spr_menu_logo_ce", {visible = 0} );
    ObjSet( "menu_but_strguide", {active = false, visible=false, input = false} );
  end;
  
  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();

  SoundEnv( "aud_menu_env" )
  SoundTheme( "aud_maintheme_mus", 1 )
  
  VidStop("vid_menu_anims_vid_kirk_turn_76",func_end);

  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  wait_gear = false;
  public.gearOverAngle();  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if tostring(GetPlatform()) == "ios" then
      ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 0.5, playing = 1 });
    elseif tostring(GetPlatform()) == "android" then
      DbgTrace("SetPerformanceMode(1)");
      SetPerformanceMode(1);
    end;
  
    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
end;
--******************************************************************************************
function public.Open()

    if ng_global.progress then
      if ( (not ng_global.progress[ "std" ].common.gamestart ) and ( ng_global.progress[ "std" ].common.gamewin ) ) and  not (ng_global.bonusunlock) then
        if IsCollectorsEdition() then
          common.DialogWindowShow( "common", "complete_std",true );
        else 
          common.DialogWindowShow( "common", "complete_std_se",true );
        end
      
        ng_global.bonusunlock = true
        SaveProfiles();
      end;
    end

end;

--***ios fix***************************************************************************************
function public.PreClose()
  ObjStopAnimate( "spr_menu_but_gear", "ang");
  ObjSet( "tmr_gear", { playing = 0 }); 
end;
--******************************************************************************************
function private.PerformanceWarning()
  iOS_PerformanceWarning();
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
function public.SetProfileText ( name )
  
  local obj = "txt_menu_but_profile_change";
  local profile_name = "";
  if  ( name ~= "ng_noprofiles" )
  and ( name ~= "ng_error" )
  then
  profile_name = name;
  if string.len(profile_name)~=0 then
      ObjSet( "txt_menu_but_profile_surname_change", {visible = 1} );
    end
  end;
  ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PlayDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common_impl.MenuPlay();


end;
--******************************************************************************************
function private.OptionsDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.MenuOptions();
end;
--******************************************************************************************
function private.CreditsDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.MenuCredits();
end;
--******************************************************************************************
function private.QuitDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.MenuQuit();  
end;
--******************************************************************************************
function private.ExtraDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
   port.TapDownTimer(0.5,
    function()
      if port.isPortable() == 1 then
        if iOS_IsBought() == 1 then
          common.MenuExtra();
        else
          common.MenuUnlock();
        end;
      else
        common.MenuExtra();
      end;
    end
    );    
end;
--******************************************************************************************
function private.StrguideDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )


    if IsCollectorsEdition() then

      common_impl.ButtonGuide_Click();
      interface.StrategyGuideShow();

    else

      local guide_url = GetGuideUrl();
      OpenBrowser( guide_url );

    end;

end;
--******************************************************************************************
function private.ProfileDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.MenuProfile();
end;
--******************************************************************************************
function private.ShopDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  common.MenuShop();
end;
--*****************************************************************************************
function private.MoreGamesDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 )
  --common.GotoRoom( "rm_moregames" );
  iOS_MoreGamesPressed();
end;
--******************************************************************************************

  private.menter_txt_color = 
    {
    play      = {0.851,0.773,0.969, 0.612,0.616,0.773},  
    options   = {0.588,0.576,0.784, 0.302,0.294,0.431},
    moregames = {0.588,0.576,0.784, 0.302,0.294,0.431},
    quit      = {0.588,0.576,0.784, 0.302,0.294,0.431},
    
    extra     = {0.341,0.341,0.341, 0.651,0.651,0.651},  
    
    strguide  = {0.706,0.518,0.514, 0.533,0.376,0.373},  
    profile   = {0.753,0.757,0.827, 0.635,0.635,0.682},    
    
    } 
--*************************************ios*****************************************************
function private.Save50Down()
   PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 );
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  port.TapDownTimer(0.5,
    function()
       PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 );
      common.MenuUnlock();
    end
   );
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
   PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 );
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  PlaySfx( "assets/levels/common/audio/aud_click_menu", 0, "", 0.0 );
  iOS_LaunchForum();
end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )
  SetCursor( CURSOR_HAND );
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  PlaySfx( "assets/levels/common/audio/aud_guidance", 0, "", 0.0 )

  if private.menter_txt_color[but_name] then
    local obj_txt = "txt_menu_but_"..but_name
    local txt_param = ObjGet(obj_txt)
    local arr = private.menter_txt_color[but_name]
    ObjAnimate( obj_txt, 12, 0, 0, "", {0,0,txt_param.color_r,txt_param.color_g,txt_param.color_b, ( common_impl.animtime * alp ) ,0,arr[1],arr[2],arr[3]} );
  end
--  if but_name == "play" then
--    SoundEnv( "aud_candle_burn_env", 1 )
--    ObjAnimate( "pfx_menu_pm_candel", 8, 0, 0, "", {0,0,0, ( common_impl.animtime * alp ),0,1} );
--  end
end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )
  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  local obj_txt = "txt_menu_but_"..but_name
  local txt_param = ObjGet(obj_txt)
  local arr = private.menter_txt_color[but_name]  
  ObjAnimate( obj_txt, 12, 0, 0, "", {0,0,txt_param.color_r,txt_param.color_g,txt_param.color_b, ( common_impl.animtime * alp ) ,0,arr[4],arr[5],arr[6]} );

--  if but_name == "play" then
--    SoundEnv( "aud_candle_burn_env", 0 )
--    ObjAnimate( "pfx_menu_pm_candel", 8, 0, 0, "", {0,0,1, ( common_impl.animtime * alp ),0,0} );
--  end

end;
--******************************************************************************************
function public.ButtonSetPos()
  local offwidth = 0.5 * ( GetAppWidth() - 1024 );
  --ObjSet( "menu_objects_left",  { pos_x = ( 512 - offwidth ) } );
  --ObjSet( "menu_objects_right", { pos_x = ( 512 + offwidth ) } );
end;
--*****************************************************************************************
-------------------------------CLK-FUCTIONS-----------------------------------------------
function public.menu_anims_kirk_zone_clk()
  local func_end = function()
    ObjSet( "vid_menu_anims_vid_kirk_turn_76", {input=1} );
  end;

  if math.random(1,3)==3 then 
    SoundSfx( "aud_menu_touch_man2" );
  else 
    SoundSfx( "aud_menu_touch_man" );
  end;
  ObjSet( "vid_menu_anims_vid_kirk_turn_76", {input=0} );
  VidPlay("vid_menu_anims_vid_kirk_turn_76",func_end);  
end;  
------------------------------------------------------------------------------------------

--*****************************************************************************************
